* This file contains two subroutine which computes renormalized W
* selfenergy. These are called by CalcMasses_atlambda.F
* subroutine SelfTWW2L_MT4(selfW) compute the finite part of W selfenergy
* with contribution of alpha_t^2
* subroutine SelfTWW2L_lambda(selfWO) compute the finite part of W selfenergy
* with contribution of alpha_t (alpha_lambda+ alpha_kappa)
* written by Thi Nhung Dao, last update: 6/2021  
c#define printMT4
c*********************************************************************
      subroutine SelfTWW2L_MT4(selfW)
      implicit none
      integer imodel,i,j,I6G3,I6G4,I6G5,I6G6,I2G3,I2G4,h1,h2
      double precision LambdaN
#include "TLMT4.h"
#include "TLMT4lambda.h"
      double precision pi2,fac
     .     ,B0T,A0T,AEpT,BEpT,I0A,K0T0,M22m42,M22m42s,
     .     M22mMSQ,M42mMSQ,selfW
      double complex abry(20),afin(50)

         pi2=pi**2
         fac= 3/16D0/pi2**2/vv2/8D0
         M22m42=M22-M42; M22m42s=M22m42**2
         M22mMSQ=M22-MSQ2; M42mMSQ=M42-MSQ2

       I0A1= I0A(M12,MCha2,MSQ2,Q2)
       I0A2= I0A(0D0,MCha2,M22,Q2)   
       I0A3= I0A(0D0,MCha2,M42,Q2)   
       I0A6= I0A(0D0,M12,MHp2,Q2)  
       I0A7=I0A(M22,MSQ2,MHp2,Q2)
       I0A8=I0A(M42,MSQ2,MHp2,Q2)
       I0A14=I0A(M12,M12,MHp2,Q2)
       I0A15=I0A(0D0,Mcha2,MSQ2,Q2)
       I0A19=I0A(0D0,MSQ2,M22,Q2)
       I0A20=I0A(0D0,MSQ2,M42,Q2)
       I0A21=I0A(0D0,M42,M22,Q2)
       I0A22=I0A(M22,M22,MHp2,Q2)
       I0A23=I0A(M42,M42,MHp2,Q2)
       I0A24=I0A(MSQ2,MSQ2,MHp2,Q2)
       I0A25=I0A(M22,M42,MHp2,Q2)
       I0A26=I0A(0D0,0D0,M12,Q2)
       alambda1=lambdaN(M12,MCha2,MSQ2)
       alambda4=LambdaN(M22,MSQ2,MHp2)
       alambda5=LambdaN(M42,MSQ2,MHp2)
       do h1=1,3
       alambda2(h1)= LambdaN(M12,M22,MNeu2(h1))
       alambda3(h1)= LambdaN(M12,M42,MNeu2(h1))
       I0A4(h1)= I0A(M12,M22,MNeu2(h1),Q2)
       I0A5(h1)= I0A(M12,M42,MNeu2(h1),Q2)
       I0A16(h1)= I0A(0D0,M22,MNeu2(h1),Q2)
       I0A17(h1)= I0A(0D0,M42,MNeu2(h1),Q2)
       I0A18(h1)= I0A(M12,MSQ2,MNeu2(h1),Q2)
       enddo

       do h1=1,5
        I0A9(h1)=I0A(M12,M12,Mah2(h1),Q2)     
        I0A10(h1)= I0A(M22,M22,Mah2(h1),Q2)
        I0A11(h1)= I0A(M22,M42,Mah2(h1),Q2)
        I0A12(h1)= I0A(M42,M42,Mah2(h1),Q2)
        I0A13(h1)=I0A(0D0, Mah2(h1), M12, Q2)
        alambda6(h1)=lambdaN(M22,M42,Mah2(h1))
       enddo

       SelfW=0
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       Do  I6G6= ihiggs,6
       SelfW=SelfW-(CSSSS(I6G6,I6G6,I6G5,I6G4)*(A0TNH(I6G6)*(2+4*
     &  aB0T1(I6G4,I6G5)+4*MSQ2*aC0TH1(I6G4,I6G5))+4*AETNH(I6G6)+(1+2*
     &  aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*MSQ2*aC0TH1(I6G4,I6G5)+
     &  4*MSQ2*aCEpTH1(I6G4,I6G5))*Mah2(I6G6))*ZU(I6G5,1)*ZUC(I6G4,1))
     &  /8.
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfW=SelfW-(CS3S3S13S13(I2G3,I2G3,I6G5,I6G4)*(A0THpN(I2G3)*(2+
     &  4*aB0T1(I6G4,I6G5)+4*MSQ2*aC0TH1(I6G4,I6G5))+4*AETHpN(I2G3)+(1+
     &  2*aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*MSQ2*aC0TH1(I6G4,I6G5)
     &  +4*MSQ2*aCEpTH1(I6G4,I6G5))*MassHpm(I2G3)**2)*ZU(I6G5,1)*
     &  ZUC(I6G4,1))/4.
       enddo
       enddo
       enddo

       Do  I6G4= 1,2
       Do  I6G5= 1,2
       Do  I6G6= 1,2
       SelfW=SelfW-((CS13S13S13S13MT4(I6G5,I6G6,I6G4,I6G6)+3*
     &  CS13S13S13S13MT4(I6G5,I6G6,I6G6,I6G4))*(4*aAETN(I6G6)+
     &  aA0TN(I6G6)*(2+4*aB0T1(I6G4,I6G5)+4*MSQ2*aC0TH1(I6G4,I6G5))+(1+
     &  2*aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*MSQ2*aC0TH1(I6G4,I6G5)
     &  +4*MSQ2*aCEpTH1(I6G4,I6G5))*MassSu2(I6G6))*ZU(I6G5,1)*
     &  ZUC(I6G4,1))/4.
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       Do  I6G3= 1,2
       SelfW=SelfW-(CS3S3S14S14(I2G3,I2G3)*(A0THpN(I2G3)*(2+4*
     &  aB0TH1(I6G3)+4*MSQ2*aC0TH2(I6G3))+4*AETHpN(I2G3)+(1+2*
     &  aB0TH1(I6G3)+4*aBEpTH1(I6G3)+2*MSQ2*aC0TH2(I6G3)+4*MSQ2*
     &  aCEpTH2(I6G3))*MassHpm(I2G3)**2)*ZU(I6G3,1)*ZUC(I6G3,1))/4.
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G6= 1,2
       SelfW=SelfW-(CS14S13S14S13MT4(I6G6,I6G6)*(4*aAETN(I6G6)+
     &  aA0TN(I6G6)*(2+4*aB0TH1(I6G3)+4*MSQ2*aC0TH2(I6G3))+(1+2*
     &  aB0TH1(I6G3)+4*aBEpTH1(I6G3)+2*MSQ2*aC0TH2(I6G3)+4*MSQ2*
     &  aCEpTH2(I6G3))*MassSu2(I6G6))*ZU(I6G3,1)*ZUC(I6G3,1))/4.
       enddo
       enddo

       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfW=SelfW-((2*a0t5+4*aet5+MSQ2+2*(2*a0t5+MSQ2)*
     &  aB0T1(I6G4,I6G5)+4*MSQ2*aBEpT1(I6G4,I6G5)+2*MSQ2**2*
     &  aC0TH1(I6G4,I6G5)+4*a0t5*MSQ2*aC0TH1(I6G4,I6G5)+4*MSQ2**2*
     &  aCEpTH1(I6G4,I6G5))*CS14S13S14S13MT4(I6G5,I6G4)*ZU(I6G5,1)*
     &  ZUC(I6G4,1))/4.
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfW=SelfW+(CS13S13S13S13MT4(I6G4,I6G5,I6G3,I6G5)+3*
     &  CS13S13S13S13MT4(I6G4,I6G5,I6G5,I6G3))*(aAETN(I6G5)+aA0TN(I6G5)
     &  *aB0T1(I6G3,I6G4)+aBEpT1(I6G3,I6G4)*MassSu2(I6G5))*ZU(I6G4,1)*
     &  ZUC(I6G3,1)
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= ihiggs,6
       SelfW=SelfW+(CSSSS(I6G5,I6G5,I6G4,I6G3)*(A0TNH(I6G5)*
     &  aB0T1(I6G3,I6G4)+AETNH(I6G5)+aBEpT1(I6G3,I6G4)*Mah2(I6G5))*
     &  ZU(I6G4,1)*ZUC(I6G3,1))/2.
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       Do  I6G3= 1,2
       Do  I6G4= 1,2
       SelfW=SelfW+CS3S3S13S13(I2G3,I2G3,I6G4,I6G3)*(A0THpN(I2G3)*
     &  aB0T1(I6G3,I6G4)+AETHpN(I2G3)+aBEpT1(I6G3,I6G4)*MassHpm(I2G3)**
     &  2)*ZU(I6G4,1)*ZUC(I6G3,1)
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       SelfW=SelfW+(aet5+a0t5*aB0T1(I6G3,I6G4)+MSQ2*aBEpT1(I6G3,I6G4))*
     &  CS14S13S14S13MT4(I6G4,I6G3)*ZU(I6G4,1)*ZUC(I6G3,1)
       enddo
       enddo

       Do  I2G3= 1,2
       SelfW=SelfW+(CS3S3S14S14(I2G3,I2G3)*((a0t5-MSQ2)*A0THpN(I2G3)+
     &  MSQ2*AETHpN(I2G3)+(-a0t5+aet5)*MassHpm(I2G3)**2))/MSQ2
       enddo

       Do  I6G5= 1,2
       SelfW=SelfW+(CS14S13S14S13MT4(I6G5,I6G5)*((a0t5-MSQ2)*
     &  aA0TN(I6G5)+MSQ2*aAETN(I6G5)+(-a0t5+aet5)*MassSu2(I6G5)))/MSQ2
       enddo
c
c W tranverse selfenergy, diagrams can be reduced to oneloop
c
c[ neutral Higgs diagrams


       do h1=ihiggs,5
       afin(1)=(-8*a0t1**2+64*a0t1*M12-32*aet1*M12+12*M12**2+8*(a0t1+
     &  M12)*A0TNH(h1)+8*M12*I0A9(h1)-12*a0t1*Mah2(h1)+8*aet1*Mah2(h1)+
     &  9*M12*Mah2(h1))/(32*M12-8*Mah2(h1))
       afin(2)=(112*a0t1*M12**2-96*aet1*M12**2+84*M12**3+32*M12**2*
     &  I0A13(h1)+32*M12**2*I0A9(h1)+8*a0t1**2*Mah2(h1)-44*a0t1*M12*
     &  Mah2(h1)+24*aet1*M12*Mah2(h1)+3*M12**2*Mah2(h1)-40*M12*
     &  I0A13(h1)*Mah2(h1)+16*M12*I0A9(h1)*Mah2(h1)-18*M12*Mah2(h1)**2+
     &  8*I0A13(h1)*Mah2(h1)**2-8*I0A9(h1)*Mah2(h1)**2+16*M12*AETNH(h1)
     &  *(-4*M12+Mah2(h1))+8*A0TNH(h1)*(16*M12**2-(a0t1+5*M12)*Mah2(h1)
     &  ))/(16.*M12*(4*M12-Mah2(h1)))
       selfW=selfW+(afin(1)*hy(h1)**2+afin(2)*hy(h1)*hyc(h1)+afin(1)*
     &  hyc(h1)**2)
       enddo

c
c Neutral Higgs diagrams, top quark
c

       do h1=ihiggs,5
       afin(1)=(-3*M22**2*M42+3*M22*M42**2+3*M22**2*MSQ2-3*M42**2*MSQ2-
     &  3*M22*MSQ2**2+3*M42*MSQ2**2+4*M22*(-M42+MSQ2)*A0T(M22,Q2)+4*
     &  M42*(M22-MSQ2)*A0T(M42,Q2)-4*M22*MSQ2*A0T(MSQ2,Q2)+4*M42*MSQ2*
     &  A0T(MSQ2,Q2)-8*M42*MSQ2*AEpT(M22,Q2)+8*MSQ2**2*AEpT(M22,Q2)+8*
     &  M22*MSQ2*AEpT(M42,Q2)-8*MSQ2**2*AEpT(M42,Q2)-8*M22*MSQ2*
     &  AEpT(MSQ2,Q2)+8*M42*MSQ2*AEpT(MSQ2,Q2)+8*M42*MSQ2*
     &  I0A(M22,M22,Mah2(h1),Q2)-8*MSQ2**2*I0A(M22,M22,Mah2(h1),Q2)-8*
     &  M22*MSQ2*I0A(M22,M42,Mah2(h1),Q2)+8*MSQ2**2*
     &  I0A(M22,M42,Mah2(h1),Q2)+8*M22*MSQ2*I0A(M22,MSQ2,Mah2(h1),Q2)-
     &  8*M42*MSQ2*I0A(M22,MSQ2,Mah2(h1),Q2))/(8.*M22m42*M22mMSQ*
     &  M42mMSQ)
       afin(2)=(-3*M22**2*M42+3*M22*M42**2+3*M22**2*MSQ2-3*M42**2*MSQ2-
     &  3*M22*MSQ2**2+3*M42*MSQ2**2+4*M22*(-M42+MSQ2)*A0T(M22,Q2)+4*
     &  M42*(M22-MSQ2)*A0T(M42,Q2)-4*M22*MSQ2*A0T(MSQ2,Q2)+4*M42*MSQ2*
     &  A0T(MSQ2,Q2)-8*M42*MSQ2*AEpT(M22,Q2)+8*MSQ2**2*AEpT(M22,Q2)+8*
     &  M22*MSQ2*AEpT(M42,Q2)-8*MSQ2**2*AEpT(M42,Q2)-8*M22*MSQ2*
     &  AEpT(MSQ2,Q2)+8*M42*MSQ2*AEpT(MSQ2,Q2)+8*M42*MSQ2*
     &  I0A(M22,M42,Mah2(h1),Q2)-8*MSQ2**2*I0A(M22,M42,Mah2(h1),Q2)-8*
     &  M22*MSQ2*I0A(M42,M42,Mah2(h1),Q2)+8*MSQ2**2*
     &  I0A(M42,M42,Mah2(h1),Q2)+8*M22*MSQ2*I0A(M42,MSQ2,Mah2(h1),Q2)-
     &  8*M42*MSQ2*I0A(M42,MSQ2,Mah2(h1),Q2))/(8.*M22m42*M22mMSQ*
     &  M42mMSQ)
       afin(3)=(-16*a0t2*M22**3+4*M22**4-8*a0t2**2*M22*MSQ2+80*a0t2*
     &  M22**2*MSQ2-16*a0t5*M22**2*MSQ2-32*aet5*M22**2*MSQ2+24*M22**3*
     &  MSQ2+8*a0t2**2*MSQ2**2-48*a0t2*M22*MSQ2**2+32*aet2*M22*MSQ2**2-
     &  28*M22**2*MSQ2**2+8*(a0t2+M22)*(M22-MSQ2)*MSQ2*A0TNH(h1)-24*
     &  M22**2*MSQ2*I0A10(h1)-8*M22*MSQ2**2*I0A10(h1)+8*M22*MSQ2*
     &  I0A(M22,MSQ2,Mah2(h1),Q2)*(4*M22-Mah2(h1))+4*a0t2*M22**2*
     &  Mah2(h1)-M22**3*Mah2(h1)-16*a0t2*M22*MSQ2*Mah2(h1)+4*a0t5*M22*
     &  MSQ2*Mah2(h1)+8*aet5*M22*MSQ2*Mah2(h1)+6*M22**2*MSQ2*Mah2(h1)+
     &  8*a0t2*MSQ2**2*Mah2(h1)-8*aet2*MSQ2**2*Mah2(h1)-5*M22*MSQ2**2*
     &  Mah2(h1)+8*M22*MSQ2*I0A10(h1)*Mah2(h1))/(8.*M22*M22mMSQ**2*(4*
     &  M22-Mah2(h1)))
       afin(4)=(M2**10-4*a0t2*M22**4+8*a0t2*M22**3*M42-2*M22**4*M42-4*
     &  a0t2*M22**2*M42**2+M22**3*M42**2+24*a0t2*M22**3*MSQ2-4*a0t5*
     &  M22**3*MSQ2-8*aet5*M22**3*MSQ2+10*M22**4*MSQ2+8*a0t2*a0t4*M22*
     &  M22m42*MSQ2+8*a0t4*M22**2*M22m42*MSQ2-40*a0t2*M22**2*M42*MSQ2+
     &  8*a0t5*M22**2*M42*MSQ2+16*aet5*M22**2*M42*MSQ2-4*M22**3*M42*
     &  MSQ2+16*a0t2*M22*M42**2*MSQ2-4*a0t5*M22*M42**2*MSQ2-8*aet5*M22*
     &  M42**2*MSQ2-6*M22**2*M42**2*MSQ2-16*a0t2*M22**2*MSQ2**2+8*aet2*
     &  M22**2*MSQ2**2-11*M22**3*MSQ2**2-8*a0t2*a0t4*M22m42*MSQ2**2-8*
     &  a0t4*M22*M22m42*MSQ2**2+24*a0t2*M22*M42*MSQ2**2-16*aet2*M22*
     &  M42*MSQ2**2+6*M22**2*M42*MSQ2**2-8*a0t2*M42**2*MSQ2**2+8*aet2*
     &  M42**2*MSQ2**2+5*M22*M42**2*MSQ2**2+8*M22**2*M42*MSQ2*I0A11(h1)
     &  -8*M22*M42**2*MSQ2*I0A11(h1)-8*M22**2*MSQ2**2*I0A11(h1)+8*M22*
     &  M42*MSQ2**2*I0A11(h1)+8*a0t2*M22**3*Mah2(h1)-2*M22**4*Mah2(h1)+
     &  8*a0t2*M22**2*M42*Mah2(h1)-2*M22**3*M42*Mah2(h1)+8*a0t2*a0t4*
     &  M22*MSQ2*Mah2(h1)-40*a0t2*M22**2*MSQ2*Mah2(h1)-8*a0t4*M22**2*
     &  MSQ2*Mah2(h1)+8*a0t5*M22**2*MSQ2*Mah2(h1)+16*aet5*M22**2*MSQ2*
     &  Mah2(h1)-4*M22**3*MSQ2*Mah2(h1)-32*a0t2*M22*M42*MSQ2*Mah2(h1)+
     &  8*a0t5*M22*M42*MSQ2*Mah2(h1)+16*aet5*M22*M42*MSQ2*Mah2(h1)-20*
     &  M22**2*M42*MSQ2*Mah2(h1)-8*a0t2*a0t4*MSQ2**2*Mah2(h1)+24*a0t2*
     &  M22*MSQ2**2*Mah2(h1)+8*a0t4*M22*MSQ2**2*Mah2(h1)-16*aet2*M22*
     &  MSQ2**2*Mah2(h1)+6*M22**2*MSQ2**2*Mah2(h1)+16*a0t2*M42*MSQ2**2*
     &  Mah2(h1)-16*aet2*M42*MSQ2**2*Mah2(h1)+22*M22*M42*MSQ2**2*
     &  Mah2(h1)+8*M22**2*MSQ2*I0A11(h1)*Mah2(h1)+16*M22*M42*MSQ2*
     &  I0A11(h1)*Mah2(h1)+8*M22*MSQ2**2*I0A11(h1)*Mah2(h1)-4*a0t2*M22*
     &  *2*Mah2(h1)**2+M22**3*Mah2(h1)**2+16*a0t2*M22*MSQ2*Mah2(h1)**2-
     &  4*a0t5*M22*MSQ2*Mah2(h1)**2-8*aet5*M22*MSQ2*Mah2(h1)**2-6*M22**
     &  2*MSQ2*Mah2(h1)**2-8*a0t2*MSQ2**2*Mah2(h1)**2+8*aet2*MSQ2**2*
     &  Mah2(h1)**2+5*M22*MSQ2**2*Mah2(h1)**2-8*M22*MSQ2*I0A11(h1)*
     &  Mah2(h1)**2+8*(M22-MSQ2)*MSQ2*A0TNH(h1)*(M22*(-2*a0t4+M22-M42)+
     &  a0t2*(M22+M42)-(a0t2+M22)*Mah2(h1))+8*M22*MSQ2*
     &  I0A(M42,MSQ2,Mah2(h1),Q2)*((M22-M42)**2-2*(M22+M42)*Mah2(h1)+
     &  Mah2(h1)**2))/(8.*M22*M22mMSQ**2*alambda6(h1))
       afin(5)=(M4**10-4*a0t4*M22**2*M42**2+8*a0t4*M22*M42**3+M22**2*
     &  M42**3-4*a0t4*M42**4-2*M22*M42**4+16*a0t4*M22**2*M42*MSQ2-4*
     &  a0t5*M22**2*M42*MSQ2-8*aet5*M22**2*M42*MSQ2-8*a0t2*a0t4*M22m42*
     &  M42*MSQ2-40*a0t4*M22*M42**2*MSQ2+8*a0t5*M22*M42**2*MSQ2+16*
     &  aet5*M22*M42**2*MSQ2-6*M22**2*M42**2*MSQ2-8*a0t2*M22m42*M42**2*
     &  MSQ2+24*a0t4*M42**3*MSQ2-4*a0t5*M42**3*MSQ2-8*aet5*M42**3*MSQ2-
     &  4*M22*M42**3*MSQ2+10*M42**4*MSQ2-8*a0t4*M22**2*MSQ2**2+8*aet4*
     &  M22**2*MSQ2**2+8*a0t2*a0t4*M22m42*MSQ2**2+24*a0t4*M22*M42*MSQ2*
     &  *2-16*aet4*M22*M42*MSQ2**2+5*M22**2*M42*MSQ2**2+8*a0t2*M22m42*
     &  M42*MSQ2**2-16*a0t4*M42**2*MSQ2**2+8*aet4*M42**2*MSQ2**2+6*M22*
     &  M42**2*MSQ2**2-11*M42**3*MSQ2**2-8*M22**2*M42*MSQ2*I0A11(h1)+8*
     &  M22*M42**2*MSQ2*I0A11(h1)+8*M22*M42*MSQ2**2*I0A11(h1)-8*M42**2*
     &  MSQ2**2*I0A11(h1)+8*a0t4*M22*M42**2*Mah2(h1)+8*a0t4*M42**3*
     &  Mah2(h1)-2*M22*M42**3*Mah2(h1)-2*M42**4*Mah2(h1)+8*a0t2*a0t4*
     &  M42*MSQ2*Mah2(h1)-32*a0t4*M22*M42*MSQ2*Mah2(h1)+8*a0t5*M22*M42*
     &  MSQ2*Mah2(h1)+16*aet5*M22*M42*MSQ2*Mah2(h1)-8*a0t2*M42**2*MSQ2*
     &  Mah2(h1)-40*a0t4*M42**2*MSQ2*Mah2(h1)+8*a0t5*M42**2*MSQ2*
     &  Mah2(h1)+16*aet5*M42**2*MSQ2*Mah2(h1)-20*M22*M42**2*MSQ2*
     &  Mah2(h1)-4*M42**3*MSQ2*Mah2(h1)-8*a0t2*a0t4*MSQ2**2*Mah2(h1)+
     &  16*a0t4*M22*MSQ2**2*Mah2(h1)-16*aet4*M22*MSQ2**2*Mah2(h1)+8*
     &  a0t2*M42*MSQ2**2*Mah2(h1)+24*a0t4*M42*MSQ2**2*Mah2(h1)-16*aet4*
     &  M42*MSQ2**2*Mah2(h1)+22*M22*M42*MSQ2**2*Mah2(h1)+6*M42**2*MSQ2*
     &  *2*Mah2(h1)+16*M22*M42*MSQ2*I0A11(h1)*Mah2(h1)+8*M42**2*MSQ2*
     &  I0A11(h1)*Mah2(h1)+8*M42*MSQ2**2*I0A11(h1)*Mah2(h1)-4*a0t4*M42*
     &  *2*Mah2(h1)**2+M42**3*Mah2(h1)**2+16*a0t4*M42*MSQ2*Mah2(h1)**2-
     &  4*a0t5*M42*MSQ2*Mah2(h1)**2-8*aet5*M42*MSQ2*Mah2(h1)**2-6*M42**
     &  2*MSQ2*Mah2(h1)**2-8*a0t4*MSQ2**2*Mah2(h1)**2+8*aet4*MSQ2**2*
     &  Mah2(h1)**2+5*M42*MSQ2**2*Mah2(h1)**2-8*M42*MSQ2*I0A11(h1)*
     &  Mah2(h1)**2+8*(M42-MSQ2)*MSQ2*A0TNH(h1)*(M42*(-2*a0t2-M22+M42)+
     &  a0t4*(M22+M42)-(a0t4+M42)*Mah2(h1))+8*M42*MSQ2*
     &  I0A(M22,MSQ2,Mah2(h1),Q2)*((M22-M42)**2-2*(M22+M42)*Mah2(h1)+
     &  Mah2(h1)**2))/(8.*M42*M42mMSQ**2*alambda6(h1))
       afin(6)=(-16*a0t4*M42**3+4*M42**4-8*a0t4**2*M42*MSQ2+80*a0t4*
     &  M42**2*MSQ2-16*a0t5*M42**2*MSQ2-32*aet5*M42**2*MSQ2+24*M42**3*
     &  MSQ2+8*a0t4**2*MSQ2**2-48*a0t4*M42*MSQ2**2+32*aet4*M42*MSQ2**2-
     &  28*M42**2*MSQ2**2+8*(a0t4+M42)*(M42-MSQ2)*MSQ2*A0TNH(h1)-24*
     &  M42**2*MSQ2*I0A12(h1)-8*M42*MSQ2**2*I0A12(h1)+8*M42*MSQ2*
     &  I0A(M42,MSQ2,Mah2(h1),Q2)*(4*M42-Mah2(h1))+4*a0t4*M42**2*
     &  Mah2(h1)-M42**3*Mah2(h1)-16*a0t4*M42*MSQ2*Mah2(h1)+4*a0t5*M42*
     &  MSQ2*Mah2(h1)+8*aet5*M42*MSQ2*Mah2(h1)+6*M42**2*MSQ2*Mah2(h1)+
     &  8*a0t4*MSQ2**2*Mah2(h1)-8*aet4*MSQ2**2*Mah2(h1)-5*M42*MSQ2**2*
     &  Mah2(h1)+8*M42*MSQ2*I0A12(h1)*Mah2(h1))/(8.*M42*M42mMSQ**2*(4*
     &  M42-Mah2(h1)))
       selfW=selfW+(afin(3)*CSSS(h1,1,1)**2*ZU(1,1)*ZUC(1,1)+afin(2)*
     &  CSSS(h1,2,1)*CSSS(h1,2,2)*ZU(2,1)*ZUC(1,1)+afin(6)*CSSS(h1,2,2)
     &  **2*ZU(2,1)*ZUC(2,1)+CSSS(h1,1,1)*(afin(1)*CSSS(h1,2,1)*ZU(2,1)
     &  *ZUC(1,1)+afin(1)*CSSS(h1,1,2)*ZU(1,1)*ZUC(2,1))+CSSS(h1,1,2)*
     &  (afin(2)*CSSS(h1,2,2)*ZU(1,1)*ZUC(2,1)+CSSS(h1,2,1)*(afin(4)*
     &  ZU(1,1)*ZUC(1,1)+afin(5)*ZU(2,1)*ZUC(2,1))))

       enddo
c
c Neutral Higgs diagrams, stop quark
c
       afin(1)=(12*a0t1-8*aet1-(4*a0t1**2)/M12-M12)/8.
       afin(2)=(12*a0t1-24*aet1-(8*a0t1**2)/M12+5*M12+8*I0A(0D0,0D0,M12,Q2))/16.
       selfW=selfW+(afin(1)*hy(6)**2+afin(2)*hy(6)*hyc(6)+afin(1)*hyc(6)**2)

c
c Neutral Goldstone boson diagrams, top quark
c


       afin(1)=(-((MSQ2*(4*a0t2+4*a0t5+8*aet2+8*aet5-8*I0A19+3*M22+3*
     &  MSQ2))/(M22mMSQ*M42mMSQ))+(4*a0t2*M42+4*a0t4*M42+3*M22*M42+3*
     &  M42**2+8*aet2*MSQ2+8*aet4*MSQ2-8*I0A21*MSQ2)/(M22m42*M42mMSQ)-
     &  (2*(4*a0t2**2*MSQ2+4*a0t2*M22*(M22+2*MSQ2)+M22*(3*M22**2+8*
     &  aet2*MSQ2+8*M22*MSQ2)))/(M22*M22m42*M22mMSQ))/8.
       afin(2)=(-((MSQ2*(4*a0t4+4*a0t5+8*aet4+8*aet5-8*I0A20+3*M42+3*
     &  MSQ2))/(M22mMSQ*M42mMSQ))-(4*a0t2*M22+4*a0t4*M22+3*M22**2+3*
     &  M22*M42+8*aet2*MSQ2+8*aet4*MSQ2-8*I0A21*MSQ2)/(M22m42*M22mMSQ)+
     &  (2*(4*a0t4**2*MSQ2+4*a0t4*M42*(M42+2*MSQ2)+M42*(3*M42**2+8*
     &  aet4*MSQ2+8*M42*MSQ2)))/(M22m42*M42*M42mMSQ))/8.
       afin(3)=(4*a0t2**2*MSQ2*(M22+MSQ2)-4*a0t2*M22*(M22**2-8*M22*
     &  MSQ2+2*MSQ2**2)+M22*(M22**3+18*M22**2*MSQ2+8*aet2*MSQ2**2-M22*
     &  MSQ2*(4*a0t5+8*aet5-8*I0A19+3*MSQ2)))/(8.*M22**2*M22mMSQ**2)
       afin(4)=(M22**4-M22**3*(M42-10*MSQ2)+M22**2*(8*a0t4-4*a0t5-8*
     &  aet5+8*I0A20+6*M42-11*MSQ2)*MSQ2-8*aet2*M42*MSQ2**2+M22*MSQ2*
     &  (4*a0t5*M42+8*aet5*M42-8*I0A20*M42+8*I0A21*M42-8*a0t4*MSQ2+8*
     &  aet2*MSQ2-8*I0A21*MSQ2-5*M42*MSQ2)-4*a0t2*(M22**3+2*(a0t4-M42)*
     &  MSQ2**2-M22**2*(M42+6*MSQ2)+2*M22*MSQ2*(-a0t4+2*(M42+MSQ2))))
     &  /(8.*M22*M22m42*M22mMSQ**2)
       afin(5)=(-(M42*(M42**3+10*M42**2*MSQ2+M42*(8*a0t2-4*a0t5-8*aet5+
     &  8*I0A19-11*MSQ2)*MSQ2-8*(a0t2-aet4+I0A21)*MSQ2**2))+M22*(M42**
     &  3-6*M42**2*MSQ2+8*aet4*MSQ2**2+M42*MSQ2*(-4*a0t5-8*aet5+8*
     &  I0A19-8*I0A21+5*MSQ2))+4*a0t4*(M42**3-6*M42**2*MSQ2-2*M42*
     &  (a0t2-2*MSQ2)*MSQ2+2*a0t2*MSQ2**2-M22*(M42**2-4*M42*MSQ2+2*
     &  MSQ2**2)))/(8.*M22m42*M42*M42mMSQ**2)
      
       afin(6)=(4*a0t4**2*MSQ2*(M42+MSQ2)-4*a0t4*M42*(M42**2-8*M42*
     &  MSQ2+2*MSQ2**2)+M42*(M42**3+18*M42**2*MSQ2+8*aet4*MSQ2**2-M42*
     &  MSQ2*(4*a0t5+8*aet5-8*I0A20+3*MSQ2)))/(8.*M42**2*M42mMSQ**2)


       selfW=selfW+(afin(3)*CSSS(6,1,1)**2*ZU(1,1)*ZUC(1,1)+afin(2)*
     &  CSSS(6,2,1)*CSSS(6,2,2)*ZU(2,1)*ZUC(1,1)+afin(6)*CSSS(6,2,2)**
     &  2*ZU(2,1)*ZUC(2,1)+CSSS(6,1,1)*(afin(1)*CSSS(6,2,1)*ZU(2,1)*
     &  ZUC(1,1)+afin(1)*CSSS(6,1,2)*ZU(1,1)*ZUC(2,1))+CSSS(6,1,2)*
     &  (afin(2)*CSSS(6,2,2)*ZU(1,1)*ZUC(2,1)+CSSS(6,2,1)*(afin(4)*
     &  ZU(1,1)*ZUC(1,1)+afin(5)*ZU(2,1)*ZUC(2,1))))
c
c Neutral Goldstone boson diagrams, stop quark
c
c] neutral Higgs diagrams

c[charged Higgs diagrams
       afin(1)=(-4*a0t1-8*aet1-(4*a0t1**2)/M12-9*M12)/8.
       selfW=selfW+afin(1)*CTBS3(1)*CTBS3C(1)
c
c charged Goldstone boson diagrams, top quark
c

       afin(1)=(-(a0t5*M22)+aet5*M22+2*a0t5*MSQ2-aet5*MSQ2+I0A19*MSQ2+
     &  M22*MSQ2+MSQ2**2+a0t2*(a0t5+MSQ2))/(M22mMSQ*MSQ2)
       afin(2)=(-(a0t5*M42)+aet5*M42+2*a0t5*MSQ2-aet5*MSQ2+I0A20*MSQ2+
     &  M42*MSQ2+MSQ2**2+a0t4*(a0t5+MSQ2))/(M42mMSQ*MSQ2)
       afin(3)=(-((4*a0t2*M22+4*a0t5*M22+3*M22**2+8*aet2*MSQ2+8*aet5*
     &  MSQ2-8*I0A19*MSQ2+3*M22*MSQ2)/(M22m42*M22mMSQ))+(4*a0t4*M42+4*
     &  a0t5*M42+3*M42**2+8*aet4*MSQ2+8*aet5*MSQ2-8*I0A20*MSQ2+3*M42*
     &  MSQ2)/(M22m42*M42mMSQ)-(2*(4*a0t5**2+12*a0t5*MSQ2+MSQ2*(8*aet5+
     &  11*MSQ2)))/(M22mMSQ*M42mMSQ))/8.
       afin(4)=-(4*a0t2**2*M22+4*a0t5**2*M22+4*a0t2*(3*M22**2-4*M22*
     &  MSQ2+MSQ2**2-a0t5*(M22+MSQ2))+(M22-MSQ2)*(M22*(-8*aet5+4*I0A19+
     &  9*M22-MSQ2)+4*aet2*(M22+MSQ2)))/(4.*M22*M22mMSQ**2)
       afin(5)=(-8*aet4*M22*M42+16*aet5*M22*M42-8*I0A19*M22*M42+8*
     &  I0A21*M22*M42-3*M22*M42**2+4*a0t5*M22*MSQ2-8*aet5*M22*MSQ2+8*
     &  a0t5*M42*MSQ2+8*aet4*M42*MSQ2-16*aet5*M42*MSQ2+16*I0A19*M42*
     &  MSQ2-8*I0A21*M42*MSQ2+10*M22*M42*MSQ2+3*M42**2*MSQ2-12*a0t5*
     &  MSQ2**2+8*aet5*MSQ2**2-8*I0A19*MSQ2**2-7*M22*MSQ2**2+6*M42*
     &  MSQ2**2-9*MSQ2**3+8*a0t2*(M42-MSQ2)*(a0t5+MSQ2)+4*a0t4*M42*(-
     &  M22+MSQ2))/(8.*M22mMSQ*M42mMSQ**2)
       afin(6)=-(4*a0t4**2*M42+4*a0t5**2*M42+4*a0t4*(3*M42**2-4*M42*
     &  MSQ2+MSQ2**2-a0t5*(M42+MSQ2))+(M42-MSQ2)*(M42*(-8*aet5+4*I0A20+
     &  9*M42-MSQ2)+4*aet4*(M42+MSQ2)))/(4.*M42*M42mMSQ**2)
       afin(7)=(-8*aet2*M22*M42+16*aet5*M22*M42-8*I0A20*M22*M42+8*
     &  I0A21*M22*M42-3*M22**2*M42+8*a0t5*M22*MSQ2+8*aet2*M22*MSQ2-16*
     &  aet5*M22*MSQ2+16*I0A20*M22*MSQ2-8*I0A21*M22*MSQ2+3*M22**2*MSQ2+
     &  4*a0t5*M42*MSQ2-8*aet5*M42*MSQ2+10*M22*M42*MSQ2-12*a0t5*MSQ2**
     &  2+8*aet5*MSQ2**2-8*I0A20*MSQ2**2+6*M22*MSQ2**2-7*M42*MSQ2**2-9*
     &  MSQ2**3+8*a0t4*(M22-MSQ2)*(a0t5+MSQ2)+4*a0t2*M22*(-M42+MSQ2))
     &  /(8.*M22mMSQ**2*M42mMSQ)
       selfW=selfW+(CS3S13S(1,1)*(afin(3)*CS3S13SC(1,2)*ZU(1,1)*
     &  ZUC(2,1)+CS3S13SC(1,1)*(afin(1)+afin(4)*ZU(1,1)*ZUC(1,1)+
     &  afin(5)*ZU(2,1)*ZUC(2,1)))+CS3S13S(1,2)*(afin(3)*CS3S13SC(1,1)*
     &  ZU(2,1)*ZUC(1,1)+CS3S13SC(1,2)*(afin(2)+afin(7)*ZU(1,1)*
     &  ZUC(1,1)+afin(6)*ZU(2,1)*ZUC(2,1))))

c
c charged Goldstone boson diagrams, stop quark
c
       afin(1)=(4*a0t1**2+12*a0t1*M12+12*A0THp*M12-8*aet1*M12-8*AETHp*
     &  M12+8*I0A14*M12+7*M12**2-4*I0A14*MHp2+8*I0A6*MHp2+5*M12*MHp2-4*
     &  MHp2*I0A(0D0,0D0,MHp2,Q2))/(8.*M12)
       selfW=selfW+CTBS3(2)*afin(1)*CTBS3C(2)

c
c charged Higgs boson diagrams, top quark
c

       afin(1)=(aet5*M22**2-2*aet5*M22*MHp2+aet5*MHp2**2+A0THp*M22*
     &  MSQ2-2*aet5*M22*MSQ2+I0A7*M22*MSQ2+M22**2*MSQ2+A0THp*MHp2*MSQ2-
     &  2*aet5*MHp2*MSQ2+I0A7*MHp2*MSQ2+2*M22*MHp2*MSQ2+MHp2**2*MSQ2-
     &  A0THp*MSQ2**2+aet5*MSQ2**2-I0A7*MSQ2**2-MSQ2**3+a0t2*(a0t5*
     &  (M22-MHp2-MSQ2)+(2*A0THp+M22+MHp2-MSQ2)*MSQ2)-a0t5*(M22**2-2*
     &  M22*MHp2+MHp2**2-3*M22*MSQ2-3*MHp2*MSQ2+2*MSQ2**2+A0THp*(M22-
     &  MHp2+MSQ2)))/(alambda4*MSQ2)
       afin(2)=(aet5*M42**2-2*aet5*M42*MHp2+aet5*MHp2**2+A0THp*M42*
     &  MSQ2-2*aet5*M42*MSQ2+I0A8*M42*MSQ2+M42**2*MSQ2+A0THp*MHp2*MSQ2-
     &  2*aet5*MHp2*MSQ2+I0A8*MHp2*MSQ2+2*M42*MHp2*MSQ2+MHp2**2*MSQ2-
     &  A0THp*MSQ2**2+aet5*MSQ2**2-I0A8*MSQ2**2-MSQ2**3+a0t4*(a0t5*
     &  (M42-MHp2-MSQ2)+(2*A0THp+M42+MHp2-MSQ2)*MSQ2)-a0t5*(M42**2-2*
     &  M42*MHp2+MHp2**2-3*M42*MSQ2-3*MHp2*MSQ2+2*MSQ2**2+A0THp*(M42-
     &  MHp2+MSQ2)))/(alambda5*MSQ2)
       afin(3)=(-3*M22**2*M42+3*M22*M42**2+4*a0t4*M42*(M22-MSQ2)-4*
     &  a0t5*M22*MSQ2+8*aet4*M22*MSQ2-8*aet5*M22*MSQ2+8*I0A24*M22*MSQ2-
     &  8*I0A8*M22*MSQ2+3*M22**2*MSQ2+4*a0t5*M42*MSQ2-8*aet2*M42*MSQ2+
     &  8*aet5*M42*MSQ2-8*I0A24*M42*MSQ2+8*I0A7*M42*MSQ2-3*M42**2*MSQ2+
     &  8*aet2*MSQ2**2-8*aet4*MSQ2**2-8*I0A7*MSQ2**2+8*I0A8*MSQ2**2-3*
     &  M22*MSQ2**2+3*M42*MSQ2**2+4*a0t2*M22*(-M42+MSQ2))/(8.*M22m42*
     &  M22mMSQ*M42mMSQ)
       afin(4)=-(M2**10+4*aet2*M22**4-8*aet5*M22**4-4*I0A22*M22**4+4*
     &  I0A7*M22**4-8*aet2*M22**3*MHp2+16*aet5*M22**3*MHp2+8*I0A22*M22*
     &  *3*MHp2-8*I0A7*M22**3*MHp2-2*M22**4*MHp2+4*aet2*M22**2*MHp2**2-
     &  8*aet5*M22**2*MHp2**2-4*I0A22*M22**2*MHp2**2+4*I0A7*M22**2*
     &  MHp2**2+M22**3*MHp2**2-8*a0t5*M22**3*MSQ2-8*aet2*M22**3*MSQ2+
     &  24*aet5*M22**3*MSQ2+8*I0A22*M22**3*MSQ2-4*I0A24*M22**3*MSQ2-12*
     &  I0A7*M22**3*MSQ2-12*M22**4*MSQ2-8*aet2*M22**2*MHp2*MSQ2+8*
     &  I0A22*M22**2*MHp2*MSQ2+8*I0A24*M22**2*MHp2*MSQ2-16*I0A7*M22**2*
     &  MHp2*MSQ2-6*M22**3*MHp2*MSQ2+8*aet5*M22*MHp2**2*MSQ2-4*I0A24*
     &  M22*MHp2**2*MSQ2+4*I0A7*M22*MHp2**2*MSQ2-2*M22**2*MHp2**2*MSQ2+
     &  16*a0t5*M22**2*MSQ2**2-24*aet5*M22**2*MSQ2**2-4*I0A22*M22**2*
     &  MSQ2**2+8*I0A24*M22**2*MSQ2**2+12*I0A7*M22**2*MSQ2**2+14*M22**
     &  3*MSQ2**2+8*aet2*M22*MHp2*MSQ2**2-16*aet5*M22*MHp2*MSQ2**2+8*
     &  I0A24*M22*MHp2*MSQ2**2-8*I0A7*M22*MHp2*MSQ2**2+18*M22**2*MHp2*
     &  MSQ2**2-4*aet2*MHp2**2*MSQ2**2+M22*MHp2**2*MSQ2**2-8*a0t5*M22*
     &  MSQ2**3+8*aet2*M22*MSQ2**3+8*aet5*M22*MSQ2**3-4*I0A24*M22*MSQ2*
     &  *3-4*I0A7*M22*MSQ2**3+4*M22**2*MSQ2**3+8*aet2*MHp2*MSQ2**3-10*
     &  M22*MHp2*MSQ2**3-4*aet2*MSQ2**4-7*M22*MSQ2**4-4*A0THp*M22*(M22-
     &  MSQ2)*(a0t5*(-M22+MHp2-3*MSQ2)+2*(M22-MSQ2)*MSQ2)+4*a0t2*(M22-
     &  MSQ2)*(-(A0THp*MSQ2*(3*M22-MHp2+MSQ2))+(M22-MSQ2)*(M22**2+
     &  (MHp2-MSQ2)**2-a0t5*(M22-MHp2+MSQ2)-2*M22*(MHp2+2*MSQ2))))/(4.*
     &  alambda4*M22*M22mMSQ**2)
       afin(5)=-(M42*(4*a0t2+4*a0t4+4*A0THp+8*aet2+8*aet4+8*AETHp-8*
     &  I0A25+3*M22+3*M42+3*MHp2)+(4*(-4*a0t2*A0THp+2*A0THp*M22-4*
     &  AETHp*M22+2*a0t2*MHp2-4*aet2*MHp2+M22*MHp2)*(M42-MSQ2)*
     &  MSQ2)/alambda4-(2*(M42-MSQ2)*(-M22+MHp2+MSQ2)*(-4*a0t2*
     &  a0t5+2*a0t5*M22-4*aet5*M22+2*a0t2*MSQ2-4*aet2*MSQ2+M22*MSQ2))
     &  /alambda4-(2*(M42-MSQ2)*(M22-MHp2+MSQ2)*(-4*aet5*MHp2+
     &  a0t5*(-4*A0THp+2*MHp2)+(2*A0THp-4*AETHp+MHp2)*MSQ2))/alambda4+
     &  (8*(-((aet2+aet5+AETHp-I0A7)*(M22**2*M42+(MHp2-MSQ2)*(M42*
     &  (MHp2-2*MSQ2)+MSQ2**2)+M22*(-2*M42*MHp2-3*M42*MSQ2+MSQ2**2)))-
     &  ((M22+MHp2+MSQ2)*(M22**2*M42+M22*(-3*MSQ2**2+M42*(-2*MHp2+MSQ2)
     &  )+(MHp2-MSQ2)*(-3*MSQ2**2+M42*(MHp2+2*MSQ2))))/8.-((2*a0t2+2*
     &  a0t5+2*A0THp+M22+MHp2+MSQ2)*(M22**2*M42+M22*(-3*MSQ2**2+M42*(-
     &  2*MHp2+MSQ2))+(MHp2-MSQ2)*(-3*MSQ2**2+M42*(MHp2+2*MSQ2))))/4.))
     &  /alambda4)/(8.*M42mMSQ**2)
       afin(6)=-(M4**10+4*aet4*M42**4-8*aet5*M42**4-4*I0A23*M42**4+4*
     &  I0A8*M42**4-8*aet4*M42**3*MHp2+16*aet5*M42**3*MHp2+8*I0A23*M42*
     &  *3*MHp2-8*I0A8*M42**3*MHp2-2*M42**4*MHp2+4*aet4*M42**2*MHp2**2-
     &  8*aet5*M42**2*MHp2**2-4*I0A23*M42**2*MHp2**2+4*I0A8*M42**2*
     &  MHp2**2+M42**3*MHp2**2-8*a0t5*M42**3*MSQ2-8*aet4*M42**3*MSQ2+
     &  24*aet5*M42**3*MSQ2+8*I0A23*M42**3*MSQ2-4*I0A24*M42**3*MSQ2-12*
     &  I0A8*M42**3*MSQ2-12*M42**4*MSQ2-8*aet4*M42**2*MHp2*MSQ2+8*
     &  I0A23*M42**2*MHp2*MSQ2+8*I0A24*M42**2*MHp2*MSQ2-16*I0A8*M42**2*
     &  MHp2*MSQ2-6*M42**3*MHp2*MSQ2+8*aet5*M42*MHp2**2*MSQ2-4*I0A24*
     &  M42*MHp2**2*MSQ2+4*I0A8*M42*MHp2**2*MSQ2-2*M42**2*MHp2**2*MSQ2+
     &  16*a0t5*M42**2*MSQ2**2-24*aet5*M42**2*MSQ2**2-4*I0A23*M42**2*
     &  MSQ2**2+8*I0A24*M42**2*MSQ2**2+12*I0A8*M42**2*MSQ2**2+14*M42**
     &  3*MSQ2**2+8*aet4*M42*MHp2*MSQ2**2-16*aet5*M42*MHp2*MSQ2**2+8*
     &  I0A24*M42*MHp2*MSQ2**2-8*I0A8*M42*MHp2*MSQ2**2+18*M42**2*MHp2*
     &  MSQ2**2-4*aet4*MHp2**2*MSQ2**2+M42*MHp2**2*MSQ2**2-8*a0t5*M42*
     &  MSQ2**3+8*aet4*M42*MSQ2**3+8*aet5*M42*MSQ2**3-4*I0A24*M42*MSQ2*
     &  *3-4*I0A8*M42*MSQ2**3+4*M42**2*MSQ2**3+8*aet4*MHp2*MSQ2**3-10*
     &  M42*MHp2*MSQ2**3-4*aet4*MSQ2**4-7*M42*MSQ2**4-4*A0THp*M42*(M42-
     &  MSQ2)*(a0t5*(-M42+MHp2-3*MSQ2)+2*(M42-MSQ2)*MSQ2)+4*a0t4*(M42-
     &  MSQ2)*(-(A0THp*MSQ2*(3*M42-MHp2+MSQ2))+(M42-MSQ2)*(M42**2+
     &  (MHp2-MSQ2)**2-a0t5*(M42-MHp2+MSQ2)-2*M42*(MHp2+2*MSQ2))))/(4.*
     &  alambda5*M42*M42mMSQ**2)
       afin(7)=-(M22*(4*a0t2+4*a0t4+4*A0THp+8*aet2+8*aet4+8*AETHp-8*
     &  I0A25+3*M22+3*M42+3*MHp2)+(4*(-4*a0t4*A0THp+2*A0THp*M42-4*
     &  AETHp*M42+2*a0t4*MHp2-4*aet4*MHp2+M42*MHp2)*(M22-MSQ2)*
     &  MSQ2)/alambda5-(2*(M22-MSQ2)*(-M42+MHp2+MSQ2)*(-4*a0t4*
     &  a0t5+2*a0t5*M42-4*aet5*M42+2*a0t4*MSQ2-4*aet4*MSQ2+M42*MSQ2))
     &  /alambda5-(2*(M22-MSQ2)*(M42-MHp2+MSQ2)*(-4*aet5*MHp2+
     &  a0t5*(-4*A0THp+2*MHp2)+(2*A0THp-4*AETHp+MHp2)*MSQ2))/alambda5+
     &  (8*(-((aet4+aet5+AETHp-I0A8)*((M42+MHp2-MSQ2)*MSQ2**2+M22*(M42*
     &  *2-2*M42*MHp2+MHp2**2-3*M42*MSQ2-3*MHp2*MSQ2+2*MSQ2**2)))-
     &  ((M42+MHp2+MSQ2)*(3*MSQ2**2*(-M42-MHp2+MSQ2)+M22*(M42**2+MHp2**
     &  2+MHp2*MSQ2-2*MSQ2**2+M42*(-2*MHp2+MSQ2))))/8.-((2*a0t4+2*a0t5+
     &  2*A0THp+M42+MHp2+MSQ2)*(3*MSQ2**2*(-M42-MHp2+MSQ2)+M22*(M42**2+
     &  MHp2**2+MHp2*MSQ2-2*MSQ2**2+M42*(-2*MHp2+MSQ2))))/4.))
     &  /alambda5)/(8.*M22mMSQ**2)
       selfW=selfW+(afin(1)*CS3S13S14(1)*CS3S14S13(1)+afin(2)*
     &  CS3S13S14(2)*CS3S14S13(2)+ZU(1,1)*((afin(4)*CS3S13S14(1)*
     &  CS3S14S13(1)+afin(7)*CS3S13S14(2)*CS3S14S13(2))*ZUC(1,1)+
     &  afin(3)*CS3S13S14(1)*CS3S14S13(2)*ZUC(2,1))+ZU(2,1)*(afin(3)*
     &  CS3S13S14(2)*CS3S14S13(1)*ZUC(1,1)+(afin(5)*CS3S13S14(1)*
     &  CS3S14S13(1)+afin(6)*CS3S13S14(2)*CS3S14S13(2))*ZUC(2,1)))

c
c "charged Higgs boson diagrams, stop quark" 
c

c]charged Higgs diagrams
c[ chargino diagrams
       afin(1)=(((MCha2-MSQ2)*MSQ2*(4*a0t5+4*a0tcha+8*aet5+8*
     &  aetcha-8*I0A15+3*MCha2+3*MSQ2))/(M22mMSQ*M42mMSQ)-((M2-MCha)*
     &  (M2+MCha)*(4*a0t2*M22+4*a0tcha*M22+3*M22**2+3*M22*MCha2+8*aet2*
     &  MSQ2+8*aetcha*MSQ2-8*I0A2*MSQ2))/(M22m42*M22mMSQ)+((M4-MCha)*
     &  (M4+MCha)*(4*a0t4*M42+4*a0tcha*M42+3*M42**2+3*M42*MCha2+8*aet4*
     &  MSQ2+8*aetcha*MSQ2-8*I0A3*MSQ2))/(M22m42*M42mMSQ)+(4*a0tcha*
     &  M22**2+4*a0t2*M22*MCha2+2*M22**2*MCha2+8*a0t2*a0tcha*MSQ2+8*
     &  aetcha*M22*MSQ2+8*aet2*MCha2*MSQ2)/(M22m42*M22mMSQ)+(2*MSQ2*(4*
     &  aet5*MCha2+2*a0t5*(2*a0tcha+MCha2)+(2*a0tcha+4*aetcha+MCha2)*
     &  MSQ2))/(M22mMSQ*M42mMSQ)-(2*(2*a0t4*M42*MCha2+M42**2*MCha2+4*
     &  aetcha*M42*MSQ2+4*aet4*MCha2*MSQ2+2*a0tcha*(M42**2+2*a0t4*MSQ2)
     &  ))/(M22m42*M42mMSQ))/8.
       afin(2)=(-2*M22**4+4*M22**2*(-2*aet2+2*I0A2+3*MCha2-2*MSQ2)*
     &  MSQ2-16*aet2*MCha2*MSQ2**2+M22**3*(-6*MCha2+13*MSQ2)+M22*MSQ2*
     &  (8*a0t5*a0tcha+8*a0t5*MCha2+16*aet5*MCha2-8*I0A15*MCha2+8*I0A2*
     &  MCha2-4*a0t5*MSQ2+16*aet2*MSQ2-8*aet5*MSQ2+8*I0A15*MSQ2-16*
     &  I0A2*MSQ2-6*MCha2*MSQ2-3*MSQ2**2)-4*a0t2*(2*M22**3+4*(a0tcha-
     &  MCha2)*MSQ2**2+2*M22*MSQ2*(-a0tcha+4*MCha2+2*MSQ2)-M22**2*(2*
     &  MCha2+7*MSQ2)))/(8.*M22*M22mMSQ**2)
       afin(3)=(-2*M42**4+4*M42**2*(-2*aet4+2*I0A3+3*MCha2-2*MSQ2)*
     &  MSQ2-16*aet4*MCha2*MSQ2**2+M42**3*(-6*MCha2+13*MSQ2)+M42*MSQ2*
     &  (8*a0t5*a0tcha+8*a0t5*MCha2+16*aet5*MCha2-8*I0A15*MCha2+8*I0A3*
     &  MCha2-4*a0t5*MSQ2+16*aet4*MSQ2-8*aet5*MSQ2+8*I0A15*MSQ2-16*
     &  I0A3*MSQ2-6*MCha2*MSQ2-3*MSQ2**2)-4*a0t4*(2*M42**3+4*(a0tcha-
     &  MCha2)*MSQ2**2+2*M42*MSQ2*(-a0tcha+4*MCha2+2*MSQ2)-M42**2*(2*
     &  MCha2+7*MSQ2)))/(8.*M42*M42mMSQ**2)
       selfW=selfW+(CF12F4S(1)*(afin(2)*CF12F4SC(1)*ZU(1,1)*ZUC(1,1)+
     &  afin(1)*CF12F4SC(2)*ZU(2,1)*ZUC(1,1))+CF12F4S(2)*(afin(1)*
     &  CF12F4SC(1)*ZU(1,1)*ZUC(2,1)+afin(3)*CF12F4SC(2)*ZU(2,1)*
     &  ZUC(2,1)))

c
c chargino diagrams, stop quark" 
c

       afin(1)=(-32*aet5*M12**4+32*aet5*M12**3*MCha2+32*aet5*M12**2*
     &  MCha2**2-32*aet5*M12*MCha2**3-8*aet1*M12**3*MSQ2+96*aet5*M12**
     &  3*MSQ2-24*I0A1*M12**3*MSQ2-9*M12**4*MSQ2-48*a0tcha*M12**2*
     &  MCha2*MSQ2+16*aet1*M12**2*MCha2*MSQ2+64*aet5*M12**2*MCha2*MSQ2-
     &  8*I0A1*M12**2*MCha2*MSQ2+8*I0A15*M12**2*MCha2*MSQ2-38*M12**3*
     &  MCha2*MSQ2-16*a0tcha*M12*MCha2**2*MSQ2-8*aet1*M12*MCha2**2*
     &  MSQ2+96*aet5*M12*MCha2**2*MSQ2-24*I0A1*M12*MCha2**2*MSQ2-16*
     &  I0A15*M12*MCha2**2*MSQ2-57*M12**2*MCha2**2*MSQ2-8*I0A1*MCha2**
     &  3*MSQ2+8*I0A15*MCha2**3*MSQ2-24*M12*MCha2**3*MSQ2+16*aet1*M12**
     &  2*MSQ2**2-96*aet5*M12**2*MSQ2**2+56*I0A1*M12**2*MSQ2**2-8*
     &  I0A15*M12**2*MSQ2**2+10*M12**3*MSQ2**2+16*a0tcha*M12*MCha2*
     &  MSQ2**2+16*aet1*M12*MCha2*MSQ2**2-96*aet5*M12*MCha2*MSQ2**2+64*
     &  I0A1*M12*MCha2*MSQ2**2+18*M12**2*MCha2*MSQ2**2+24*I0A1*MCha2**
     &  2*MSQ2**2-24*I0A15*MCha2**2*MSQ2**2+8*M12*MCha2**2*MSQ2**2-8*
     &  aet1*M12*MSQ2**3+32*aet5*M12*MSQ2**3-40*I0A1*M12*MSQ2**3+16*
     &  I0A15*M12*MSQ2**3+7*M12**2*MSQ2**3-24*I0A1*MCha2*MSQ2**3+24*
     &  I0A15*MCha2*MSQ2**3+24*M12*MCha2*MSQ2**3+8*I0A1*MSQ2**4-8*
     &  I0A15*MSQ2**4-8*M12*MSQ2**4+16*a0t5*M12*(2*M12**3-M12**2*(2*
     &  MCha2+5*MSQ2)+(MCha2-MSQ2)*(-2*a0tcha*MCha2+2*MCha2**2+a0tcha*
     &  MSQ2-4*MCha2*MSQ2+MSQ2**2)+M12*(2*a0tcha*MCha2-2*MCha2**2+
     &  a0tcha*MSQ2-9*MCha2*MSQ2+4*MSQ2**2))-4*a0t1*(2*a0t5*(4*M12**3-
     &  (-(MCha2)+MSQ2)**2*MSQ2+6*M12*MSQ2*(-MCha2+MSQ2)-M12**2*(4*
     &  MCha2+9*MSQ2))+MSQ2*(2*a0tcha*(3*M12**2+4*M12*(MCha2-MSQ2)+
     &  (MCha2-MSQ2)**2)-M12*(5*M12**2+MCha2**2-6*MCha2*MSQ2+5*MSQ2**2-
     &  2*M12*(11*MCha2+5*MSQ2)))))/(16.*alambda1*M12*MSQ2)
       afin(2)=(8*a0t2*M12-8*aet1*M12-16*aet2*M12+3*M12**2+a0t1*(-8*
     &  a0t2+8*a0tcha+4*M12)+8*I0A2*M22+2*M12*M22-8*I0A2*MCha2+4*M12*
     &  MCha2+8*(M12-M22+MCha2)*I0A(M12,M22,MCha2,Q2))/(16.*M12)
       afin(3)=(8*a0t4*M12-8*aet1*M12-16*aet4*M12+3*M12**2+a0t1*(-8*
     &  a0t4+8*a0tcha+4*M12)+8*I0A3*M42+2*M12*M42-8*I0A3*MCha2+4*M12*
     &  MCha2+8*(M12-M42+MCha2)*I0A(M12,M42,MCha2,Q2))/(16.*M12)
       afin(4)=(8*a0t2*a0tcha*M12**2*M22-8*a0t5*a0tcha*M12**2*M22+8*
     &  a0t2*M12**3*M22+16*aet2*M12**3*M22-32*aet5*M12**3*M22+8*I0A1*
     &  M12**3*M22-4*a0t2*M12**2*M22**2-8*aet2*M12**2*M22**2+2*M12**3*
     &  M22**2-3*M12**2*M22**3-16*a0t2*a0tcha*M12*M22*MCha2+32*a0t5*
     &  a0tcha*M12*M22*MCha2-8*a0t2*M12**2*M22*MCha2-16*aet2*M12**2*
     &  M22*MCha2+32*aet5*M12**2*M22*MCha2-8*I0A1*M12**2*M22*MCha2+8*
     &  a0t2*M12*M22**2*MCha2+16*aet2*M12*M22**2*MCha2-2*M12**2*M22**2*
     &  MCha2+6*M12*M22**3*MCha2+8*a0t2*a0tcha*M22*MCha2**2-24*a0t5*
     &  a0tcha*M22*MCha2**2-8*a0t2*M12*M22*MCha2**2-16*aet2*M12*M22*
     &  MCha2**2+32*aet5*M12*M22*MCha2**2-8*I0A1*M12*M22*MCha2**2-4*
     &  a0t2*M22**2*MCha2**2-8*aet2*M22**2*MCha2**2-2*M12*M22**2*MCha2*
     &  *2-3*M22**3*MCha2**2+8*a0t2*M22*MCha2**3+16*aet2*M22*MCha2**3-
     &  32*aet5*M22*MCha2**3+8*I0A1*M22*MCha2**3+2*M22**2*MCha2**3-8*
     &  a0t5*M12**3*MSQ2+16*aet5*M12**3*MSQ2-16*a0t2*a0tcha*M12*M22*
     &  MSQ2+32*a0t5*a0tcha*M12*M22*MSQ2-16*a0t2*M12**2*M22*MSQ2-4*
     &  a0t5*M12**2*M22*MSQ2-32*aet2*M12**2*M22*MSQ2+88*aet5*M12**2*
     &  M22*MSQ2-40*I0A1*M12**2*M22*MSQ2-4*M12**3*M22*MSQ2+8*a0t2*M12*
     &  M22**2*MSQ2+16*aet2*M12*M22**2*MSQ2-4*M12**2*M22**2*MSQ2+6*M12*
     &  M22**3*MSQ2-16*a0t5*a0tcha*M12*MCha2*MSQ2+8*a0t5*M12**2*MCha2*
     &  MSQ2-16*aet5*M12**2*MCha2*MSQ2-16*a0t2*a0tcha*M22*MCha2*MSQ2+
     &  48*a0t5*a0tcha*M22*MCha2*MSQ2-32*a0t2*M12*M22*MCha2*MSQ2-24*
     &  a0t5*M12*M22*MCha2*MSQ2-32*a0tcha*M12*M22*MCha2*MSQ2-64*aet2*
     &  M12*M22*MCha2*MSQ2+80*aet5*M12*M22*MCha2*MSQ2-16*I0A1*M12*M22*
     &  MCha2*MSQ2-28*M12**2*M22*MCha2*MSQ2+8*a0t2*M22**2*MCha2*MSQ2+
     &  16*aet2*M22**2*MCha2*MSQ2-8*M12*M22**2*MCha2*MSQ2+6*M22**3*
     &  MCha2*MSQ2+16*a0t5*a0tcha*MCha2**2*MSQ2+8*a0t5*M12*MCha2**2*
     &  MSQ2-16*aet5*M12*MCha2**2*MSQ2-16*a0t2*M22*MCha2**2*MSQ2-4*
     &  a0t5*M22*MCha2**2*MSQ2-32*aet2*M22*MCha2**2*MSQ2+88*aet5*M22*
     &  MCha2**2*MSQ2-40*I0A1*M22*MCha2**2*MSQ2-28*M12*M22*MCha2**2*
     &  MSQ2-4*M22**2*MCha2**2*MSQ2-8*a0t5*MCha2**3*MSQ2+16*aet5*MCha2*
     &  *3*MSQ2-4*M22*MCha2**3*MSQ2-16*a0t5*a0tcha*M12*MSQ2**2+24*a0t5*
     &  M12**2*MSQ2**2-48*aet5*M12**2*MSQ2**2+16*I0A1*M12**2*MSQ2**2+2*
     &  M12**3*MSQ2**2+8*a0t2*a0tcha*M22*MSQ2**2-24*a0t5*a0tcha*M22*
     &  MSQ2**2+8*a0t2*M12*M22*MSQ2**2+8*a0t5*M12*M22*MSQ2**2+16*aet2*
     &  M12*M22*MSQ2**2-80*aet5*M12*M22*MSQ2**2+56*I0A1*M12*M22*MSQ2**
     &  2+5*M12**2*M22*MSQ2**2-4*a0t2*M22**2*MSQ2**2-8*aet2*M22**2*
     &  MSQ2**2+2*M12*M22**2*MSQ2**2-3*M22**3*MSQ2**2-32*a0t5*a0tcha*
     &  MCha2*MSQ2**2+48*a0t5*M12*MCha2*MSQ2**2+32*a0tcha*M12*MCha2*
     &  MSQ2**2-32*aet5*M12*MCha2*MSQ2**2+30*M12**2*MCha2*MSQ2**2+8*
     &  a0t2*M22*MCha2*MSQ2**2+8*a0t5*M22*MCha2*MSQ2**2+16*aet2*M22*
     &  MCha2*MSQ2**2-80*aet5*M22*MCha2*MSQ2**2+56*I0A1*M22*MCha2*MSQ2*
     &  *2-10*M12*M22*MCha2*MSQ2**2+2*M22**2*MCha2*MSQ2**2+24*a0t5*
     &  MCha2**2*MSQ2**2-48*aet5*MCha2**2*MSQ2**2+16*I0A1*MCha2**2*
     &  MSQ2**2+30*M12*MCha2**2*MSQ2**2+5*M22*MCha2**2*MSQ2**2+2*MCha2*
     &  *3*MSQ2**2+16*a0t5*a0tcha*MSQ2**3-24*a0t5*M12*MSQ2**3+48*aet5*
     &  M12*MSQ2**3-32*I0A1*M12*MSQ2**3+2*M12**2*MSQ2**3-4*a0t5*M22*
     &  MSQ2**3+24*aet5*M22*MSQ2**3-24*I0A1*M22*MSQ2**3+2*M12*M22*MSQ2*
     &  *3-24*a0t5*MCha2*MSQ2**3+48*aet5*MCha2*MSQ2**3-32*I0A1*MCha2*
     &  MSQ2**3+12*M12*MCha2*MSQ2**3+2*M22*MCha2*MSQ2**3+2*MCha2**2*
     &  MSQ2**3+8*a0t5*MSQ2**4-16*aet5*MSQ2**4+16*I0A1*MSQ2**4-10*M12*
     &  MSQ2**4-3*M22*MSQ2**4-10*MCha2*MSQ2**4+6*MSQ2**5+8*a0t1*(-2*(2*
     &  M12*MCha2+a0tcha*(M12+MCha2-MSQ2))*(M22-MSQ2)*MSQ2+a0t2*M22*
     &  (M12**2+(MCha2-MSQ2)**2-2*M12*(MCha2+MSQ2))-a0t5*(M12**2*(3*
     &  M22-2*MSQ2)+(MCha2-MSQ2)*(M22*MCha2-3*M22*MSQ2+2*MSQ2**2)+M12*
     &  (-4*M22*MCha2-6*M22*MSQ2+2*MCha2*MSQ2+4*MSQ2**2)))-8*M22*(M12-
     &  M22+MCha2)*(M12**2+(MCha2-MSQ2)**2-2*M12*(MCha2+MSQ2))*
     &  I0A(M12,M22,MCha2,Q2))/(8.*alambda1*M22mMSQ**2)
       afin(5)=(8*a0t4*a0tcha*M12**2*M42-8*a0t5*a0tcha*M12**2*M42+8*
     &  a0t4*M12**3*M42+16*aet4*M12**3*M42-32*aet5*M12**3*M42+8*I0A1*
     &  M12**3*M42-4*a0t4*M12**2*M42**2-8*aet4*M12**2*M42**2+2*M12**3*
     &  M42**2-3*M12**2*M42**3-16*a0t4*a0tcha*M12*M42*MCha2+32*a0t5*
     &  a0tcha*M12*M42*MCha2-8*a0t4*M12**2*M42*MCha2-16*aet4*M12**2*
     &  M42*MCha2+32*aet5*M12**2*M42*MCha2-8*I0A1*M12**2*M42*MCha2+8*
     &  a0t4*M12*M42**2*MCha2+16*aet4*M12*M42**2*MCha2-2*M12**2*M42**2*
     &  MCha2+6*M12*M42**3*MCha2+8*a0t4*a0tcha*M42*MCha2**2-24*a0t5*
     &  a0tcha*M42*MCha2**2-8*a0t4*M12*M42*MCha2**2-16*aet4*M12*M42*
     &  MCha2**2+32*aet5*M12*M42*MCha2**2-8*I0A1*M12*M42*MCha2**2-4*
     &  a0t4*M42**2*MCha2**2-8*aet4*M42**2*MCha2**2-2*M12*M42**2*MCha2*
     &  *2-3*M42**3*MCha2**2+8*a0t4*M42*MCha2**3+16*aet4*M42*MCha2**3-
     &  32*aet5*M42*MCha2**3+8*I0A1*M42*MCha2**3+2*M42**2*MCha2**3-8*
     &  a0t5*M12**3*MSQ2+16*aet5*M12**3*MSQ2-16*a0t4*a0tcha*M12*M42*
     &  MSQ2+32*a0t5*a0tcha*M12*M42*MSQ2-16*a0t4*M12**2*M42*MSQ2-4*
     &  a0t5*M12**2*M42*MSQ2-32*aet4*M12**2*M42*MSQ2+88*aet5*M12**2*
     &  M42*MSQ2-40*I0A1*M12**2*M42*MSQ2-4*M12**3*M42*MSQ2+8*a0t4*M12*
     &  M42**2*MSQ2+16*aet4*M12*M42**2*MSQ2-4*M12**2*M42**2*MSQ2+6*M12*
     &  M42**3*MSQ2-16*a0t5*a0tcha*M12*MCha2*MSQ2+8*a0t5*M12**2*MCha2*
     &  MSQ2-16*aet5*M12**2*MCha2*MSQ2-16*a0t4*a0tcha*M42*MCha2*MSQ2+
     &  48*a0t5*a0tcha*M42*MCha2*MSQ2-32*a0t4*M12*M42*MCha2*MSQ2-24*
     &  a0t5*M12*M42*MCha2*MSQ2-32*a0tcha*M12*M42*MCha2*MSQ2-64*aet4*
     &  M12*M42*MCha2*MSQ2+80*aet5*M12*M42*MCha2*MSQ2-16*I0A1*M12*M42*
     &  MCha2*MSQ2-28*M12**2*M42*MCha2*MSQ2+8*a0t4*M42**2*MCha2*MSQ2+
     &  16*aet4*M42**2*MCha2*MSQ2-8*M12*M42**2*MCha2*MSQ2+6*M42**3*
     &  MCha2*MSQ2+16*a0t5*a0tcha*MCha2**2*MSQ2+8*a0t5*M12*MCha2**2*
     &  MSQ2-16*aet5*M12*MCha2**2*MSQ2-16*a0t4*M42*MCha2**2*MSQ2-4*
     &  a0t5*M42*MCha2**2*MSQ2-32*aet4*M42*MCha2**2*MSQ2+88*aet5*M42*
     &  MCha2**2*MSQ2-40*I0A1*M42*MCha2**2*MSQ2-28*M12*M42*MCha2**2*
     &  MSQ2-4*M42**2*MCha2**2*MSQ2-8*a0t5*MCha2**3*MSQ2+16*aet5*MCha2*
     &  *3*MSQ2-4*M42*MCha2**3*MSQ2-16*a0t5*a0tcha*M12*MSQ2**2+24*a0t5*
     &  M12**2*MSQ2**2-48*aet5*M12**2*MSQ2**2+16*I0A1*M12**2*MSQ2**2+2*
     &  M12**3*MSQ2**2+8*a0t4*a0tcha*M42*MSQ2**2-24*a0t5*a0tcha*M42*
     &  MSQ2**2+8*a0t4*M12*M42*MSQ2**2+8*a0t5*M12*M42*MSQ2**2+16*aet4*
     &  M12*M42*MSQ2**2-80*aet5*M12*M42*MSQ2**2+56*I0A1*M12*M42*MSQ2**
     &  2+5*M12**2*M42*MSQ2**2-4*a0t4*M42**2*MSQ2**2-8*aet4*M42**2*
     &  MSQ2**2+2*M12*M42**2*MSQ2**2-3*M42**3*MSQ2**2-32*a0t5*a0tcha*
     &  MCha2*MSQ2**2+48*a0t5*M12*MCha2*MSQ2**2+32*a0tcha*M12*MCha2*
     &  MSQ2**2-32*aet5*M12*MCha2*MSQ2**2+30*M12**2*MCha2*MSQ2**2+8*
     &  a0t4*M42*MCha2*MSQ2**2+8*a0t5*M42*MCha2*MSQ2**2+16*aet4*M42*
     &  MCha2*MSQ2**2-80*aet5*M42*MCha2*MSQ2**2+56*I0A1*M42*MCha2*MSQ2*
     &  *2-10*M12*M42*MCha2*MSQ2**2+2*M42**2*MCha2*MSQ2**2+24*a0t5*
     &  MCha2**2*MSQ2**2-48*aet5*MCha2**2*MSQ2**2+16*I0A1*MCha2**2*
     &  MSQ2**2+30*M12*MCha2**2*MSQ2**2+5*M42*MCha2**2*MSQ2**2+2*MCha2*
     &  *3*MSQ2**2+16*a0t5*a0tcha*MSQ2**3-24*a0t5*M12*MSQ2**3+48*aet5*
     &  M12*MSQ2**3-32*I0A1*M12*MSQ2**3+2*M12**2*MSQ2**3-4*a0t5*M42*
     &  MSQ2**3+24*aet5*M42*MSQ2**3-24*I0A1*M42*MSQ2**3+2*M12*M42*MSQ2*
     &  *3-24*a0t5*MCha2*MSQ2**3+48*aet5*MCha2*MSQ2**3-32*I0A1*MCha2*
     &  MSQ2**3+12*M12*MCha2*MSQ2**3+2*M42*MCha2*MSQ2**3+2*MCha2**2*
     &  MSQ2**3+8*a0t5*MSQ2**4-16*aet5*MSQ2**4+16*I0A1*MSQ2**4-10*M12*
     &  MSQ2**4-3*M42*MSQ2**4-10*MCha2*MSQ2**4+6*MSQ2**5+8*a0t1*(-2*(2*
     &  M12*MCha2+a0tcha*(M12+MCha2-MSQ2))*(M42-MSQ2)*MSQ2+a0t4*M42*
     &  (M12**2+(MCha2-MSQ2)**2-2*M12*(MCha2+MSQ2))-a0t5*(M12**2*(3*
     &  M42-2*MSQ2)+(MCha2-MSQ2)*(M42*MCha2-3*M42*MSQ2+2*MSQ2**2)+M12*
     &  (-4*M42*MCha2-6*M42*MSQ2+2*MCha2*MSQ2+4*MSQ2**2)))-8*M42*(M12-
     &  M42+MCha2)*(M12**2+(MCha2-MSQ2)**2-2*M12*(MCha2+MSQ2))*
     &  I0A(M12,M42,MCha2,Q2))/(8.*alambda1*M42mMSQ**2)
       selfW=selfW+(afin(2)*CF12F4S(1)*CF12F4SC(1)+afin(3)*CF12F4S(2)*
     &  CF12F4SC(2)+CF12F3S*CF12F3SC*(afin(1)+afin(4)*ZU(1,1)*ZUC(1,1)+
     &  afin(5)*ZU(2,1)*ZUC(2,1)))

c]chargino diagrams

c[neutralino diagrams
       do h1=ineu,3
       afin(1)=(-8*aet1*M12**3+7*M12**4+16*aet1*M12**2*M22-6*M12**3*
     &  M22-8*aet1*M12*M22**2-9*M12**2*M22**2+8*M12*M22**3-8*M12**2*
     &  M22*I0A16(h1)+16*M12*M22**2*I0A16(h1)-8*M22**3*I0A16(h1)+8*M12*
     &  *3*I0A4(h1)-8*M12**2*M22*I0A4(h1)-8*M12*M22**2*I0A4(h1)+8*M22**
     &  3*I0A4(h1)-8*aet1*M12*MNeu(h1)**4-9*M12**2*MNeu(h1)**4-8*M12*
     &  M22*MNeu(h1)**4-16*M12*A0TNeu(h1)*MNeu(h1)**4-16*M12*I0A16(h1)*
     &  MNeu(h1)**4-24*M22*I0A16(h1)*MNeu(h1)**4+8*M12*I0A4(h1)*
     &  MNeu(h1)**4+24*M22*I0A4(h1)*MNeu(h1)**4-8*M12*MNeu(h1)**6+8*
     &  I0A16(h1)*MNeu(h1)**6-8*I0A4(h1)*MNeu(h1)**6+16*aet1*M12**2*
     &  MNeu2(h1)+10*M12**3*MNeu2(h1)+16*aet1*M12*M22*MNeu2(h1)-14*M12*
     &  *2*M22*MNeu2(h1)+8*M12*M22**2*MNeu2(h1)+16*M12**2*A0TNeu(h1)*
     &  MNeu2(h1)+16*M12*M22*A0TNeu(h1)*MNeu2(h1)+8*M12**2*I0A16(h1)*
     &  MNeu2(h1)+24*M22**2*I0A16(h1)*MNeu2(h1)-8*M12**2*I0A4(h1)*
     &  MNeu2(h1)-24*M22**2*I0A4(h1)*MNeu2(h1)+16*a0t2*M12*((M12-M22)**
     &  2-(M12+M22)*MNeu2(h1)-A0TNeu(h1)*(M12-M22+MNeu2(h1)))+4*a0t1*
     &  (2*a0t2*(M12-M22+MNeu2(h1))**2+2*A0TNeu(h1)*(M12**2-M22**2-
     &  MNeu(h1)**4+2*M22*MNeu2(h1))+M12*(5*(M12-M22)**2+MNeu(h1)**4-6*
     &  (M12+M22)*MNeu2(h1))))/(16.*M12*alambda2(h1))
       afin(2)=(-8*aet1*M12**3+7*M12**4+16*aet1*M12**2*M42-6*M12**3*
     &  M42-8*aet1*M12*M42**2-9*M12**2*M42**2+8*M12*M42**3-8*M12**2*
     &  M42*I0A17(h1)+16*M12*M42**2*I0A17(h1)-8*M42**3*I0A17(h1)+8*M12*
     &  *3*I0A5(h1)-8*M12**2*M42*I0A5(h1)-8*M12*M42**2*I0A5(h1)+8*M42**
     &  3*I0A5(h1)-8*aet1*M12*MNeu(h1)**4-9*M12**2*MNeu(h1)**4-8*M12*
     &  M42*MNeu(h1)**4-16*M12*A0TNeu(h1)*MNeu(h1)**4-16*M12*I0A17(h1)*
     &  MNeu(h1)**4-24*M42*I0A17(h1)*MNeu(h1)**4+8*M12*I0A5(h1)*
     &  MNeu(h1)**4+24*M42*I0A5(h1)*MNeu(h1)**4-8*M12*MNeu(h1)**6+8*
     &  I0A17(h1)*MNeu(h1)**6-8*I0A5(h1)*MNeu(h1)**6+16*aet1*M12**2*
     &  MNeu2(h1)+10*M12**3*MNeu2(h1)+16*aet1*M12*M42*MNeu2(h1)-14*M12*
     &  *2*M42*MNeu2(h1)+8*M12*M42**2*MNeu2(h1)+16*M12**2*A0TNeu(h1)*
     &  MNeu2(h1)+16*M12*M42*A0TNeu(h1)*MNeu2(h1)+8*M12**2*I0A17(h1)*
     &  MNeu2(h1)+24*M42**2*I0A17(h1)*MNeu2(h1)-8*M12**2*I0A5(h1)*
     &  MNeu2(h1)-24*M42**2*I0A5(h1)*MNeu2(h1)+16*a0t4*M12*((M12-M42)**
     &  2-(M12+M42)*MNeu2(h1)-A0TNeu(h1)*(M12-M42+MNeu2(h1)))+4*a0t1*
     &  (2*a0t4*(M12-M42+MNeu2(h1))**2+2*A0TNeu(h1)*(M12**2-M42**2-
     &  MNeu(h1)**4+2*M42*MNeu2(h1))+M12*(5*(M12-M42)**2+MNeu(h1)**4-6*
     &  (M12+M42)*MNeu2(h1))))/(16.*M12*alambda3(h1))
       afin(3)=(M1*(3*M22**2*M42-3*M22*M42**2-3*M22**2*MSQ2+3*M42**2*
     &  MSQ2+3*M22*MSQ2**2-3*M42*MSQ2**2+4*M22*(M42-MSQ2)*A0T(M22,Q2)+
     &  4*M42*(-M22+MSQ2)*A0T(M42,Q2)+4*M22*MSQ2*A0T(MSQ2,Q2)-4*M42*
     &  MSQ2*A0T(MSQ2,Q2)+8*M42*MSQ2*AEpT(M22,Q2)-8*MSQ2**2*
     &  AEpT(M22,Q2)-8*M22*MSQ2*AEpT(M42,Q2)+8*MSQ2**2*AEpT(M42,Q2)+8*
     &  M22*MSQ2*AEpT(MSQ2,Q2)-8*M42*MSQ2*AEpT(MSQ2,Q2)-8*M42*MSQ2*
     &  I0A(M12,M22,MNeu2(h1),Q2)+8*MSQ2**2*I0A(M12,M22,MNeu2(h1),Q2)+
     &  8*M22*MSQ2*I0A(M12,M42,MNeu2(h1),Q2)-8*MSQ2**2*
     &  I0A(M12,M42,MNeu2(h1),Q2)-8*M22*MSQ2*I0A(M12,MSQ2,MNeu2(h1),Q2)
     &  +8*M42*MSQ2*I0A(M12,MSQ2,MNeu2(h1),Q2))*MNeu(h1))/(4.*M22m42*
     &  M22mMSQ*M42mMSQ)
       afin(4)=-(MNeu(h1)*(8*aet1*M12**2-7*M12**3-16*aet1*M12*M22-2*
     &  M12**2*M22+8*aet1*M22**2+9*M12*M22**2-8*M12**2*A0TNeu(h1)+8*
     &  M12*M22*A0TNeu(h1)-8*M12**2*I0A4(h1)+8*M12*M22*I0A4(h1)+8*aet1*
     &  MNeu(h1)**4+9*M12*MNeu(h1)**4-16*aet1*M12*MNeu2(h1)-2*M12**2*
     &  MNeu2(h1)-16*aet1*M22*MNeu2(h1)+14*M12*M22*MNeu2(h1)+8*M12*
     &  A0TNeu(h1)*MNeu2(h1)+8*M12*I0A4(h1)*MNeu2(h1)+8*a0t2*M12*(-M12+
     &  M22+2*A0TNeu(h1)+MNeu2(h1))-4*a0t1*(5*M12**2-8*M12*M22+3*M22**
     &  2+3*MNeu(h1)**4+2*A0TNeu(h1)*(M12+M22-MNeu2(h1))-8*M12*
     &  MNeu2(h1)-6*M22*MNeu2(h1)+2*a0t2*(M12-M22+MNeu2(h1)))))/(8.*M1*
     &  alambda2(h1))
       afin(5)=-(MNeu(h1)*(8*aet1*M12**2-7*M12**3-16*aet1*M12*M42-2*
     &  M12**2*M42+8*aet1*M42**2+9*M12*M42**2-8*M12**2*A0TNeu(h1)+8*
     &  M12*M42*A0TNeu(h1)-8*M12**2*I0A5(h1)+8*M12*M42*I0A5(h1)+8*aet1*
     &  MNeu(h1)**4+9*M12*MNeu(h1)**4-16*aet1*M12*MNeu2(h1)-2*M12**2*
     &  MNeu2(h1)-16*aet1*M42*MNeu2(h1)+14*M12*M42*MNeu2(h1)+8*M12*
     &  A0TNeu(h1)*MNeu2(h1)+8*M12*I0A5(h1)*MNeu2(h1)+8*a0t4*M12*(-M12+
     &  M42+2*A0TNeu(h1)+MNeu2(h1))-4*a0t1*(5*M12**2-8*M12*M42+3*M42**
     &  2+3*MNeu(h1)**4+2*A0TNeu(h1)*(M12+M42-MNeu2(h1))-8*M12*
     &  MNeu2(h1)-6*M42*MNeu2(h1)+2*a0t4*(M12-M42+MNeu2(h1)))))/(8.*M1*
     &  alambda3(h1))
       afin(6)=-(M1*MNeu(h1)*(M2**10+M12**2*M22**3-2*M12*M22**4-4*a0t5*
     &  M12**2*M22*MSQ2-8*aet5*M12**2*M22*MSQ2+8*a0t5*M12*M22**2*MSQ2+
     &  16*aet5*M12*M22**2*MSQ2-6*M12**2*M22**2*MSQ2-4*a0t5*M22**3*
     &  MSQ2-8*aet5*M22**3*MSQ2-4*M12*M22**3*MSQ2+10*M22**4*MSQ2+8*
     &  aet2*M12**2*MSQ2**2-16*aet2*M12*M22*MSQ2**2+5*M12**2*M22*MSQ2**
     &  2+8*aet2*M22**2*MSQ2**2+6*M12*M22**2*MSQ2**2-11*M22**3*MSQ2**2-
     &  8*M12*M22**2*MSQ2*A0TNeu(h1)+8*M22**3*MSQ2*A0TNeu(h1)+8*M12*
     &  M22*MSQ2**2*A0TNeu(h1)-8*M22**2*MSQ2**2*A0TNeu(h1)+8*M12**2*
     &  M22*MSQ2*I0A18(h1)-16*M12*M22**2*MSQ2*I0A18(h1)+8*M22**3*MSQ2*
     &  I0A18(h1)-8*M12**2*M22*MSQ2*I0A4(h1)+8*M12*M22**2*MSQ2*I0A4(h1)
     &  +8*M12*M22*MSQ2**2*I0A4(h1)-8*M22**2*MSQ2**2*I0A4(h1)+M22**3*
     &  MNeu(h1)**4-4*a0t5*M22*MSQ2*MNeu(h1)**4-8*aet5*M22*MSQ2*
     &  MNeu(h1)**4-6*M22**2*MSQ2*MNeu(h1)**4+8*aet2*MSQ2**2*MNeu(h1)**
     &  4+5*M22*MSQ2**2*MNeu(h1)**4+8*M22*MSQ2*I0A18(h1)*MNeu(h1)**4-8*
     &  M22*MSQ2*I0A4(h1)*MNeu(h1)**4-2*M12*M22**3*MNeu2(h1)-2*M22**4*
     &  MNeu2(h1)+8*a0t5*M12*M22*MSQ2*MNeu2(h1)+16*aet5*M12*M22*MSQ2*
     &  MNeu2(h1)+8*a0t5*M22**2*MSQ2*MNeu2(h1)+16*aet5*M22**2*MSQ2*
     &  MNeu2(h1)-20*M12*M22**2*MSQ2*MNeu2(h1)-4*M22**3*MSQ2*MNeu2(h1)-
     &  16*aet2*M12*MSQ2**2*MNeu2(h1)-16*aet2*M22*MSQ2**2*MNeu2(h1)+22*
     &  M12*M22*MSQ2**2*MNeu2(h1)+6*M22**2*MSQ2**2*MNeu2(h1)-8*M22**2*
     &  MSQ2*A0TNeu(h1)*MNeu2(h1)+8*M22*MSQ2**2*A0TNeu(h1)*MNeu2(h1)-
     &  16*M12*M22*MSQ2*I0A18(h1)*MNeu2(h1)-16*M22**2*MSQ2*I0A18(h1)*
     &  MNeu2(h1)+16*M12*M22*MSQ2*I0A4(h1)*MNeu2(h1)+8*M22**2*MSQ2*
     &  I0A4(h1)*MNeu2(h1)+8*M22*MSQ2**2*I0A4(h1)*MNeu2(h1)-8*a0t1*
     &  (M22-MSQ2)*MSQ2*((M12-M22)*(a0t2+M22)+2*M22*A0TNeu(h1)+(-a0t2+
     &  M22)*MNeu2(h1))-4*a0t2*(M12**2*M22**2-2*M12*M22**3+M22**4-4*
     &  M12**2*M22*MSQ2+10*M12*M22**2*MSQ2-6*M22**3*MSQ2+2*M12**2*MSQ2*
     &  *2-6*M12*M22*MSQ2**2+4*M22**2*MSQ2**2+(M22**2-4*M22*MSQ2+2*
     &  MSQ2**2)*MNeu(h1)**4+2*MSQ2*(-M22+MSQ2)*A0TNeu(h1)*(M12+M22-
     &  MNeu2(h1))-2*(M12*(M22**2-4*M22*MSQ2+2*MSQ2**2)+M22*(M22**2-5*
     &  M22*MSQ2+3*MSQ2**2))*MNeu2(h1))))/(4.*M22*M22mMSQ**2*
     &  alambda2(h1))
       afin(7)=-(M1*MNeu(h1)*(M4**10+M12**2*M42**3-2*M12*M42**4-4*a0t5*
     &  M12**2*M42*MSQ2-8*aet5*M12**2*M42*MSQ2+8*a0t5*M12*M42**2*MSQ2+
     &  16*aet5*M12*M42**2*MSQ2-6*M12**2*M42**2*MSQ2-4*a0t5*M42**3*
     &  MSQ2-8*aet5*M42**3*MSQ2-4*M12*M42**3*MSQ2+10*M42**4*MSQ2+8*
     &  aet4*M12**2*MSQ2**2-16*aet4*M12*M42*MSQ2**2+5*M12**2*M42*MSQ2**
     &  2+8*aet4*M42**2*MSQ2**2+6*M12*M42**2*MSQ2**2-11*M42**3*MSQ2**2-
     &  8*M12*M42**2*MSQ2*A0TNeu(h1)+8*M42**3*MSQ2*A0TNeu(h1)+8*M12*
     &  M42*MSQ2**2*A0TNeu(h1)-8*M42**2*MSQ2**2*A0TNeu(h1)+8*M12**2*
     &  M42*MSQ2*I0A18(h1)-16*M12*M42**2*MSQ2*I0A18(h1)+8*M42**3*MSQ2*
     &  I0A18(h1)-8*M12**2*M42*MSQ2*I0A5(h1)+8*M12*M42**2*MSQ2*I0A5(h1)
     &  +8*M12*M42*MSQ2**2*I0A5(h1)-8*M42**2*MSQ2**2*I0A5(h1)+M42**3*
     &  MNeu(h1)**4-4*a0t5*M42*MSQ2*MNeu(h1)**4-8*aet5*M42*MSQ2*
     &  MNeu(h1)**4-6*M42**2*MSQ2*MNeu(h1)**4+8*aet4*MSQ2**2*MNeu(h1)**
     &  4+5*M42*MSQ2**2*MNeu(h1)**4+8*M42*MSQ2*I0A18(h1)*MNeu(h1)**4-8*
     &  M42*MSQ2*I0A5(h1)*MNeu(h1)**4-2*M12*M42**3*MNeu2(h1)-2*M42**4*
     &  MNeu2(h1)+8*a0t5*M12*M42*MSQ2*MNeu2(h1)+16*aet5*M12*M42*MSQ2*
     &  MNeu2(h1)+8*a0t5*M42**2*MSQ2*MNeu2(h1)+16*aet5*M42**2*MSQ2*
     &  MNeu2(h1)-20*M12*M42**2*MSQ2*MNeu2(h1)-4*M42**3*MSQ2*MNeu2(h1)-
     &  16*aet4*M12*MSQ2**2*MNeu2(h1)-16*aet4*M42*MSQ2**2*MNeu2(h1)+22*
     &  M12*M42*MSQ2**2*MNeu2(h1)+6*M42**2*MSQ2**2*MNeu2(h1)-8*M42**2*
     &  MSQ2*A0TNeu(h1)*MNeu2(h1)+8*M42*MSQ2**2*A0TNeu(h1)*MNeu2(h1)-
     &  16*M12*M42*MSQ2*I0A18(h1)*MNeu2(h1)-16*M42**2*MSQ2*I0A18(h1)*
     &  MNeu2(h1)+16*M12*M42*MSQ2*I0A5(h1)*MNeu2(h1)+8*M42**2*MSQ2*
     &  I0A5(h1)*MNeu2(h1)+8*M42*MSQ2**2*I0A5(h1)*MNeu2(h1)-8*a0t1*
     &  (M42-MSQ2)*MSQ2*((M12-M42)*(a0t4+M42)+2*M42*A0TNeu(h1)+(-a0t4+
     &  M42)*MNeu2(h1))-4*a0t4*(M12**2*M42**2-2*M12*M42**3+M42**4-4*
     &  M12**2*M42*MSQ2+10*M12*M42**2*MSQ2-6*M42**3*MSQ2+2*M12**2*MSQ2*
     &  *2-6*M12*M42*MSQ2**2+4*M42**2*MSQ2**2+(M42**2-4*M42*MSQ2+2*
     &  MSQ2**2)*MNeu(h1)**4+2*MSQ2*(-M42+MSQ2)*A0TNeu(h1)*(M12+M42-
     &  MNeu2(h1))-2*(M12*(M42**2-4*M42*MSQ2+2*MSQ2**2)+M42*(M42**2-5*
     &  M42*MSQ2+3*MSQ2**2))*MNeu2(h1))))/(4.*M42*M42mMSQ**2*
     &  alambda3(h1))
       afin(8)=(-8*aet1*M12**2-8*aet2*M12**2+5*M12**3+16*aet1*M12*M22+
     &  16*aet2*M12*M22-5*M12**2*M22-8*aet1*M22**2-8*aet2*M22**2-5*M12*
     &  M22**2+5*M22**3+8*M12**2*I0A4(h1)-16*M12*M22*I0A4(h1)+8*M22**2*
     &  I0A4(h1)-8*aet1*MNeu(h1)**4-8*aet2*MNeu(h1)**4-7*M12*MNeu(h1)**
     &  4-7*M22*MNeu(h1)**4-8*A0TNeu(h1)*MNeu(h1)**4-2*MNeu(h1)**6+16*
     &  aet1*M12*MNeu2(h1)+16*aet2*M12*MNeu2(h1)+4*M12**2*MNeu2(h1)+16*
     &  aet1*M22*MNeu2(h1)+16*aet2*M22*MNeu2(h1)-16*M12*M22*MNeu2(h1)+
     &  4*M22**2*MNeu2(h1)+8*M12*A0TNeu(h1)*MNeu2(h1)+8*M22*A0TNeu(h1)*
     &  MNeu2(h1)-8*M12*I0A4(h1)*MNeu2(h1)-8*M22*I0A4(h1)*MNeu2(h1)+4*
     &  a0t1*(3*(M12-M22)**2+MNeu(h1)**4+2*A0TNeu(h1)*(M12-M22-
     &  MNeu2(h1))-4*(-a0t2+M12+M22)*MNeu2(h1))+4*a0t2*(3*(M12-M22)**2+
     &  MNeu(h1)**4-4*(M12+M22)*MNeu2(h1)-2*A0TNeu(h1)*(M12-M22+
     &  MNeu2(h1))))/(8.*alambda2(h1))
       afin(9)=(-8*aet1*M12**2-8*aet4*M12**2+5*M12**3+16*aet1*M12*M42+
     &  16*aet4*M12*M42-5*M12**2*M42-8*aet1*M42**2-8*aet4*M42**2-5*M12*
     &  M42**2+5*M42**3+8*M12**2*I0A5(h1)-16*M12*M42*I0A5(h1)+8*M42**2*
     &  I0A5(h1)-8*aet1*MNeu(h1)**4-8*aet4*MNeu(h1)**4-7*M12*MNeu(h1)**
     &  4-7*M42*MNeu(h1)**4-8*A0TNeu(h1)*MNeu(h1)**4-2*MNeu(h1)**6+16*
     &  aet1*M12*MNeu2(h1)+16*aet4*M12*MNeu2(h1)+4*M12**2*MNeu2(h1)+16*
     &  aet1*M42*MNeu2(h1)+16*aet4*M42*MNeu2(h1)-16*M12*M42*MNeu2(h1)+
     &  4*M42**2*MNeu2(h1)+8*M12*A0TNeu(h1)*MNeu2(h1)+8*M42*A0TNeu(h1)*
     &  MNeu2(h1)-8*M12*I0A5(h1)*MNeu2(h1)-8*M42*I0A5(h1)*MNeu2(h1)+4*
     &  a0t1*(3*(M12-M42)**2+MNeu(h1)**4+2*A0TNeu(h1)*(M12-M42-
     &  MNeu2(h1))-4*(-a0t4+M12+M42)*MNeu2(h1))+4*a0t4*(3*(M12-M42)**2+
     &  MNeu(h1)**4-4*(M12+M42)*MNeu2(h1)-2*A0TNeu(h1)*(M12-M42+
     &  MNeu2(h1))))/(8.*alambda3(h1))
       afin(10)=((-8*(a0t1*a0t2+aet2*M12+aet1*M22))/M22m42+(2*M22*(2*
     &  a0t2*M12+4*aet2*M12+4*aet1*M22+M12*M22+2*a0t1*(2*a0t2+M22)))
     &  /(M22m42*M22mMSQ)+(8*(a0t1*a0t4+aet4*M12+aet1*M42))/M22m42-(2*
     &  M42*(2*a0t4*M12+4*aet4*M12+4*aet1*M42+M12*M42+2*a0t1*(2*a0t4+
     &  M42)))/(M22m42*M42mMSQ)+(2*MSQ2*(2*a0t5*M12+4*aet5*M12+4*aet1*
     &  MSQ2+M12*MSQ2+2*a0t1*(2*a0t5+MSQ2)))/(M22mMSQ*M42mMSQ)-(MSQ2*(-
     &  M12+MSQ2-MNeu2(h1))*(4*a0t1+4*a0t5+8*aet1+8*aet5+3*M12+3*MSQ2+
     &  4*A0TNeu(h1)+8*AETNeu(h1)-8*I0A18(h1)+3*MNeu2(h1)))/(M22mMSQ*
     &  M42mMSQ)+((M12-M22+MNeu2(h1))*(4*a0t1*M22+4*a0t2*M22+3*M12*M22+
     &  3*M22**2+8*aet1*MSQ2+8*aet2*MSQ2+4*M22*A0TNeu(h1)+8*MSQ2*
     &  AETNeu(h1)-8*MSQ2*I0A4(h1)+3*M22*MNeu2(h1)))/(M22m42*M22mMSQ)-
     &  ((M12-M42+MNeu2(h1))*(4*a0t1*M42+4*a0t4*M42+3*M12*M42+3*M42**2+
     &  8*aet1*MSQ2+8*aet4*MSQ2+4*M42*A0TNeu(h1)+8*MSQ2*AETNeu(h1)-8*
     &  MSQ2*I0A5(h1)+3*M42*MNeu2(h1)))/(M22m42*M42mMSQ)+(2*MSQ2*(2*(2*
     &  a0t5+MSQ2)*A0TNeu(h1)+4*MSQ2*AETNeu(h1)+(2*a0t5+4*aet5+MSQ2)*
     &  MNeu2(h1)))/(M22mMSQ*M42mMSQ)+(4*(M22**2+2*a0t2*MSQ2)*
     &  A0TNeu(h1)+8*M22*MSQ2*AETNeu(h1)+2*(2*a0t2*M22+M22**2+4*aet2*
     &  MSQ2)*MNeu2(h1))/(M22m42*M22mMSQ)-(2*(2*(M42**2+2*a0t4*MSQ2)*
     &  A0TNeu(h1)+4*M42*MSQ2*AETNeu(h1)+(2*a0t4*M42+M42**2+4*aet4*
     &  MSQ2)*MNeu2(h1)))/(M22m42*M42mMSQ))/8.
       afin(11)=(-2*M12*M2**10-2*M2**12-6*M12**3*M22**3+10*M12**2*M22**
     &  4+13*M2**10*MSQ2+16*aet5*M12**3*M22*MSQ2-8*aet2*M12**2*M22**2*
     &  MSQ2-32*aet5*M12**2*M22**2*MSQ2+12*M12**3*M22**2*MSQ2+16*aet2*
     &  M12*M22**3*MSQ2+16*aet5*M12*M22**3*MSQ2-11*M12**2*M22**3*MSQ2-
     &  8*aet2*M22**4*MSQ2-14*M12*M22**4*MSQ2-16*aet2*M12**3*MSQ2**2+
     &  48*aet2*M12**2*M22*MSQ2**2-8*aet5*M12**2*M22*MSQ2**2-6*M12**3*
     &  M22*MSQ2**2-48*aet2*M12*M22**2*MSQ2**2+16*aet5*M12*M22**2*MSQ2*
     &  *2+4*M12**2*M22**2*MSQ2**2+16*aet2*M22**3*MSQ2**2-8*aet5*M22**
     &  3*MSQ2**2+10*M12*M22**3*MSQ2**2-8*M22**4*MSQ2**2-3*M12**2*M22*
     &  MSQ2**3+6*M12*M22**2*MSQ2**3-3*M22**3*MSQ2**3+16*a0t1*M12*M22**
     &  2*MSQ2*A0TNeu(h1)-16*a0t1*M22**3*MSQ2*A0TNeu(h1)-16*a0t1*M12*
     &  M22*MSQ2**2*A0TNeu(h1)+16*a0t1*M22**2*MSQ2**2*A0TNeu(h1)-8*M12*
     &  *3*M22*MSQ2*I0A18(h1)+16*M12**2*M22**2*MSQ2*I0A18(h1)-8*M12*
     &  M22**3*MSQ2*I0A18(h1)+8*M12**2*M22*MSQ2**2*I0A18(h1)-16*M12*
     &  M22**2*MSQ2**2*I0A18(h1)+8*M22**3*MSQ2**2*I0A18(h1)+8*M12**3*
     &  M22*MSQ2*I0A4(h1)-8*M12**2*M22**2*MSQ2*I0A4(h1)-8*M12*M22**3*
     &  MSQ2*I0A4(h1)+8*M22**4*MSQ2*I0A4(h1)-16*M12**2*M22*MSQ2**2*
     &  I0A4(h1)+32*M12*M22**2*MSQ2**2*I0A4(h1)-16*M22**3*MSQ2**2*
     &  I0A4(h1)+6*M12*M22**3*MNeu(h1)**4+10*M22**4*MNeu(h1)**4-16*
     &  aet5*M12*M22*MSQ2*MNeu(h1)**4-8*aet2*M22**2*MSQ2*MNeu(h1)**4-
     &  32*aet5*M22**2*MSQ2*MNeu(h1)**4+20*M12*M22**2*MSQ2*MNeu(h1)**4-
     &  11*M22**3*MSQ2*MNeu(h1)**4+16*aet2*M12*MSQ2**2*MNeu(h1)**4+48*
     &  aet2*M22*MSQ2**2*MNeu(h1)**4-8*aet5*M22*MSQ2**2*MNeu(h1)**4-26*
     &  M12*M22*MSQ2**2*MNeu(h1)**4+4*M22**2*MSQ2**2*MNeu(h1)**4-3*M22*
     &  MSQ2**3*MNeu(h1)**4+8*M12*M22*MSQ2*I0A18(h1)*MNeu(h1)**4+16*
     &  M22**2*MSQ2*I0A18(h1)*MNeu(h1)**4+8*M22*MSQ2**2*I0A18(h1)*
     &  MNeu(h1)**4-8*M12*M22*MSQ2*I0A4(h1)*MNeu(h1)**4-8*M22**2*MSQ2*
     &  I0A4(h1)*MNeu(h1)**4-16*M22*MSQ2**2*I0A4(h1)*MNeu(h1)**4-6*M22*
     &  *3*MNeu(h1)**6+16*aet5*M22*MSQ2*MNeu(h1)**6+12*M22**2*MSQ2*
     &  MNeu(h1)**6-16*aet2*MSQ2**2*MNeu(h1)**6-6*M22*MSQ2**2*MNeu(h1)*
     &  *6-8*M22*MSQ2*I0A18(h1)*MNeu(h1)**6+8*M22*MSQ2*I0A4(h1)*
     &  MNeu(h1)**6-2*M2**10*MNeu2(h1)+6*M12**2*M22**3*MNeu2(h1)+28*
     &  M12*M22**4*MNeu2(h1)-16*aet5*M12**2*M22*MSQ2*MNeu2(h1)+32*a0t1*
     &  M12*M22**2*MSQ2*MNeu2(h1)+16*aet2*M12*M22**2*MSQ2*MNeu2(h1)-64*
     &  aet5*M12*M22**2*MSQ2*MNeu2(h1)+20*M12**2*M22**2*MSQ2*MNeu2(h1)+
     &  16*aet2*M22**3*MSQ2*MNeu2(h1)+16*aet5*M22**3*MSQ2*MNeu2(h1)-42*
     &  M12*M22**3*MSQ2*MNeu2(h1)-14*M22**4*MSQ2*MNeu2(h1)+16*aet2*M12*
     &  *2*MSQ2**2*MNeu2(h1)-32*a0t1*M12*M22*MSQ2**2*MNeu2(h1)+32*aet2*
     &  M12*M22*MSQ2**2*MNeu2(h1)+16*aet5*M12*M22*MSQ2**2*MNeu2(h1)-26*
     &  M12**2*M22*MSQ2**2*MNeu2(h1)-48*aet2*M22**2*MSQ2**2*MNeu2(h1)+
     &  16*aet5*M22**2*MSQ2**2*MNeu2(h1)+8*M12*M22**2*MSQ2**2*MNeu2(h1)
     &  +10*M22**3*MSQ2**2*MNeu2(h1)+6*M12*M22*MSQ2**3*MNeu2(h1)+6*M22*
     &  *2*MSQ2**3*MNeu2(h1)+16*a0t1*M22**2*MSQ2*A0TNeu(h1)*MNeu2(h1)+
     &  32*M12*M22**2*MSQ2*A0TNeu(h1)*MNeu2(h1)-16*a0t1*M22*MSQ2**2*
     &  A0TNeu(h1)*MNeu2(h1)-32*M12*M22*MSQ2**2*A0TNeu(h1)*MNeu2(h1)+8*
     &  M12**2*M22*MSQ2*I0A18(h1)*MNeu2(h1)+32*M12*M22**2*MSQ2*
     &  I0A18(h1)*MNeu2(h1)-8*M22**3*MSQ2*I0A18(h1)*MNeu2(h1)-16*M12*
     &  M22*MSQ2**2*I0A18(h1)*MNeu2(h1)-16*M22**2*MSQ2**2*I0A18(h1)*
     &  MNeu2(h1)-8*M12**2*M22*MSQ2*I0A4(h1)*MNeu2(h1)-16*M12*M22**2*
     &  MSQ2*I0A4(h1)*MNeu2(h1)-8*M22**3*MSQ2*I0A4(h1)*MNeu2(h1)+32*
     &  M22**2*MSQ2**2*I0A4(h1)*MNeu2(h1)+4*a0t5*M22*MSQ2*(2*a0t1+2*
     &  M12-MSQ2+2*A0TNeu(h1)+2*MNeu2(h1))*((M12-M22)**2+MNeu(h1)**4-2*
     &  (M12+M22)*MNeu2(h1))+4*a0t2*(-2*M2**10+2*M12**3*M22**2-6*M12**
     &  2*M22**3+6*M12*M22**4-8*M12**3*M22*MSQ2+23*M12**2*M22**2*MSQ2-
     &  22*M12*M22**3*MSQ2+7*M22**4*MSQ2+4*M12**3*MSQ2**2-12*M12**2*
     &  M22*MSQ2**2+12*M12*M22**2*MSQ2**2-4*M22**3*MSQ2**2-2*M12*M22**
     &  2*MNeu(h1)**4-6*M22**3*MNeu(h1)**4+8*M12*M22*MSQ2*MNeu(h1)**4+
     &  23*M22**2*MSQ2*MNeu(h1)**4-4*M12*MSQ2**2*MNeu(h1)**4-12*M22*
     &  MSQ2**2*MNeu(h1)**4+2*M22**2*MNeu(h1)**6-8*M22*MSQ2*MNeu(h1)**
     &  6+4*MSQ2**2*MNeu(h1)**6-2*M12**2*M22**2*MNeu2(h1)-4*M12*M22**3*
     &  MNeu2(h1)+6*M22**4*MNeu2(h1)+8*M12**2*M22*MSQ2*MNeu2(h1)+26*
     &  M12*M22**2*MSQ2*MNeu2(h1)-22*M22**3*MSQ2*MNeu2(h1)-4*M12**2*
     &  MSQ2**2*MNeu2(h1)-16*M12*M22*MSQ2**2*MNeu2(h1)+12*M22**2*MSQ2**
     &  2*MNeu2(h1)+2*a0t1*MSQ2*((M12-M22)**2*(M22-2*MSQ2)-M22*MNeu(h1)
     &  **4+2*(M12+M22)*MSQ2*MNeu2(h1))+2*MSQ2*A0TNeu(h1)*(M22*(-M12+
     &  M22)*(M12+M22-2*MSQ2)+(M22-2*MSQ2)*MNeu(h1)**4+(-2*M22**2+2*
     &  M12*MSQ2+4*M22*MSQ2)*MNeu2(h1))))/(8.*M22*M22mMSQ**2*
     &  alambda2(h1))
       afin(12)=(-2*M12*M4**10-2*M4**12-6*M12**3*M42**3+10*M12**2*M42**
     &  4+13*M4**10*MSQ2+16*aet5*M12**3*M42*MSQ2-8*aet4*M12**2*M42**2*
     &  MSQ2-32*aet5*M12**2*M42**2*MSQ2+12*M12**3*M42**2*MSQ2+16*aet4*
     &  M12*M42**3*MSQ2+16*aet5*M12*M42**3*MSQ2-11*M12**2*M42**3*MSQ2-
     &  8*aet4*M42**4*MSQ2-14*M12*M42**4*MSQ2-16*aet4*M12**3*MSQ2**2+
     &  48*aet4*M12**2*M42*MSQ2**2-8*aet5*M12**2*M42*MSQ2**2-6*M12**3*
     &  M42*MSQ2**2-48*aet4*M12*M42**2*MSQ2**2+16*aet5*M12*M42**2*MSQ2*
     &  *2+4*M12**2*M42**2*MSQ2**2+16*aet4*M42**3*MSQ2**2-8*aet5*M42**
     &  3*MSQ2**2+10*M12*M42**3*MSQ2**2-8*M42**4*MSQ2**2-3*M12**2*M42*
     &  MSQ2**3+6*M12*M42**2*MSQ2**3-3*M42**3*MSQ2**3+16*a0t1*M12*M42**
     &  2*MSQ2*A0TNeu(h1)-16*a0t1*M42**3*MSQ2*A0TNeu(h1)-16*a0t1*M12*
     &  M42*MSQ2**2*A0TNeu(h1)+16*a0t1*M42**2*MSQ2**2*A0TNeu(h1)-8*M12*
     &  *3*M42*MSQ2*I0A18(h1)+16*M12**2*M42**2*MSQ2*I0A18(h1)-8*M12*
     &  M42**3*MSQ2*I0A18(h1)+8*M12**2*M42*MSQ2**2*I0A18(h1)-16*M12*
     &  M42**2*MSQ2**2*I0A18(h1)+8*M42**3*MSQ2**2*I0A18(h1)+8*M12**3*
     &  M42*MSQ2*I0A5(h1)-8*M12**2*M42**2*MSQ2*I0A5(h1)-8*M12*M42**3*
     &  MSQ2*I0A5(h1)+8*M42**4*MSQ2*I0A5(h1)-16*M12**2*M42*MSQ2**2*
     &  I0A5(h1)+32*M12*M42**2*MSQ2**2*I0A5(h1)-16*M42**3*MSQ2**2*
     &  I0A5(h1)+6*M12*M42**3*MNeu(h1)**4+10*M42**4*MNeu(h1)**4-16*
     &  aet5*M12*M42*MSQ2*MNeu(h1)**4-8*aet4*M42**2*MSQ2*MNeu(h1)**4-
     &  32*aet5*M42**2*MSQ2*MNeu(h1)**4+20*M12*M42**2*MSQ2*MNeu(h1)**4-
     &  11*M42**3*MSQ2*MNeu(h1)**4+16*aet4*M12*MSQ2**2*MNeu(h1)**4+48*
     &  aet4*M42*MSQ2**2*MNeu(h1)**4-8*aet5*M42*MSQ2**2*MNeu(h1)**4-26*
     &  M12*M42*MSQ2**2*MNeu(h1)**4+4*M42**2*MSQ2**2*MNeu(h1)**4-3*M42*
     &  MSQ2**3*MNeu(h1)**4+8*M12*M42*MSQ2*I0A18(h1)*MNeu(h1)**4+16*
     &  M42**2*MSQ2*I0A18(h1)*MNeu(h1)**4+8*M42*MSQ2**2*I0A18(h1)*
     &  MNeu(h1)**4-8*M12*M42*MSQ2*I0A5(h1)*MNeu(h1)**4-8*M42**2*MSQ2*
     &  I0A5(h1)*MNeu(h1)**4-16*M42*MSQ2**2*I0A5(h1)*MNeu(h1)**4-6*M42*
     &  *3*MNeu(h1)**6+16*aet5*M42*MSQ2*MNeu(h1)**6+12*M42**2*MSQ2*
     &  MNeu(h1)**6-16*aet4*MSQ2**2*MNeu(h1)**6-6*M42*MSQ2**2*MNeu(h1)*
     &  *6-8*M42*MSQ2*I0A18(h1)*MNeu(h1)**6+8*M42*MSQ2*I0A5(h1)*
     &  MNeu(h1)**6-2*M4**10*MNeu2(h1)+6*M12**2*M42**3*MNeu2(h1)+28*
     &  M12*M42**4*MNeu2(h1)-16*aet5*M12**2*M42*MSQ2*MNeu2(h1)+32*a0t1*
     &  M12*M42**2*MSQ2*MNeu2(h1)+16*aet4*M12*M42**2*MSQ2*MNeu2(h1)-64*
     &  aet5*M12*M42**2*MSQ2*MNeu2(h1)+20*M12**2*M42**2*MSQ2*MNeu2(h1)+
     &  16*aet4*M42**3*MSQ2*MNeu2(h1)+16*aet5*M42**3*MSQ2*MNeu2(h1)-42*
     &  M12*M42**3*MSQ2*MNeu2(h1)-14*M42**4*MSQ2*MNeu2(h1)+16*aet4*M12*
     &  *2*MSQ2**2*MNeu2(h1)-32*a0t1*M12*M42*MSQ2**2*MNeu2(h1)+32*aet4*
     &  M12*M42*MSQ2**2*MNeu2(h1)+16*aet5*M12*M42*MSQ2**2*MNeu2(h1)-26*
     &  M12**2*M42*MSQ2**2*MNeu2(h1)-48*aet4*M42**2*MSQ2**2*MNeu2(h1)+
     &  16*aet5*M42**2*MSQ2**2*MNeu2(h1)+8*M12*M42**2*MSQ2**2*MNeu2(h1)
     &  +10*M42**3*MSQ2**2*MNeu2(h1)+6*M12*M42*MSQ2**3*MNeu2(h1)+6*M42*
     &  *2*MSQ2**3*MNeu2(h1)+16*a0t1*M42**2*MSQ2*A0TNeu(h1)*MNeu2(h1)+
     &  32*M12*M42**2*MSQ2*A0TNeu(h1)*MNeu2(h1)-16*a0t1*M42*MSQ2**2*
     &  A0TNeu(h1)*MNeu2(h1)-32*M12*M42*MSQ2**2*A0TNeu(h1)*MNeu2(h1)+8*
     &  M12**2*M42*MSQ2*I0A18(h1)*MNeu2(h1)+32*M12*M42**2*MSQ2*
     &  I0A18(h1)*MNeu2(h1)-8*M42**3*MSQ2*I0A18(h1)*MNeu2(h1)-16*M12*
     &  M42*MSQ2**2*I0A18(h1)*MNeu2(h1)-16*M42**2*MSQ2**2*I0A18(h1)*
     &  MNeu2(h1)-8*M12**2*M42*MSQ2*I0A5(h1)*MNeu2(h1)-16*M12*M42**2*
     &  MSQ2*I0A5(h1)*MNeu2(h1)-8*M42**3*MSQ2*I0A5(h1)*MNeu2(h1)+32*
     &  M42**2*MSQ2**2*I0A5(h1)*MNeu2(h1)+4*a0t5*M42*MSQ2*(2*a0t1+2*
     &  M12-MSQ2+2*A0TNeu(h1)+2*MNeu2(h1))*((M12-M42)**2+MNeu(h1)**4-2*
     &  (M12+M42)*MNeu2(h1))+4*a0t4*(-2*M4**10+2*M12**3*M42**2-6*M12**
     &  2*M42**3+6*M12*M42**4-8*M12**3*M42*MSQ2+23*M12**2*M42**2*MSQ2-
     &  22*M12*M42**3*MSQ2+7*M42**4*MSQ2+4*M12**3*MSQ2**2-12*M12**2*
     &  M42*MSQ2**2+12*M12*M42**2*MSQ2**2-4*M42**3*MSQ2**2-2*M12*M42**
     &  2*MNeu(h1)**4-6*M42**3*MNeu(h1)**4+8*M12*M42*MSQ2*MNeu(h1)**4+
     &  23*M42**2*MSQ2*MNeu(h1)**4-4*M12*MSQ2**2*MNeu(h1)**4-12*M42*
     &  MSQ2**2*MNeu(h1)**4+2*M42**2*MNeu(h1)**6-8*M42*MSQ2*MNeu(h1)**
     &  6+4*MSQ2**2*MNeu(h1)**6-2*M12**2*M42**2*MNeu2(h1)-4*M12*M42**3*
     &  MNeu2(h1)+6*M42**4*MNeu2(h1)+8*M12**2*M42*MSQ2*MNeu2(h1)+26*
     &  M12*M42**2*MSQ2*MNeu2(h1)-22*M42**3*MSQ2*MNeu2(h1)-4*M12**2*
     &  MSQ2**2*MNeu2(h1)-16*M12*M42*MSQ2**2*MNeu2(h1)+12*M42**2*MSQ2**
     &  2*MNeu2(h1)+2*a0t1*MSQ2*((M12-M42)**2*(M42-2*MSQ2)-M42*MNeu(h1)
     &  **4+2*(M12+M42)*MSQ2*MNeu2(h1))+2*MSQ2*A0TNeu(h1)*(M42*(-M12+
     &  M42)*(M12+M42-2*MSQ2)+(M42-2*MSQ2)*MNeu(h1)**4+(-2*M42**2+2*
     &  M12*MSQ2+4*M42*MSQ2)*MNeu2(h1))))/(8.*M42*M42mMSQ**2*
     &  alambda3(h1))
       selfW=selfW+(CF11FSL(h1,1)*(afin(3)*CF11FSRC(h1,2)*ZU(2,1)*
     &  ZUC(1,1)+CF11FSRC(h1,1)*(afin(4)+afin(6)*ZU(1,1)*ZUC(1,1)))+
     &  CF11FSLC(h1,1)*(CF11FSR(h1,1)*(afin(4)+afin(6)*ZU(1,1)*ZUC(1,1)
     &  )+CF11FSL(h1,1)*(afin(8)+afin(11)*ZU(1,1)*ZUC(1,1))+afin(10)*
     &  CF11FSL(h1,2)*ZU(1,1)*ZUC(2,1)+afin(3)*CF11FSR(h1,2)*ZU(1,1)*
     &  ZUC(2,1))+CF11FSRC(h1,1)*(CF11FSR(h1,1)*(afin(1)+afin(11)*
     &  ZU(1,1)*ZUC(1,1))+afin(10)*CF11FSR(h1,2)*ZU(1,1)*ZUC(2,1))+
     &  CF11FSL(h1,2)*(afin(3)*CF11FSRC(h1,1)*ZU(1,1)*ZUC(2,1)+
     &  CF11FSRC(h1,2)*(afin(5)+afin(7)*ZU(2,1)*ZUC(2,1)))+
     &  CF11FSRC(h1,2)*(afin(10)*CF11FSR(h1,1)*ZU(2,1)*ZUC(1,1)+
     &  CF11FSR(h1,2)*(afin(2)+afin(12)*ZU(2,1)*ZUC(2,1)))+
     &  CF11FSLC(h1,2)*(afin(10)*CF11FSL(h1,1)*ZU(2,1)*ZUC(1,1)+afin(3)
     &  *CF11FSR(h1,1)*ZU(2,1)*ZUC(1,1)+CF11FSR(h1,2)*(afin(5)+afin(7)*
     &  ZU(2,1)*ZUC(2,1))+CF11FSL(h1,2)*(afin(9)+afin(12)*ZU(2,1)*
     &  ZUC(2,1))))
       enddo


       SelfW=-(SelfW*fac)
#ifdef printMT4
      Write(16,110) "TwoLoopWSelfMSSM[Sum][Nhung1]=", DBLE(selfW)
110   format(A,F24.14)
#endif
      end subroutine SelfTWW2L_MT4

c
c======================================================================
c
      subroutine SelfTWW2L_lambda(selfWO)
      implicit none
      integer imodel,signf
      double complex selfWDP,selfWSP,selfW
      double complex selfWCTDP,selfWCTSP,selfWCT
      double precision afac,afac2,MSQ,selfWO
#include "TLMT4.h"
#include "TLMT4lambda.h"
         afac= SW2/16D0/pi**4/vv2
         afac2= SW2/16D0/pi**2/vv2
       selfWDP=0D0;selfWSP=0D0;selfW=0D0
       selfWCTDP=0D0;selfWCTSP=0D0;selfWCT=0D0
       MSQ=Sqrt(MSQ2)
       signf=1D0

       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .gt. 1D-15) then      
       selfW=selfW-(CS1S1S1S1(INH3,INH4,INH5,INH5)*CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETNH(INH5)+A0TNH(INH5)*(2+4*
     &  aB0TNCH(INH4,ICH3)+4*aC0THHCH(INH3,INH4,ICH3)*Mah2(INH3))+(1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3)+2*
     &  (aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*
     &  Mah2(INH3))*Mah2(INH5)))/32.
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .gt. 1D-15) then       
       selfW=selfW-(CS1S1S3S3(INH4,INH4,ICH3,ICH4)*CS1S3V3(INH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETNH(INH4)+A0TNH(INH4)*(2+4*
     &  aB0TCH(ICH3,ICH4)+4*aC0THCHCH(INH3,ICH3,ICH4)*Mah2(INH3))+(1+2*
     &  aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4)+2*
     &  (aC0THCHCH(INH3,ICH3,ICH4)+2*aCepTHCHCH(INH3,ICH3,ICH4))*
     &  Mah2(INH3))*Mah2(INH4)))/32.
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .gt. 1D-15) then        
       selfW=selfW-(CS1S1S3S3(INH3,INH4,ICH4,ICH4)*CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETHpN(ICH4)+A0THpN(ICH4)*(2+4*
     &  aB0TNCH(INH4,ICH3)+4*aC0THHCH(INH3,INH4,ICH3)*Mah2(INH3))+(1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3)+2*
     &  (aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*
     &  Mah2(INH3))*MassHpm(ICH4)**2))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .gt. 1D-15) then       
       selfW=selfW-(CS1S3V3(INH3,ICH4)*CS3S3S3S3(ICH3,ICH5,ICH4,ICH5)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETHpN(ICH5)+A0THpN(ICH5)*(2+4*
     &  aB0TCH(ICH3,ICH4)+4*aC0THCHCH(INH3,ICH3,ICH4)*Mah2(INH3))+(1+2*
     &  aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4)+2*
     &  (aC0THCHCH(INH3,ICH3,ICH4)+2*aCepTHCHCH(INH3,ICH3,ICH4))*
     &  Mah2(INH3))*MassHpm(ICH5)**2))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .gt. 1D-15) then         
       selfW=selfW+(-3*CS1S3V3(INH4,ICH3)*CSSSS(INH3,INH4,ISt3,ISt3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*aAETN(ISt3)+aA0TN(ISt3)*(2+4*
     &  aB0TNCH(INH4,ICH3)+4*aC0THHCH(INH3,INH4,ICH3)*Mah2(INH3))+(1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3)+2*
     &  (aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*
     &  Mah2(INH3))*MassSu2(ISt3)))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do ISt3=1,2
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .gt. 1D-15) then        
       selfW=selfW+(-3*CS1S3V3(INH3,ICH4)*
     &  CS3S3S13S13(ICH3,ICH4,ISt3,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*(4*
     &  aAETN(ISt3)+aA0TN(ISt3)*(2+4*aB0TCH(ICH3,ICH4)+4*
     &  aC0THCHCH(INH3,ICH3,ICH4)*Mah2(INH3))+(1+2*aB0TCH(ICH3,ICH4)+4*
     &  aBEpTCH(ICH3,ICH4)+2*(aC0THCHCH(INH3,ICH3,ICH4)+2*
     &  aCepTHCHCH(INH3,ICH3,ICH4))*Mah2(INH3))*MassSu2(ISt3)))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .gt. 1D-15) then       
       selfW=selfW+(-3*CS1S3V3(INH3,ICH4)*CS3S3S14S14(ICH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(2*a0t5+4*aet5+MSQ2+2*(2*a0t5+MSQ2)*
     &  aB0TCH(ICH3,ICH4)+4*MSQ2*aBEpTCH(ICH3,ICH4)+2*((2*a0t5+MSQ2)*
     &  aC0THCHCH(INH3,ICH3,ICH4)+2*MSQ2*aCepTHCHCH(INH3,ICH3,ICH4))*
     &  Mah2(INH3)))/16.
              endif
       enddo 
       enddo 
       enddo 

c
c topo1-NoGBC
c
c#define MATHEMATICA
#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[1][Nhung1]=",DBLE(selfW)
       selfW=0
#endif
     
        Do ICH3=1,2
        Do INH3=1,6
        Do INH4=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .lt. 1D-15) then 
        do INH5=1,6
       selfW=selfW-(CS1S1S1S1(INH3,INH4,INH5,INH5)*CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETNH(INH5)+A0TNH(INH5)*(2+4*
     &  aB0TNCH(INH4,ICH3)+4*aC0THHCH(INH3,INH4,ICH3)*Mah2(INH3))+(1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3)+2*
     &  (aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*
     &  Mah2(INH3))*Mah2(INH5)))/32.
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .lt. 1D-15) then 
        do INH4=1,6
       selfW=selfW-(CS1S1S3S3(INH4,INH4,ICH3,ICH4)*CS1S3V3(INH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETNH(INH4)+A0TNH(INH4)*(2+4*
     &  aB0TCH(ICH3,ICH4)+4*aC0THCHCH(INH3,ICH3,ICH4)*Mah2(INH3))+(1+2*
     &  aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4)+2*
     &  (aC0THCHCH(INH3,ICH3,ICH4)+2*aCepTHCHCH(INH3,ICH3,ICH4))*
     &  Mah2(INH3))*Mah2(INH4)))/32.
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do INH3=1,6
        Do INH4=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .lt. 1D-15) then 
        do ICH4=1,2
       selfW=selfW-(CS1S1S3S3(INH3,INH4,ICH4,ICH4)*CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETHpN(ICH4)+A0THpN(ICH4)*(2+4*
     &  aB0TNCH(INH4,ICH3)+4*aC0THHCH(INH3,INH4,ICH3)*Mah2(INH3))+(1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3)+2*
     &  (aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*
     &  Mah2(INH3))*MassHpm(ICH4)**2))/16.
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .lt. 1D-15) then 
        do ICH5=1,2
       selfW=selfW-(CS1S3V3(INH3,ICH4)*CS3S3S3S3(ICH3,ICH5,ICH4,ICH5)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*AETHpN(ICH5)+A0THpN(ICH5)*(2+4*
     &  aB0TCH(ICH3,ICH4)+4*aC0THCHCH(INH3,ICH3,ICH4)*Mah2(INH3))+(1+2*
     &  aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4)+2*
     &  (aC0THCHCH(INH3,ICH3,ICH4)+2*aCepTHCHCH(INH3,ICH3,ICH4))*
     &  Mah2(INH3))*MassHpm(ICH5)**2))/16.
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do INH3=1,6
        Do INH4=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .lt. 1D-15) then 
        do ISt3=1,2
       selfW=selfW+(-3*CS1S3V3(INH4,ICH3)*CSSSS(INH3,INH4,ISt3,ISt3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*aAETN(ISt3)+aA0TN(ISt3)*(2+4*
     &  aB0TNCH(INH4,ICH3)+4*aC0THHCH(INH3,INH4,ICH3)*Mah2(INH3))+(1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3)+2*
     &  (aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*
     &  Mah2(INH3))*MassSu2(ISt3)))/16.
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .lt. 1D-15) then 
        do ISt3=1,2
       selfW=selfW+(-3*CS1S3V3(INH3,ICH4)*
     &  CS3S3S13S13(ICH3,ICH4,ISt3,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*(4*
     &  aAETN(ISt3)+aA0TN(ISt3)*(2+4*aB0TCH(ICH3,ICH4)+4*
     &  aC0THCHCH(INH3,ICH3,ICH4)*Mah2(INH3))+(1+2*aB0TCH(ICH3,ICH4)+4*
     &  aBEpTCH(ICH3,ICH4)+2*(aC0THCHCH(INH3,ICH3,ICH4)+2*
     &  aCepTHCHCH(INH3,ICH3,ICH4))*Mah2(INH3))*MassSu2(ISt3)))/16.
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .lt. 1D-15) then 
       selfW=selfW+(-3*CS1S3V3(INH3,ICH4)*CS3S3S14S14(ICH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(2*a0t5+4*aet5+MSQ2+2*(2*a0t5+MSQ2)*
     &  aB0TCH(ICH3,ICH4)+4*MSQ2*aBEpTCH(ICH3,ICH4)+2*((2*a0t5+MSQ2)*
     &  aC0THCHCH(INH3,ICH3,ICH4)+2*MSQ2*aCepTHCHCH(INH3,ICH3,ICH4))*
     &  Mah2(INH3)))/16.
              endif
        Enddo 
        Enddo 
        Enddo 

c
c topo1-GBC
c

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[1][Nhung1]=",DBLE(selfW)
       selfW=0
#endif

       do INe3=1,3
       do INe4=1,3
       do INH3=1,6
       selfW=selfW+((CF11F12V3R(INe4)*(CFF11S1R(INe4,INe3,INH3)*(-
     &  (CFF12S1R(INH3)*(FD111ChaChaH(2,INH3)-FD111ChaChiH(2,INe3,INH3)
     &  -FD111ChaChiH(2,INe4,INH3)+FD111ChiChiH(2,INe3,INe4,INH3))*(2*
     &  MCha2*DCONJG(CF11F12V3L(INe3))-MCha*DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3)))+CFF12S1L(INH3)*(-2*DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChaChaH(7,INH3)-FD111ChaChiH(7,INe3,INH3)-
     &  FD111ChaChiH(7,INe4,INH3)+FD111ChiChiH(7,INe3,INe4,INH3))+MCha*
     &  DCONJG(CF11F12V3R(INe3))*(FD111ChaChaH(4,INH3)-
     &  FD111ChaChiH(4,INe3,INH3)-FD111ChiChaH(4,INe4,INH3)+
     &  FD111ChiChiH(4,INe4,INe3,INH3))*MNeu(INe3)))+
     &  CFF11S1L(INe4,INe3,INH3)*(CFF12S1L(INH3)*(FD111ChaChaH(2,INH3)-
     &  FD111ChaChiH(2,INe3,INH3)-FD111ChaChiH(2,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe4,INH3))*(MCha*DCONJG(CF11F12V3R(INe3))-
     &  2*DCONJG(CF11F12V3L(INe3))*MNeu(INe3))+CFF12S1R(INH3)*(MCha*
     &  DCONJG(CF11F12V3R(INe3))*(FD111ChaChaH(4,INH3)-
     &  FD111ChaChiH(4,INe4,INH3)-FD111ChiChaH(4,INe3,INH3)+
     &  FD111ChiChiH(4,INe3,INe4,INH3))+2*MCha2*DCONJG(CF11F12V3L(INe3)
     &  )*(FD111ChaChiH(1,INe3,INH3)+FD111ChaChiH(1,INe4,INH3)-
     &  FD111ChaHCha(1,INH3)-FD111ChiChiH(1,INe3,INe4,INH3))*MNeu(INe3)
     &  ))*MNeu(INe4))+CF11F12V3L(INe4)*(CFF11S1L(INe4,INe3,INH3)*(-
     &  (CFF12S1L(INH3)*(FD111ChaChaH(2,INH3)-FD111ChaChiH(2,INe3,INH3)
     &  -FD111ChaChiH(2,INe4,INH3)+FD111ChiChiH(2,INe3,INe4,INH3))*(2*
     &  MCha2*DCONJG(CF11F12V3R(INe3))-MCha*DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3)))+CFF12S1R(INH3)*(-2*DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChaChaH(7,INH3)-FD111ChaChiH(7,INe3,INH3)-
     &  FD111ChaChiH(7,INe4,INH3)+FD111ChiChiH(7,INe3,INe4,INH3))+MCha*
     &  DCONJG(CF11F12V3L(INe3))*(FD111ChaChaH(4,INH3)-
     &  FD111ChaChiH(4,INe3,INH3)-FD111ChiChaH(4,INe4,INH3)+
     &  FD111ChiChiH(4,INe4,INe3,INH3))*MNeu(INe3)))+
     &  CFF11S1R(INe4,INe3,INH3)*(CFF12S1R(INH3)*(FD111ChaChaH(2,INH3)-
     &  FD111ChaChiH(2,INe3,INH3)-FD111ChaChiH(2,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe4,INH3))*(MCha*DCONJG(CF11F12V3L(INe3))-
     &  2*DCONJG(CF11F12V3R(INe3))*MNeu(INe3))+CFF12S1L(INH3)*(MCha*
     &  DCONJG(CF11F12V3L(INe3))*(FD111ChaChaH(4,INH3)-
     &  FD111ChaChiH(4,INe4,INH3)-FD111ChiChaH(4,INe3,INH3)+
     &  FD111ChiChiH(4,INe3,INe4,INH3))+2*MCha2*DCONJG(CF11F12V3R(INe3)
     &  )*(FD111ChaChiH(1,INe3,INH3)+FD111ChaChiH(1,INe4,INH3)-
     &  FD111ChaHCha(1,INH3)-FD111ChiChiH(1,INe3,INe4,INH3))*MNeu(INe3)
     &  ))*MNeu(INe4)))/(4.*(MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4)))+(CF11F12V3R(INe4)*(2*MCha*
     &  CFF11S1L(INe4,INe3,INH3)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4)*
     &  (MCha2-MNeu2(INe3))*(CFF12S1R(INH3)*(4*a0tcha+3*MCha2-4*
     &  A0TNeu(INe4)-3*MNeu2(INe4))+2*CFF12S1L(INH3)*(MCha2-MNeu2(INe4)
     &  ))+CFF11S1R(INe4,INe3,INH3)*(4*MCha*CFF12S1R(INH3)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(MCha2-MNeu2(INe3))*(MCha2-
     &  MNeu2(INe4))+CFF12S1L(INH3)*(2*MCha*DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3)*(4*a0tcha+3*MCha2-4*A0TNeu(INe3)-3*MNeu2(INe3))*
     &  (MCha2-MNeu2(INe4))+DCONJG(CF11F12V3L(INe3))*(-24*a0tcha*MCha2*
     &  *2-10*MCha2**3+MNeu(INe3)**6+6*MCha2*MNeu(INe4)**4+MNeu(INe4)**
     &  6+12*a0tcha*MCha2*MNeu2(INe3)+5*MCha2**2*MNeu2(INe3)+12*MCha2*
     &  A0TNeu(INe3)*MNeu2(INe3)+MNeu(INe4)**4*MNeu2(INe3)-MCha2*
     &  MNeu2(INe3)**2+2*MNeu2(INe3)**3+12*a0tcha*MCha2*MNeu2(INe4)+5*
     &  MCha2**2*MNeu2(INe4)+12*MCha2*A0TNeu(INe4)*MNeu2(INe4)-3*
     &  MNeu(INe4)**4*MNeu2(INe4)-12*A0TNeu(INe3)*MNeu2(INe3)*
     &  MNeu2(INe4)-12*A0TNeu(INe4)*MNeu2(INe3)*MNeu2(INe4)-6*
     &  MNeu2(INe3)**2*MNeu2(INe4)-MCha2*MNeu2(INe4)**2-6*MNeu2(INe3)*
     &  MNeu2(INe4)**2+2*MNeu2(INe4)**3+MNeu(INe3)**4*(6*MCha2-3*
     &  MNeu2(INe3)+MNeu2(INe4))-2*Mah2(INH3)*(6*MCha2**2+MNeu(INe3)**
     &  4+MNeu(INe4)**4-6*MCha2*MNeu2(INe3)-MNeu2(INe3)**2-6*MCha2*
     &  MNeu2(INe4)+6*MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe4)**2)))))+
     &  CF11F12V3L(INe4)*(2*MCha*CFF11S1R(INe4,INe3,INH3)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4)*(MCha2-MNeu2(INe3))*
     &  (CFF12S1L(INH3)*(4*a0tcha+3*MCha2-4*A0TNeu(INe4)-3*MNeu2(INe4))
     &  +2*CFF12S1R(INH3)*(MCha2-MNeu2(INe4)))+CFF11S1L(INe4,INe3,INH3)
     &  *(4*MCha*CFF12S1L(INH3)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*
     &  (MCha2-MNeu2(INe3))*(MCha2-MNeu2(INe4))+CFF12S1R(INH3)*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(4*a0tcha+3*MCha2-4*
     &  A0TNeu(INe3)-3*MNeu2(INe3))*(MCha2-MNeu2(INe4))+
     &  DCONJG(CF11F12V3R(INe3))*(-24*a0tcha*MCha2**2-10*MCha2**3+
     &  MNeu(INe3)**6+6*MCha2*MNeu(INe4)**4+MNeu(INe4)**6+12*a0tcha*
     &  MCha2*MNeu2(INe3)+5*MCha2**2*MNeu2(INe3)+12*MCha2*A0TNeu(INe3)*
     &  MNeu2(INe3)+MNeu(INe4)**4*MNeu2(INe3)-MCha2*MNeu2(INe3)**2+2*
     &  MNeu2(INe3)**3+12*a0tcha*MCha2*MNeu2(INe4)+5*MCha2**2*
     &  MNeu2(INe4)+12*MCha2*A0TNeu(INe4)*MNeu2(INe4)-3*MNeu(INe4)**4*
     &  MNeu2(INe4)-12*A0TNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)-12*
     &  A0TNeu(INe4)*MNeu2(INe3)*MNeu2(INe4)-6*MNeu2(INe3)**2*
     &  MNeu2(INe4)-MCha2*MNeu2(INe4)**2-6*MNeu2(INe3)*MNeu2(INe4)**2+
     &  2*MNeu2(INe4)**3+MNeu(INe3)**4*(6*MCha2-3*MNeu2(INe3)+
     &  MNeu2(INe4))-2*Mah2(INH3)*(6*MCha2**2+MNeu(INe3)**4+MNeu(INe4)*
     &  *4-6*MCha2*MNeu2(INe3)-MNeu2(INe3)**2-6*MCha2*MNeu2(INe4)+6*
     &  MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe4)**2))))))/(64.*(MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4))))
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
       selfW=selfW+((CF11F12S3R(INe4,ICH3)*(CF11F12V3R(INe4)*(-
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChaChaHp(2,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD111ChiChiHp(2,INe3,INe4,ICH3))*(MCha2*DCONJG(CF11F12V3L(INe3)
     &  )-2*MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(2*DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChaChaHp(7,ICH3)-FD111ChaChiHp(7,INe3,ICH3)-
     &  FD111ChaChiHp(7,INe4,ICH3)+FD111ChiChiHp(7,INe3,INe4,ICH3))+
     &  MCha*DCONJG(CF11F12V3L(INe3))*(-FD111ChaChaHp(4,ICH3)+
     &  FD111ChaChiHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)-
     &  FD111ChiChiHp(4,INe4,INe3,ICH3))*MNeu(INe3)))+CF11F12V3L(INe4)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChaChaHp(2,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD111ChiChiHp(2,INe3,INe4,ICH3))*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))-DCONJG(CF11F12V3R(INe3))*MNeu(INe3))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(MCha*DCONJG(CF11F12V3R(INe3))*(-
     &  FD111ChaChaHp(4,ICH3)+FD111ChaChiHp(4,INe4,ICH3)+
     &  FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChiHp(4,INe3,INe4,ICH3))+2*
     &  MCha2*DCONJG(CF11F12V3L(INe3))*(FD111ChaChaHp(1,ICH3)-
     &  FD111ChaChiHp(1,INe3,ICH3)-FD111ChaChiHp(1,INe4,ICH3)+
     &  FD111ChiChiHp(1,INe3,INe4,ICH3))*MNeu(INe3)))*MNeu(INe4))+
     &  CF11F12S3L(INe4,ICH3)*(CF11F12V3L(INe4)*(-
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChaChaHp(2,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD111ChiChiHp(2,INe3,INe4,ICH3))*(MCha2*DCONJG(CF11F12V3R(INe3)
     &  )-2*MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(2*DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChaChaHp(7,ICH3)-FD111ChaChiHp(7,INe3,ICH3)-
     &  FD111ChaChiHp(7,INe4,ICH3)+FD111ChiChiHp(7,INe3,INe4,ICH3))+
     &  MCha*DCONJG(CF11F12V3R(INe3))*(-FD111ChaChaHp(4,ICH3)+
     &  FD111ChaChiHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)-
     &  FD111ChiChiHp(4,INe4,INe3,ICH3))*MNeu(INe3)))+CF11F12V3R(INe4)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChaChaHp(2,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD111ChiChiHp(2,INe3,INe4,ICH3))*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(MCha*DCONJG(CF11F12V3L(INe3))*(-
     &  FD111ChaChaHp(4,ICH3)+FD111ChaChiHp(4,INe4,ICH3)+
     &  FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChiHp(4,INe3,INe4,ICH3))+2*
     &  MCha2*DCONJG(CF11F12V3R(INe3))*(FD111ChaChaHp(1,ICH3)-
     &  FD111ChaChiHp(1,INe3,ICH3)-FD111ChaChiHp(1,INe4,ICH3)+
     &  FD111ChiChiHp(1,INe3,INe4,ICH3))*MNeu(INe3)))*MNeu(INe4)))/(4.*
     &  (MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+(-(CF11F12S3R(INe4,ICH3)*(2*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe4)*(MCha2-MNeu2(INe3))*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(4*a0tcha+3*MCha2-4*A0TNeu(INe4)-
     &  3*MNeu2(INe4))+2*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  (MCha2-MNeu2(INe4)))+CF11F12V3R(INe4)*(4*MCha2*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*(MCha2-
     &  MNeu2(INe3))*(MCha2-MNeu2(INe4))+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (2*MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(4*a0tcha+3*MCha2-
     &  4*A0TNeu(INe3)-3*MNeu2(INe3))*(MCha2-MNeu2(INe4))+
     &  DCONJG(CF11F12V3R(INe3))*(-24*a0tcha*MCha2**2-10*MCha2**3+
     &  MNeu(INe3)**6+6*MCha2*MNeu(INe4)**4+MNeu(INe4)**6+12*a0tcha*
     &  MCha2*MNeu2(INe3)+5*MCha2**2*MNeu2(INe3)+12*MCha2*A0TNeu(INe3)*
     &  MNeu2(INe3)+MNeu(INe4)**4*MNeu2(INe3)-MCha2*MNeu2(INe3)**2+2*
     &  MNeu2(INe3)**3+12*a0tcha*MCha2*MNeu2(INe4)+5*MCha2**2*
     &  MNeu2(INe4)+12*MCha2*A0TNeu(INe4)*MNeu2(INe4)-3*MNeu(INe4)**4*
     &  MNeu2(INe4)-12*A0TNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)-12*
     &  A0TNeu(INe4)*MNeu2(INe3)*MNeu2(INe4)-6*MNeu2(INe3)**2*
     &  MNeu2(INe4)-MCha2*MNeu2(INe4)**2-6*MNeu2(INe3)*MNeu2(INe4)**2+
     &  2*MNeu2(INe4)**3+MNeu(INe3)**4*(6*MCha2-3*MNeu2(INe3)+
     &  MNeu2(INe4))-2*MassHpm(ICH3)**2*(6*MCha2**2+MNeu(INe3)**4+
     &  MNeu(INe4)**4-6*MCha2*MNeu2(INe3)-MNeu2(INe3)**2-6*MCha2*
     &  MNeu2(INe4)+6*MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe4)**2))))))+
     &  CF11F12S3L(INe4,ICH3)*(-2*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4)*(MCha2-MNeu2(INe3))*(MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(4*a0tcha+3*MCha2-4*A0TNeu(INe4)-
     &  3*MNeu2(INe4))+2*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  (MCha2-MNeu2(INe4)))+CF11F12V3L(INe4)*(-4*MCha2*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*(MCha2-
     &  MNeu2(INe3))*(MCha2-MNeu2(INe4))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (-2*MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(4*a0tcha+3*MCha2-
     &  4*A0TNeu(INe3)-3*MNeu2(INe3))*(MCha2-MNeu2(INe4))+
     &  DCONJG(CF11F12V3L(INe3))*(24*a0tcha*MCha2**2+10*MCha2**3-
     &  MNeu(INe3)**6-6*MCha2*MNeu(INe4)**4-MNeu(INe4)**6-12*a0tcha*
     &  MCha2*MNeu2(INe3)-5*MCha2**2*MNeu2(INe3)-12*MCha2*A0TNeu(INe3)*
     &  MNeu2(INe3)-MNeu(INe4)**4*MNeu2(INe3)+MCha2*MNeu2(INe3)**2-2*
     &  MNeu2(INe3)**3-12*a0tcha*MCha2*MNeu2(INe4)-5*MCha2**2*
     &  MNeu2(INe4)-12*MCha2*A0TNeu(INe4)*MNeu2(INe4)+3*MNeu(INe4)**4*
     &  MNeu2(INe4)+12*A0TNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)+12*
     &  A0TNeu(INe4)*MNeu2(INe3)*MNeu2(INe4)+6*MNeu2(INe3)**2*
     &  MNeu2(INe4)+MCha2*MNeu2(INe4)**2+6*MNeu2(INe3)*MNeu2(INe4)**2-
     &  2*MNeu2(INe4)**3-MNeu(INe3)**4*(6*MCha2-3*MNeu2(INe3)+
     &  MNeu2(INe4))+2*MassHpm(ICH3)**2*(6*MCha2**2+MNeu(INe3)**4+
     &  MNeu(INe4)**4-6*MCha2*MNeu2(INe3)-MNeu2(INe3)**2-6*MCha2*
     &  MNeu2(INe4)+6*MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe4)**2))))))
     &  /(64.*(MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4))))
       enddo 
       enddo 
       enddo 


       do INe3=1,3
       do ISt3=1,2
       selfW=selfW+((-3*(-2*CF4F3V3*M1*CF11F12V3R(INe3)*
     &  CF11FSLC(INe3,ISt3)*CF12F4S(ISt3)*FD111BChaST(7,ISt3)-2*M1*
     &  CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)*DCONJG(CF4F3V3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111BChaST(7,ISt3)+2*CF4F3V3*M1*
     &  CF11F12V3R(INe3)*CF11FSLC(INe3,ISt3)*CF12F4S(ISt3)*
     &  FD111BChiST(7,INe3,ISt3)+2*M1*CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)
     &  *DCONJG(CF4F3V3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111BChiST(7,INe3,ISt3)+2*CF4F3V3*M1*CF11F12V3R(INe3)*
     &  CF11FSLC(INe3,ISt3)*CF12F4S(ISt3)*FD111TChaST(7,ISt3)+2*M1*
     &  CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)*DCONJG(CF4F3V3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChaST(7,ISt3)-2*CF4F3V3*M1*
     &  CF11F12V3R(INe3)*CF11FSLC(INe3,ISt3)*CF12F4S(ISt3)*
     &  FD111TChiST(7,INe3,ISt3)-2*M1*CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)
     &  *DCONJG(CF4F3V3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChiST(7,INe3,ISt3)-2*CF4F3V3*M12*CF11F12V3R(INe3)*
     &  CF11FSRC(INe3,ISt3)*CF12F4S(ISt3)*FD111BChaST(2,ISt3)*
     &  MNeu(INe3)+M1*MCha*CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)*
     &  DCONJG(CF4F3V3)*DCONJG(CF11F12V3L(INe3))*FD111BChaST(4,ISt3)*
     &  MNeu(INe3)+2*CF4F3V3*M12*CF11F12V3R(INe3)*CF11FSRC(INe3,ISt3)*
     &  CF12F4S(ISt3)*FD111BChiST(2,INe3,ISt3)*MNeu(INe3)-M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)*DCONJG(CF4F3V3)*
     &  DCONJG(CF11F12V3L(INe3))*FD111BChiST(4,INe3,ISt3)*MNeu(INe3)+2*
     &  CF4F3V3*M12*CF11F12V3R(INe3)*CF11FSRC(INe3,ISt3)*CF12F4S(ISt3)*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)-M1*MCha*CF11FSL(INe3,ISt3)*
     &  CF12F4SC(ISt3)*DCONJG(CF4F3V3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(4,ISt3)*MNeu(INe3)-2*CF4F3V3*M12*CF11F12V3R(INe3)*
     &  CF11FSRC(INe3,ISt3)*CF12F4S(ISt3)*FD111TChiST(2,INe3,ISt3)*
     &  MNeu(INe3)+M1*MCha*CF11FSL(INe3,ISt3)*CF12F4SC(ISt3)*
     &  DCONJG(CF4F3V3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(4,INe3,ISt3)*MNeu(INe3)+M12*CF11FSR(INe3,ISt3)*
     &  CF12F4SC(ISt3)*DCONJG(CF4F3V3)*(FD111BChaST(2,ISt3)-
     &  FD111BChiST(2,INe3,ISt3)-FD111TChaST(2,ISt3)+
     &  FD111TChiST(2,INe3,ISt3))*(MCha*DCONJG(CF11F12V3L(INe3))-2*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))+CF4F3V3*MCha*
     &  CF11F12V3L(INe3)*CF12F4S(ISt3)*(M12*CF11FSRC(INe3,ISt3)*
     &  (FD111BChaST(2,ISt3)-FD111BChiST(2,INe3,ISt3)-
     &  FD111TChaST(2,ISt3)+FD111TChiST(2,INe3,ISt3))+M1*
     &  CF11FSLC(INe3,ISt3)*(FD111BChaST(4,ISt3)-
     &  FD111BChiST(4,INe3,ISt3)-FD111TChaST(4,ISt3)+
     &  FD111TChiST(4,INe3,ISt3))*MNeu(INe3))))/(4.*M1*M12*(MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3)))+(3*(CF4F3V3*CF11F12V3R(INe3)*
     &  CF11FSLC(INe3,ISt3)*CF12F4S(ISt3)*(-12*a0t1*M12*MCha2-12*
     &  a0tcha*M12*MCha2-5*M12**2*MCha2-5*M12*MCha2**2+MNeu(INe3)**6+
     &  MNeu(INe3)**4*(6*M12+16*aA0TN(ISt3)-3*MNeu2(INe3))+12*a0t1*M12*
     &  MNeu2(INe3)+5*M12**2*MNeu2(INe3)+12*M12*A0TNeu(INe3)*
     &  MNeu2(INe3)-M12*MNeu2(INe3)**2-16*aA0TN(ISt3)*MNeu2(INe3)**2+2*
     &  MNeu2(INe3)**3-2*MassSu2(ISt3)*(6*M12*MCha2+MNeu(INe3)**4-6*
     &  M12*MNeu2(INe3)-MNeu2(INe3)**2))+2*CF4F3V3*MCha*
     &  CF11F12V3L(INe3)*CF12F4S(ISt3)*(M12*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*(4*a0tcha+3*MCha2-4*A0TNeu(INe3)-3*MNeu2(INe3))+M1*
     &  CF11FSRC(INe3,ISt3)*(2*M12*MCha2+MNeu(INe3)**4-2*M12*
     &  MNeu2(INe3)-MNeu2(INe3)**2))+CF12F4SC(ISt3)*DCONJG(CF4F3V3)*(2*
     &  M1*MCha*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*(2*M12*
     &  MCha2+MNeu(INe3)**4-2*M12*MNeu2(INe3)-MNeu2(INe3)**2)+
     &  CF11FSL(INe3,ISt3)*(2*M12*MCha*DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3)*(4*a0tcha+3*MCha2-4*A0TNeu(INe3)-3*MNeu2(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*(-12*a0t1*M12*MCha2-12*a0tcha*M12*
     &  MCha2-5*M12**2*MCha2-5*M12*MCha2**2+MNeu(INe3)**6+MNeu(INe3)**
     &  4*(6*M12+16*aA0TN(ISt3)-3*MNeu2(INe3))+12*a0t1*M12*MNeu2(INe3)+
     &  5*M12**2*MNeu2(INe3)+12*M12*A0TNeu(INe3)*MNeu2(INe3)-M12*
     &  MNeu2(INe3)**2-16*aA0TN(ISt3)*MNeu2(INe3)**2+2*MNeu2(INe3)**3-
     &  2*MassSu2(ISt3)*(6*M12*MCha2+MNeu(INe3)**4-6*M12*MNeu2(INe3)-
     &  MNeu2(INe3)**2))))))/(64.*M12*(MCha2-MNeu2(INe3))))
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[2][Nhung1]=",DBLE(selfW)
       selfW=0
#endif
c
c topo2-NoGBC
c
c
c topo2-GBC
c
       do ICH3=1,2
       do INH3=1,6
              if( Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+2*((3*CF4F3V3*IC*CS1S3V3(INH3,ICH3)*CTBS3C(ICH3)*(M12*
     &  FD111BHpT(2,ICH3)*hy(INH3)-M12*FD111BHT(2,INH3)*hy(INH3)-M12*
     &  FD111THpT(2,ICH3)*hy(INH3)+M12*FD111THT(2,INH3)*hy(INH3)+
     &  FD111BHpT(5,ICH3)*hyc(INH3)+FD111BHpT(6,ICH3)*hyc(INH3)-2*
     &  FD111BHpT(7,ICH3)*hyc(INH3)-FD111BHT(5,INH3)*hyc(INH3)-
     &  FD111BHT(6,INH3)*hyc(INH3)+2*FD111BHT(7,INH3)*hyc(INH3)-
     &  FD111THpT(5,ICH3)*hyc(INH3)-FD111THpT(6,ICH3)*hyc(INH3)+2*
     &  FD111THpT(7,ICH3)*hyc(INH3)+FD111THT(5,INH3)*hyc(INH3)+
     &  FD111THT(6,INH3)*hyc(INH3)-2*FD111THT(7,INH3)*hyc(INH3)))/(4.*
     &  M12*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))+(3*
     &  CF4F3V3*IC*CS1S3V3(INH3,ICH3)*CTBS3C(ICH3)*(4*M12*hy(INH3)*(-
     &  Mah2(INH3)+MassHpm(ICH3)**2)+hyc(INH3)*(-((4*a0t1+11*M12+8*
     &  A0TNH(INH3))*Mah2(INH3))-2*Mah2(INH3)**2+MassHpm(ICH3)**2*(4*
     &  a0t1+11*M12+8*A0THpN(ICH3)+2*MassHpm(ICH3)**2))))/(64.*
     &  (Mah2(INH3)-MassHpm(ICH3)**2)))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+2*((-3*CF4F3V3*IC*CS1S3V3(INH3,ICH3)*CTBS3C(ICH3)*
     &  (M12*FD211HpBT(2,ICH3)*hy(INH3)-M12*FD211HpTT(2,ICH3)*hy(INH3)+
     &  (FD211HpBT(6,ICH3)-2*FD211HpBT(7,ICH3)+FD211HpBT(9,ICH3)-
     &  FD211HpTT(6,ICH3)+2*FD211HpTT(7,ICH3)-FD211HpTT(9,ICH3))*
     &  hyc(INH3)))/(4.*M12)-(3*CF4F3V3*IC*CS1S3V3(INH3,ICH3)*
     &  CTBS3C(ICH3)*(4*M12*hy(INH3)+hyc(INH3)*(4*a0t1+11*M12+16*
     &  A0THpN(ICH3)-4*MassHpm(ICH3)**2)))/64.)
               endif
              endif
       enddo 
       enddo 
       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
       do INH3=1,6
              if( Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+2*((IC*CS1S3V3(INH3,ICH3)*(CF11F12S3L(INe4,ICH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChaHChi(5,INH3,INe4)+FD111ChaHChi(6,INH3,INe4)-2*
     &  FD111ChaHChi(7,INH3,INe4)-FD111ChaHpChi(5,ICH3,INe4)-
     &  FD111ChaHpChi(6,ICH3,INe4)+2*FD111ChaHpChi(7,ICH3,INe4)-
     &  FD111ChiHChi(5,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH3,INe4)+
     &  2*FD111ChiHChi(7,INe3,INH3,INe4)+
     &  FD111ChiHpChi(5,INe3,ICH3,INe4)+FD111ChiHpChi(6,INe3,ICH3,INe4)
     &  -2*FD111ChiHpChi(7,INe3,ICH3,INe4))+MCha*
     &  DCONJG(CF11F12V3R(INe3))*(FD111ChaHChi(2,INH3,INe4)-
     &  FD111ChaHChi(3,INH3,INe4)-FD111ChaHpChi(2,ICH3,INe4)+
     &  FD111ChaHpChi(3,ICH3,INe4)-FD111ChiHChi(2,INe3,INH3,INe4)+
     &  FD111ChiHChi(3,INe3,INH3,INe4)+FD111ChiHpChi(2,INe3,ICH3,INe4)-
     &  FD111ChiHpChi(3,INe3,ICH3,INe4))*MNeu(INe3))+
     &  CFF11S1L(INe3,INe4,INH3)*(FD111ChaHChi(2,INH3,INe4)-
     &  FD111ChaHpChi(2,ICH3,INe4)-FD111ChiHChi(2,INe3,INH3,INe4)+
     &  FD111ChiHpChi(2,INe3,ICH3,INe4))*(MCha*DCONJG(CF11F12V3R(INe3))
     &  +DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3R(INe4,ICH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (DCONJG(CF11F12V3R(INe3))*(FD111ChaHChi(5,INH3,INe4)+
     &  FD111ChaHChi(6,INH3,INe4)-2*FD111ChaHChi(7,INH3,INe4)-
     &  FD111ChaHpChi(5,ICH3,INe4)-FD111ChaHpChi(6,ICH3,INe4)+2*
     &  FD111ChaHpChi(7,ICH3,INe4)-FD111ChiHChi(5,INe3,INH3,INe4)-
     &  FD111ChiHChi(6,INe3,INH3,INe4)+2*FD111ChiHChi(7,INe3,INH3,INe4)
     &  +FD111ChiHpChi(5,INe3,ICH3,INe4)+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)-2*
     &  FD111ChiHpChi(7,INe3,ICH3,INe4))+MCha*DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChaHChi(2,INH3,INe4)-FD111ChaHChi(3,INH3,INe4)-
     &  FD111ChaHpChi(2,ICH3,INe4)+FD111ChaHpChi(3,ICH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH3,INe4)+FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHpChi(2,INe3,ICH3,INe4)-FD111ChiHpChi(3,INe3,ICH3,INe4)
     &  )*MNeu(INe3))+CFF11S1R(INe3,INe4,INH3)*
     &  (FD111ChaHChi(2,INH3,INe4)-FD111ChaHpChi(2,ICH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH3,INe4)+FD111ChiHpChi(2,INe3,ICH3,INe4))
     &  *(MCha*DCONJG(CF11F12V3L(INe3))+DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3))*MNeu(INe4))))/(4.*(Mah(INH3)-MassHpm(ICH3))*
     &  (Mah(INH3)+MassHpm(ICH3))*(MCha-MNeu(INe3))*(MCha+MNeu(INe3)))-
     &  (IC*CS1S3V3(INH3,ICH3)*(CF11F12S3L(INe4,ICH3)*(4*
     &  CFF11S1L(INe3,INe4,INH3)*(Mah2(INH3)-MassHpm(ICH3)**2)*(MCha*
     &  DCONJG(CF11F12V3R(INe3))+DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  MNeu(INe4)*(MCha2-MNeu2(INe3))+CFF11S1R(INe3,INe4,INH3)*(-2*
     &  MCha*DCONJG(CF11F12V3R(INe3))*(Mah2(INH3)-MassHpm(ICH3)**2)*
     &  MNeu(INe3)*(4*a0tcha+MCha2-4*A0TNeu(INe3)-MNeu2(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*(2*Mah2(INH3)**2*(MCha2-MNeu2(INe3))+
     &  Mah2(INH3)*(4*a0tcha*MCha2+3*MCha2**2-3*MNeu(INe3)**4+8*
     &  A0TNH(INH3)*(MCha2-MNeu2(INe3))-4*A0TNeu(INe3)*MNeu2(INe3)+8*
     &  MCha2*MNeu2(INe4)-8*MNeu2(INe3)*MNeu2(INe4))+MassHpm(ICH3)**2*
     &  (-4*a0tcha*MCha2-3*MCha2**2+3*MNeu(INe3)**4-8*A0THpN(ICH3)*
     &  (MCha2-MNeu2(INe3))-2*MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))+4*
     &  A0TNeu(INe3)*MNeu2(INe3)-8*MCha2*MNeu2(INe4)+8*MNeu2(INe3)*
     &  MNeu2(INe4)))))+CF11F12S3R(INe4,ICH3)*(4*
     &  CFF11S1R(INe3,INe4,INH3)*(Mah2(INH3)-MassHpm(ICH3)**2)*(MCha*
     &  DCONJG(CF11F12V3L(INe3))+DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*
     &  MNeu(INe4)*(MCha2-MNeu2(INe3))+CFF11S1L(INe3,INe4,INH3)*(-2*
     &  MCha*DCONJG(CF11F12V3L(INe3))*(Mah2(INH3)-MassHpm(ICH3)**2)*
     &  MNeu(INe3)*(4*a0tcha+MCha2-4*A0TNeu(INe3)-MNeu2(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*(2*Mah2(INH3)**2*(MCha2-MNeu2(INe3))+
     &  Mah2(INH3)*(4*a0tcha*MCha2+3*MCha2**2-3*MNeu(INe3)**4+8*
     &  A0TNH(INH3)*(MCha2-MNeu2(INe3))-4*A0TNeu(INe3)*MNeu2(INe3)+8*
     &  MCha2*MNeu2(INe4)-8*MNeu2(INe3)*MNeu2(INe4))+MassHpm(ICH3)**2*
     &  (-4*a0tcha*MCha2-3*MCha2**2+3*MNeu(INe3)**4-8*A0THpN(ICH3)*
     &  (MCha2-MNeu2(INe3))-2*MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))+4*
     &  A0TNeu(INe3)*MNeu2(INe3)-8*MCha2*MNeu2(INe4)+8*MNeu2(INe3)*
     &  MNeu2(INe4)))))))/(64.*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(MCha-MNeu(INe3))*(MCha+MNeu(INe3))))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+2*((IC*CS1S3V3(INH3,ICH3)*(CF11F12S3L(INe4,ICH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(DCONJG(CF11F12V3L(INe3))*
     &  (FD211HpChaChi(6,ICH3,INe4)-2*FD211HpChaChi(7,ICH3,INe4)+
     &  FD211HpChaChi(9,ICH3,INe4)-FD211HpChiChi(6,ICH3,INe3,INe4)+2*
     &  FD211HpChiChi(7,ICH3,INe3,INe4)-FD211HpChiChi(9,ICH3,INe3,INe4)
     &  )+MCha*DCONJG(CF11F12V3R(INe3))*(FD211HpChaChi(2,ICH3,INe4)-
     &  FD211HpChaChi(4,ICH3,INe4)-FD211HpChiChi(2,ICH3,INe3,INe4)+
     &  FD211HpChiChi(4,ICH3,INe3,INe4))*MNeu(INe3))+
     &  CFF11S1L(INe3,INe4,INH3)*(FD211HpChaChi(2,ICH3,INe4)-
     &  FD211HpChiChi(2,ICH3,INe3,INe4))*(MCha*DCONJG(CF11F12V3R(INe3))
     &  +DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3R(INe4,ICH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (DCONJG(CF11F12V3R(INe3))*(FD211HpChaChi(6,ICH3,INe4)-2*
     &  FD211HpChaChi(7,ICH3,INe4)+FD211HpChaChi(9,ICH3,INe4)-
     &  FD211HpChiChi(6,ICH3,INe3,INe4)+2*
     &  FD211HpChiChi(7,ICH3,INe3,INe4)-FD211HpChiChi(9,ICH3,INe3,INe4)
     &  )+MCha*DCONJG(CF11F12V3L(INe3))*(FD211HpChaChi(2,ICH3,INe4)-
     &  FD211HpChaChi(4,ICH3,INe4)-FD211HpChiChi(2,ICH3,INe3,INe4)+
     &  FD211HpChiChi(4,ICH3,INe3,INe4))*MNeu(INe3))+
     &  CFF11S1R(INe3,INe4,INH3)*(FD211HpChaChi(2,ICH3,INe4)-
     &  FD211HpChiChi(2,ICH3,INe3,INe4))*(MCha*DCONJG(CF11F12V3L(INe3))
     &  +DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/(4.*(MCha**
     &  2-MNeu(INe3)**2))-(IC*CS1S3V3(INH3,ICH3)*(CF11F12S3L(INe4,ICH3)
     &  *(4*CFF11S1L(INe3,INe4,INH3)*(MCha*DCONJG(CF11F12V3R(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4)*(MCha2-
     &  MNeu2(INe3))+CFF11S1R(INe3,INe4,INH3)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(-4*a0tcha-MCha2+4*
     &  A0TNeu(INe3)+MNeu2(INe3))+DCONJG(CF11F12V3L(INe3))*(4*a0tcha*
     &  MCha2+3*MCha2**2+3*MNeu(INe3)**4+16*A0THpN(ICH3)*(MCha2-
     &  MNeu2(INe3))-4*MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-6*MNeu2(INe3)**2+8*MCha2*MNeu2(INe4)-
     &  8*MNeu2(INe3)*MNeu2(INe4))))+CF11F12S3R(INe4,ICH3)*(4*
     &  CFF11S1R(INe3,INe4,INH3)*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4)*(MCha2-
     &  MNeu2(INe3))+CFF11S1L(INe3,INe4,INH3)*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(-4*a0tcha-MCha2+4*
     &  A0TNeu(INe3)+MNeu2(INe3))+DCONJG(CF11F12V3R(INe3))*(4*a0tcha*
     &  MCha2+3*MCha2**2+3*MNeu(INe3)**4+16*A0THpN(ICH3)*(MCha2-
     &  MNeu2(INe3))-4*MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-6*MNeu2(INe3)**2+8*MCha2*MNeu2(INe4)-
     &  8*MNeu2(INe3)*MNeu2(INe4))))))/(64.*(MCha2-MNeu2(INe3))))
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do INe3=1,3
       do INH3=1,6
              if( Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+2*((IC*CS1S3V3(INH3,ICH3)*(CF11F12S3L(INe3,ICH3)*(-
     &  (MCha*CFF12S1L(INH3)*(FD111ChaHCha(2,INH3)-
     &  FD111ChaHpCha(2,ICH3)-FD111ChiHCha(2,INe3,INH3)+
     &  FD111ChiHpCha(2,INe3,ICH3))*(MCha*DCONJG(CF11F12V3R(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)))+CFF12S1R(INH3)*
     &  (DCONJG(CF11F12V3R(INe3))*(-FD111ChaHCha(5,INH3)-
     &  FD111ChaHCha(6,INH3)+2*FD111ChaHCha(7,INH3)+
     &  FD111ChaHpCha(5,ICH3)+FD111ChaHpCha(6,ICH3)-2*
     &  FD111ChaHpCha(7,ICH3)+FD111ChiHCha(5,INe3,INH3)+
     &  FD111ChiHCha(6,INe3,INH3)-2*FD111ChiHCha(7,INe3,INH3)-
     &  FD111ChiHpCha(5,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH3)+2*
     &  FD111ChiHpCha(7,INe3,ICH3))+MCha*DCONJG(CF11F12V3L(INe3))*(-
     &  FD111ChaHCha(2,INH3)+FD111ChaHCha(3,INH3)+FD111ChaHpCha(2,ICH3)
     &  -FD111ChaHpCha(3,ICH3)+FD111ChiHCha(2,INe3,INH3)-
     &  FD111ChiHCha(3,INe3,INH3)-FD111ChiHpCha(2,INe3,ICH3)+
     &  FD111ChiHpCha(3,INe3,ICH3))*MNeu(INe3)))+CF11F12S3R(INe3,ICH3)*
     &  (-(MCha*CFF12S1R(INH3)*(FD111ChaHCha(2,INH3)-
     &  FD111ChaHpCha(2,ICH3)-FD111ChiHCha(2,INe3,INH3)+
     &  FD111ChiHpCha(2,INe3,ICH3))*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)))+CFF12S1L(INH3)*
     &  (DCONJG(CF11F12V3L(INe3))*(-FD111ChaHCha(5,INH3)-
     &  FD111ChaHCha(6,INH3)+2*FD111ChaHCha(7,INH3)+
     &  FD111ChaHpCha(5,ICH3)+FD111ChaHpCha(6,ICH3)-2*
     &  FD111ChaHpCha(7,ICH3)+FD111ChiHCha(5,INe3,INH3)+
     &  FD111ChiHCha(6,INe3,INH3)-2*FD111ChiHCha(7,INe3,INH3)-
     &  FD111ChiHpCha(5,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH3)+2*
     &  FD111ChiHpCha(7,INe3,ICH3))+MCha*DCONJG(CF11F12V3R(INe3))*(-
     &  FD111ChaHCha(2,INH3)+FD111ChaHCha(3,INH3)+FD111ChaHpCha(2,ICH3)
     &  -FD111ChaHpCha(3,ICH3)+FD111ChiHCha(2,INe3,INH3)-
     &  FD111ChiHCha(3,INe3,INH3)-FD111ChiHpCha(2,INe3,ICH3)+
     &  FD111ChiHpCha(3,INe3,ICH3))*MNeu(INe3)))))/(4.*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3)))+(IC*CS1S3V3(INH3,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*(4*MCha*CFF12S1R(INH3)*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*(MCha2-MNeu2(INe3))+
     &  CFF12S1L(INH3)*(-2*MCha*DCONJG(CF11F12V3R(INe3))*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)*MNeu(INe3)*(4*a0tcha+MCha2-4*A0TNeu(INe3)-
     &  MNeu2(INe3))+DCONJG(CF11F12V3L(INe3))*(2*Mah2(INH3)**2*(MCha2-
     &  MNeu2(INe3))+Mah2(INH3)*(4*a0tcha*MCha2+11*MCha2**2-MNeu(INe3)*
     &  *4+8*A0TNH(INH3)*(MCha2-MNeu2(INe3))-8*MCha2*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-2*MNeu2(INe3)**2)+MassHpm(ICH3)**2*(-
     &  4*a0tcha*MCha2-11*MCha2**2+MNeu(INe3)**4-8*A0THpN(ICH3)*(MCha2-
     &  MNeu2(INe3))-2*MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))+8*MCha2*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2))))+
     &  CF11F12S3L(INe3,ICH3)*(4*MCha*CFF12S1L(INH3)*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)*(MCha*DCONJG(CF11F12V3R(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*(MCha2-MNeu2(INe3))+
     &  CFF12S1R(INH3)*(-2*MCha*DCONJG(CF11F12V3L(INe3))*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)*MNeu(INe3)*(4*a0tcha+MCha2-4*A0TNeu(INe3)-
     &  MNeu2(INe3))+DCONJG(CF11F12V3R(INe3))*(2*Mah2(INH3)**2*(MCha2-
     &  MNeu2(INe3))+Mah2(INH3)*(4*a0tcha*MCha2+11*MCha2**2-MNeu(INe3)*
     &  *4+8*A0TNH(INH3)*(MCha2-MNeu2(INe3))-8*MCha2*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-2*MNeu2(INe3)**2)+MassHpm(ICH3)**2*(-
     &  4*a0tcha*MCha2-11*MCha2**2+MNeu(INe3)**4-8*A0THpN(ICH3)*(MCha2-
     &  MNeu2(INe3))-2*MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))+8*MCha2*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2))))))
     &  /(64.*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*
     &  (MCha-MNeu(INe3))*(MCha+MNeu(INe3))))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+2*(-(IC*CS1S3V3(INH3,ICH3)*(CF11F12S3L(INe3,ICH3)*
     &  (MCha*CFF12S1L(INH3)*(FD211HpChaCha(2,ICH3)-
     &  FD211HpChiCha(2,ICH3,INe3))*(MCha*DCONJG(CF11F12V3R(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))+CFF12S1R(INH3)*
     &  (DCONJG(CF11F12V3R(INe3))*(FD211HpChaCha(6,ICH3)-2*
     &  FD211HpChaCha(7,ICH3)+FD211HpChaCha(9,ICH3)-
     &  FD211HpChiCha(6,ICH3,INe3)+2*FD211HpChiCha(7,ICH3,INe3)-
     &  FD211HpChiCha(9,ICH3,INe3))+MCha*DCONJG(CF11F12V3L(INe3))*
     &  (FD211HpChaCha(2,ICH3)-FD211HpChaCha(4,ICH3)-
     &  FD211HpChiCha(2,ICH3,INe3)+FD211HpChiCha(4,ICH3,INe3))*
     &  MNeu(INe3)))+CF11F12S3R(INe3,ICH3)*(MCha*CFF12S1R(INH3)*
     &  (FD211HpChaCha(2,ICH3)-FD211HpChiCha(2,ICH3,INe3))*(MCha*
     &  DCONJG(CF11F12V3L(INe3))+DCONJG(CF11F12V3R(INe3))*MNeu(INe3))+
     &  CFF12S1L(INH3)*(DCONJG(CF11F12V3L(INe3))*(FD211HpChaCha(6,ICH3)
     &  -2*FD211HpChaCha(7,ICH3)+FD211HpChaCha(9,ICH3)-
     &  FD211HpChiCha(6,ICH3,INe3)+2*FD211HpChiCha(7,ICH3,INe3)-
     &  FD211HpChiCha(9,ICH3,INe3))+MCha*DCONJG(CF11F12V3R(INe3))*
     &  (FD211HpChaCha(2,ICH3)-FD211HpChaCha(4,ICH3)-
     &  FD211HpChiCha(2,ICH3,INe3)+FD211HpChiCha(4,ICH3,INe3))*
     &  MNeu(INe3)))))/(4.*(MCha**2-MNeu(INe3)**2))+(IC*
     &  CS1S3V3(INH3,ICH3)*(CF11F12S3R(INe3,ICH3)*(4*MCha*
     &  CFF12S1R(INH3)*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*(MCha2-MNeu2(INe3))+
     &  CFF12S1L(INH3)*(2*MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(-4*
     &  a0tcha-MCha2+4*A0TNeu(INe3)+MNeu2(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*(4*a0tcha*MCha2+11*MCha2**2-3*
     &  MNeu(INe3)**4+16*A0THpN(ICH3)*(MCha2-MNeu2(INe3))-4*
     &  MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))-8*MCha2*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3))))+CF11F12S3L(INe3,ICH3)*(4*MCha*
     &  CFF12S1L(INH3)*(MCha*DCONJG(CF11F12V3R(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*(MCha2-MNeu2(INe3))+
     &  CFF12S1R(INH3)*(2*MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(-4*
     &  a0tcha-MCha2+4*A0TNeu(INe3)+MNeu2(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*(4*a0tcha*MCha2+11*MCha2**2-3*
     &  MNeu(INe3)**4+16*A0THpN(ICH3)*(MCha2-MNeu2(INe3))-4*
     &  MassHpm(ICH3)**2*(MCha2-MNeu2(INe3))-8*MCha2*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3))))))/(64.*(MCha2-MNeu2(INe3))))
               endif
              endif
       enddo 
       enddo 
       enddo 
       do INe3=1,3
       do ISt3=1,2
       selfW=selfW+2*((3*CF12F3S*CS14S13V3(ISt3)*(M1*CF11FSLC(INe3,ISt3)*
     &  (FD111ChaSTT(2,ISt3)-FD111ChiStT(2,INe3,ISt3)-FD111SBChaT(2)+
     &  FD111SBChiT(2,INe3))*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))+CF11FSRC(INe3,ISt3)*
     &  (DCONJG(CF11F12V3R(INe3))*(FD111ChaSTT(5,ISt3)+
     &  FD111ChaSTT(6,ISt3)-2*FD111ChaSTT(7,ISt3)-
     &  FD111ChiStT(5,INe3,ISt3)-FD111ChiStT(6,INe3,ISt3)+2*
     &  FD111ChiStT(7,INe3,ISt3)-FD111SBChaT(6)+2*FD111SBChaT(7)-
     &  FD111SBChaT(8)+FD111SBChiT(6,INe3)-2*FD111SBChiT(7,INe3)+
     &  FD111SBChiT(8,INe3))+MCha*DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChaSTT(2,ISt3)-FD111ChaSTT(3,ISt3)-
     &  FD111ChiStT(2,INe3,ISt3)+FD111ChiStT(3,INe3,ISt3)-
     &  FD111SBChaT(2)+FD111SBChaT(4)+FD111SBChiT(2,INe3)-
     &  FD111SBChiT(4,INe3))*MNeu(INe3))))/(4.*(MSQ-MassSu(ISt3))*(MSQ+
     &  MassSu(ISt3))*(MCha-MNeu(INe3))*(MCha+MNeu(INe3)))+(3*CF12F3S*
     &  CS14S13V3(ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*(MCha*
     &  DCONJG(CF11F12V3L(INe3))+DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*
     &  (2*MCha2*MSQ2-MNeu(INe3)**4-2*MassSu2(ISt3)*(MCha2-MNeu2(INe3))
     &  -2*MSQ2*MNeu2(INe3)+MNeu2(INe3)**2)+CF11FSRC(INe3,ISt3)*(2*
     &  MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(-4*a0tcha*MSQ2-MCha2*
     &  MSQ2+4*A0TNeu(INe3)*(MSQ2-MassSu2(ISt3))-MNeu(INe3)**4+
     &  MassSu2(ISt3)*(4*a0tcha+MCha2-MNeu2(INe3))+MSQ2*MNeu2(INe3)+
     &  MNeu2(INe3)**2)+DCONJG(CF11F12V3R(INe3))*(8*a0t5*MCha2*MSQ2+4*
     &  a0tcha*MCha2*MSQ2+8*M12*MCha2*MSQ2+3*MCha2**2*MSQ2+2*MCha2*
     &  MSQ2**2-(8*a0t1+3*M12+2*MSQ2)*MNeu(INe3)**4-2*MassSu(ISt3)**4*
     &  (MCha2-MNeu2(INe3))-8*a0t5*MSQ2*MNeu2(INe3)-8*M12*MSQ2*
     &  MNeu2(INe3)-2*MSQ2**2*MNeu2(INe3)-4*MSQ2*A0TNeu(INe3)*
     &  MNeu2(INe3)+8*a0t1*MNeu2(INe3)**2+3*M12*MNeu2(INe3)**2-MSQ2*
     &  MNeu2(INe3)**2+MassSu2(ISt3)*(-4*a0tcha*MCha2-8*M12*MCha2-3*
     &  MCha2**2+MNeu(INe3)**4-8*aA0TN(ISt3)*(MCha2-MNeu2(INe3))+8*M12*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2)))))
     &  /(64.*(MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))))
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac/2D0
      Write(16,110) "TwoLoopWSelfNoGBC[3][Nhung1]=",DBLE(selfW)

      Write(16,110) "TwoLoopWSelfNoGBC[4][Nhung1]=",DBLE(selfW)      
       selfW=0
#endif 
c
c topo3+4-NoGBC
c

        ICH3=1
        INH3=6
       selfW=selfW+2*((0D0,-0.046875)*CF4F3V3*CS1S3V3(6,1)*CTBS3C(1)*(4*
     &  M12*hy(6)+(4*a0t1+11*M12)*hyc(6))-((0D0,0.75)*CF4F3V3*
     &  CS1S3V3(6,1)*CTBS3C(1)*(M12*(FD211HpBT(2,1)-FD211HpTT(2,1))*
     &  hy(6)+(FD211HpBT(6,1)-2*FD211HpBT(7,1)+FD211HpBT(9,1)-
     &  FD211HpTT(6,1)+2*FD211HpTT(7,1)-FD211HpTT(9,1))*hyc(6)))/M12)
        ICH3=1
        INH3=6
       do INe3=1,3
       do INe4=1,3
       selfW=selfW+2*(((0D0,0.25)*CS1S3V3(6,1)*(CF11F12S3L(INe4,1)*
     &  (CFF11S1R(INe3,INe4,6)*(DCONJG(CF11F12V3L(INe3))*
     &  (FD211HpChaChi(6,1,INe4)-2*FD211HpChaChi(7,1,INe4)+
     &  FD211HpChaChi(9,1,INe4)-FD211HpChiChi(6,1,INe3,INe4)+2*
     &  FD211HpChiChi(7,1,INe3,INe4)-FD211HpChiChi(9,1,INe3,INe4))+
     &  MCha*DCONJG(CF11F12V3R(INe3))*(FD211HpChaChi(2,1,INe4)-
     &  FD211HpChaChi(4,1,INe4)-FD211HpChiChi(2,1,INe3,INe4)+
     &  FD211HpChiChi(4,1,INe3,INe4))*MNeu(INe3))+CFF11S1L(INe3,INe4,6)
     &  *(FD211HpChaChi(2,1,INe4)-FD211HpChiChi(2,1,INe3,INe4))*(MCha*
     &  DCONJG(CF11F12V3R(INe3))+DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  MNeu(INe4))+CF11F12S3R(INe4,1)*(CFF11S1L(INe3,INe4,6)*
     &  (DCONJG(CF11F12V3R(INe3))*(FD211HpChaChi(6,1,INe4)-2*
     &  FD211HpChaChi(7,1,INe4)+FD211HpChaChi(9,1,INe4)-
     &  FD211HpChiChi(6,1,INe3,INe4)+2*FD211HpChiChi(7,1,INe3,INe4)-
     &  FD211HpChiChi(9,1,INe3,INe4))+MCha*DCONJG(CF11F12V3L(INe3))*
     &  (FD211HpChaChi(2,1,INe4)-FD211HpChaChi(4,1,INe4)-
     &  FD211HpChiChi(2,1,INe3,INe4)+FD211HpChiChi(4,1,INe3,INe4))*
     &  MNeu(INe3))+CFF11S1R(INe3,INe4,6)*(FD211HpChaChi(2,1,INe4)-
     &  FD211HpChiChi(2,1,INe3,INe4))*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3)))+((0D0,0.015625)*CS1S3V3(6,1)*
     &  (CF11F12S3L(INe4,1)*(2*CFF11S1L(INe3,INe4,6)*(MCha*
     &  DCONJG(CF11F12V3R(INe3))+DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  MNeu(INe4)*((-1+2*logx)*MCha2-(1+2*logx)*MCha2+MNeu2(INe3)+(1-
     &  2*logx)*MNeu2(INe3)+2*logx*MNeu2(INe3))+CFF11S1R(INe3,INe4,6)*
     &  (2*MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(4*a0tcha-2*(-1+
     &  logx)*MCha2+(-1+2*logx)*MCha2-4*A0TNeu(INe3)+(1-2*logx)*
     &  MNeu2(INe3)+2*(-1+logx)*MNeu2(INe3))+DCONJG(CF11F12V3L(INe3))*
     &  (-(MCha2*(4*a0tcha+3*MCha2+8*MNeu2(INe4)))+MNeu2(INe3)*(4*
     &  A0TNeu(INe3)+3*MNeu2(INe3)+8*MNeu2(INe4)))))+CF11F12S3R(INe4,1)
     &  *(2*CFF11S1R(INe3,INe4,6)*(MCha*DCONJG(CF11F12V3L(INe3))+
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4)*((-1+2*logx)*
     &  MCha2-(1+2*logx)*MCha2+MNeu2(INe3)+(1-2*logx)*MNeu2(INe3)+2*
     &  logx*MNeu2(INe3))+CFF11S1L(INe3,INe4,6)*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(4*a0tcha-2*(-1+logx)*
     &  MCha2+(-1+2*logx)*MCha2-4*A0TNeu(INe3)+(1-2*logx)*MNeu2(INe3)+
     &  2*(-1+logx)*MNeu2(INe3))+DCONJG(CF11F12V3R(INe3))*(-(MCha2*(4*
     &  a0tcha+3*MCha2+8*MNeu2(INe4)))+MNeu2(INe3)*(4*A0TNeu(INe3)+3*
     &  MNeu2(INe3)+8*MNeu2(INe4)))))))/(MCha2-MNeu2(INe3)))
       enddo 
       enddo 


#ifdef MATHEMATICA
       selfW=selfW*afac/2D0
      Write(16,110) "TwoLoopWSelfGBC[3][Nhung1]=",DBLE(selfW)

      Write(16,110) "TwoLoopWSelfGBC[4][Nhung1]=",DBLE(selfW)      
       selfW=0
#endif

c
c topo3+4-GBC
c


       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
          if( Abs(Mah(INH3) - MassHpm(ICH3)) .gt. 1D-15) then 
                if( Abs(Mah(INH4) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+(-(CS1S1S1(INH3,INH4,INH5)*CS1S3S3(INH5,ICH3,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(INH3,ICH3)))/16.+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S3S3(INH5,ICH3,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHH(2,INH3,INH4,INH5)-FD111HHpH(2,INH3,ICH4,INH5)-
     &  FD111HHpH(2,INH4,ICH3,INH5)+FD111HpHpH(2,ICH3,ICH4,INH5)))/(4.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)*(Mah(INH4)**2-MassHpm(ICH4)**2)
     &  ))
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH5=1,2
       do INH3=1,6
       do ICH3=1,2
       do INH4=1,6
       do ICH4=1,2
          if( Abs(Mah(INH3) - MassHpm(ICH5)) .gt. 1D-15) then 
                if( Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH4,ICH5,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH5)))/16.+
     &  (CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH4,ICH5,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH5))*
     &  (FD111HHpH(2,INH4,ICH4,INH3)-FD111HHpH(4,INH4,ICH4,INH3)+
     &  FD111HHpHp(2,INH3,ICH3,ICH4)+FD111HHpHp(2,INH4,ICH5,ICH4)-
     &  FD111HpHpHp(2,ICH3,ICH5,ICH4)))/(4.*(Mah(INH4)**2-MassHpm(ICH3)
     &  **2)*(Mah(INH3)**2-MassHpm(ICH5)**2)))
                endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do INH3=1,6
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(Mah(INH3) - MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((-3*IC*(CS1S3V3(INH3,ICH3)*CS3S13SC(ICH3,ISt4)*
     &  CSSS(INH3,ISt4,ISt3)*DCONJG(CS14S13V3(ISt3))-CS14S13V3(ISt3)*
     &  CS3S13S(ICH3,ISt4)*CSSS(INH3,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3)))*(FD111HpSTSB(2,ICH3,ISt4)-
     &  FD111HpSTSB(4,ICH3,ISt4)+FD111HpSTST(2,ICH3,ISt3,ISt4)-
     &  FD111HSTSB(2,INH3,ISt4)+FD111HSTSB(4,INH3,ISt4)-
     &  FD111HSTST(2,INH3,ISt3,ISt4)))/(4.*(Mah(INH3)**2-MassHpm(ICH3)*
     &  *2)*(MSQ**2-MassSu(ISt3)**2))+(3*IC*(CS1S3V3(INH3,ICH3)*
     &  CS3S13SC(ICH3,ISt4)*CSSS(INH3,ISt4,ISt3)*DCONJG(CS14S13V3(ISt3)
     &  )-CS14S13V3(ISt3)*CS3S13S(ICH3,ISt4)*CSSS(INH3,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3)))*(Mah2(INH3)-MassHpm(ICH3)**2)*(-
     &  MSQ2+MassSu2(ISt3)))/(16.*(-Mah2(INH3)+MassHpm(ICH3)**2)*(MSQ2-
     &  MassSu2(ISt3))))

              endif
       enddo 
       enddo 
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[5][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo5-NoGBC
c


        ICH3=1
        INH3=6
        ! diagram1
       do ICH4=1,2
       do INH4=1,6
       do INH5=1,6
          if( Abs(-Mah(INH4) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(6,INH4,INH5)*CS1S3S3(INH5,1,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(6,1))*
     &  (FD211HpHH(2,1,INH4,INH5)-FD211HpHpH(2,1,ICH4,INH5)))/(4.*
     &  (Mah(INH4)**2-MassHpm(ICH4)**2))+(CS1S1S1(6,INH4,INH5)*
     &  CS1S3S3(INH5,1,ICH4)*CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(6,1))*
     &  ((-1+2*logx)*Mah2(INH4)-(1+2*logx)*Mah2(INH4)+2*MassHpm(ICH4)**
     &  2))/(32.*(Mah2(INH4)-MassHpm(ICH4)**2)))
          else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+(-(CS1S1S1(6,INH4,INH5)*CS1S3S3(INH5,1,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(6,1)))/16.+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S3S3(INH5,ICH3,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD221HpHpH(2,ICH3,ICH4,INH5))/4.)
            else
       selfW=selfW+(-(CS1S1S1(6,INH4,INH5)*CS1S3S3(INH5,1,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(6,1)))/16.+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S3S3(INH5,ICH3,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD221HpHpH(2,ICH3,ICH4,INH5))/4.)
            endif
          endif
       enddo 
       enddo 
       enddo 

        ICH4=1
        INH4=6
        ! diagram1
       do ICH3=1,2
       do INH3=1,6
       do INH5=1,6
          if( Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(INH3,6,INH5)*CS1S3S3(INH5,ICH3,1)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD211HpHH(2,1,INH3,INH5)-FD211HpHpH(2,1,ICH3,INH5)))/(4.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2))+(CS1S1S1(INH3,6,INH5)*
     &  CS1S3S3(INH5,ICH3,1)*CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  ((-1+2*logx)*Mah2(INH3)-(1+2*logx)*Mah2(INH3)+2*MassHpm(ICH3)**
     &  2))/(32.*(Mah2(INH3)-MassHpm(ICH3)**2)))
          else
          if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+(-(CS1S1S1(INH3,6,INH5)*CS1S3S3(INH5,ICH3,1)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,ICH3)))/16.+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S3S3(INH5,ICH3,ICH4)*
     &  CS1S3V3(INH4,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD221HpHpH(2,ICH3,ICH4,INH5))/4.)
            endif
          endif
       enddo 
       enddo 
       enddo 

        ICH5=1
        INH3=6
        ! diagram2
       do ICH3=1,2
       do ICH4=1,2
       do INH4=1,6       
          if( Abs(-Mah(INH4) + MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(6,ICH4,ICH3)*CS1S3S3(INH4,1,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(6,1))*(-
     &  FD211HpHHp(2,1,INH4,ICH4)+FD211HpHpHp(2,1,ICH3,ICH4)))/(4.*
     &  (Mah(INH4)**2-MassHpm(ICH3)**2))+(CS1S3S3(6,ICH4,ICH3)*
     &  CS1S3S3(INH4,1,ICH4)*CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(6,1))*
     &  (Mah2(INH4)+(1-2*logx)*Mah2(INH4)+2*logx*Mah2(INH4)-2*
     &  MassHpm(ICH3)**2))/(32.*(Mah2(INH4)-MassHpm(ICH3)**2)))
          else
          if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(6,ICH4,ICH3)*CS1S3S3(INH4,1,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(6,1)))/16.-
     &  (CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH4,ICH5,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH5))*
     &  FD221HpHpHp(2,ICH3,ICH5,ICH4))/4.)
            else
       selfW=selfW+((CS1S3S3(6,ICH4,ICH3)*CS1S3S3(INH4,1,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(6,1)))/16.-
     &  (CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH4,ICH5,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH5))*
     &  FD221HpHpHp(2,ICH3,ICH5,ICH4))/4.)
            endif
          endif
       enddo 
       enddo 
       enddo 

        ICH3=1
        INH4=6
        ! diagram2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
        
          if( Abs(-Mah(INH3) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(6,ICH5,ICH4)*CS1S3S3(INH3,ICH4,1)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,ICH5))*(-
     &  FD211HpHHp(2,1,INH3,ICH4)+FD211HpHpHp(2,1,ICH5,ICH4)))/(4.*
     &  (Mah(INH3)**2-MassHpm(ICH5)**2))+(CS1S3S3(6,ICH5,ICH4)*
     &  CS1S3S3(INH3,ICH4,1)*CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,ICH5))*
     &  (Mah2(INH3)+(1-2*logx)*Mah2(INH3)+2*logx*Mah2(INH3)-2*
     &  MassHpm(ICH5)**2))/(32.*(Mah2(INH3)-MassHpm(ICH5)**2)))
          else
          if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(6,ICH5,ICH4)*CS1S3S3(INH3,ICH4,1)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,ICH5)))/16.-
     &  (CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH4,ICH5,ICH4)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH5))*
     &  FD221HpHpHp(2,ICH3,ICH5,ICH4))/4.)
            endif
          endif
       enddo 
       enddo 
       enddo 
        ! diagram3

        ICH3=1
        INH3=6
        ! diagram3
       do ISt3=1,2
       do ISt4=1,2
       selfW=selfW+(((0D0,-0.75)*(CS1S3V3(6,1)*CS3S13SC(1,ISt4)*
     &  CSSS(6,ISt4,ISt3)*DCONJG(CS14S13V3(ISt3))-CS14S13V3(ISt3)*
     &  CS3S13S(1,ISt4)*CSSS(6,ISt3,ISt4)*DCONJG(CS1S3V3(6,1)))*
     &  (FD211HpSBST(2,1,ISt4)-FD211HpSTST(2,1,ISt3,ISt4)))/((MSQ-
     &  MassSu(ISt3))*(MSQ+MassSu(ISt3)))-((0D0,0.09375)*(CS1S3V3(6,1)*
     &  CS3S13SC(1,ISt4)*CSSS(6,ISt4,ISt3)*DCONJG(CS14S13V3(ISt3))-
     &  CS14S13V3(ISt3)*CS3S13S(1,ISt4)*CSSS(6,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(6,1)))*((-1+2*logx)*MSQ2-(1+2*logx)*MSQ2+2*
     &  MassSu2(ISt3)))/(MSQ2-MassSu2(ISt3)))
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[5][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo5-GBC
c
       !diagram 1
       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
       do INH3=1,6
              if( Abs(MNeu(INe3) - MNeu(INe5)) .gt. 1D-15) then 
       selfW=selfW+((CF11F12V3R(INe5)*(CFF11S1R(INe3,INe4,INH3)*(2*
     &  MCha*DCONJG(CF11F12V3L(INe3))-DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3))*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(2,INe4,INe5,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(2,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(2,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (FD111ChiChiH(4,INe5,INe4,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(4,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(4,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  MNeu(INe5)*(DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChiChiH(4,INe5,INe4,INH3)*(MCha**2-MNeu(INe3)**2)+
     &  FD111ChaChiH(4,INe4,INH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChiChiH(4,INe3,INe4,INH3)*(-MCha**2+MNeu(INe5)**2))+2*
     &  MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*
     &  (FD111ChiChiH(1,INe4,INe5,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(1,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(1,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))+
     &  CFF11S1R(INe4,INe5,INH3)*(DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChiChiH(5,INe5,INe4,INH3)*(MCha**2-MNeu(INe3)**2)+
     &  FD111ChaChiH(5,INe4,INH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChiChiH(5,INe3,INe4,INH3)*(-MCha**2+MNeu(INe5)**2))+2*
     &  MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*
     &  (FD111ChiChiH(2,INe4,INe5,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(2,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(2,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))))+
     &  CF11F12V3L(INe5)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)*
     &  (CFF11S1L(INe3,INe4,INH3)*(2*MCha*DCONJG(CF11F12V3R(INe3))-
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  (FD111ChiChiH(2,INe4,INe5,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(2,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(2,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe4)*(DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChiChiH(4,INe5,INe4,INH3)*(MCha**2-MNeu(INe3)**2)+
     &  FD111ChaChiH(4,INe4,INH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChiChiH(4,INe3,INe4,INH3)*(-MCha**2+MNeu(INe5)**2))+2*
     &  MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*
     &  (FD111ChiChiH(1,INe4,INe5,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(1,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(1,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))))+
     &  CFF11S1L(INe4,INe5,INH3)*(CFF11S1L(INe3,INe4,INH3)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  MNeu(INe4)*(FD111ChiChiH(4,INe5,INe4,INH3)*(-MCha**2+MNeu(INe3)
     &  **2)+FD111ChiChiH(4,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(4,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1R(INe3,INe4,INH3)*(DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChiChiH(5,INe5,INe4,INH3)*(MCha**2-MNeu(INe3)**2)+
     &  FD111ChaChiH(5,INe4,INH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChiChiH(5,INe3,INe4,INH3)*(-MCha**2+MNeu(INe5)**2))+2*
     &  MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*
     &  (FD111ChiChiH(2,INe4,INe5,INH3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiChiH(2,INe3,INe4,INH3)*(MCha**2-MNeu(INe5)**2)+
     &  FD111ChaChiH(2,INe4,INH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))))))
     &  /(4.*(MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe5))*
     &  (MNeu(INe3)-MNeu(INe5))*(MCha+MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+((-2*MNeu(INe4)*(CF11F12V3R(INe5)*
     &  DCONJG(CF11F12V3R(INe3))*(CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe5))+CF11F12V3L(INe5)*
     &  DCONJG(CF11F12V3L(INe3))*(CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe3)+CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)))*(4*A0TNeu(INe3)*
     &  MNeu2(INe3)+4*A0TNH(INH3)*MNeu2(INe3)+3*Mah2(INH3)*MNeu2(INe3)+
     &  3*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+4*
     &  A0TNH(INH3)*MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe4)+3*MNeu2(INe3)*
     &  MNeu2(INe4)))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+(2*MNeu(INe4)*
     &  (CF11F12V3R(INe5)*DCONJG(CF11F12V3R(INe3))*
     &  (CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe5,INH3)*MNeu(INe5))+
     &  CF11F12V3L(INe5)*DCONJG(CF11F12V3L(INe3))*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe5,INH3)*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)))*
     &  (4*a0tcha*MCha2+3*MCha2**2+3*MCha2*Mah2(INH3)+4*A0TNeu(INe4)*
     &  (MCha2+Mah2(INH3))+3*MCha2*MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe4)
     &  +4*A0TNH(INH3)*(MCha2+MNeu2(INe4))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe5))*(MCha+MNeu(INe5)))-
     &  ((CF11F12V3L(INe5)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12V3R(INe5)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*DCONJG(CF11F12V3R(INe3)))*(4*
     &  A0TNeu(INe3)*MNeu(INe3)**4+2*Mah2(INH3)*MNeu(INe3)**4+4*
     &  Mah2(INH3)*MNeu(INe4)**4-3*Mah2(INH3)**2*MNeu2(INe3)+MNeu(INe3)
     &  **4*MNeu2(INe3)+MNeu(INe4)**4*MNeu2(INe3)+2*MNeu2(INe3)**3+8*
     &  A0TNeu(INe4)*Mah2(INH3)*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe3)*
     &  MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+4*MNeu2(INe3)*
     &  *2*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)**2+A0TNH(INH3)*(8*
     &  MNeu(INe3)**4+8*MNeu(INe4)**4-4*Mah2(INH3)*MNeu2(INe3)+8*
     &  MNeu2(INe3)*MNeu2(INe4))))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  ((CF11F12V3L(INe5)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12V3R(INe5)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*DCONJG(CF11F12V3R(INe3)))*MNeu(INe3)*
     &  MNeu(INe5)*(4*a0tcha*MCha2+3*MCha2**2-3*Mah2(INH3)**2+
     &  MNeu(INe4)**4+4*MCha2*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*Mah2(INH3)*(MCha2+MNeu2(INe4))+A0TNH(INH3)*(-
     &  4*Mah2(INH3)+8*(MCha2+MNeu2(INe4)))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe5))*(MCha+MNeu(INe5)))+
     &  ((CF11F12V3L(INe5)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12V3R(INe5)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*DCONJG(CF11F12V3R(INe3)))*MNeu(INe3)*
     &  MNeu(INe5)*(3*Mah2(INH3)**2-MNeu(INe3)**4-MNeu(INe4)**4-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-2*MNeu2(INe3)**2-4*A0TNeu(INe4)*
     &  MNeu2(INe4)-4*MNeu2(INe3)*MNeu2(INe4)-2*MNeu2(INe4)**2-2*
     &  Mah2(INH3)*(MNeu2(INe3)+MNeu2(INe4))+4*A0TNH(INH3)*(Mah2(INH3)-
     &  2*(MNeu2(INe3)+MNeu2(INe4)))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  ((CF11F12V3L(INe5)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12V3R(INe5)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*DCONJG(CF11F12V3R(INe3)))*(-3*MCha2*
     &  Mah2(INH3)**2+MCha2*(MCha2*(4*a0tcha+3*MCha2)+3*MNeu(INe4)**4+
     &  4*(MCha2+A0TNeu(INe4))*MNeu2(INe4))+2*Mah2(INH3)*(MCha2**2+2*
     &  MNeu(INe4)**4+(MCha2+4*A0TNeu(INe4))*MNeu2(INe4))+A0TNH(INH3)*
     &  (-4*MCha2*Mah2(INH3)+8*(MNeu(INe4)**4+MCha2*(MCha2+MNeu2(INe4))
     &  ))))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe5))*
     &  (MCha+MNeu(INe5)))-(2*MNeu(INe4)*(CF11F12V3R(INe5)*
     &  DCONJG(CF11F12V3R(INe3))*(CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe5))+CF11F12V3L(INe5)*
     &  DCONJG(CF11F12V3L(INe3))*(CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe3)+CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)))*(2*Mah2(INH3)*MNeu2(INe4)
     &  +4*A0TNeu(INe5)*MNeu2(INe5)+3*Mah2(INH3)*MNeu2(INe5)+3*
     &  MNeu2(INe4)*MNeu2(INe5)+3*MNeu2(INe5)**2+4*A0TNeu(INe4)*
     &  (Mah2(INH3)+MNeu2(INe5))+4*A0TNH(INH3)*(MNeu2(INe4)+MNeu2(INe5)
     &  )))/((MCha-MNeu(INe5))*(MCha+MNeu(INe5))*(-MNeu(INe3)+
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+((CF11F12V3L(INe5)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe5)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe3,INe4,INH3)*
     &  DCONJG(CF11F12V3R(INe3)))*MNeu(INe3)*MNeu(INe5)*(3*Mah2(INH3)**
     &  2-MNeu(INe4)**4-MNeu(INe5)**4-4*A0TNeu(INe4)*MNeu2(INe4)-2*
     &  MNeu2(INe4)**2-4*A0TNeu(INe5)*MNeu2(INe5)-4*MNeu2(INe4)*
     &  MNeu2(INe5)-2*MNeu2(INe5)**2-2*Mah2(INH3)*(MNeu2(INe4)+
     &  MNeu2(INe5))+4*A0TNH(INH3)*(Mah2(INH3)-2*(MNeu2(INe4)+
     &  MNeu2(INe5)))))/((MCha-MNeu(INe5))*(MCha+MNeu(INe5))*(-
     &  MNeu(INe3)+MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))-
     &  ((CF11F12V3L(INe5)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12V3R(INe5)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  Mah2(INH3)**2*MNeu2(INe5)+A0TNH(INH3)*(8*MNeu(INe4)**4+8*
     &  MNeu(INe5)**4-4*(Mah2(INH3)-2*MNeu2(INe4))*MNeu2(INe5))+2*
     &  Mah2(INH3)*(2*MNeu(INe4)**4+MNeu(INe5)**4+MNeu2(INe4)*(4*
     &  A0TNeu(INe4)+MNeu2(INe5)))+MNeu2(INe5)*(MNeu(INe4)**4+
     &  MNeu(INe5)**4+2*(2*A0TNeu(INe4)*MNeu2(INe4)+MNeu2(INe4)**2+2*
     &  A0TNeu(INe5)*MNeu2(INe5)+2*MNeu2(INe4)*MNeu2(INe5)+MNeu2(INe5)**2
     &  ))))/((MCha-MNeu(INe5))*(MCha+MNeu(INe5))*(-MNeu(INe3)+MNeu(INe5))
     &  *(MNeu(INe3)+MNeu(INe5))))/64.)
              else
               if( Abs(MNeu(INe3)) .gt. 1D-15) then 
       selfW=selfW+((CF11F12V3R(INe5)*(CFF11S1R(INe3,INe4,INH3)*(2*
     &  MCha*DCONJG(CF11F12V3L(INe3))-DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3))*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe3)*(-
     &  FD111ChaChiH(2,INe4,INH3)+FD111ChiChiH(2,INe3,INe4,INH3)+
     &  FD211ChiChiH(2,INe3,INe4,INH3)*(MCha**2-MNeu(INe3)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*(-FD111ChaChiH(4,INe4,INH3)+
     &  FD111ChiChiH(4,INe3,INe4,INH3)+FD211ChiChiH(4,INe3,INe4,INH3)*
     &  (MCha**2-MNeu(INe3)**2))*MNeu(INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  (CFF11S1R(INe4,INe5,INH3)*(2*MCha*DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3)*(-FD111ChaChiH(2,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe4,INH3)*
     &  (MCha**2-MNeu(INe3)**2))+DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChaChiH(5,INe4,INH3)-FD111ChiChiH(5,INe3,INe4,INH3)+
     &  FD211ChiChiH(5,INe3,INe4,INH3)*(-MCha**2+MNeu(INe3)**2)))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*(DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3)*(FD111ChaChiH(4,INe4,INH3)-
     &  FD111ChiChiH(4,INe3,INe4,INH3)+FD211ChiChiH(4,INe3,INe4,INH3)*
     &  (-MCha**2+MNeu(INe3)**2))+2*MCha*DCONJG(CF11F12V3L(INe3))*(-
     &  FD111ChaChiH(1,INe4,INH3)+FD111ChiChiH(1,INe3,INe4,INH3)+
     &  FD211ChiChiH(1,INe3,INe4,INH3)*(MCha**2-MNeu(INe3)**2))*
     &  MNeu2(INe3))))+CF11F12V3L(INe5)*(CFF11S1L(INe4,INe5,INH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(2*MCha*DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3)*(-FD111ChaChiH(2,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe4,INH3)*
     &  (MCha**2-MNeu(INe3)**2))+DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChaChiH(5,INe4,INH3)-FD111ChiChiH(5,INe3,INe4,INH3)+
     &  FD211ChiChiH(5,INe3,INe4,INH3)*(-MCha**2+MNeu(INe3)**2)))+
     &  CFF11S1L(INe3,INe4,INH3)*(2*MCha*DCONJG(CF11F12V3R(INe3))-
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*(-
     &  FD111ChaChiH(4,INe4,INH3)+FD111ChiChiH(4,INe3,INe4,INH3)+
     &  FD211ChiChiH(4,INe3,INe4,INH3)*(MCha**2-MNeu(INe3)**2))*
     &  MNeu(INe4))+CFF11S1R(INe4,INe5,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  MNeu(INe3)*(-2*MCha*DCONJG(CF11F12V3R(INe3))+
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*(FD111ChaChiH(2,INe4,INH3)
     &  -FD111ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe4,INH3)*
     &  (-MCha**2+MNeu(INe3)**2))+CFF11S1R(INe3,INe4,INH3)*MNeu(INe4)*
     &  (DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(FD111ChaChiH(4,INe4,INH3)
     &  -FD111ChiChiH(4,INe3,INe4,INH3)+FD211ChiChiH(4,INe3,INe4,INH3)*
     &  (-MCha**2+MNeu(INe3)**2))+2*MCha*DCONJG(CF11F12V3R(INe3))*(-
     &  FD111ChaChiH(1,INe4,INH3)+FD111ChiChiH(1,INe3,INe4,INH3)+
     &  FD211ChiChiH(1,INe3,INe4,INH3)*(MCha**2-MNeu(INe3)**2))*
     &  MNeu2(INe3)))))/(4.*(MCha**2-MNeu(INe3)**2)**2)+
     &  (CF11F12V3L(INe5)*DCONJG(CF11F12V3L(INe3))*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)*(CFF11S1L(INe3,INe4,INH3)*
     &  MNeu(INe3)*(4*a0tcha*MCha2+3*MCha2**2-MNeu(INe3)**4-4*
     &  A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))-2*MCha2*MNeu2(INe3))+2*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe4)*(4*a0tcha*MCha2+3*MCha2**2-
     &  4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))-2*MCha2*MNeu2(INe3)-
     &  MNeu2(INe3)**2))+CFF11S1L(INe4,INe5,INH3)*(2*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)*(4*a0tcha*MCha2+
     &  3*MCha2**2-4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))-2*MCha2*
     &  MNeu2(INe3)-MNeu2(INe3)**2)+CFF11S1R(INe3,INe4,INH3)*(4*a0tcha*
     &  MCha2**2+3*MCha2**3-5*MCha2*MNeu(INe3)**4-4*A0TNeu(INe3)*
     &  MNeu(INe3)**4+5*MNeu(INe3)**6-12*MCha2*A0TNeu(INe3)*MNeu2(INe3)
     &  -MNeu(INe3)**4*MNeu2(INe3)+2*MNeu(INe4)**4*MNeu2(INe3)+12*
     &  A0TNeu(INe3)*MNeu2(INe3)**2-2*MNeu2(INe3)**3+4*MCha2**2*
     &  MNeu2(INe4)-8*MCha2*MNeu2(INe3)*MNeu2(INe4)+4*MNeu2(INe3)**2*
     &  MNeu2(INe4)-2*MNeu2(INe3)*MNeu2(INe4)**2+8*A0TNH(INH3)*(MCha2**
     &  2-MNeu(INe3)**4+MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe3)*(2*MCha2-2*
     &  MNeu2(INe3)+MNeu2(INe4)))+2*Mah2(INH3)*(MCha2**2-MNeu(INe3)**4+
     &  MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe3)*(2*MCha2-2*MNeu2(INe3)+
     &  MNeu2(INe4))))))+CF11F12V3R(INe5)*DCONJG(CF11F12V3R(INe3))*
     &  (CFF11S1R(INe3,INe4,INH3)*MNeu(INe3)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe3)*(4*a0tcha*MCha2+3*MCha2**2-MNeu(INe3)**4-4*
     &  A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))-2*MCha2*MNeu2(INe3))+2*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(4*a0tcha*MCha2+3*MCha2**2-
     &  4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))-2*MCha2*MNeu2(INe3)-
     &  MNeu2(INe3)**2))+CFF11S1L(INe3,INe4,INH3)*(2*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe3)*MNeu(INe4)*(4*a0tcha*MCha2+
     &  3*MCha2**2-4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))-2*MCha2*
     &  MNeu2(INe3)-MNeu2(INe3)**2)+CFF11S1R(INe4,INe5,INH3)*(4*a0tcha*
     &  MCha2**2+3*MCha2**3-5*MCha2*MNeu(INe3)**4-4*A0TNeu(INe3)*
     &  MNeu(INe3)**4+5*MNeu(INe3)**6-12*MCha2*A0TNeu(INe3)*MNeu2(INe3)
     &  -MNeu(INe3)**4*MNeu2(INe3)+2*MNeu(INe4)**4*MNeu2(INe3)+12*
     &  A0TNeu(INe3)*MNeu2(INe3)**2-2*MNeu2(INe3)**3+4*MCha2**2*
     &  MNeu2(INe4)-8*MCha2*MNeu2(INe3)*MNeu2(INe4)+4*MNeu2(INe3)**2*
     &  MNeu2(INe4)-2*MNeu2(INe3)*MNeu2(INe4)**2+8*A0TNH(INH3)*(MCha2**
     &  2-MNeu(INe3)**4+MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe3)*(2*MCha2-2*
     &  MNeu2(INe3)+MNeu2(INe4)))+2*Mah2(INH3)*(MCha2**2-MNeu(INe3)**4+
     &  MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe3)*(2*MCha2-2*MNeu2(INe3)+
     &  MNeu2(INe4)))))))/(64.*(MCha2-MNeu2(INe3))**2))
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       !diagram 2
       do INe3=1,3
       do INH3=1,6
       selfW=selfW+((CF11F12V3R(INe3)*(MCha*CFF12S1L(INH3)**2*(MCha*
     &  DCONJG(CF11F12V3R(INe3))-2*DCONJG(CF11F12V3L(INe3))*MNeu(INe3))
     &  *(-FD111ChaChaH(4,INH3)+FD111ChiChaH(4,INe3,INH3)+
     &  FD211ChaChaH(4,INH3)*(MCha**2-MNeu(INe3)**2))+MCha**2*
     &  CFF12S1R(INH3)**2*(DCONJG(CF11F12V3R(INe3))*(-
     &  FD111ChaChaH(4,INH3)+FD111ChiChaH(4,INe3,INH3)+
     &  FD211ChaChaH(4,INH3)*(MCha**2-MNeu(INe3)**2))+2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(-FD111ChaChiH(1,INe3,INH3)
     &  +FD111ChaHCha(1,INH3)+FD211ChaChaH(1,INH3)*(-MCha**2+MNeu(INe3)
     &  **2)))+CFF12S1L(INH3)*CFF12S1R(INH3)*(DCONJG(CF11F12V3R(INe3))*
     &  (-(MCha**2*FD111ChaChaH(2,INH3))-FD111ChaChaH(5,INH3)+MCha**2*
     &  FD111ChaChiH(2,INe3,INH3)+FD111ChiChaH(5,INe3,INH3)+MCha**4*
     &  FD211ChaChaH(2,INH3)+MCha**2*FD211ChaChaH(5,INH3)-MCha**2*
     &  FD211ChaChaH(2,INH3)*MNeu(INe3)**2-FD211ChaChaH(5,INH3)*
     &  MNeu(INe3)**2)+4*MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*
     &  (FD111ChaChaH(2,INH3)-FD111ChaChiH(2,INe3,INH3)+
     &  FD211ChaChaH(2,INH3)*(-MCha**2+MNeu(INe3)**2))))+
     &  CF11F12V3L(INe3)*(MCha*CFF12S1R(INH3)**2*(MCha*
     &  DCONJG(CF11F12V3L(INe3))-2*DCONJG(CF11F12V3R(INe3))*MNeu(INe3))
     &  *(-FD111ChaChaH(4,INH3)+FD111ChiChaH(4,INe3,INH3)+
     &  FD211ChaChaH(4,INH3)*(MCha**2-MNeu(INe3)**2))+MCha**2*
     &  CFF12S1L(INH3)**2*(DCONJG(CF11F12V3L(INe3))*(-
     &  FD111ChaChaH(4,INH3)+FD111ChiChaH(4,INe3,INH3)+
     &  FD211ChaChaH(4,INH3)*(MCha**2-MNeu(INe3)**2))+2*MCha*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(-FD111ChaChiH(1,INe3,INH3)
     &  +FD111ChaHCha(1,INH3)+FD211ChaChaH(1,INH3)*(-MCha**2+MNeu(INe3)
     &  **2)))+CFF12S1L(INH3)*CFF12S1R(INH3)*(DCONJG(CF11F12V3L(INe3))*
     &  (-(MCha**2*FD111ChaChaH(2,INH3))-FD111ChaChaH(5,INH3)+MCha**2*
     &  FD111ChaChiH(2,INe3,INH3)+FD111ChiChaH(5,INe3,INH3)+MCha**4*
     &  FD211ChaChaH(2,INH3)+MCha**2*FD211ChaChaH(5,INH3)-MCha**2*
     &  FD211ChaChaH(2,INH3)*MNeu(INe3)**2-FD211ChaChaH(5,INH3)*
     &  MNeu(INe3)**2)+4*MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*
     &  (FD111ChaChaH(2,INH3)-FD111ChaChiH(2,INe3,INH3)+
     &  FD211ChaChaH(2,INH3)*(-MCha**2+MNeu(INe3)**2)))))/(4.*(MCha**2-
     &  MNeu(INe3)**2)**2)+((CF11F12V3L(INe3)*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12V3R(INe3)*DCONJG(CF11F12V3R(INe3)))*(2*MCha2*
     &  CFF12S1L(INH3)**2*(4*a0tcha*MCha2-MCha2**2-8*a0tcha*MNeu2(INe3)
     &  -2*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+3*MNeu2(INe3)**
     &  2)+2*MCha2*CFF12S1R(INH3)**2*(4*a0tcha*MCha2-MCha2**2-8*a0tcha*
     &  MNeu2(INe3)-2*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+3*
     &  MNeu2(INe3)**2)+CFF12S1L(INH3)*CFF12S1R(INH3)*(12*a0tcha*MCha2*
     &  *2+5*MCha2**3+MCha2*MNeu(INe3)**4-20*a0tcha*MCha2*MNeu2(INe3)-
     &  15*MCha2**2*MNeu2(INe3)+4*MCha2*A0TNeu(INe3)*MNeu2(INe3)+3*
     &  MNeu(INe3)**4*MNeu2(INe3)+6*MCha2*MNeu2(INe3)**2+4*A0TNeu(INe3)
     &  *MNeu2(INe3)**2+2*Mah2(INH3)*(MCha2**2+MNeu(INe3)**4-2*MCha2*
     &  MNeu2(INe3))+8*A0TNH(INH3)*(MCha2**2-2*MCha2*MNeu2(INe3)+
     &  MNeu2(INe3)**2))))/(64.*(MCha2-MNeu2(INe3))**2))
       enddo 
       enddo 
       !diagram 3

       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
       selfW=selfW+((CF11F12S3R(INe4,ICH3)*(CF11F12V3L(INe3)*(MCha*
     &  DCONJG(CF11F12V3L(INe3))-2*DCONJG(CF11F12V3R(INe3))*MNeu(INe3))
     &  *(MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(-
     &  FD111ChaChiHp(2,INe4,ICH3)+FD111ChiChiHp(2,INe3,INe4,ICH3)+
     &  FD211ChaChiHp(2,INe4,ICH3)*(MCha**2-MNeu(INe3)**2))+
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(4,INe4,ICH3)+
     &  FD111ChiChiHp(4,INe3,INe4,ICH3)+FD211ChaChiHp(4,INe4,ICH3)*
     &  (MCha**2-MNeu(INe3)**2))*MNeu(INe4))+CF11F12V3R(INe3)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(DCONJG(CF11F12V3R(INe3))*(-
     &  FD111ChaChiHp(5,INe4,ICH3)+FD111ChiChiHp(5,INe3,INe4,ICH3)+
     &  FD211ChaChiHp(5,INe4,ICH3)*(MCha**2-MNeu(INe3)**2))+2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(FD111ChaChiHp(2,INe4,ICH3)
     &  -FD111ChiChiHp(2,INe3,INe4,ICH3)+FD211ChaChiHp(2,INe4,ICH3)*(-
     &  MCha**2+MNeu(INe3)**2)))+DCONJG(CF11F12S3L(INe4,ICH3))*(MCha*
     &  DCONJG(CF11F12V3R(INe3))*(-FD111ChaChiHp(4,INe4,ICH3)+
     &  FD111ChiChiHp(4,INe3,INe4,ICH3)+FD211ChaChiHp(4,INe4,ICH3)*
     &  (MCha**2-MNeu(INe3)**2))+2*MCha2*DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3)*(FD111ChaChiHp(1,INe4,ICH3)-
     &  FD111ChiChiHp(1,INe3,INe4,ICH3)+FD211ChaChiHp(1,INe4,ICH3)*(-
     &  MCha**2+MNeu(INe3)**2)))*MNeu(INe4)))+CF11F12S3L(INe4,ICH3)*
     &  (CF11F12V3R(INe3)*(MCha*DCONJG(CF11F12V3R(INe3))-2*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*(MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD111ChiChiHp(2,INe3,INe4,ICH3)+FD211ChaChiHp(2,INe4,ICH3)*
     &  (MCha**2-MNeu(INe3)**2))+DCONJG(CF11F12S3R(INe4,ICH3))*(-
     &  FD111ChaChiHp(4,INe4,ICH3)+FD111ChiChiHp(4,INe3,INe4,ICH3)+
     &  FD211ChaChiHp(4,INe4,ICH3)*(MCha**2-MNeu(INe3)**2))*MNeu(INe4))
     &  +CF11F12V3L(INe3)*(DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (DCONJG(CF11F12V3L(INe3))*(-FD111ChaChiHp(5,INe4,ICH3)+
     &  FD111ChiChiHp(5,INe3,INe4,ICH3)+FD211ChaChiHp(5,INe4,ICH3)*
     &  (MCha**2-MNeu(INe3)**2))+2*MCha*DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3)*(FD111ChaChiHp(2,INe4,ICH3)-
     &  FD111ChiChiHp(2,INe3,INe4,ICH3)+FD211ChaChiHp(2,INe4,ICH3)*(-
     &  MCha**2+MNeu(INe3)**2)))+DCONJG(CF11F12S3R(INe4,ICH3))*(MCha*
     &  DCONJG(CF11F12V3L(INe3))*(-FD111ChaChiHp(4,INe4,ICH3)+
     &  FD111ChiChiHp(4,INe3,INe4,ICH3)+FD211ChaChiHp(4,INe4,ICH3)*
     &  (MCha**2-MNeu(INe3)**2))+2*MCha2*DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3)*(FD111ChaChiHp(1,INe4,ICH3)-
     &  FD111ChiChiHp(1,INe3,INe4,ICH3)+FD211ChaChiHp(1,INe4,ICH3)*(-
     &  MCha**2+MNeu(INe3)**2)))*MNeu(INe4))))/(4.*(MCha**2-MNeu(INe3)*
     &  *2)**2)+(CF11F12S3L(INe4,ICH3)*(MCha*CF11F12V3R(INe3)*
     &  DCONJG(CF11F12V3R(INe3))*(2*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe4)*(4*a0tcha*MCha2-MCha2**2-8*a0tcha*MNeu2(INe3)-2*
     &  MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+3*MNeu2(INe3)**2)+
     &  MCha*DCONJG(CF11F12S3L(INe4,ICH3))*(4*a0tcha*MCha2-MCha2**2+
     &  MNeu(INe3)**4+4*A0TNeu(INe3)*MNeu2(INe3)+2*MassHpm(ICH3)**2*
     &  MNeu2(INe3)+2*MNeu2(INe3)**2+4*MNeu2(INe3)*MNeu2(INe4)-2*
     &  MNeu2(INe3)*(4*a0tcha+MCha2+MassHpm(ICH3)**2+2*MNeu2(INe4))))+
     &  CF11F12V3L(INe3)*DCONJG(CF11F12V3L(INe3))*(2*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(4*a0tcha*MCha2-MCha2*
     &  *2-8*a0tcha*MNeu2(INe3)-2*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*
     &  MNeu2(INe3)+3*MNeu2(INe3)**2)+DCONJG(CF11F12S3L(INe4,ICH3))*(8*
     &  a0tcha*MCha2**2+2*MCha2**3+2*MCha2**2*MassHpm(ICH3)**2+4*
     &  A0TNeu(INe3)*MNeu(INe3)**4+2*MassHpm(ICH3)**2*MNeu(INe3)**4-2*
     &  MCha2*MNeu(INe4)**4-3*MassHpm(ICH3)**4*MNeu2(INe3)+MNeu(INe3)**
     &  4*MNeu2(INe3)+MNeu(INe4)**4*MNeu2(INe3)+2*MNeu2(INe3)**3+4*
     &  MCha2**2*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe3)*MNeu2(INe4)+2*
     &  MassHpm(ICH3)**2*MNeu2(INe3)*MNeu2(INe4)+4*MNeu2(INe3)**2*
     &  MNeu2(INe4)+2*MCha2*MNeu2(INe4)**2+2*MNeu2(INe3)*MNeu2(INe4)**
     &  2-MNeu2(INe3)*(12*a0tcha*MCha2+5*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe4)**4+8*MCha2*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassHpm(ICH3)**2*(2*MCha2+MNeu2(INe4)))+4*
     &  A0THpN(ICH3)*(-(MassHpm(ICH3)**2*MNeu2(INe3))+2*(MCha2**2+
     &  MNeu(INe3)**4+MNeu2(INe3)*MNeu2(INe4))+MNeu2(INe3)*
     &  (MassHpm(ICH3)**2-2*(2*MCha2+MNeu2(INe4)))))))+
     &  CF11F12S3R(INe4,ICH3)*(MCha*CF11F12V3L(INe3)*
     &  DCONJG(CF11F12V3L(INe3))*(2*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe4)*(4*a0tcha*MCha2-MCha2**2-8*a0tcha*MNeu2(INe3)-2*
     &  MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+3*MNeu2(INe3)**2)+
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(4*a0tcha*MCha2-MCha2**2+
     &  MNeu(INe3)**4+4*A0TNeu(INe3)*MNeu2(INe3)+2*MassHpm(ICH3)**2*
     &  MNeu2(INe3)+2*MNeu2(INe3)**2+4*MNeu2(INe3)*MNeu2(INe4)-2*
     &  MNeu2(INe3)*(4*a0tcha+MCha2+MassHpm(ICH3)**2+2*MNeu2(INe4))))+
     &  CF11F12V3R(INe3)*DCONJG(CF11F12V3R(INe3))*(2*MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(4*a0tcha*MCha2-MCha2*
     &  *2-8*a0tcha*MNeu2(INe3)-2*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*
     &  MNeu2(INe3)+3*MNeu2(INe3)**2)+DCONJG(CF11F12S3R(INe4,ICH3))*(8*
     &  a0tcha*MCha2**2+2*MCha2**3+2*MCha2**2*MassHpm(ICH3)**2+4*
     &  A0TNeu(INe3)*MNeu(INe3)**4+2*MassHpm(ICH3)**2*MNeu(INe3)**4-2*
     &  MCha2*MNeu(INe4)**4-3*MassHpm(ICH3)**4*MNeu2(INe3)+MNeu(INe3)**
     &  4*MNeu2(INe3)+MNeu(INe4)**4*MNeu2(INe3)+2*MNeu2(INe3)**3+4*
     &  MCha2**2*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe3)*MNeu2(INe4)+2*
     &  MassHpm(ICH3)**2*MNeu2(INe3)*MNeu2(INe4)+4*MNeu2(INe3)**2*
     &  MNeu2(INe4)+2*MCha2*MNeu2(INe4)**2+2*MNeu2(INe3)*MNeu2(INe4)**
     &  2-MNeu2(INe3)*(12*a0tcha*MCha2+5*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe4)**4+8*MCha2*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassHpm(ICH3)**2*(2*MCha2+MNeu2(INe4)))+4*
     &  A0THpN(ICH3)*(-(MassHpm(ICH3)**2*MNeu2(INe3))+2*(MCha2**2+
     &  MNeu(INe3)**4+MNeu2(INe3)*MNeu2(INe4))+MNeu2(INe3)*
     &  (MassHpm(ICH3)**2-2*(2*MCha2+MNeu2(INe4))))))))/(64.*(MCha2-MNeu2(INe3))**2))
       enddo 
       enddo 
       enddo 

       !diagram 4
       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
              if( Abs(MNeu(INe3) - MNeu(INe4)) .gt. 1D-15) then 
       selfW=selfW+((((CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChaHp(5,ICH3))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+((CF11F12S3L(INe4,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChaHp(5,ICH3))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MCha-MNeu(INe4))*(MCha+MNeu(INe4)))-(2*MCha2*
     &  (CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChaHp(1,ICH3)*MNeu(INe3)*MNeu(INe4))/((MCha-MNeu(INe3))
     &  *(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))-(2*
     &  MCha2*(CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChaHp(1,ICH3)*MNeu(INe3)*MNeu(INe4))/((MCha-MNeu(INe3))
     &  *(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))-
     &  ((CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(8,INe3,ICH3))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3)
     &  )*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(8,INe3,ICH3))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3)
     &  )*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))+(2*MCha2*
     &  (CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(1,INe3,ICH3)*MNeu(INe3)*MNeu(INe4))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(2*MCha2*(CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(1,INe3,ICH3)*MNeu(INe3)*MNeu(INe4))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-((CF11F12S3R(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(8,INe4,ICH3))/((MCha-MNeu(INe4))*(MCha+MNeu(INe4)
     &  )*(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(8,INe4,ICH3))/((MCha-MNeu(INe4))*(MCha+MNeu(INe4)
     &  )*(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))+(2*MCha2*
     &  (CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(1,INe4,ICH3)*MNeu(INe3)*MNeu(INe4))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(2*MCha2*(CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  FD111ChaChiHp(1,INe4,ICH3)*MNeu(INe3)*MNeu(INe4))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(MCha*FD111ChaChaHp(4,ICH3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+(MCha*FD111ChiChaHp(4,INe3,ICH3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(MCha*FD111ChiChaHp(4,INe4,ICH3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(MCha*FD111ChaChaHp(4,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+(MCha*FD111ChiChaHp(4,INe3,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(MCha*FD111ChiChaHp(4,INe4,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(FD111ChaChaHp(2,ICH3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*(2*MCha*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+
     &  CF11F12V3L(INe4)*(2*MCha*DCONJG(CF11F12V3R(INe3))-
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*(2*MCha*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+(FD111ChaChiHp(2,INe3,ICH3)*(CF11F12S3R(INe4,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*(2*MCha*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  MNeu(INe4))+CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))
     &  *(2*MCha*CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(FD111ChaChiHp(2,INe4,ICH3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*(2*MCha*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+
     &  CF11F12V3L(INe4)*(2*MCha*DCONJG(CF11F12V3R(INe3))-
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*(2*MCha*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(FD111ChaChaHp(2,ICH3)*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*(2*MCha*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+
     &  CF11F12V3L(INe4)*(2*MCha*DCONJG(CF11F12V3R(INe3))-
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*(2*MCha*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+(FD111ChaChiHp(2,INe3,ICH3)*(CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*(2*MCha*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+CF11F12V3L(INe4)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  MNeu(INe4))+CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))
     &  *(2*MCha*CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(FD111ChaChiHp(2,INe4,ICH3)*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*(2*MCha*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+
     &  CF11F12V3L(INe4)*(2*MCha*DCONJG(CF11F12V3R(INe3))-
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*(2*MCha*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4))))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))))/4.+((MCha2*(CF11F12S3R(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+8*(a0tcha+MCha2)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(6*MCha2-MassHpm(ICH3)**2)))
     &  /((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+(MCha2*(CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+8*(a0tcha+MCha2)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(6*MCha2-MassHpm(ICH3)**2)))
     &  /((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+((CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+4*MCha2*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(4*MCha2-MassHpm(ICH3)**2))*
     &  MNeu(INe3)*MNeu(INe4))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+((CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3R(INe3,ICH3)*CF11F12V3R(INe4)
     &  *DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+4*MCha2*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(4*MCha2-MassHpm(ICH3)**2))*
     &  MNeu(INe3)*MNeu(INe4))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+(2*MCha*(2*MCha2*(4*
     &  a0tcha+3*MCha2)+8*MCha2*A0THpN(ICH3)+(4*a0tcha+5*MCha2)*
     &  MassHpm(ICH3)**2)*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+(2*MCha*
     &  (2*MCha2*(4*a0tcha+3*MCha2)+8*MCha2*A0THpN(ICH3)+(4*a0tcha+5*
     &  MCha2)*MassHpm(ICH3)**2)*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe4))))/((MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))-(2*MCha*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4)))*(4*
     &  A0THpN(ICH3)*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(4*a0tcha+2*
     &  MCha2+3*MNeu2(INe3))+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*
     &  A0TNeu(INe3)+3*MNeu2(INe3))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  (2*MCha*(CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*MNeu(INe4)))*(4*
     &  A0THpN(ICH3)*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(4*a0tcha+2*
     &  MCha2+3*MNeu2(INe3))+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*
     &  A0TNeu(INe3)+3*MNeu2(INe3))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  MNeu(INe3)*MNeu(INe4)*(4*a0tcha*MCha2+3*MCha2**2-3*
     &  MassHpm(ICH3)**4+MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*
     &  (MCha2+MNeu2(INe3))+A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+
     &  MNeu2(INe3)))))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  MNeu(INe3)*MNeu(INe4)*(4*a0tcha*MCha2+3*MCha2**2-3*
     &  MassHpm(ICH3)**4+MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*
     &  (MCha2+MNeu2(INe3))+A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+
     &  MNeu2(INe3)))))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+MNeu2(INe3)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe3)**4+4*(MCha2+A0TNeu(INe3))*MNeu2(INe3))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassHpm(ICH3)**2*(MNeu(INe3)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe3)))))/((MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-((CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+MNeu2(INe3)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe3)**4+4*(MCha2+A0TNeu(INe3))*MNeu2(INe3))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassHpm(ICH3)**2*(MNeu(INe3)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe3)))))/((MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-(2*MCha*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe4)))*(4*A0THpN(ICH3)*(MCha2+
     &  MNeu2(INe4))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*MNeu2(INe4))+
     &  MNeu2(INe4)*(4*a0tcha+3*MCha2+4*A0TNeu(INe4)+3*MNeu2(INe4))))
     &  /((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(2*MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)+CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe4)))*(4*A0THpN(ICH3)*(MCha2+
     &  MNeu2(INe4))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*MNeu2(INe4))+
     &  MNeu2(INe4)*(4*a0tcha+3*MCha2+4*A0TNeu(INe4)+3*MNeu2(INe4))))
     &  /((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-((CF11F12S3R(INe4,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  MNeu(INe3)*MNeu(INe4)*(4*a0tcha*MCha2+3*MCha2**2-3*
     &  MassHpm(ICH3)**4+MNeu(INe4)**4+4*MCha2*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+2*MNeu2(INe4)**2+2*MassHpm(ICH3)**2*
     &  (MCha2+MNeu2(INe4))+A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+
     &  MNeu2(INe4)))))/((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-
     &  MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  MNeu(INe3)*MNeu(INe4)*(4*a0tcha*MCha2+3*MCha2**2-3*
     &  MassHpm(ICH3)**4+MNeu(INe4)**4+4*MCha2*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+2*MNeu2(INe4)**2+2*MassHpm(ICH3)**2*
     &  (MCha2+MNeu2(INe4))+A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+
     &  MNeu2(INe4)))))/((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-
     &  MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe4)+MNeu2(INe4)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe4)**4+4*(MCha2+A0TNeu(INe4))*MNeu2(INe4))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe4)+8*MNeu2(INe4)**2)+2*MassHpm(ICH3)**2*(MNeu(INe4)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe4)))))/((MCha-MNeu(INe4))*
     &  (MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-((CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe4)+MNeu2(INe4)*(MCha2*(4*a0tcha+3*MCha2)
     &  +3*MNeu(INe4)**4+4*(MCha2+A0TNeu(INe4))*MNeu2(INe4))+A0THpN(ICH3)
     &  *(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*MNeu2(INe4)+8*MNeu2(INe4)**2)
     &  +2*MassHpm(ICH3)**2*(MNeu(INe4)**4+MCha2*(4*a0tcha+2*MCha2+
     &  MNeu2(INe4)))))/((MCha-MNeu(INe4))*(MCha+MNeu(INe4))
     &  *(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))))/64.)
              else
               if( Abs(MNeu(INe3)) .gt. 1D-15) then 
       selfW=selfW+(-(-(MCha2*(CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+8*(a0tcha+MCha2)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(6*MCha2-MassHpm(ICH3)**2)))-
     &  MCha2*(CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+8*(a0tcha+MCha2)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(6*MCha2-MassHpm(ICH3)**2))-2*
     &  MCha*(CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3)))*(2*MCha2*(4*a0tcha+3*MCha2)+8*MCha2*
     &  A0THpN(ICH3)+(4*a0tcha+5*MCha2)*MassHpm(ICH3)**2)*MNeu(INe3)-2*
     &  MCha*(CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)))*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3)))*(2*MCha2*(4*a0tcha+3*MCha2)+8*MCha2*
     &  A0THpN(ICH3)+(4*a0tcha+5*MCha2)*MassHpm(ICH3)**2)*MNeu(INe3)-
     &  (CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+4*MCha2*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(4*MCha2-MassHpm(ICH3)**2))*
     &  MNeu2(INe3)-(CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(2*
     &  MCha2*(4*a0tcha+5*MCha2)+4*MCha2*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(4*MCha2-MassHpm(ICH3)**2))*
     &  MNeu2(INe3)+2*(CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*MNeu2(INe3)*(2*MCha2+4*
     &  A0THpN(ICH3)+4*A0TNeu(INe3)+MassHpm(ICH3)**2+MNeu2(INe3))+2*
     &  (CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*MNeu2(INe3)*(2*MCha2+4*
     &  A0THpN(ICH3)+4*A0TNeu(INe3)+MassHpm(ICH3)**2+MNeu2(INe3))+2*
     &  MCha*(CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3)))*(MCha-MNeu(INe3))*MNeu(INe3)*(MCha+
     &  MNeu(INe3))*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*
     &  MassHpm(ICH3)**2+2*MNeu2(INe3))+2*MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3)))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3)))*(MCha-MNeu(INe3))*MNeu(INe3)*(MCha+
     &  MNeu(INe3))*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*
     &  MassHpm(ICH3)**2+2*MNeu2(INe3))+2*MCha*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3)))*MNeu(INe3)*(4*A0THpN(ICH3)*(MCha2+
     &  MNeu2(INe3))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*MNeu2(INe3))+
     &  MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0TNeu(INe3)+3*MNeu2(INe3)))+2*
     &  MCha*(CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)))*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3)))*MNeu(INe3)*(4*A0THpN(ICH3)*(MCha2+
     &  MNeu2(INe3))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*MNeu2(INe3))+
     &  MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0TNeu(INe3)+3*MNeu2(INe3)))+
     &  (CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(4*a0tcha*MCha2+3*MCha2**2-3*
     &  MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*
     &  (MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+
     &  4*MNeu2(INe3)))+(CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(4*a0tcha*MCha2+3*MCha2**2-3*
     &  MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*
     &  (MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+
     &  4*MNeu2(INe3)))+(CF11F12S3R(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  MNeu2(INe3)*(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+
     &  A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe3))))+
     &  (CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3R(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*
     &  MNeu2(INe3)*(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+
     &  A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe3))))+
     &  (CF11F12S3R(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+MNeu2(INe3)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe3)**4+4*(MCha2+A0TNeu(INe3))*MNeu2(INe3))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassHpm(ICH3)**2*(MNeu(INe3)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe3))))+(CF11F12S3L(INe4,ICH3)
     &  *CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12S3R(INe4,ICH3)*CF11F12V3R(INe4)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+MNeu2(INe3)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe3)**4+4*(MCha2+A0TNeu(INe3))*MNeu2(INe3))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassHpm(ICH3)**2*(MNeu(INe3)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe3)))))/(64.*(MCha2-
     &  MNeu2(INe3))**2)+(-2*MCha**2*CF11F12S3L(INe4,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD111ChaChaHp(4,ICH3)-2*MCha**2*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChaHp(4,ICH3)+CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChaHp(5,ICH3)+CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChaHp(5,ICH3)-CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChiHp(8,INe3,ICH3)-CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD111ChaChiHp(8,INe3,ICH3)+2*MCha**2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiChaHp(4,INe3,ICH3)+2*MCha**2*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD111ChiChaHp(4,INe3,ICH3)+2*MCha**4*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)+2*MCha**4*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD211ChiChaHpm(4,INe3,ICH3)-MCha**2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(5,INe3,ICH3)-MCha**2*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD211ChiChaHpm(5,INe3,ICH3)-2*MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChaHp(2,ICH3)*MNeu(INe3)-2*MCha*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD111ChaChaHp(2,ICH3)*MNeu(INe3)-2*
     &  MCha*CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChaHp(2,ICH3)*MNeu(INe3)-2*MCha*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD111ChaChaHp(2,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChaHp(4,ICH3)*MNeu(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD111ChaChaHp(4,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChaHp(4,ICH3)*MNeu(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3R(INe3))*FD111ChaChaHp(4,ICH3)*MNeu(INe3)+2*
     &  MCha*CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)+2*MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)+2*MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)+2*MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+2*MCha**3*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)+2*MCha**3*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)+2*MCha**3*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)+2*MCha**3*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)-MCha**3*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)-MCha**3*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)-MCha**3*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)-MCha**3*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)+CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD111ChaChaHp(2,ICH3)*MNeu(INe3)**2+
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChaHp(2,ICH3)*MNeu(INe3)**2-CF11F12S3L(INe3,ICH3)*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)*
     &  *2-CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-MCha**2*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**2-MCha**2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**2-2*MCha**2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**2-2*MCha**2*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**2+CF11F12S3L(INe4,ICH3)
     &  *CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD211ChiChaHpm(5,INe3,ICH3)*MNeu(INe3)
     &  **2+CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(5,INe3,ICH3)*MNeu(INe3)**2-2*MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3-2*MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3-2*MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3-2*MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3+MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3+MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3+MCha*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3+MCha*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3+CF11F12S3L(INe3,ICH3)
     &  *CF11F12V3L(INe4)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)
     &  **4+CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**4-2*MCha2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChaHp(1,ICH3)*MNeu2(INe3)-2*MCha2*CF11F12S3L(INe3,ICH3)
     &  *CF11F12V3R(INe4)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  DCONJG(CF11F12V3L(INe3))*FD111ChaChaHp(1,ICH3)*MNeu2(INe3)+2*
     &  MCha2*CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChiHp(1,INe3,ICH3)*MNeu2(INe3)+2*MCha2*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChaChiHp(1,INe3,ICH3)*MNeu2(INe3)+2*MCha**2*MCha2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(1,INe3,ICH3)*MNeu2(INe3)+2*MCha**2*MCha2*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(1,INe3,ICH3)*MNeu2(INe3)-2*MCha2*
     &  CF11F12S3L(INe4,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(1,INe3,ICH3)*MNeu(INe3)**2*MNeu2(INe3)-2*MCha2*
     &  CF11F12S3L(INe3,ICH3)*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiChaHpm(1,INe3,ICH3)*MNeu(INe3)**2*MNeu2(INe3)+
     &  CF11F12S3R(INe4,ICH3)*(CF11F12V3R(INe4)*(MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*(-FD111ChaChaHp(4,ICH3)+
     &  FD111ChiChaHp(4,INe3,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(MCha**
     &  2-MNeu(INe3)**2))+DCONJG(CF11F12S3R(INe3,ICH3))*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(-FD111ChaChaHp(2,ICH3)+
     &  FD111ChaChiHp(2,INe3,ICH3)+FD211ChiChaHpm(2,INe3,ICH3)*(MCha**
     &  2-MNeu(INe3)**2))+DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChaChaHp(5,ICH3)-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD211ChiChaHpm(5,INe3,ICH3)*(-MCha**2+MNeu(INe3)**2))))+
     &  CF11F12V3L(INe4)*(DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*(-2*
     &  MCha*DCONJG(CF11F12V3R(INe3))+DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3))*(FD111ChaChaHp(2,ICH3)-FD111ChaChiHp(2,INe3,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MCha**2+MNeu(INe3)**2))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(MCha*DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3)*(FD111ChaChaHp(4,ICH3)-FD111ChiChaHp(4,INe3,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(-MCha**2+MNeu(INe3)**2))+2*MCha2*
     &  DCONJG(CF11F12V3R(INe3))*(-FD111ChaChaHp(1,ICH3)+
     &  FD111ChaChiHp(1,INe3,ICH3)+FD211ChiChaHpm(1,INe3,ICH3)*(MCha**
     &  2-MNeu(INe3)**2))*MNeu2(INe3))))+CF11F12S3R(INe3,ICH3)*
     &  (CF11F12V3R(INe4)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*(-
     &  FD111ChaChaHp(2,ICH3)+FD111ChaChiHp(2,INe3,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(MCha**2-MNeu(INe3)**2))+MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChaHp(4,ICH3)+
     &  FD111ChiChaHp(4,INe3,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(MCha**
     &  2-MNeu(INe3)**2)))+CF11F12V3L(INe4)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(2*MCha*DCONJG(CF11F12V3R(INe3))
     &  *MNeu(INe3)*(-FD111ChaChaHp(2,ICH3)+FD111ChaChiHp(2,INe3,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(MCha**2-MNeu(INe3)**2))+
     &  DCONJG(CF11F12V3L(INe3))*(FD111ChaChaHp(5,ICH3)-FD111ChaChiHp(8,INe3,ICH3)
     &  +FD211ChiChaHpm(5,INe3,ICH3)*(-MCha**2+MNeu(INe3)**2)))
     &  +DCONJG(CF11F12S3L(INe4,ICH3))*(MCha*DCONJG(CF11F12V3L(INe3))
     &  *MNeu(INe3)*(FD111ChaChaHp(4,ICH3)-FD111ChiChaHp(4,INe3,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(-MCha**2+MNeu(INe3)**2))+2*MCha2*
     &  DCONJG(CF11F12V3R(INe3))*(-FD111ChaChaHp(1,ICH3)+FD111ChaChiHp(1,INe3,ICH3)
     &  +FD211ChiChaHpm(1,INe3,ICH3)*(MCha**2-MNeu(INe3)**2))*
     &  MNeu2(INe3)))))/(4.*(MCha**2-MNeu(INe3)**2)**2))
               endif
              endif
       enddo 
       enddo 
       enddo 
        !diagram 5
       do INe3=1,3
       do INe4=1,3
       do ISt3=1,2
              if( Abs(MNeu(INe3) - MNeu(INe4)) .gt. 1D-15) then 
       selfW=selfW+((3*(CF11F12V3R(INe4)*(-(MCha**2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(5,INe3,ISt3))+MCha**2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(5,INe4,ISt3)+2*MCha**3*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)-2*MCha**3*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(8,ISt3)*MNeu(INe3)**2-2*MCha*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)**3+2*MCha*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**3-M1*MCha**2*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)-M1*MCha**2*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)+M1*MCha**2*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+M1*MCha**2*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+2*MCha**3*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe4)-2*MCha**3*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe4)+2*M1*MCha**3*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+2*M1*MCha**3*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-2*M1*MCha**3*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-2*M1*MCha**3*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-MCha**2*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+MCha**2*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-2*MCha*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe3)**2*MNeu(INe4)+M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(3,ISt3)*MNeu(INe3)**2*MNeu(INe4)+M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(3,ISt3)*MNeu(INe3)**2*MNeu(INe4)+2*MCha*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-2*M1*MCha*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(1,ISt3)*MNeu(INe3)**3*MNeu(INe4)-2*M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(1,ISt3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe3)**3*MNeu(INe4)+2*M1*MCha*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)+2*M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(5,INe3,ISt3)*MNeu(INe4)**2-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(8,ISt3)*MNeu(INe4)**2+2*MCha*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)*MNeu(INe4)**2-2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**2+M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+2*MCha*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe4)**3-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(3,ISt3)*MNeu(INe4)**3-M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(3,ISt3)*MNeu(INe4)**3-2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**3+2*M1*MCha*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(1,ISt3)*MNeu(INe3)*MNeu(INe4)**3+2*M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(1,ISt3)*MNeu(INe3)*MNeu(INe4)**3-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe3)*MNeu(INe4)**3-2*M1*MCha*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3-2*M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3+
     &  CF11FSLC(INe3,ISt3)*(2*MCha*DCONJG(CF11F12V3L(INe3))-
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*(CF11FSL(INe4,ISt3)*
     &  MNeu(INe4)*(FD111TChiST(2,INe4,ISt3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111TChiST(2,INe3,ISt3)*(MCha**2-MNeu(INe4)**2)+
     &  FD111TChaST(2,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+M1*
     &  CF11FSR(INe4,ISt3)*(FD111ChiTST(4,INe4,ISt3)*(-MCha**2+
     &  MNeu(INe3)**2)+FD111ChiTST(4,INe3,ISt3)*(MCha**2-MNeu(INe4)**2)
     &  +FD111TChaST(3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11FSLC(INe4,ISt3)*(M1*CF11FSR(INe3,ISt3)*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))-DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*
     &  (FD111ChiTST(4,INe4,ISt3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiTST(4,INe3,ISt3)*(MCha**2-MNeu(INe4)**2)+
     &  FD111TChaST(3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CF11FSL(INe3,ISt3)*(DCONJG(CF11F12V3R(INe3))*
     &  (FD111ChiTST(5,INe4,ISt3)*(MCha**2-MNeu(INe3)**2)+
     &  FD111TChaST(8,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiTST(5,INe3,ISt3)*(-MCha**2+MNeu(INe4)**2))+2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(FD111TChiST(2,INe4,ISt3)*
     &  (-MCha**2+MNeu(INe3)**2)+FD111TChiST(2,INe3,ISt3)*(MCha**2-
     &  MNeu(INe4)**2)+FD111TChaST(2,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**
     &  2)))))+CF11F12V3L(INe4)*(-(MCha**2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiTST(5,INe3,ISt3))+MCha**2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiTST(5,INe4,ISt3)+2*MCha**3*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)-2*MCha**3*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(8,ISt3)*MNeu(INe3)**2-2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)**3+2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**3-M1*MCha**2*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)-M1*MCha**2*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)+M1*MCha**2*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+M1*MCha**2*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+2*MCha**3*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe4)-2*MCha**3*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe4)+2*M1*MCha**3*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+2*M1*MCha**3*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-2*M1*MCha**3*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-2*M1*MCha**3*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-MCha**2*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+MCha**2*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe3)**2*MNeu(INe4)+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(3,ISt3)*MNeu(INe3)**2*MNeu(INe4)+M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(3,ISt3)*MNeu(INe3)**2*MNeu(INe4)+2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-2*M1*MCha*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(1,ISt3)*MNeu(INe3)**3*MNeu(INe4)-2*M1*MCha*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(1,ISt3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe3)**3*MNeu(INe4)+2*M1*MCha*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)+2*M1*MCha*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(5,INe3,ISt3)*MNeu(INe4)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(8,ISt3)*MNeu(INe4)**2+2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)*MNeu(INe4)**2-2*MCha*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**2+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChaST(2,ISt3)*MNeu(INe4)**3-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*FD111TChaST(3,ISt3)
     &  *MNeu(INe4)**3-M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))*FD111TChaST(3,ISt3)*MNeu(INe4)**3-2*
     &  MCha*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**
     &  3+2*M1*MCha*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChaST(1,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+2*M1*MCha*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChaST(1,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3-CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))*FD111TChaST(2,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3-2*M1*MCha*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3-2*M1*MCha*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSL(INe3,ISt3)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  (CF11FSLC(INe4,ISt3)*MNeu(INe4)*(FD111TChiST(2,INe4,ISt3)*(-
     &  MCha**2+MNeu(INe3)**2)+FD111TChiST(2,INe3,ISt3)*(MCha**2-
     &  MNeu(INe4)**2)+FD111TChaST(2,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**
     &  2))+M1*CF11FSRC(INe4,ISt3)*(FD111ChiTST(4,INe4,ISt3)*(-MCha**2+
     &  MNeu(INe3)**2)+FD111ChiTST(4,INe3,ISt3)*(MCha**2-MNeu(INe4)**2)
     &  +FD111TChaST(3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11FSL(INe4,ISt3)*(M1*CF11FSRC(INe3,ISt3)*(2*MCha*
     &  DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*
     &  (FD111ChiTST(4,INe4,ISt3)*(-MCha**2+MNeu(INe3)**2)+
     &  FD111ChiTST(4,INe3,ISt3)*(MCha**2-MNeu(INe4)**2)+
     &  FD111TChaST(3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CF11FSLC(INe3,ISt3)*(DCONJG(CF11F12V3L(INe3))*
     &  (FD111ChiTST(5,INe4,ISt3)*(MCha**2-MNeu(INe3)**2)+
     &  FD111TChaST(8,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiTST(5,INe3,ISt3)*(-MCha**2+MNeu(INe4)**2))+2*MCha*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3)*(FD111TChiST(2,INe4,ISt3)*
     &  (-MCha**2+MNeu(INe3)**2)+FD111TChiST(2,INe3,ISt3)*(MCha**2-
     &  MNeu(INe4)**2)+FD111TChaST(2,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**
     &  2)))))))/(4.*(MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-
     &  MNeu(INe4))*(MNeu(INe3)-MNeu(INe4))*(MCha+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(3*(((CF11F12V3L(INe4)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  +CF11F12V3R(INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3)))*(MCha2*(4*a0t1*M12+3*M12**2+4*a0tcha*
     &  MCha2+4*M12*MCha2+3*MCha2**2)-3*MCha2*MassSu(ISt3)**4+2*(4*
     &  a0t1*M12+2*M12**2+M12*MCha2+MCha2**2)*MassSu2(ISt3)+aA0TN(ISt3)
     &  *(8*(M12**2+M12*MCha2+MCha2**2)-4*MCha2*MassSu2(ISt3))))
     &  /((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+
     &  MNeu(INe4)))+((CF11F12V3L(INe4)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*(MCha2*(4*a0t1*M12+3*M12**2+4*a0tcha*MCha2+4*M12*MCha2+3*
     &  MCha2**2)-3*MCha2*MassSu(ISt3)**4+2*(4*a0t1*M12+2*M12**2+M12*
     &  MCha2+MCha2**2)*MassSu2(ISt3)+aA0TN(ISt3)*(8*(M12**2+M12*MCha2+
     &  MCha2**2)-4*MCha2*MassSu2(ISt3))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+
     &  ((CF11F12V3L(INe4)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3)))*(4*a0t1*M12+3*
     &  M12**2+4*a0tcha*MCha2+4*M12*MCha2+3*MCha2**2-3*MassSu(ISt3)**4+
     &  aA0TN(ISt3)*(8*(M12+MCha2)-4*MassSu2(ISt3))+2*(M12+MCha2)*
     &  MassSu2(ISt3))*MNeu(INe3)*MNeu(INe4))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+
     &  ((CF11F12V3L(INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3)))*(4*a0t1*M12+3*
     &  M12**2+4*a0tcha*MCha2+4*M12*MCha2+3*MCha2**2-3*MassSu(ISt3)**4+
     &  aA0TN(ISt3)*(8*(M12+MCha2)-4*MassSu2(ISt3))+2*(M12+MCha2)*
     &  MassSu2(ISt3))*MNeu(INe3)*MNeu(INe4))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+(2*M1*(MCha2*
     &  (4*a0t1+4*a0tcha+3*(M12+MCha2))+4*(M12+MCha2)*aA0TN(ISt3)+(4*
     &  a0t1+2*M12+3*MCha2)*MassSu2(ISt3))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*(CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)+CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*(CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe3)+CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe4))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))+(2*M1*(MCha2*
     &  (4*a0t1+4*a0tcha+3*(M12+MCha2))+4*(M12+MCha2)*aA0TN(ISt3)+(4*
     &  a0t1+2*M12+3*MCha2)*MassSu2(ISt3))*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*(CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)+CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe4))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*(CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)+CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4))))/((MCha-MNeu(INe3))*(MCha+
     &  MNeu(INe3))*(MCha-MNeu(INe4))*(MCha+MNeu(INe4)))-(2*M1*
     &  (CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*(CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)+CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*(CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe3)+CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe4)))*(4*aA0TN(ISt3)*(M12+
     &  MNeu2(INe3))+MassSu2(ISt3)*(4*a0t1+2*M12+3*MNeu2(INe3))+
     &  MNeu2(INe3)*(4*a0t1+3*M12+4*A0TNeu(INe3)+3*MNeu2(INe3))))
     &  /((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(2*M1*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*(CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)+CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe4))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*(CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)+CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4)))*(4*aA0TN(ISt3)*(M12+
     &  MNeu2(INe3))+MassSu2(ISt3)*(4*a0t1+2*M12+3*MNeu2(INe3))+
     &  MNeu2(INe3)*(4*a0t1+3*M12+4*A0TNeu(INe3)+3*MNeu2(INe3))))
     &  /((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-((CF11F12V3L(INe4)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*MNeu(INe3)*MNeu(INe4)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe3)**4+4*M12*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe3))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe3)))))/((MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-((CF11F12V3L(INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*MNeu(INe3)*MNeu(INe4)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe3)**4+4*M12*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe3))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe3)))))/((MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-((CF11F12V3L(INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*(-3*MassSu(ISt3)**4*MNeu2(INe3)+MNeu2(INe3)*(M12*(4*a0t1+3*
     &  M12)+3*MNeu(INe3)**4+4*(M12+A0TNeu(INe3))*MNeu2(INe3))+
     &  aA0TN(ISt3)*(8*M12**2+(8*M12-4*MassSu2(ISt3))*MNeu2(INe3)+8*
     &  MNeu2(INe3)**2)+2*MassSu2(ISt3)*(MNeu(INe3)**4+M12*(4*a0t1+2*
     &  M12+MNeu2(INe3)))))/((MCha-MNeu(INe3))*(MCha+MNeu(INe3))*
     &  (MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12V3L(INe4)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3)))*(-3*MassSu(ISt3)*
     &  *4*MNeu2(INe3)+MNeu2(INe3)*(M12*(4*a0t1+3*M12)+3*MNeu(INe3)**4+
     &  4*(M12+A0TNeu(INe3))*MNeu2(INe3))+aA0TN(ISt3)*(8*M12**2+(8*M12-
     &  4*MassSu2(ISt3))*MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassSu2(ISt3)*
     &  (MNeu(INe3)**4+M12*(4*a0t1+2*M12+MNeu2(INe3)))))/((MCha-
     &  MNeu(INe3))*(MCha+MNeu(INe3))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(2*M1*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*(CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)+CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*(CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe3)+CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe4)))*(4*aA0TN(ISt3)*(M12+
     &  MNeu2(INe4))+MassSu2(ISt3)*(4*a0t1+2*M12+3*MNeu2(INe4))+
     &  MNeu2(INe4)*(4*a0t1+3*M12+4*A0TNeu(INe4)+3*MNeu2(INe4))))
     &  /((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-(2*M1*(CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*(CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)+CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe4))+CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*(CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)+CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4)))*(4*aA0TN(ISt3)*(M12+
     &  MNeu2(INe4))+MassSu2(ISt3)*(4*a0t1+2*M12+3*MNeu2(INe4))+
     &  MNeu2(INe4)*(4*a0t1+3*M12+4*A0TNeu(INe4)+3*MNeu2(INe4))))
     &  /((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))-((CF11F12V3L(INe4)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*MNeu(INe3)*MNeu(INe4)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe4)**4+4*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe4))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe4)))))/((MCha-MNeu(INe4))*
     &  (MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-((CF11F12V3L(INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*MNeu(INe3)*MNeu(INe4)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe4)**4+4*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe4))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe4)))))/((MCha-MNeu(INe4))*
     &  (MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4)))-((CF11F12V3L(INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  )*(-3*MassSu(ISt3)**4*MNeu2(INe4)+MNeu2(INe4)*(M12*(4*a0t1+3*
     &  M12)+3*MNeu(INe4)**4+4*(M12+A0TNeu(INe4))*MNeu2(INe4))+
     &  aA0TN(ISt3)*(8*M12**2+(8*M12-4*MassSu2(ISt3))*MNeu2(INe4)+8*
     &  MNeu2(INe4)**2)+2*MassSu2(ISt3)*(MNeu(INe4)**4+M12*(4*a0t1+2*
     &  M12+MNeu2(INe4)))))/((MCha-MNeu(INe4))*(MCha+MNeu(INe4))*(-
     &  MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))-
     &  ((CF11F12V3L(INe4)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))+CF11F12V3R(INe4)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3)))*(-3*MassSu(ISt3)*
     &  *4*MNeu2(INe4)+MNeu2(INe4)*(M12*(4*a0t1+3*M12)+3*MNeu(INe4)**4+
     &  4*(M12+A0TNeu(INe4))*MNeu2(INe4))+aA0TN(ISt3)*(8*M12**2+(8*M12-
     &  4*MassSu2(ISt3))*MNeu2(INe4)+8*MNeu2(INe4)**2)+2*MassSu2(ISt3)*
     &  (MNeu(INe4)**4+M12*(4*a0t1+2*M12+MNeu2(INe4)))))/((MCha-
     &  MNeu(INe4))*(MCha+MNeu(INe4))*(-MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))))/64.)
              else
               if( Abs(MNeu(INe3)) .gt. 1D-15) then 
       selfW=selfW+((3*(CF11F12V3R(INe4)*(-(CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(5,INe3,ISt3))+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(8,ISt3)-MCha**2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiTST(5,INe3,ISt3)-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-2*MCha*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)-2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(3,ISt3)*MNeu(INe3)+M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(3,ISt3)*MNeu(INe3)+2*MCha*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)+2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)+2*MCha**3*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)+2*MCha**3*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)-M1*MCha**2*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*MCha**2*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-MCha**2*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**2+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiTST(5,INe3,ISt3)*MNeu(INe3)**2-2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3-2*MCha*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3+M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**4+CF11FSLC(INe3,ISt3)*(2*
     &  MCha*DCONJG(CF11F12V3L(INe3))-DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3))*(CF11FSL(INe4,ISt3)*MNeu(INe3)*(-
     &  FD111TChaST(2,ISt3)+FD111TChiST(2,INe3,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(MCha**2-MNeu(INe3)**2))+M1*
     &  CF11FSR(INe4,ISt3)*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111TChaST(3,ISt3)+FD211ChiTST(4,INe3,ISt3)*(MCha**2-
     &  MNeu(INe3)**2)))+CF11FSLC(INe4,ISt3)*(M1*CF11FSR(INe3,ISt3)*(2*
     &  MCha*DCONJG(CF11F12V3L(INe3))-DCONJG(CF11F12V3R(INe3))*
     &  MNeu(INe3))*(FD111ChiTST(4,INe3,ISt3)-FD111TChaST(3,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(MCha**2-MNeu(INe3)**2))+
     &  CF11FSL(INe3,ISt3)*(2*MCha*DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*
     &  (-FD111TChaST(2,ISt3)+FD111TChiST(2,INe3,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(MCha**2-MNeu(INe3)**2))+
     &  DCONJG(CF11F12V3R(INe3))*(-FD111ChiTST(5,INe3,ISt3)+
     &  FD111TChaST(8,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MCha**2+
     &  MNeu(INe3)**2))))-2*M1*MCha*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(1,ISt3)*MNeu2(INe3)-2*M1*MCha*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(1,ISt3)*MNeu2(INe3)+2*M1*MCha*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(1,INe3,ISt3)*MNeu2(INe3)+2*M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChiST(1,INe3,ISt3)*MNeu2(INe3)+2*M1*MCha**3*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(1,INe3,ISt3)*MNeu2(INe3)+2*M1*MCha**3*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(1,INe3,ISt3)*MNeu2(INe3)-2*M1*MCha*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*MNeu2(INe3)-2*M1*MCha*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*MNeu2(INe3))+
     &  CF11F12V3L(INe4)*(-(CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))*FD111ChiTST(5,INe3,ISt3))+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD111TChaST(8,ISt3)-MCha**2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiTST(5,INe3,ISt3)-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-2*MCha*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)-2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*FD111TChaST(3,ISt3)
     &  *MNeu(INe3)+M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3L(INe3))*FD111TChaST(3,ISt3)*MNeu(INe3)+2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)+2*MCha*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)+2*MCha**3*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)+2*MCha**3*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)-M1*MCha**2*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*MCha**2*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChaST(2,ISt3)*MNeu(INe3)**2-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-MCha**2*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiTST(5,INe3,ISt3)*MNeu(INe3)**2-2*MCha*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3-2*MCha*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*DCONJG(CF11F12V3R(INe3))
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3+M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*DCONJG(CF11F12V3L(INe3))*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**4+CF11FSL(INe3,ISt3)*(2*
     &  MCha*DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3))*(CF11FSLC(INe4,ISt3)*MNeu(INe3)*(-
     &  FD111TChaST(2,ISt3)+FD111TChiST(2,INe3,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(MCha**2-MNeu(INe3)**2))+M1*
     &  CF11FSRC(INe4,ISt3)*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111TChaST(3,ISt3)+FD211ChiTST(4,INe3,ISt3)*(MCha**2-
     &  MNeu(INe3)**2)))+CF11FSL(INe4,ISt3)*(M1*CF11FSRC(INe3,ISt3)*(2*
     &  MCha*DCONJG(CF11F12V3R(INe3))-DCONJG(CF11F12V3L(INe3))*
     &  MNeu(INe3))*(FD111ChiTST(4,INe3,ISt3)-FD111TChaST(3,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(MCha**2-MNeu(INe3)**2))+
     &  CF11FSLC(INe3,ISt3)*(2*MCha*DCONJG(CF11F12V3R(INe3))*MNeu(INe3)
     &  *(-FD111TChaST(2,ISt3)+FD111TChiST(2,INe3,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(MCha**2-MNeu(INe3)**2))+
     &  DCONJG(CF11F12V3L(INe3))*(-FD111ChiTST(5,INe3,ISt3)+
     &  FD111TChaST(8,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MCha**2+
     &  MNeu(INe3)**2))))-2*M1*MCha*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*DCONJG(CF11F12V3R(INe3))*FD111TChaST(1,ISt3)
     &  *MNeu2(INe3)-2*M1*MCha*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChaST(1,ISt3)*MNeu2(INe3)+2*M1*
     &  MCha*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChiST(1,INe3,ISt3)*MNeu2(INe3)+
     &  2*M1*MCha*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD111TChiST(1,INe3,ISt3)*MNeu2(INe3)+
     &  2*M1*MCha**3*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD211ChiTST(1,INe3,ISt3)*MNeu2(INe3)+
     &  2*M1*MCha**3*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD211ChiTST(1,INe3,ISt3)*MNeu2(INe3)-
     &  2*M1*MCha*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**
     &  2*MNeu2(INe3)-2*M1*MCha*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  DCONJG(CF11F12V3R(INe3))*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**
     &  2*MNeu2(INe3))))/(4.*(MCha**2-MNeu(INe3)**2)**2)-(3*
     &  (CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*(MNeu(INe3)*
     &  (CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*(-4*a0tcha*
     &  MCha2-3*MCha2**2+MNeu(INe3)**4+4*A0TNeu(INe3)*(2*MCha2-
     &  MNeu2(INe3))+2*MCha2*MNeu2(INe3))+2*M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*(-4*a0tcha*MCha2-3*MCha2**2+4*A0TNeu(INe3)*
     &  (2*MCha2-MNeu2(INe3))+2*MCha2*MNeu2(INe3)+MNeu2(INe3)**2)+
     &  CF11FSL(INe4,ISt3)*(CF11FSLC(INe3,ISt3)*MNeu(INe3)*(-4*a0tcha*
     &  MCha2-3*MCha2**2+MNeu(INe3)**4+4*A0TNeu(INe3)*(2*MCha2-
     &  MNeu2(INe3))+2*MCha2*MNeu2(INe3))+2*M1*CF11FSRC(INe3,ISt3)*(-4*
     &  a0tcha*MCha2-3*MCha2**2+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*
     &  MCha2*MNeu2(INe3)+MNeu2(INe3)**2)))+CF11FSL(INe3,ISt3)*(2*M1*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*(-4*a0tcha*MCha2-3*MCha2**2+4*
     &  A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*MCha2*MNeu2(INe3)+
     &  MNeu2(INe3)**2)+CF11FSLC(INe4,ISt3)*(-4*a0tcha*MCha2**2-4*M12*
     &  MCha2**2-3*MCha2**3-2*MCha2**2*MassSu2(ISt3)+3*MCha2*MNeu(INe3)
     &  **4+2*MassSu2(ISt3)*MNeu(INe3)**4+4*a0t1*M12*MNeu2(INe3)+3*M12*
     &  *2*MNeu2(INe3)+8*M12*MCha2*MNeu2(INe3)+12*MCha2*A0TNeu(INe3)*
     &  MNeu2(INe3)-3*MassSu(ISt3)**4*MNeu2(INe3)+2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*MCha2*MassSu2(ISt3)*MNeu2(INe3)+3*MNeu(INe3)**4*
     &  MNeu2(INe3)+4*M12*MNeu2(INe3)**2+2*MCha2*MNeu2(INe3)**2+4*
     &  A0TNeu(INe3)*MNeu2(INe3)**2-MNeu2(INe3)*(4*a0t1*M12+3*M12**2-3*
     &  MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*MNeu2(INe3)+12*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+
     &  2*MNeu2(INe3)))+4*aA0TN(ISt3)*(-(MassSu2(ISt3)*MNeu2(INe3))+2*
     &  (-MCha2**2+(M12+2*MCha2)*MNeu2(INe3)+MNeu2(INe3)**2)+
     &  MNeu2(INe3)*(MassSu2(ISt3)-2*(M12+2*MNeu2(INe3))))))+
     &  CF11FSR(INe4,ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*MNeu(INe3)*(-4*
     &  a0tcha*MCha2-3*MCha2**2+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*
     &  MCha2*MNeu2(INe3)+MNeu2(INe3)**2)+CF11FSRC(INe3,ISt3)*(-4*
     &  a0tcha*MCha2**2-4*M12*MCha2**2-3*MCha2**3-2*MCha2**2*
     &  MassSu2(ISt3)+3*MCha2*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe3)*
     &  *4+4*a0t1*M12*MNeu2(INe3)+3*M12**2*MNeu2(INe3)+8*M12*MCha2*
     &  MNeu2(INe3)+12*MCha2*A0TNeu(INe3)*MNeu2(INe3)-3*MassSu(ISt3)**
     &  4*MNeu2(INe3)+2*M12*MassSu2(ISt3)*MNeu2(INe3)+4*MCha2*
     &  MassSu2(ISt3)*MNeu2(INe3)+3*MNeu(INe3)**4*MNeu2(INe3)+4*M12*
     &  MNeu2(INe3)**2+2*MCha2*MNeu2(INe3)**2+4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-MNeu2(INe3)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)*
     &  *4+3*MNeu(INe3)**4+8*M12*MNeu2(INe3)+12*A0TNeu(INe3)*
     &  MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+2*MNeu2(INe3)
     &  ))+4*aA0TN(ISt3)*(-(MassSu2(ISt3)*MNeu2(INe3))+2*(-MCha2**2+
     &  (M12+2*MCha2)*MNeu2(INe3)+MNeu2(INe3)**2)+MNeu2(INe3)*
     &  (MassSu2(ISt3)-2*(M12+2*MNeu2(INe3)))))))+CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*(MNeu(INe3)*(CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*(-4*a0tcha*MCha2-3*MCha2**2+
     &  MNeu(INe3)**4+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*MCha2*
     &  MNeu2(INe3))+2*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*(-4*
     &  a0tcha*MCha2-3*MCha2**2+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*
     &  MCha2*MNeu2(INe3)+MNeu2(INe3)**2)+CF11FSL(INe3,ISt3)*
     &  (CF11FSLC(INe4,ISt3)*MNeu(INe3)*(-4*a0tcha*MCha2-3*MCha2**2+
     &  MNeu(INe3)**4+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*MCha2*
     &  MNeu2(INe3))+2*M1*CF11FSRC(INe4,ISt3)*(-4*a0tcha*MCha2-3*MCha2*
     &  *2+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*MCha2*MNeu2(INe3)+
     &  MNeu2(INe3)**2)))+CF11FSL(INe4,ISt3)*(2*M1*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)*(-4*a0tcha*MCha2-3*MCha2**2+4*A0TNeu(INe3)*(2*MCha2-
     &  MNeu2(INe3))+2*MCha2*MNeu2(INe3)+MNeu2(INe3)**2)+
     &  CF11FSLC(INe3,ISt3)*(-4*a0tcha*MCha2**2-4*M12*MCha2**2-3*MCha2*
     &  *3-2*MCha2**2*MassSu2(ISt3)+3*MCha2*MNeu(INe3)**4+2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+4*a0t1*M12*MNeu2(INe3)+3*M12**2*
     &  MNeu2(INe3)+8*M12*MCha2*MNeu2(INe3)+12*MCha2*A0TNeu(INe3)*
     &  MNeu2(INe3)-3*MassSu(ISt3)**4*MNeu2(INe3)+2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*MCha2*MassSu2(ISt3)*MNeu2(INe3)+3*MNeu(INe3)**4*
     &  MNeu2(INe3)+4*M12*MNeu2(INe3)**2+2*MCha2*MNeu2(INe3)**2+4*
     &  A0TNeu(INe3)*MNeu2(INe3)**2-MNeu2(INe3)*(4*a0t1*M12+3*M12**2-3*
     &  MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*MNeu2(INe3)+12*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+
     &  2*MNeu2(INe3)))+4*aA0TN(ISt3)*(-(MassSu2(ISt3)*MNeu2(INe3))+2*
     &  (-MCha2**2+(M12+2*MCha2)*MNeu2(INe3)+MNeu2(INe3)**2)+
     &  MNeu2(INe3)*(MassSu2(ISt3)-2*(M12+2*MNeu2(INe3))))))+
     &  CF11FSR(INe3,ISt3)*(2*M1*CF11FSLC(INe4,ISt3)*MNeu(INe3)*(-4*
     &  a0tcha*MCha2-3*MCha2**2+4*A0TNeu(INe3)*(2*MCha2-MNeu2(INe3))+2*
     &  MCha2*MNeu2(INe3)+MNeu2(INe3)**2)+CF11FSRC(INe4,ISt3)*(-4*
     &  a0tcha*MCha2**2-4*M12*MCha2**2-3*MCha2**3-2*MCha2**2*
     &  MassSu2(ISt3)+3*MCha2*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe3)*
     &  *4+4*a0t1*M12*MNeu2(INe3)+3*M12**2*MNeu2(INe3)+8*M12*MCha2*
     &  MNeu2(INe3)+12*MCha2*A0TNeu(INe3)*MNeu2(INe3)-3*MassSu(ISt3)**
     &  4*MNeu2(INe3)+2*M12*MassSu2(ISt3)*MNeu2(INe3)+4*MCha2*
     &  MassSu2(ISt3)*MNeu2(INe3)+3*MNeu(INe3)**4*MNeu2(INe3)+4*M12*
     &  MNeu2(INe3)**2+2*MCha2*MNeu2(INe3)**2+4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-MNeu2(INe3)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)*
     &  *4+3*MNeu(INe3)**4+8*M12*MNeu2(INe3)+12*A0TNeu(INe3)*
     &  MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+2*MNeu2(INe3)
     &  ))+4*aA0TN(ISt3)*(-(MassSu2(ISt3)*MNeu2(INe3))+2*(-MCha2**2+   
     &  (M12+2*MCha2)*MNeu2(INe3)+MNeu2(INe3)**2)+MNeu2(INe3)*(MassSu2(ISt3)-2*
     & (M12+2*MNeu2(INe3)))))))))/(64.*(MCha2-MNeu2(INe3))**2))
               endif
              endif
       enddo 
       enddo 
       enddo 
       !diagram 6
       do INe3=1,3
       do ISt3=1,2
       selfW=selfW+((3*CF12F4S(ISt3)*CF12F4SC(ISt3)*(MCha*
     &  CF11F12V3L(INe3)*(MCha*DCONJG(CF11F12V3L(INe3))-2*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*(-FD111BChaST(2,ISt3)+
     &  FD111BChiST(2,INe3,ISt3)+FD211ChaBST(2,ISt3)*(MCha**2-
     &  MNeu(INe3)**2))+CF11F12V3R(INe3)*(DCONJG(CF11F12V3R(INe3))*(-
     &  FD111BChaST(8,ISt3)+FD111BChiST(8,INe3,ISt3)+
     &  FD211ChaBST(5,ISt3)*(MCha**2-MNeu(INe3)**2))+2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(FD111BChaST(2,ISt3)-
     &  FD111BChiST(2,INe3,ISt3)+FD211ChaBST(2,ISt3)*(-MCha**2+
     &  MNeu(INe3)**2)))))/(4.*(MCha**2-MNeu(INe3)**2)**2)+(3*
     &  CF12F4S(ISt3)*CF12F4SC(ISt3)*(MCha2*CF11F12V3L(INe3)*
     &  DCONJG(CF11F12V3L(INe3))*(4*a0tcha*MCha2-MCha2**2+3*MNeu(INe3)*
     &  *4+4*A0TNeu(INe3)*MNeu2(INe3)+2*MassSu2(ISt3)*MNeu2(INe3)-2*(4*
     &  a0tcha+MCha2+MassSu2(ISt3))*MNeu2(INe3))+CF11F12V3R(INe3)*
     &  DCONJG(CF11F12V3R(INe3))*(8*a0tcha*MCha2**2+2*MCha2**3+2*MCha2*
     &  *2*MassSu2(ISt3)+2*MassSu2(ISt3)*MNeu(INe3)**4+MNeu(INe3)**6-3*
     &  MassSu(ISt3)**4*MNeu2(INe3)-(MCha2*(12*a0tcha+5*MCha2)-3*
     &  MassSu(ISt3)**4+4*MCha2*MassSu2(ISt3))*MNeu2(INe3)+2*MNeu(INe3)
     &  **4*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)**2+4*aA0TN(ISt3)*(-
     &  (MassSu2(ISt3)*MNeu2(INe3))+(-4*MCha2+MassSu2(ISt3))*
     &  MNeu2(INe3)+2*(MCha2**2+MNeu2(INe3)**2)))))/(64.*(MCha2-
     &  MNeu2(INe3))**2))
       enddo 
       enddo 
       !diagram 8
       do INe3=1,3
       selfW=selfW+((3*CF12F3S*CF12F3SC*(MCha*CF11F12V3L(INe3)*(MCha*
     &  DCONJG(CF11F12V3L(INe3))-2*DCONJG(CF11F12V3R(INe3))*MNeu(INe3))
     &  *(FD111ChiTSB(2,INe3)-FD111TChaSB(2)+MCha**2*FD211ChaTSB(2)-
     &  FD211ChaTSB(2)*MNeu(INe3)**2)+CF11F12V3R(INe3)*(2*MCha*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3)*(-FD111ChiTSB(2,INe3)+
     &  FD111TChaSB(2)-MCha**2*FD211ChaTSB(2)+FD211ChaTSB(2)*MNeu(INe3)
     &  **2)+DCONJG(CF11F12V3R(INe3))*(FD111ChiTSB(5,INe3)-
     &  FD111TChaSB(8)+MCha**2*FD211ChaTSB(5)-FD211ChaTSB(5)*MNeu(INe3)
     &  **2))))/(4.*(MCha**2-MNeu(INe3)**2)**2)+(3*CF12F3S*CF12F3SC*
     &  (MCha2*CF11F12V3L(INe3)*DCONJG(CF11F12V3L(INe3))*(4*a0tcha*
     &  MCha2-MCha2**2+3*MNeu(INe3)**4+8*a0t5*MNeu2(INe3)+4*M12*
     &  MNeu2(INe3)+2*MSQ2*MNeu2(INe3)-2*(4*a0t5+4*a0tcha+2*M12+MCha2+
     &  MSQ2)*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3))+CF11F12V3R(INe3)*
     &  DCONJG(CF11F12V3R(INe3))*(8*a0t5*MCha2**2+8*a0tcha*MCha2**2+4*
     &  M12*MCha2**2+2*MCha2**3+2*MCha2**2*MSQ2+4*a0t1*M12*MNeu2(INe3)+
     &  8*a0t5*M12*MNeu2(INe3)+3*M12**2*MNeu2(INe3)-4*a0t5*MSQ2*
     &  MNeu2(INe3)+2*M12*MSQ2*MNeu2(INe3)-3*MSQ2**2*MNeu2(INe3)-(4*
     &  a0t1*M12+8*a0t5*M12+3*M12**2+16*a0t5*MCha2+12*a0tcha*MCha2+8*
     &  M12*MCha2+5*MCha2**2-4*a0t5*MSQ2+2*M12*MSQ2+4*MCha2*MSQ2-3*
     &  MSQ2**2)*MNeu2(INe3)+4*M12*MNeu2(INe3)**2+2*MSQ2*MNeu2(INe3)**
     &  2+4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu(INe3)**4*(8*a0t5+3*
     &  MNeu2(INe3)))))/(64.*(MCha2-MNeu2(INe3))**2))
       enddo 


#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[6][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo6-NoGBC
c 
c
c topo6-GBC
c


       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 

       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*((6*
     &  M12*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))*(2*M12*(4*a0t1+M12)
     &  +(8*a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))+(2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH4)+CFF12S1R(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))
     &  +(6*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))*(2*M12**2*(4*a0t1+
     &  M12)+2*M12*(4*a0t1+3*M12+4*A0TNH(INH3))*Mah2(INH3)+(4*a0t1+5*
     &  M12)*Mah2(INH3)**2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))
     &  +(2*(CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*
     &  CFF12S1R(INH4))*(2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+
     &  3*MCha2+4*A0TNH(INH3))*Mah2(INH3)+(4*a0tcha+5*MCha2)*Mah2(INH3)
     &  **2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))-(3*(hy(INH4)*
     &  hyc(INH3)+hy(INH3)*hyc(INH4))*(4*M12**2*(4*a0t1+M12)+2*M12*(4*
     &  a0t1+M12)*Mah2(INH3)+(8*a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)**
     &  2+3*Mah2(INH3)**3))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4)
     &  )*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))-
     &  ((CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*
     &  (4*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+MCha2)*
     &  Mah2(INH3)+(8*a0tcha+6*MCha2+4*A0TNH(INH3))*Mah2(INH3)**2+3*
     &  Mah2(INH3)**3))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))-(6*M12*
     &  (hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))*(2*M12*(4*a0t1+M12)+(8*
     &  a0t1+6*M12+4*A0TNH(INH4))*Mah2(INH4)+3*Mah2(INH4)**2))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))-(2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH4)+CFF12S1R(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH4))*
     &  Mah2(INH4)+3*Mah2(INH4)**2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))
     &  -(6*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))*(2*M12**2*(4*a0t1+
     &  M12)+2*M12*(4*a0t1+3*M12+4*A0TNH(INH4))*Mah2(INH4)+(4*a0t1+5*
     &  M12)*Mah2(INH4)**2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))
     &  -(2*(CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*
     &  CFF12S1R(INH4))*(2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+
     &  3*MCha2+4*A0TNH(INH4))*Mah2(INH4)+(4*a0tcha+5*MCha2)*Mah2(INH4)
     &  **2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(3*(hy(INH4)*
     &  hyc(INH3)+hy(INH3)*hyc(INH4))*(4*M12**2*(4*a0t1+M12)+2*M12*(4*
     &  a0t1+M12)*Mah2(INH4)+(8*a0t1+6*M12+4*A0TNH(INH4))*Mah2(INH4)**
     &  2+3*Mah2(INH4)**3))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4)
     &  )*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+
     &  ((CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*
     &  (4*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+MCha2)*
     &  Mah2(INH4)+(8*a0tcha+6*MCha2+4*A0TNH(INH4))*Mah2(INH4)**2+3*
     &  Mah2(INH4)**3))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))-(6*M12*
     &  (hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))*(2*M12*(4*a0t1+M12)+(8*
     &  a0t1+6*M12+4*A0THpN(ICH3))*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)
     &  )/((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-
     &  Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))-(2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH4)+CFF12S1R(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0THpN(ICH3))*
     &  MassHpm(ICH3)**2+3*MassHpm(ICH3)**4))/((Mah(INH3)-MassHpm(ICH3)
     &  )*(Mah(INH3)+MassHpm(ICH3))*(-Mah(INH4)+MassHpm(ICH3))*
     &  (Mah(INH4)+MassHpm(ICH3)))-(6*(hy(INH4)*hyc(INH3)+hy(INH3)*
     &  hyc(INH4))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+4*
     &  A0THpN(ICH3))*MassHpm(ICH3)**2+(4*a0t1+5*M12)*MassHpm(ICH3)**4)
     &  )/((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-
     &  Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))-(2*
     &  (CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*
     &  A0THpN(ICH3))*MassHpm(ICH3)**2+(4*a0tcha+5*MCha2)*MassHpm(ICH3)
     &  **4))/((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-
     &  Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(3*
     &  (hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))*(4*M12**2*(4*a0t1+M12)+
     &  2*M12*(4*a0t1+M12)*MassHpm(ICH3)**2+(8*a0t1+6*M12+4*
     &  A0THpN(ICH3))*MassHpm(ICH3)**4+3*MassHpm(ICH3)**6))/((Mah(INH3)
     &  -MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-Mah(INH4)+
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+((CFF12S1L(INH4)*
     &  CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*(4*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+MCha2)*MassHpm(ICH3)**2+(8*
     &  a0tcha+6*MCha2+4*A0THpN(ICH3))*MassHpm(ICH3)**4+3*MassHpm(ICH3)
     &  **6))/((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-
     &  Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))))/32.+
     &  (CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-3*
     &  (FD111THpT(6,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2-
     &  FD111THpT(8,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2-
     &  FD111THT(6,INH4)*hy(INH4)*hyc(INH3)*Mah(INH3)**2+
     &  FD111THT(8,INH4)*hy(INH4)*hyc(INH3)*Mah(INH3)**2+
     &  FD111THpT(6,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2-
     &  FD111THpT(8,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2-
     &  FD111THT(6,INH4)*hy(INH3)*hyc(INH4)*Mah(INH3)**2+
     &  FD111THT(8,INH4)*hy(INH3)*hyc(INH4)*Mah(INH3)**2+M12*
     &  FD111THT(3,INH3)*hy(INH3)*hy(INH4)*Mah(INH4)**2-
     &  FD111THpT(6,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2+
     &  FD111THpT(8,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2+
     &  FD111THT(6,INH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2-
     &  FD111THT(8,INH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2-
     &  FD111THpT(6,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+
     &  FD111THpT(8,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+
     &  FD111THT(6,INH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2-
     &  FD111THT(8,INH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD111THT(3,INH3)*hyc(INH3)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD111THpT(3,ICH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))*
     &  (Mah(INH3)**2-Mah(INH4)**2)-M12*FD111THT(3,INH3)*hy(INH3)*
     &  hy(INH4)*MassHpm(ICH3)**2-FD111THT(6,INH3)*hy(INH4)*hyc(INH3)*
     &  MassHpm(ICH3)**2+FD111THT(6,INH4)*hy(INH4)*hyc(INH3)*
     &  MassHpm(ICH3)**2+FD111THT(8,INH3)*hy(INH4)*hyc(INH3)*
     &  MassHpm(ICH3)**2-FD111THT(8,INH4)*hy(INH4)*hyc(INH3)*
     &  MassHpm(ICH3)**2-FD111THT(6,INH3)*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**2+FD111THT(6,INH4)*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**2+FD111THT(8,INH3)*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**2-FD111THT(8,INH4)*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**2-M12*FD111THT(3,INH3)*hyc(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**2-M12*FD111THT(3,INH4)*(hy(INH3)*hy(INH4)+
     &  hyc(INH3)*hyc(INH4))*(Mah(INH3)**2-MassHpm(ICH3)**2))+
     &  CFF12S1L(INH3)*(CFF12S1R(INH4)*(-(FD111ChaHpCha(6,ICH3)*
     &  Mah(INH3)**2)+FD111ChaHpCha(8,ICH3)*Mah(INH3)**2-
     &  FD111ChaHCha(6,INH3)*Mah(INH4)**2+FD111ChaHCha(8,INH3)*
     &  Mah(INH4)**2+FD111ChaHpCha(6,ICH3)*Mah(INH4)**2-
     &  FD111ChaHpCha(8,ICH3)*Mah(INH4)**2+FD111ChaHCha(6,INH3)*
     &  MassHpm(ICH3)**2-FD111ChaHCha(8,INH3)*MassHpm(ICH3)**2+
     &  FD111ChaHCha(6,INH4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111ChaHCha(8,INH4)*(-Mah(INH3)**2+MassHpm(ICH3)**2))+MCha2*
     &  CFF12S1L(INH4)*(FD111ChaHpCha(3,ICH3)*(-Mah(INH3)**2+Mah(INH4)*
     &  *2)+FD111ChaHCha(3,INH4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111ChaHCha(3,INH3)*(-Mah(INH4)**2+MassHpm(ICH3)**2)))+
     &  CFF12S1R(INH3)*(CFF12S1L(INH4)*(-(FD111ChaHpCha(6,ICH3)*
     &  Mah(INH3)**2)+FD111ChaHpCha(8,ICH3)*Mah(INH3)**2-
     &  FD111ChaHCha(6,INH3)*Mah(INH4)**2+FD111ChaHCha(8,INH3)*
     &  Mah(INH4)**2+FD111ChaHpCha(6,ICH3)*Mah(INH4)**2-
     &  FD111ChaHpCha(8,ICH3)*Mah(INH4)**2+FD111ChaHCha(6,INH3)*
     &  MassHpm(ICH3)**2-FD111ChaHCha(8,INH3)*MassHpm(ICH3)**2+
     &  FD111ChaHCha(6,INH4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111ChaHCha(8,INH4)*(-Mah(INH3)**2+MassHpm(ICH3)**2))+MCha2*
     &  CFF12S1R(INH4)*(FD111ChaHpCha(3,ICH3)*(-Mah(INH3)**2+Mah(INH4)*
     &  *2)+FD111ChaHCha(3,INH4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111ChaHCha(3,INH3)*(-Mah(INH4)**2+MassHpm(ICH3)**2)))))/(2.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3))))
              else
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(3*
     &  (FD111THpT(6,ICH3)*hy(INH4)*hyc(INH3)-FD111THpT(8,ICH3)*
     &  hy(INH4)*hyc(INH3)-FD111THT(6,INH4)*hy(INH4)*hyc(INH3)+
     &  FD111THT(8,INH4)*hy(INH4)*hyc(INH3)+FD111THpT(6,ICH3)*hy(INH3)*
     &  hyc(INH4)-FD111THpT(8,ICH3)*hy(INH3)*hyc(INH4)-FD111THT(6,INH4)
     &  *hy(INH3)*hyc(INH4)+FD111THT(8,INH4)*hy(INH3)*hyc(INH4)+M12*
     &  FD111THpT(3,ICH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD111THT(3,INH4)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))+M12*
     &  FD211HpTT(4,ICH3)*hy(INH3)*hy(INH4)*Mah(INH4)**2-
     &  FD211HpTT(5,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2+
     &  FD211HpTT(6,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2-
     &  FD211HpTT(5,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+
     &  FD211HpTT(6,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD211HpTT(4,ICH3)*hyc(INH3)*hyc(INH4)*Mah(INH4)**2-M12*
     &  FD211HpTT(4,ICH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2+
     &  FD211HpTT(5,ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2-
     &  FD211HpTT(6,ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2+
     &  FD211HpTT(5,ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-
     &  FD211HpTT(6,ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-M12*
     &  FD211HpTT(4,ICH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH4)*(-FD111ChaHCha(6,INH4)+
     &  FD111ChaHCha(8,INH4)+FD111ChaHpCha(6,ICH3)-
     &  FD111ChaHpCha(8,ICH3)-FD211HpChaCha(5,ICH3)*Mah(INH4)**2+
     &  FD211HpChaCha(6,ICH3)*Mah(INH4)**2+FD211HpChaCha(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpChaCha(6,ICH3)*MassHpm(ICH3)**2)+MCha2*
     &  CFF12S1L(INH4)*(-FD111ChaHCha(3,INH4)+FD111ChaHpCha(3,ICH3)+
     &  FD211HpChaCha(4,ICH3)*(Mah(INH4)**2-MassHpm(ICH3)**2)))+
     &  CFF12S1R(INH3)*(CFF12S1L(INH4)*(-FD111ChaHCha(6,INH4)+
     &  FD111ChaHCha(8,INH4)+FD111ChaHpCha(6,ICH3)-
     &  FD111ChaHpCha(8,ICH3)-FD211HpChaCha(5,ICH3)*Mah(INH4)**2+
     &  FD211HpChaCha(6,ICH3)*Mah(INH4)**2+FD211HpChaCha(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpChaCha(6,ICH3)*MassHpm(ICH3)**2)+MCha2*
     &  CFF12S1R(INH4)*(-FD111ChaHCha(3,INH4)+FD111ChaHpCha(3,ICH3)+
     &  FD211HpChaCha(4,ICH3)*(Mah(INH4)**2-MassHpm(ICH3)**2)))))/(2.*
     &  (Mah(INH4)**2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-16*MCha2*A0THpN(ICH3)*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH4)+8*MCha2*A0TNH(INH4)*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH4)-48*M12*A0THpN(ICH3)*
     &  hy(INH3)*hy(INH4)*Mah2(INH4)+24*M12*A0TNH(INH4)*hy(INH3)*
     &  hy(INH4)*Mah2(INH4)-96*M12*A0THpN(ICH3)*hy(INH4)*hyc(INH3)*
     &  Mah2(INH4)+48*M12*A0TNH(INH4)*hy(INH4)*hyc(INH3)*Mah2(INH4)-96*
     &  M12*A0THpN(ICH3)*hy(INH3)*hyc(INH4)*Mah2(INH4)+48*M12*
     &  A0TNH(INH4)*hy(INH3)*hyc(INH4)*Mah2(INH4)-48*M12*A0THpN(ICH3)*
     &  hyc(INH3)*hyc(INH4)*Mah2(INH4)+24*M12*A0TNH(INH4)*hyc(INH3)*
     &  hyc(INH4)*Mah2(INH4)+6*MCha2*CFF12S1R(INH3)*CFF12S1R(INH4)*
     &  Mah2(INH4)**2+18*M12*hy(INH3)*hy(INH4)*Mah2(INH4)**2+12*M12*
     &  hy(INH4)*hyc(INH3)*Mah2(INH4)**2-12*A0TNH(INH4)*hy(INH4)*
     &  hyc(INH3)*Mah2(INH4)**2+12*M12*hy(INH3)*hyc(INH4)*Mah2(INH4)**
     &  2-12*A0TNH(INH4)*hy(INH3)*hyc(INH4)*Mah2(INH4)**2+18*M12*
     &  hyc(INH3)*hyc(INH4)*Mah2(INH4)**2-9*hy(INH4)*hyc(INH3)*
     &  Mah2(INH4)**3-9*hy(INH3)*hyc(INH4)*Mah2(INH4)**3+8*MCha2*
     &  A0THpN(ICH3)*CFF12S1R(INH3)*CFF12S1R(INH4)*MassHpm(ICH3)**2+24*
     &  M12*A0THpN(ICH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2+48*M12*
     &  A0THpN(ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2+48*M12*
     &  A0THpN(ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2+24*M12*
     &  A0THpN(ICH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2-4*MCha2*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH4)*MassHpm(ICH3)**2-12*
     &  M12*hy(INH3)*hy(INH4)*Mah2(INH4)*MassHpm(ICH3)**2+24*M12*
     &  hy(INH4)*hyc(INH3)*Mah2(INH4)*MassHpm(ICH3)**2+36*A0THpN(ICH3)*
     &  hy(INH4)*hyc(INH3)*Mah2(INH4)*MassHpm(ICH3)**2+24*M12*hy(INH3)*
     &  hyc(INH4)*Mah2(INH4)*MassHpm(ICH3)**2+36*A0THpN(ICH3)*hy(INH3)*
     &  hyc(INH4)*Mah2(INH4)*MassHpm(ICH3)**2-12*M12*hyc(INH3)*
     &  hyc(INH4)*Mah2(INH4)*MassHpm(ICH3)**2-2*MCha2*CFF12S1R(INH3)*
     &  CFF12S1R(INH4)*MassHpm(ICH3)**4-6*M12*hy(INH3)*hy(INH4)*
     &  MassHpm(ICH3)**4-36*M12*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**4-24*
     &  A0THpN(ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**4-36*M12*
     &  hy(INH3)*hyc(INH4)*MassHpm(ICH3)**4-24*A0THpN(ICH3)*hy(INH3)*
     &  hyc(INH4)*MassHpm(ICH3)**4-6*M12*hyc(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**4+15*hy(INH4)*hyc(INH3)*Mah2(INH4)*MassHpm(ICH3)
     &  **4+15*hy(INH3)*hyc(INH4)*Mah2(INH4)*MassHpm(ICH3)**4-6*
     &  hy(INH4)*hyc(INH3)*MassHpm(ICH3)**6-6*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**6+CFF12S1L(INH4)*CFF12S1R(INH3)*(2*MCha2*(4*
     &  a0tcha+5*MCha2+8*A0TNH(INH4))*Mah2(INH4)+4*(MCha2-A0TNH(INH4))*
     &  Mah2(INH4)**2-3*Mah2(INH4)**3+Mah2(INH4)*(-2*MCha2*(4*a0tcha+5*
     &  MCha2)+8*MCha2*MassHpm(ICH3)**2+5*MassHpm(ICH3)**4-4*
     &  A0THpN(ICH3)*(8*MCha2-3*MassHpm(ICH3)**2))-2*MassHpm(ICH3)**2*
     &  (6*MCha2*MassHpm(ICH3)**2+MassHpm(ICH3)**4+A0THpN(ICH3)*(-8*
     &  MCha2+4*MassHpm(ICH3)**2)))+CFF12S1L(INH3)*(2*MCha2*
     &  CFF12S1L(INH4)*((8*a0tcha+6*MCha2+4*A0TNH(INH4))*Mah2(INH4)+3*
     &  Mah2(INH4)**2+4*A0THpN(ICH3)*MassHpm(ICH3)**2-MassHpm(ICH3)**4-
     &  2*Mah2(INH4)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+MassHpm(ICH3)**2)
     &  )+CFF12S1R(INH4)*(2*MCha2*(4*a0tcha+5*MCha2+8*A0TNH(INH4))*
     &  Mah2(INH4)+4*(MCha2-A0TNH(INH4))*Mah2(INH4)**2-3*Mah2(INH4)**3+
     &  Mah2(INH4)*(-2*MCha2*(4*a0tcha+5*MCha2)+8*MCha2*MassHpm(ICH3)**
     &  2+5*MassHpm(ICH3)**4-4*A0THpN(ICH3)*(8*MCha2-3*MassHpm(ICH3)**
     &  2))-2*MassHpm(ICH3)**2*(6*MCha2*MassHpm(ICH3)**2+MassHpm(ICH3)*
     &  *4+A0THpN(ICH3)*(-8*MCha2+4*MassHpm(ICH3)**2))))))/(32.*
     &  (Mah2(INH4)-MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(3*
     &  (FD111THpT(6,ICH3)*hy(INH4)*hyc(INH3)-FD111THpT(8,ICH3)*
     &  hy(INH4)*hyc(INH3)-FD111THT(6,INH3)*hy(INH4)*hyc(INH3)+
     &  FD111THT(8,INH3)*hy(INH4)*hyc(INH3)+FD111THpT(6,ICH3)*hy(INH3)*
     &  hyc(INH4)-FD111THpT(8,ICH3)*hy(INH3)*hyc(INH4)-FD111THT(6,INH3)
     &  *hy(INH3)*hyc(INH4)+FD111THT(8,INH3)*hy(INH3)*hyc(INH4)+M12*
     &  FD111THpT(3,ICH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD111THT(3,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))+M12*
     &  FD211HpTT(4,ICH3)*hy(INH3)*hy(INH4)*Mah(INH3)**2-
     &  FD211HpTT(5,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2+
     &  FD211HpTT(6,ICH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2-
     &  FD211HpTT(5,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2+
     &  FD211HpTT(6,ICH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2+M12*
     &  FD211HpTT(4,ICH3)*hyc(INH3)*hyc(INH4)*Mah(INH3)**2-M12*
     &  FD211HpTT(4,ICH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2+
     &  FD211HpTT(5,ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2-
     &  FD211HpTT(6,ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2+
     &  FD211HpTT(5,ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-
     &  FD211HpTT(6,ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-M12*
     &  FD211HpTT(4,ICH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH4)*(-FD111ChaHCha(6,INH3)+
     &  FD111ChaHCha(8,INH3)+FD111ChaHpCha(6,ICH3)-
     &  FD111ChaHpCha(8,ICH3)-FD211HpChaCha(5,ICH3)*Mah(INH3)**2+
     &  FD211HpChaCha(6,ICH3)*Mah(INH3)**2+FD211HpChaCha(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpChaCha(6,ICH3)*MassHpm(ICH3)**2)+MCha2*
     &  CFF12S1L(INH4)*(-FD111ChaHCha(3,INH3)+FD111ChaHpCha(3,ICH3)+
     &  FD211HpChaCha(4,ICH3)*(Mah(INH3)**2-MassHpm(ICH3)**2)))+
     &  CFF12S1R(INH3)*(CFF12S1L(INH4)*(-FD111ChaHCha(6,INH3)+
     &  FD111ChaHCha(8,INH3)+FD111ChaHpCha(6,ICH3)-
     &  FD111ChaHpCha(8,ICH3)-FD211HpChaCha(5,ICH3)*Mah(INH3)**2+
     &  FD211HpChaCha(6,ICH3)*Mah(INH3)**2+FD211HpChaCha(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpChaCha(6,ICH3)*MassHpm(ICH3)**2)+MCha2*
     &  CFF12S1R(INH4)*(-FD111ChaHCha(3,INH3)+FD111ChaHpCha(3,ICH3)+
     &  FD211HpChaCha(4,ICH3)*(Mah(INH3)**2-MassHpm(ICH3)**2)))))/(2.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-16*MCha2*A0THpN(ICH3)*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH3)+8*MCha2*A0TNH(INH3)*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH3)-48*M12*A0THpN(ICH3)*
     &  hy(INH3)*hy(INH4)*Mah2(INH3)+24*M12*A0TNH(INH3)*hy(INH3)*
     &  hy(INH4)*Mah2(INH3)-96*M12*A0THpN(ICH3)*hy(INH4)*hyc(INH3)*
     &  Mah2(INH3)+48*M12*A0TNH(INH3)*hy(INH4)*hyc(INH3)*Mah2(INH3)-96*
     &  M12*A0THpN(ICH3)*hy(INH3)*hyc(INH4)*Mah2(INH3)+48*M12*
     &  A0TNH(INH3)*hy(INH3)*hyc(INH4)*Mah2(INH3)-48*M12*A0THpN(ICH3)*
     &  hyc(INH3)*hyc(INH4)*Mah2(INH3)+24*M12*A0TNH(INH3)*hyc(INH3)*
     &  hyc(INH4)*Mah2(INH3)+6*MCha2*CFF12S1R(INH3)*CFF12S1R(INH4)*
     &  Mah2(INH3)**2+18*M12*hy(INH3)*hy(INH4)*Mah2(INH3)**2+12*M12*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)**2-12*A0TNH(INH3)*hy(INH4)*
     &  hyc(INH3)*Mah2(INH3)**2+12*M12*hy(INH3)*hyc(INH4)*Mah2(INH3)**
     &  2-12*A0TNH(INH3)*hy(INH3)*hyc(INH4)*Mah2(INH3)**2+18*M12*
     &  hyc(INH3)*hyc(INH4)*Mah2(INH3)**2-9*hy(INH4)*hyc(INH3)*
     &  Mah2(INH3)**3-9*hy(INH3)*hyc(INH4)*Mah2(INH3)**3+8*MCha2*
     &  A0THpN(ICH3)*CFF12S1R(INH3)*CFF12S1R(INH4)*MassHpm(ICH3)**2+24*
     &  M12*A0THpN(ICH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2+48*M12*
     &  A0THpN(ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2+48*M12*
     &  A0THpN(ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2+24*M12*
     &  A0THpN(ICH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2-4*MCha2*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH3)*MassHpm(ICH3)**2-12*
     &  M12*hy(INH3)*hy(INH4)*Mah2(INH3)*MassHpm(ICH3)**2+24*M12*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)*MassHpm(ICH3)**2+36*A0THpN(ICH3)*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)*MassHpm(ICH3)**2+24*M12*hy(INH3)*
     &  hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**2+36*A0THpN(ICH3)*hy(INH3)*
     &  hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**2-12*M12*hyc(INH3)*
     &  hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**2-2*MCha2*CFF12S1R(INH3)*
     &  CFF12S1R(INH4)*MassHpm(ICH3)**4-6*M12*hy(INH3)*hy(INH4)*
     &  MassHpm(ICH3)**4-36*M12*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**4-24*
     &  A0THpN(ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**4-36*M12*
     &  hy(INH3)*hyc(INH4)*MassHpm(ICH3)**4-24*A0THpN(ICH3)*hy(INH3)*
     &  hyc(INH4)*MassHpm(ICH3)**4-6*M12*hyc(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**4+15*hy(INH4)*hyc(INH3)*Mah2(INH3)*MassHpm(ICH3)
     &  **4+15*hy(INH3)*hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**4-6*
     &  hy(INH4)*hyc(INH3)*MassHpm(ICH3)**6-6*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**6+CFF12S1L(INH4)*CFF12S1R(INH3)*(2*MCha2*(4*
     &  a0tcha+5*MCha2+8*A0TNH(INH3))*Mah2(INH3)+4*(MCha2-A0TNH(INH3))*
     &  Mah2(INH3)**2-3*Mah2(INH3)**3+Mah2(INH3)*(-2*MCha2*(4*a0tcha+5*
     &  MCha2)+8*MCha2*MassHpm(ICH3)**2+5*MassHpm(ICH3)**4-4*
     &  A0THpN(ICH3)*(8*MCha2-3*MassHpm(ICH3)**2))-2*MassHpm(ICH3)**2*
     &  (6*MCha2*MassHpm(ICH3)**2+MassHpm(ICH3)**4+A0THpN(ICH3)*(-8*
     &  MCha2+4*MassHpm(ICH3)**2)))+CFF12S1L(INH3)*(2*MCha2*
     &  CFF12S1L(INH4)*((8*a0tcha+6*MCha2+4*A0TNH(INH3))*Mah2(INH3)+3*
     &  Mah2(INH3)**2+4*A0THpN(ICH3)*MassHpm(ICH3)**2-MassHpm(ICH3)**4-
     &  2*Mah2(INH3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+MassHpm(ICH3)**2)
     &  )+CFF12S1R(INH4)*(2*MCha2*(4*a0tcha+5*MCha2+8*A0TNH(INH3))*
     &  Mah2(INH3)+4*(MCha2-A0TNH(INH3))*Mah2(INH3)**2-3*Mah2(INH3)**3+
     &  Mah2(INH3)*(-2*MCha2*(4*a0tcha+5*MCha2)+8*MCha2*MassHpm(ICH3)**
     &  2+5*MassHpm(ICH3)**4-4*A0THpN(ICH3)*(8*MCha2-3*MassHpm(ICH3)**
     &  2))-2*MassHpm(ICH3)**2*(6*MCha2*MassHpm(ICH3)**2+MassHpm(ICH3)*
     &  *4+A0THpN(ICH3)*(-8*MCha2+4*MassHpm(ICH3)**2))))))/(32.*
     &  (Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH4) - MassHpm(ICH3))*Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-3*
     &  (FD111THpT(6,ICH3)*hy(INH4)*hyc(INH3)-FD111THpT(8,ICH3)*
     &  hy(INH4)*hyc(INH3)-FD111THT(6,INH3)*hy(INH4)*hyc(INH3)+
     &  FD111THT(8,INH3)*hy(INH4)*hyc(INH3)+FD111THpT(6,ICH3)*hy(INH3)*
     &  hyc(INH4)-FD111THpT(8,ICH3)*hy(INH3)*hyc(INH4)-FD111THT(6,INH3)
     &  *hy(INH3)*hyc(INH4)+FD111THT(8,INH3)*hy(INH3)*hyc(INH4)+M12*
     &  FD111THpT(3,ICH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD111THT(3,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))+M12*
     &  FD211HTT(4,INH3)*hy(INH3)*hy(INH4)*Mah(INH3)**2-
     &  FD211HTT(5,INH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2+
     &  FD211HTT(6,INH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2-
     &  FD211HTT(5,INH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2+
     &  FD211HTT(6,INH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2+M12*
     &  FD211HTT(4,INH3)*hyc(INH3)*hyc(INH4)*Mah(INH3)**2-M12*
     &  FD211HTT(4,INH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2+
     &  FD211HTT(5,INH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2-
     &  FD211HTT(6,INH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2+
     &  FD211HTT(5,INH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-
     &  FD211HTT(6,INH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-M12*
     &  FD211HTT(4,INH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH4)*(FD111ChaHCha(6,INH3)-
     &  FD111ChaHCha(8,INH3)-FD111ChaHpCha(6,ICH3)+
     &  FD111ChaHpCha(8,ICH3)+FD211HChaCha(5,INH3)*Mah(INH3)**2-
     &  FD211HChaCha(6,INH3)*Mah(INH3)**2-FD211HChaCha(5,INH3)*
     &  MassHpm(ICH3)**2+FD211HChaCha(6,INH3)*MassHpm(ICH3)**2)+MCha2*
     &  CFF12S1L(INH4)*(FD111ChaHCha(3,INH3)-FD111ChaHpCha(3,ICH3)+
     &  FD211HChaCha(4,INH3)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))+
     &  CFF12S1R(INH3)*(CFF12S1L(INH4)*(FD111ChaHCha(6,INH3)-
     &  FD111ChaHCha(8,INH3)-FD111ChaHpCha(6,ICH3)+
     &  FD111ChaHpCha(8,ICH3)+FD211HChaCha(5,INH3)*Mah(INH3)**2-
     &  FD211HChaCha(6,INH3)*Mah(INH3)**2-FD211HChaCha(5,INH3)*
     &  MassHpm(ICH3)**2+FD211HChaCha(6,INH3)*MassHpm(ICH3)**2)+MCha2*
     &  CFF12S1R(INH4)*(FD111ChaHCha(3,INH3)-FD111ChaHpCha(3,ICH3)+
     &  FD211HChaCha(4,INH3)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))))/(2.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(8*MCha2*A0TNH(INH3)*CFF12S1R(INH3)*
     &  CFF12S1R(INH4)*Mah2(INH3)+24*M12*A0TNH(INH3)*hy(INH3)*hy(INH4)*
     &  Mah2(INH3)+48*M12*A0TNH(INH3)*hy(INH4)*hyc(INH3)*Mah2(INH3)+48*
     &  M12*A0TNH(INH3)*hy(INH3)*hyc(INH4)*Mah2(INH3)+24*M12*
     &  A0TNH(INH3)*hyc(INH3)*hyc(INH4)*Mah2(INH3)-2*MCha2*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH3)**2-6*M12*hy(INH3)*
     &  hy(INH4)*Mah2(INH3)**2-36*M12*hy(INH4)*hyc(INH3)*Mah2(INH3)**2-
     &  24*A0TNH(INH3)*hy(INH4)*hyc(INH3)*Mah2(INH3)**2-36*M12*hy(INH3)
     &  *hyc(INH4)*Mah2(INH3)**2-24*A0TNH(INH3)*hy(INH3)*hyc(INH4)*
     &  Mah2(INH3)**2-6*M12*hyc(INH3)*hyc(INH4)*Mah2(INH3)**2-6*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)**3-6*hy(INH3)*hyc(INH4)*
     &  Mah2(INH3)**3+8*MCha2*A0THpN(ICH3)*CFF12S1R(INH3)*
     &  CFF12S1R(INH4)*MassHpm(ICH3)**2-16*MCha2*A0TNH(INH3)*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*MassHpm(ICH3)**2+24*M12*
     &  A0THpN(ICH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2-48*M12*
     &  A0TNH(INH3)*hy(INH3)*hy(INH4)*MassHpm(ICH3)**2+48*M12*
     &  A0THpN(ICH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2-96*M12*
     &  A0TNH(INH3)*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2+48*M12*
     &  A0THpN(ICH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2-96*M12*
     &  A0TNH(INH3)*hy(INH3)*hyc(INH4)*MassHpm(ICH3)**2+24*M12*
     &  A0THpN(ICH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2-48*M12*
     &  A0TNH(INH3)*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**2-4*MCha2*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH3)*MassHpm(ICH3)**2-12*
     &  M12*hy(INH3)*hy(INH4)*Mah2(INH3)*MassHpm(ICH3)**2+24*M12*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)*MassHpm(ICH3)**2+36*A0TNH(INH3)*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)*MassHpm(ICH3)**2+24*M12*hy(INH3)*
     &  hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**2+36*A0TNH(INH3)*hy(INH3)*
     &  hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**2-12*M12*hyc(INH3)*
     &  hyc(INH4)*Mah2(INH3)*MassHpm(ICH3)**2+15*hy(INH4)*hyc(INH3)*
     &  Mah2(INH3)**2*MassHpm(ICH3)**2+15*hy(INH3)*hyc(INH4)*Mah2(INH3)
     &  **2*MassHpm(ICH3)**2+6*MCha2*CFF12S1R(INH3)*CFF12S1R(INH4)*
     &  MassHpm(ICH3)**4+18*M12*hy(INH3)*hy(INH4)*MassHpm(ICH3)**4+12*
     &  M12*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**4-12*A0THpN(ICH3)*
     &  hy(INH4)*hyc(INH3)*MassHpm(ICH3)**4+12*M12*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**4-12*A0THpN(ICH3)*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**4+18*M12*hyc(INH3)*hyc(INH4)*MassHpm(ICH3)**4-9*
     &  hy(INH4)*hyc(INH3)*MassHpm(ICH3)**6-9*hy(INH3)*hyc(INH4)*
     &  MassHpm(ICH3)**6+CFF12S1L(INH4)*CFF12S1R(INH3)*(2*MCha2*(4*
     &  a0tcha+5*MCha2+16*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**3+
     &  Mah2(INH3)**2*(-4*MCha2+4*A0TNH(INH3)-5*Mah2(INH3)+5*
     &  MassHpm(ICH3)**2)+MassHpm(ICH3)**2*(16*MCha2*A0THpN(ICH3)-32*
     &  MCha2*A0TNH(INH3)+4*MCha2*MassHpm(ICH3)**2-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2-3*MassHpm(ICH3)**4)-2*Mah2(INH3)*(A0TNH(INH3)*
     &  (8*MCha2+6*Mah2(INH3)-6*MassHpm(ICH3)**2)+MCha2*(4*a0tcha+5*
     &  MCha2+4*Mah2(INH3)-4*MassHpm(ICH3)**2)))+CFF12S1L(INH3)*(-2*
     &  MCha2*CFF12S1L(INH4)*(-2*(4*a0tcha+3*MCha2+4*A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2+MassHpm(ICH3)**2*(-4*A0THpN(ICH3)+8*
     &  A0TNH(INH3)-3*MassHpm(ICH3)**2)+2*Mah2(INH3)*(4*a0tcha+3*MCha2+
     &  2*A0TNH(INH3)-Mah2(INH3)+MassHpm(ICH3)**2))+CFF12S1R(INH4)*(2*
     &  MCha2*(4*a0tcha+5*MCha2+16*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)
     &  **3+Mah2(INH3)**2*(-4*MCha2+4*A0TNH(INH3)-5*Mah2(INH3)+5*
     &  MassHpm(ICH3)**2)+MassHpm(ICH3)**2*(16*MCha2*A0THpN(ICH3)-32*
     &  MCha2*A0TNH(INH3)+4*MCha2*MassHpm(ICH3)**2-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2-3*MassHpm(ICH3)**4)-2*Mah2(INH3)*(A0TNH(INH3)*
     &  (8*MCha2+6*Mah2(INH3)-6*MassHpm(ICH3)**2)+MCha2*(4*a0tcha+5*
     &  MCha2+4*Mah2(INH3)-4*MassHpm(ICH3)**2))))))/(32.*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH4) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(-Mah(INH3) + MassHpm(ICH3)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+(-(CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CFF12S1R(INH3)*(MCha2*CFF12S1R(INH4)*FD311HpChaCha(3,ICH3)+
     &  CFF12S1L(INH4)*(-FD311HpChaCha(4,ICH3)+FD311HpChaCha(6,ICH3)))+
     &  CFF12S1L(INH3)*(MCha2*CFF12S1L(INH4)*FD311HpChaCha(3,ICH3)+
     &  CFF12S1R(INH4)*(-FD311HpChaCha(4,ICH3)+FD311HpChaCha(6,ICH3)))+
     &  3*(-((FD311HpTT(4,ICH3)-FD311HpTT(6,ICH3))*(hy(INH4)*hyc(INH3)+
     &  hy(INH3)*hyc(INH4)))+M12*FD311HpTT(3,ICH3)*(hy(INH3)*hy(INH4)+
     &  hyc(INH3)*hyc(INH4)))))/2.+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0THpN(ICH3)*(2*MCha2*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)+6*M12*hy(INH3)*hy(INH4)+12*M12*
     &  hy(INH4)*hyc(INH3)+12*M12*hy(INH3)*hyc(INH4)+6*M12*hyc(INH3)*
     &  hyc(INH4)-9*hy(INH4)*hyc(INH3)*MassHpm(ICH3)**2-9*hy(INH3)*
     &  hyc(INH4)*MassHpm(ICH3)**2+CFF12S1L(INH4)*CFF12S1R(INH3)*(4*
     &  MCha2-3*MassHpm(ICH3)**2)+CFF12S1L(INH3)*(2*MCha2*
     &  CFF12S1L(INH4)+CFF12S1R(INH4)*(4*MCha2-3*MassHpm(ICH3)**2)))+
     &  MassHpm(ICH3)**2*(CFF12S1L(INH4)*CFF12S1R(INH3)*(-20*MCha2+
     &  MassHpm(ICH3)**2)+CFF12S1L(INH3)*(-6*MCha2*CFF12S1L(INH4)+
     &  CFF12S1R(INH4)*(-20*MCha2+MassHpm(ICH3)**2))-3*(2*MCha2*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)+hyc(INH3)*(20*M12*hy(INH4)+6*M12*
     &  hyc(INH4)-hy(INH4)*MassHpm(ICH3)**2)+hy(INH3)*(6*M12*hy(INH4)+
     &  20*M12*hyc(INH4)-hyc(INH4)*MassHpm(ICH3)**2)))))/(32.*
     &  MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
       do INH3=1,6
       do INH4=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*(-
     &  (FD111ChiHpChi(6,INe3,ICH3,INe4)*Mah(INH3)**2)+
     &  FD111ChiHpChi(8,INe3,ICH3,INe4)*Mah(INH3)**2-
     &  FD111ChiHChi(6,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(8,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)*Mah(INH4)**2-
     &  FD111ChiHpChi(8,INe3,ICH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(6,INe3,INH3,INe4)*MassHpm(ICH3)**2-
     &  FD111ChiHChi(8,INe3,INH3,INe4)*MassHpm(ICH3)**2+
     &  FD111ChiHChi(6,INe3,INH4,INe4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111ChiHChi(8,INe3,INH4,INe4)*(-Mah(INH3)**2+MassHpm(ICH3)**2)
     &  )+CFF11S1L(INe3,INe4,INH3)*(FD111ChiHpChi(3,INe3,ICH3,INe4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)+FD111ChiHChi(3,INe3,INH4,INe4)*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)+FD111ChiHChi(3,INe3,INH3,INe4)*
     &  (-Mah(INH4)**2+MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*(-
     &  (FD111ChiHpChi(6,INe3,ICH3,INe4)*Mah(INH3)**2)+
     &  FD111ChiHpChi(8,INe3,ICH3,INe4)*Mah(INH3)**2-
     &  FD111ChiHChi(6,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(8,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)*Mah(INH4)**2-
     &  FD111ChiHpChi(8,INe3,ICH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(6,INe3,INH3,INe4)*MassHpm(ICH3)**2-
     &  FD111ChiHChi(8,INe3,INH3,INe4)*MassHpm(ICH3)**2+
     &  FD111ChiHChi(6,INe3,INH4,INe4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111ChiHChi(8,INe3,INH4,INe4)*(-Mah(INH3)**2+MassHpm(ICH3)**2)
     &  )+CFF11S1R(INe3,INe4,INH3)*(FD111ChiHpChi(3,INe3,ICH3,INe4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)+FD111ChiHChi(3,INe3,INH4,INe4)*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)+FD111ChiHChi(3,INe3,INH3,INe4)*
     &  (-Mah(INH4)**2+MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-(((CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*(4*A0TNH(INH3)*Mah2(INH3)**2+3*
     &  Mah2(INH3)**3+Mah2(INH3)*MNeu(INe3)**4-3*Mah2(INH3)*MNeu(INe4)*
     &  *4+4*A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+4*Mah2(INH3)**2*
     &  MNeu2(INe3)+2*Mah2(INH3)*MNeu2(INe3)**2+A0TNeu(INe4)*(8*
     &  Mah2(INH3)**2+8*MNeu(INe3)**4+Mah2(INH3)*(8*MNeu2(INe3)-4*
     &  MNeu2(INe4)))+2*Mah2(INH3)**2*MNeu2(INe4)+4*MNeu(INe3)**4*
     &  MNeu2(INe4)+8*A0TNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)
     &  *MNeu2(INe3)*MNeu2(INe4)))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))
     &  )+((CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH4))*(4*
     &  A0TNH(INH4)*Mah2(INH4)**2+3*Mah2(INH4)**3+Mah2(INH4)*MNeu(INe3)
     &  **4-3*Mah2(INH4)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH4)*
     &  MNeu2(INe3)+4*Mah2(INH4)**2*MNeu2(INe3)+2*Mah2(INH4)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH4)**2+8*MNeu(INe3)**4+
     &  Mah2(INH4)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH4)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4)))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+
     &  ((CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH4))*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**4+3*MassHpm(ICH3)**6+MassHpm(ICH3)*
     &  *2*MNeu(INe3)**4-3*MassHpm(ICH3)**2*MNeu(INe4)**4+4*
     &  A0TNeu(INe3)*MassHpm(ICH3)**2*MNeu2(INe3)+4*MassHpm(ICH3)**4*
     &  MNeu2(INe3)+2*MassHpm(ICH3)**2*MNeu2(INe3)**2+A0TNeu(INe4)*(8*
     &  MassHpm(ICH3)**4+8*MNeu(INe3)**4+MassHpm(ICH3)**2*(8*
     &  MNeu2(INe3)-4*MNeu2(INe4)))+2*MassHpm(ICH3)**4*MNeu2(INe4)+4*
     &  MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*MNeu2(INe3)*
     &  MNeu2(INe4)+2*MassHpm(ICH3)**2*MNeu2(INe3)*MNeu2(INe4)))
     &  /((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-
     &  Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(2*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2+3*
     &  Mah2(INH3)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+
     &  3*Mah2(INH3)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH3)+MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*
     &  (Mah(INH3)+Mah(INH4))*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3)))+(2*(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*(4*A0TNH(INH3)*Mah2(INH3)*MNeu2(INe3)
     &  +3*Mah2(INH3)**2*MNeu2(INe3)+3*Mah2(INH3)*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*(Mah2(INH3)**2+MNeu(INe3)**4+Mah2(INH3)*
     &  MNeu2(INe3))+4*A0TNH(INH3)*Mah2(INH3)*MNeu2(INe4)+2*Mah2(INH3)*
     &  *2*MNeu2(INe4)+2*MNeu(INe3)**4*MNeu2(INe4)+3*Mah2(INH3)*
     &  MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)*MNeu2(INe3)*(Mah2(INH3)+
     &  MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))-(2*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2+3*
     &  Mah2(INH4)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH4)+MNeu2(INe3))+
     &  3*Mah2(INH4)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH4)+MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*
     &  (Mah(INH3)+Mah(INH4))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+
     &  MassHpm(ICH3)))-(2*(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*(4*A0TNH(INH4)*Mah2(INH4)*MNeu2(INe3)
     &  +3*Mah2(INH4)**2*MNeu2(INe3)+3*Mah2(INH4)*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*(Mah2(INH4)**2+MNeu(INe3)**4+Mah2(INH4)*
     &  MNeu2(INe3))+4*A0TNH(INH4)*Mah2(INH4)*MNeu2(INe4)+2*Mah2(INH4)*
     &  *2*MNeu2(INe4)+2*MNeu(INe3)**4*MNeu2(INe4)+3*Mah2(INH4)*
     &  MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)*MNeu2(INe3)*(Mah2(INH4)+
     &  MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))-(2*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+4*A0TNeu(INe4)*
     &  MassHpm(ICH3)**2+3*MassHpm(ICH3)**4+4*A0TNeu(INe4)*MNeu2(INe3)+
     &  3*MassHpm(ICH3)**2*MNeu2(INe3)+3*MassHpm(ICH3)**2*MNeu2(INe4)+
     &  2*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)*(MassHpm(ICH3)**2+
     &  MNeu2(INe4))))/((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(-Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+
     &  MassHpm(ICH3)))-(2*(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*(4*A0TNeu(INe3)*MassHpm(ICH3)**2*
     &  MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)+3*MassHpm(ICH3)**2*
     &  MNeu2(INe3)**2+4*A0TNeu(INe4)*(MassHpm(ICH3)**4+MNeu(INe3)**4+
     &  MassHpm(ICH3)**2*MNeu2(INe3))+2*MassHpm(ICH3)**4*MNeu2(INe4)+2*
     &  MNeu(INe3)**4*MNeu2(INe4)+4*A0TNeu(INe3)*MNeu2(INe3)*
     &  MNeu2(INe4)+3*MassHpm(ICH3)**2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2*(MNeu2(INe3)+MNeu2(INe4))))
     &  /((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))))/64.)
              else
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*(-
     &  FD111ChiHChi(6,INe3,INH4,INe4)+FD111ChiHChi(8,INe3,INH4,INe4)+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)-FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  -FD211HpChiChi(5,ICH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HpChiChi(5,ICH3,INe3,INe4)*MassHpm(ICH3)**2-
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*MassHpm(ICH3)**2)+
     &  CFF11S1L(INe3,INe4,INH3)*(-FD111ChiHChi(3,INe3,INH4,INe4)+
     &  FD111ChiHpChi(3,INe3,ICH3,INe4)+FD211HpChiChi(4,ICH3,INe3,INe4)
     &  *(Mah(INH4)**2-MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*(-
     &  FD111ChiHChi(6,INe3,INH4,INe4)+FD111ChiHChi(8,INe3,INH4,INe4)+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)-FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  -FD211HpChiChi(5,ICH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HpChiChi(5,ICH3,INe3,INe4)*MassHpm(ICH3)**2-
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*MassHpm(ICH3)**2)+
     &  CFF11S1R(INe3,INe4,INH3)*(-FD111ChiHChi(3,INe3,INH4,INe4)+
     &  FD111ChiHpChi(3,INe3,ICH3,INe4)+FD211HpChiChi(4,ICH3,INe3,INe4)
     &  *(Mah(INH4)**2-MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH4)**2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0TNH(INH4)*Mah2(INH4)*
     &  (CFF11S1R(INe4,INe3,INH4)*(2*CFF11S1R(INe3,INe4,INH3)*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1L(INe3,INe4,INH3)*(-Mah2(INH4)+2*
     &  (MNeu2(INe3)+MNeu2(INe4))))+CFF11S1L(INe4,INe3,INH4)*(2*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(-Mah2(INH4)+2*(MNeu2(INe3)+
     &  MNeu2(INe4)))))+CFF11S1R(INe4,INe3,INH4)*(2*
     &  CFF11S1R(INe3,INe4,INH3)*(-8*A0THpN(ICH3)*Mah2(INH4)+3*
     &  Mah2(INH4)**2+4*A0THpN(ICH3)*MassHpm(ICH3)**2-2*Mah2(INH4)*
     &  MassHpm(ICH3)**2-MassHpm(ICH3)**4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,INH3)*(-3*Mah2(INH4)**3+5*Mah2(INH4)*
     &  MassHpm(ICH3)**4-2*MassHpm(ICH3)**6+3*Mah2(INH4)*MNeu(INe3)**4-
     &  2*MassHpm(ICH3)**2*MNeu(INe3)**4-3*Mah2(INH4)*MNeu(INe4)**4-4*
     &  A0TNeu(INe3)*Mah2(INH4)*MNeu2(INe3)+4*Mah2(INH4)*MassHpm(ICH3)*
     &  *2*MNeu2(INe3)-6*MassHpm(ICH3)**4*MNeu2(INe3)-6*Mah2(INH4)*
     &  MNeu2(INe3)**2+2*MassHpm(ICH3)**2*MNeu2(INe3)**2-4*A0TNeu(INe4)
     &  *Mah2(INH4)*MNeu2(INe4)+4*Mah2(INH4)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-6*MassHpm(ICH3)**4*MNeu2(INe4)-4*Mah2(INH4)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH4)**2*(MNeu2(INe3)+
     &  MNeu2(INe4))+Mah2(INH4)*(-MNeu(INe3)**4+3*MNeu(INe4)**4+4*
     &  (A0TNeu(INe3)*MNeu2(INe3)+MNeu2(INe3)**2+A0TNeu(INe4)*
     &  MNeu2(INe4)+MNeu2(INe3)*MNeu2(INe4)))+4*A0THpN(ICH3)*(2*
     &  MassHpm(ICH3)**2*(-MassHpm(ICH3)**2+MNeu2(INe3)+MNeu2(INe4))+
     &  Mah2(INH4)*(3*MassHpm(ICH3)**2-4*(MNeu2(INe3)+MNeu2(INe4))))))+
     &  CFF11S1L(INe4,INe3,INH4)*(2*CFF11S1L(INe3,INe4,INH3)*(-8*
     &  A0THpN(ICH3)*Mah2(INH4)+3*Mah2(INH4)**2+4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2-2*Mah2(INH4)*MassHpm(ICH3)**2-MassHpm(ICH3)**
     &  4)*MNeu(INe3)*MNeu(INe4)+CFF11S1R(INe3,INe4,INH3)*(-3*
     &  Mah2(INH4)**3+5*Mah2(INH4)*MassHpm(ICH3)**4-2*MassHpm(ICH3)**6+
     &  3*Mah2(INH4)*MNeu(INe3)**4-2*MassHpm(ICH3)**2*MNeu(INe3)**4-3*
     &  Mah2(INH4)*MNeu(INe4)**4-4*A0TNeu(INe3)*Mah2(INH4)*MNeu2(INe3)+
     &  4*Mah2(INH4)*MassHpm(ICH3)**2*MNeu2(INe3)-6*MassHpm(ICH3)**4*
     &  MNeu2(INe3)-6*Mah2(INH4)*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*
     &  MNeu2(INe3)**2-4*A0TNeu(INe4)*Mah2(INH4)*MNeu2(INe4)+4*
     &  Mah2(INH4)*MassHpm(ICH3)**2*MNeu2(INe4)-6*MassHpm(ICH3)**4*
     &  MNeu2(INe4)-4*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH4)**
     &  2*(MNeu2(INe3)+MNeu2(INe4))+Mah2(INH4)*(-MNeu(INe3)**4+3*
     &  MNeu(INe4)**4+4*(A0TNeu(INe3)*MNeu2(INe3)+MNeu2(INe3)**2+
     &  A0TNeu(INe4)*MNeu2(INe4)+MNeu2(INe3)*MNeu2(INe4)))+4*
     &  A0THpN(ICH3)*(2*MassHpm(ICH3)**2*(-MassHpm(ICH3)**2+MNeu2(INe3)
     &  +MNeu2(INe4))+Mah2(INH4)*(3*MassHpm(ICH3)**2-4*(MNeu2(INe3)+
     &  MNeu2(INe4))))))))/(64.*(Mah2(INH4)-MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*(-
     &  FD111ChiHChi(6,INe3,INH3,INe4)+FD111ChiHChi(8,INe3,INH3,INe4)+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)-FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  -FD211HpChiChi(5,ICH3,INe3,INe4)*Mah(INH3)**2+
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*Mah(INH3)**2+
     &  FD211HpChiChi(5,ICH3,INe3,INe4)*MassHpm(ICH3)**2-
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*MassHpm(ICH3)**2)+
     &  CFF11S1L(INe3,INe4,INH3)*(-FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHpChi(3,INe3,ICH3,INe4)+FD211HpChiChi(4,ICH3,INe3,INe4)
     &  *(Mah(INH3)**2-MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*(-
     &  FD111ChiHChi(6,INe3,INH3,INe4)+FD111ChiHChi(8,INe3,INH3,INe4)+
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)-FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  -FD211HpChiChi(5,ICH3,INe3,INe4)*Mah(INH3)**2+
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*Mah(INH3)**2+
     &  FD211HpChiChi(5,ICH3,INe3,INe4)*MassHpm(ICH3)**2-
     &  FD211HpChiChi(6,ICH3,INe3,INe4)*MassHpm(ICH3)**2)+
     &  CFF11S1R(INe3,INe4,INH3)*(-FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHpChi(3,INe3,ICH3,INe4)+FD211HpChiChi(4,ICH3,INe3,INe4)
     &  *(Mah(INH3)**2-MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0TNH(INH3)*Mah2(INH3)*
     &  (CFF11S1R(INe4,INe3,INH4)*(2*CFF11S1R(INe3,INe4,INH3)*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1L(INe3,INe4,INH3)*(-Mah2(INH3)+2*
     &  (MNeu2(INe3)+MNeu2(INe4))))+CFF11S1L(INe4,INe3,INH4)*(2*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(-Mah2(INH3)+2*(MNeu2(INe3)+
     &  MNeu2(INe4)))))+CFF11S1R(INe4,INe3,INH4)*(2*
     &  CFF11S1R(INe3,INe4,INH3)*(-8*A0THpN(ICH3)*Mah2(INH3)+3*
     &  Mah2(INH3)**2+4*A0THpN(ICH3)*MassHpm(ICH3)**2-2*Mah2(INH3)*
     &  MassHpm(ICH3)**2-MassHpm(ICH3)**4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,INH3)*(-3*Mah2(INH3)**3+5*Mah2(INH3)*
     &  MassHpm(ICH3)**4-2*MassHpm(ICH3)**6+3*Mah2(INH3)*MNeu(INe3)**4-
     &  2*MassHpm(ICH3)**2*MNeu(INe3)**4-3*Mah2(INH3)*MNeu(INe4)**4-4*
     &  A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+4*Mah2(INH3)*MassHpm(ICH3)*
     &  *2*MNeu2(INe3)-6*MassHpm(ICH3)**4*MNeu2(INe3)-6*Mah2(INH3)*
     &  MNeu2(INe3)**2+2*MassHpm(ICH3)**2*MNeu2(INe3)**2-4*A0TNeu(INe4)
     &  *Mah2(INH3)*MNeu2(INe4)+4*Mah2(INH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-6*MassHpm(ICH3)**4*MNeu2(INe4)-4*Mah2(INH3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)**2*(MNeu2(INe3)+
     &  MNeu2(INe4))+Mah2(INH3)*(-MNeu(INe3)**4+3*MNeu(INe4)**4+4*
     &  (A0TNeu(INe3)*MNeu2(INe3)+MNeu2(INe3)**2+A0TNeu(INe4)*
     &  MNeu2(INe4)+MNeu2(INe3)*MNeu2(INe4)))+4*A0THpN(ICH3)*(2*
     &  MassHpm(ICH3)**2*(-MassHpm(ICH3)**2+MNeu2(INe3)+MNeu2(INe4))+
     &  Mah2(INH3)*(3*MassHpm(ICH3)**2-4*(MNeu2(INe3)+MNeu2(INe4))))))+
     &  CFF11S1L(INe4,INe3,INH4)*(2*CFF11S1L(INe3,INe4,INH3)*(-8*
     &  A0THpN(ICH3)*Mah2(INH3)+3*Mah2(INH3)**2+4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2-2*Mah2(INH3)*MassHpm(ICH3)**2-MassHpm(ICH3)**
     &  4)*MNeu(INe3)*MNeu(INe4)+CFF11S1R(INe3,INe4,INH3)*(-3*
     &  Mah2(INH3)**3+5*Mah2(INH3)*MassHpm(ICH3)**4-2*MassHpm(ICH3)**6+
     &  3*Mah2(INH3)*MNeu(INe3)**4-2*MassHpm(ICH3)**2*MNeu(INe3)**4-3*
     &  Mah2(INH3)*MNeu(INe4)**4-4*A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+
     &  4*Mah2(INH3)*MassHpm(ICH3)**2*MNeu2(INe3)-6*MassHpm(ICH3)**4*
     &  MNeu2(INe3)-6*Mah2(INH3)*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*
     &  MNeu2(INe3)**2-4*A0TNeu(INe4)*Mah2(INH3)*MNeu2(INe4)+4*
     &  Mah2(INH3)*MassHpm(ICH3)**2*MNeu2(INe4)-6*MassHpm(ICH3)**4*
     &  MNeu2(INe4)-4*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)**
     &  2*(MNeu2(INe3)+MNeu2(INe4))+Mah2(INH3)*(-MNeu(INe3)**4+3*
     &  MNeu(INe4)**4+4*(A0TNeu(INe3)*MNeu2(INe3)+MNeu2(INe3)**2+
     &  A0TNeu(INe4)*MNeu2(INe4)+MNeu2(INe3)*MNeu2(INe4)))+4*
     &  A0THpN(ICH3)*(2*MassHpm(ICH3)**2*(-MassHpm(ICH3)**2+MNeu2(INe3)
     &  +MNeu2(INe4))+Mah2(INH3)*(3*MassHpm(ICH3)**2-4*(MNeu2(INe3)+
     &  MNeu2(INe4))))))))/(64.*(Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH4) - MassHpm(ICH3))*Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(8,INe3,INH3,INe4)-
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)+FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  +FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*MassHpm(ICH3)**2+
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*MassHpm(ICH3)**2)+
     &  CFF11S1L(INe3,INe4,INH3)*(FD111ChiHChi(3,INe3,INH3,INe4)-
     &  FD111ChiHpChi(3,INe3,ICH3,INe4)+FD211HNeuNeu(4,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(8,INe3,INH3,INe4)-
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)+FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  +FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*MassHpm(ICH3)**2+
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*MassHpm(ICH3)**2)+
     &  CFF11S1R(INe3,INe4,INH3)*(FD111ChiHChi(3,INe3,INH3,INe4)-
     &  FD111ChiHpChi(3,INe3,ICH3,INe4)+FD211HNeuNeu(4,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+MassHpm(ICH3)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH4,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0TNH(INH3)*
     &  (CFF11S1R(INe4,INe3,INH4)*(-2*CFF11S1R(INe3,INe4,INH3)*(-
     &  Mah2(INH3)+2*MassHpm(ICH3)**2)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,INH3)*(Mah2(INH3)**2+4*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)*(MNeu2(INe3)+MNeu2(INe4))-Mah2(INH3)*(3*
     &  Mah2(INH3)-3*MassHpm(ICH3)**2+2*(MNeu2(INe3)+MNeu2(INe4)))))+
     &  CFF11S1L(INe4,INe3,INH4)*(-2*CFF11S1L(INe3,INe4,INH3)*(-
     &  Mah2(INH3)+2*MassHpm(ICH3)**2)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(Mah2(INH3)**2+4*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)*(MNeu2(INe3)+MNeu2(INe4))-Mah2(INH3)*(3*
     &  Mah2(INH3)-3*MassHpm(ICH3)**2+2*(MNeu2(INe3)+MNeu2(INe4))))))+
     &  CFF11S1R(INe4,INe3,INH4)*(2*CFF11S1R(INe3,INe4,INH3)*(-
     &  Mah2(INH3)**2+4*A0THpN(ICH3)*MassHpm(ICH3)**2-2*Mah2(INH3)*
     &  MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,INH3)*(3*Mah2(INH3)**3-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**4-3*MassHpm(ICH3)**6-3*Mah2(INH3)*MNeu(INe3)**4+
     &  2*MassHpm(ICH3)**2*MNeu(INe3)**4+3*Mah2(INH3)*MNeu(INe4)**4+4*
     &  A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+8*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)+2*MassHpm(ICH3)**4*MNeu2(INe3)+6*
     &  Mah2(INH3)*MNeu2(INe3)**2-2*MassHpm(ICH3)**2*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*Mah2(INH3)*MNeu2(INe4)+8*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe4)+2*MassHpm(ICH3)**4*MNeu2(INe4)+4*
     &  Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)-Mah2(INH3)**2*(5*Mah2(INH3)-
     &  5*MassHpm(ICH3)**2+2*(MNeu2(INe3)+MNeu2(INe4)))+Mah2(INH3)*
     &  (MNeu(INe3)**4-3*MNeu(INe4)**4-4*(A0TNeu(INe3)*MNeu2(INe3)-
     &  MassHpm(ICH3)**2*MNeu2(INe3)+MNeu2(INe3)**2+A0TNeu(INe4)*
     &  MNeu2(INe4)-MassHpm(ICH3)**2*MNeu2(INe4)+MNeu2(INe3)*
     &  MNeu2(INe4)+Mah2(INH3)*(MNeu2(INe3)+MNeu2(INe4))))))+
     &  CFF11S1L(INe4,INe3,INH4)*(2*CFF11S1L(INe3,INe4,INH3)*(-
     &  Mah2(INH3)**2+4*A0THpN(ICH3)*MassHpm(ICH3)**2-2*Mah2(INH3)*
     &  MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(3*Mah2(INH3)**3-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**4-3*MassHpm(ICH3)**6-3*Mah2(INH3)*MNeu(INe3)**4+
     &  2*MassHpm(ICH3)**2*MNeu(INe3)**4+3*Mah2(INH3)*MNeu(INe4)**4+4*
     &  A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+8*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)+2*MassHpm(ICH3)**4*MNeu2(INe3)+6*
     &  Mah2(INH3)*MNeu2(INe3)**2-2*MassHpm(ICH3)**2*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*Mah2(INH3)*MNeu2(INe4)+8*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe4)+2*MassHpm(ICH3)**4*MNeu2(INe4)+4*
     &  Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)-Mah2(INH3)**2*(5*Mah2(INH3)-
     &  5*MassHpm(ICH3)**2+2*(MNeu2(INe3)+MNeu2(INe4)))+Mah2(INH3)*
     &  (MNeu(INe3)**4-3*MNeu(INe4)**4-4*(A0TNeu(INe3)*MNeu2(INe3)-
     &  MassHpm(ICH3)**2*MNeu2(INe3)+MNeu2(INe3)**2+A0TNeu(INe4)*
     &  MNeu2(INe4)-MassHpm(ICH3)**2*MNeu2(INe4)+MNeu2(INe3)*
     &  MNeu2(INe4)+Mah2(INH3)*(MNeu2(INe3)+MNeu2(INe4))))))))/(64.*
     &  (Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH4) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(-Mah(INH3) + MassHpm(ICH3)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD311HpChiChi(4,ICH3,INe3,INe4)-
     &  FD311HpChiChi(6,ICH3,INe3,INe4))-CFF11S1L(INe3,INe4,INH3)*
     &  FD311HpChiChi(3,ICH3,INe3,INe4)*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD311HpChiChi(4,ICH3,INe3,INe4)-
     &  FD311HpChiChi(6,ICH3,INe3,INe4))-CFF11S1R(INe3,INe4,INH3)*
     &  FD311HpChiChi(3,ICH3,INe3,INe4)*MNeu(INe3)*MNeu(INe4))))/4.+
     &  (CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(MassHpm(ICH3)**
     &  2*(CFF11S1R(INe3,INe4,INH3)*(-6*CFF11S1R(INe4,INe3,INH4)*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1L(INe4,INe3,INH4)*(MassHpm(ICH3)**
     &  2-10*(MNeu2(INe3)+MNeu2(INe4))))+CFF11S1L(INe3,INe4,INH3)*(-6*
     &  CFF11S1L(INe4,INe3,INH4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe4,INe3,INH4)*(MassHpm(ICH3)**2-10*(MNeu2(INe3)+
     &  MNeu2(INe4)))))+4*A0THpN(ICH3)*(CFF11S1R(INe3,INe4,INH3)*(2*
     &  CFF11S1R(INe4,INe3,INH4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe4,INe3,INH4)*(-3*MassHpm(ICH3)**2+2*(MNeu2(INe3)+
     &  MNeu2(INe4))))+CFF11S1L(INe3,INe4,INH3)*(2*
     &  CFF11S1L(INe4,INe3,INH4)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe4,INe3,INH4)*(-3*MassHpm(ICH3)**2+2*(MNeu2(INe3)+
     &  MNeu2(INe4)))))))/(64.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
          if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-(FD111THpB(8,ICH3)*Mah(INH3)**2)+
     &  FD111THpB(8,ICH4)*Mah(INH3)**2-FD111THB(6,INH3)*MassHpm(ICH3)**
     &  2+FD111THB(8,INH3)*MassHpm(ICH3)**2-FD111THpB(8,ICH4)*
     &  MassHpm(ICH3)**2+FD111THpB(6,ICH4)*(-Mah(INH3)**2+MassHpm(ICH3)
     &  **2)+FD111THB(6,INH3)*MassHpm(ICH4)**2-FD111THB(8,INH3)*
     &  MassHpm(ICH4)**2+FD111THpB(8,ICH3)*MassHpm(ICH4)**2+
     &  FD111THpB(6,ICH3)*(Mah(INH3)**2-MassHpm(ICH4)**2)))/(2.*
     &  (Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(Mah(INH3)-
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))+(3*
     &  CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(M12*(4*a0t1+3*M12+8*A0TNH(INH3))*
     &  Mah2(INH3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)+2*(M12-2*
     &  A0TNH(INH3))*Mah2(INH3)**2*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)-
     &  3*Mah2(INH3)**3*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)+
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2*(-8*M12*A0THpN(ICH4)+2*M12*
     &  MassHpm(ICH3)**2-3*MassHpm(ICH3)**4+A0THpN(ICH3)*(8*M12-4*
     &  MassHpm(ICH3)**2)-2*M12*MassHpm(ICH4)**2+4*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2+3*MassHpm(ICH4)**4)+Mah2(INH3)*(-(M12*(4*a0t1+
     &  3*M12+8*A0THpN(ICH3))*MassHpm(ICH3)**2)-2*(M12-2*A0THpN(ICH3))*
     &  MassHpm(ICH3)**4+3*MassHpm(ICH3)**6+MassHpm(ICH4)**2*(4*a0t1*
     &  M12+3*M12**2+8*M12*A0THpN(ICH4)+2*M12*MassHpm(ICH4)**2-4*
     &  A0THpN(ICH4)*MassHpm(ICH4)**2-3*MassHpm(ICH4)**4))))/(32.*
     &  (Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(Mah(INH3)-
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4))))
              else
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((-3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(FD111THB(6,INH3)-FD111THB(8,INH3)-
     &  FD111THpB(6,ICH3)+FD111THpB(8,ICH3)+FD211HpTB(5,ICH3)*Mah(INH3)
     &  **2-FD211HpTB(6,ICH3)*Mah(INH3)**2-FD211HpTB(5,ICH3)*
     &  MassHpm(ICH3)**2+FD211HpTB(6,ICH3)*MassHpm(ICH3)**2))/(2.*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(3*CS1S3V3(INH3,ICH4)*
     &  CTBS3(ICH3)*CTBS3C(ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*(M12*(4*
     &  a0t1+3*M12+8*A0TNH(INH3))*Mah2(INH3)+2*(M12-2*A0TNH(INH3))*
     &  Mah2(INH3)**2-3*Mah2(INH3)**3+8*M12*A0THpN(ICH3)*MassHpm(ICH3)*
     &  *2-6*M12*MassHpm(ICH3)**4-8*A0THpN(ICH3)*MassHpm(ICH3)**4-2*
     &  MassHpm(ICH3)**6+Mah2(INH3)*(-4*a0t1*M12-3*M12**2-16*M12*
     &  A0THpN(ICH3)+4*M12*MassHpm(ICH3)**2+12*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2+5*MassHpm(ICH3)**4)))/(32.*(Mah2(INH3)-
     &  MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(Mah(INH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(FD111THpB(6,ICH3)-FD111THpB(6,ICH4)
     &  -FD111THpB(8,ICH3)+FD111THpB(8,ICH4)+FD211HpTB(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpTB(6,ICH3)*MassHpm(ICH3)**2-
     &  FD211HpTB(5,ICH3)*MassHpm(ICH4)**2+FD211HpTB(6,ICH3)*
     &  MassHpm(ICH4)**2))/(2.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+
     &  (3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-2*MassHpm(ICH3)**6+8*M12*
     &  A0THpN(ICH4)*MassHpm(ICH4)**2+4*M12*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+2*M12*MassHpm(ICH4)**4-4*A0THpN(ICH4)*
     &  MassHpm(ICH4)**4-3*MassHpm(ICH4)**6+MassHpm(ICH3)**4*(-6*M12+5*
     &  MassHpm(ICH4)**2)+4*A0THpN(ICH3)*(-2*MassHpm(ICH3)**4-4*M12*
     &  MassHpm(ICH4)**2+MassHpm(ICH3)**2*(2*M12+3*MassHpm(ICH4)**2))))
     &  /(32.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((-3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(FD111THpB(6,ICH3)-FD111THpB(6,ICH4)
     &  -FD111THpB(8,ICH3)+FD111THpB(8,ICH4)+FD211HpTB(5,ICH4)*
     &  MassHpm(ICH3)**2-FD211HpTB(6,ICH4)*MassHpm(ICH3)**2-
     &  FD211HpTB(5,ICH4)*MassHpm(ICH4)**2+FD211HpTB(6,ICH4)*
     &  MassHpm(ICH4)**2))/(2.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+
     &  (3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(2*M12*MassHpm(ICH3)**4-3*
     &  MassHpm(ICH3)**6+A0THpN(ICH3)*(8*M12*MassHpm(ICH3)**2-4*
     &  MassHpm(ICH3)**4)+4*M12*MassHpm(ICH3)**2*MassHpm(ICH4)**2-6*
     &  M12*MassHpm(ICH4)**4+5*MassHpm(ICH3)**2*MassHpm(ICH4)**4-2*
     &  MassHpm(ICH4)**6-4*A0THpN(ICH4)*(-2*M12*MassHpm(ICH4)**2+2*
     &  MassHpm(ICH4)**4+MassHpm(ICH3)**2*(4*M12-3*MassHpm(ICH4)**2))))
     &  /(32.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(FD311HpTB(4,ICH3)-FD311HpTB(6,ICH3)
     &  ))/2.+(3*CS1S3V3(INH3,ICH4)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-10*M12*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(2*M12-3*MassHpm(ICH3)**2)))
     &  /(32.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INe3=1,3
       do INH3=1,6
          if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  (FD111ChiHpCha(8,INe3,ICH3)*Mah(INH3)**2)+
     &  FD111ChiHpCha(8,INe3,ICH4)*Mah(INH3)**2-
     &  FD111ChiHCha(6,INe3,INH3)*MassHpm(ICH3)**2+
     &  FD111ChiHCha(8,INe3,INH3)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH3)**2+
     &  FD111ChiHpCha(6,INe3,ICH4)*(-Mah(INH3)**2+MassHpm(ICH3)**2)+
     &  FD111ChiHCha(6,INe3,INH3)*MassHpm(ICH4)**2-
     &  FD111ChiHCha(8,INe3,INH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(6,INe3,ICH3)*(Mah(INH3)**2-MassHpm(ICH4)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH4)*
     &  (-Mah(INH3)**2+MassHpm(ICH3)**2)+FD111ChiHpCha(3,INe3,ICH3)*
     &  (Mah(INH3)**2-MassHpm(ICH4)**2)+FD111ChiHCha(3,INe3,INH3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  (FD111ChiHpCha(8,INe3,ICH3)*Mah(INH3)**2)+
     &  FD111ChiHpCha(8,INe3,ICH4)*Mah(INH3)**2-
     &  FD111ChiHCha(6,INe3,INH3)*MassHpm(ICH3)**2+
     &  FD111ChiHCha(8,INe3,INH3)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH3)**2+
     &  FD111ChiHpCha(6,INe3,ICH4)*(-Mah(INH3)**2+MassHpm(ICH3)**2)+
     &  FD111ChiHCha(6,INe3,INH3)*MassHpm(ICH4)**2-
     &  FD111ChiHCha(8,INe3,INH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(6,INe3,ICH3)*(Mah(INH3)**2-MassHpm(ICH4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH4)*
     &  (-Mah(INH3)**2+MassHpm(ICH3)**2)+FD111ChiHpCha(3,INe3,ICH3)*
     &  (Mah(INH3)**2-MassHpm(ICH4)**2)+FD111ChiHCha(3,INe3,INH3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))))/(2.*
     &  (Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(Mah(INH3)-
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))+
     &  (CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*((-2*MCha*
     &  (CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)
     &  *(3*MassHpm(ICH3)**4+4*A0TNeu(INe3)*(MCha2+MassHpm(ICH3)**2)+2*
     &  (2*a0tcha+MCha2)*MNeu2(INe3)+MassHpm(ICH3)**2*(4*a0tcha+3*
     &  MCha2+4*A0THpN(ICH3)+3*MNeu2(INe3))))/((Mah(INH3)-MassHpm(ICH3)
     &  )*(Mah(INH3)+MassHpm(ICH3))*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4)))-(2*MCha*(CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)*(3*MassHpm(ICH4)**4+
     &  4*A0TNeu(INe3)*(MCha2+MassHpm(ICH4)**2)+2*(2*a0tcha+MCha2)*
     &  MNeu2(INe3)+MassHpm(ICH4)**2*(4*a0tcha+3*MCha2+4*A0THpN(ICH4)+
     &  3*MNeu2(INe3))))/((Mah(INH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4))*(-MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4)))+(2*(CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*(4*a0tcha*MNeu(INe3)**4+2*MCha2*
     &  MNeu(INe3)**4+4*MCha2*A0TNeu(INe3)*MNeu2(INe3)+4*A0TNH(INH3)*
     &  Mah2(INH3)*(MCha2+MNeu2(INe3))+Mah2(INH3)**2*(4*a0tcha+2*MCha2+
     &  3*MNeu2(INe3))+Mah2(INH3)*MNeu2(INe3)*(4*a0tcha+3*MCha2+4*
     &  A0TNeu(INe3)+3*MNeu2(INe3))))/((Mah(INH3)-MassHpm(ICH3))*
     &  (Mah(INH3)+MassHpm(ICH3))*(Mah(INH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4)))-(2*(CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*(4*a0tcha*MNeu(INe3)**4+2*MCha2*
     &  MNeu(INe3)**4+4*MCha2*A0TNeu(INe3)*MNeu2(INe3)+4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**4*(4*
     &  a0tcha+2*MCha2+3*MNeu2(INe3))+MassHpm(ICH3)**2*MNeu2(INe3)*(4*
     &  a0tcha+3*MCha2+4*A0TNeu(INe3)+3*MNeu2(INe3))))/((Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(MassHpm(ICH3)-
     &  MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))-(2*
     &  (CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3)))*(4*a0tcha*
     &  MNeu(INe3)**4+2*MCha2*MNeu(INe3)**4+4*MCha2*A0TNeu(INe3)*
     &  MNeu2(INe3)+4*A0THpN(ICH4)*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))
     &  +MassHpm(ICH4)**4*(4*a0tcha+2*MCha2+3*MNeu2(INe3))+
     &  MassHpm(ICH4)**2*MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0TNeu(INe3)+
     &  3*MNeu2(INe3))))/((Mah(INH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4))*(-MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4)))+(2*MCha*(CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)*(3*Mah2(INH3)**2+4*
     &  A0TNeu(INe3)*(MCha2+Mah2(INH3))+2*(2*a0tcha+MCha2)*MNeu2(INe3)+
     &  Mah2(INH3)*(4*a0tcha+3*MCha2+4*A0TNH(INH3)+3*MNeu2(INe3))))
     &  /((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*
     &  (Mah(INH3)-MassHpm(ICH4))*(Mah(INH3)+MassHpm(ICH4)))-
     &  ((CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3)))*(3*
     &  Mah2(INH3)**3+4*(2*a0tcha+MCha2)*MNeu(INe3)**4+8*MCha2*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*Mah2(INH3)**2*(4*a0tcha+MCha2+2*
     &  A0TNH(INH3)+2*MNeu2(INe3))+Mah2(INH3)*(-(MCha2*(4*a0tcha+3*
     &  MCha2))+MNeu(INe3)**4+2*(4*a0tcha+MCha2+2*A0TNeu(INe3))*
     &  MNeu2(INe3)+2*MNeu2(INe3)**2)))/((Mah(INH3)-MassHpm(ICH3))*
     &  (Mah(INH3)+MassHpm(ICH3))*(Mah(INH3)-MassHpm(ICH4))*(Mah(INH3)+
     &  MassHpm(ICH4)))+((CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*(3*MassHpm(ICH3)**6+4*(2*a0tcha+
     &  MCha2)*MNeu(INe3)**4+8*MCha2*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MassHpm(ICH3)**4*(4*a0tcha+MCha2+2*A0THpN(ICH3)+2*MNeu2(INe3))+
     &  MassHpm(ICH3)**2*(-(MCha2*(4*a0tcha+3*MCha2))+MNeu(INe3)**4+2*
     &  (4*a0tcha+MCha2+2*A0TNeu(INe3))*MNeu2(INe3)+2*MNeu2(INe3)**2)))
     &  /((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*
     &  (MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))+
     &  ((CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3)))*(3*
     &  MassHpm(ICH4)**6+4*(2*a0tcha+MCha2)*MNeu(INe3)**4+8*MCha2*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MassHpm(ICH4)**4*(4*a0tcha+MCha2+2*
     &  A0THpN(ICH4)+2*MNeu2(INe3))+MassHpm(ICH4)**2*(-(MCha2*(4*
     &  a0tcha+3*MCha2))+MNeu(INe3)**4+2*(4*a0tcha+MCha2+2*A0TNeu(INe3)
     &  )*MNeu2(INe3)+2*MNeu2(INe3)**2)))/((Mah(INH3)-MassHpm(ICH4))*
     &  (Mah(INH3)+MassHpm(ICH4))*(-MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))))/32.)
              else
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD111ChiHCha(6,INe3,INH3)+FD111ChiHCha(8,INe3,INH3)+
     &  FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(8,INe3,ICH3)-
     &  FD211HpChiCha(5,ICH3,INe3)*Mah(INH3)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*Mah(INH3)**2+
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChiHCha(3,INe3,INH3)+
     &  FD111ChiHpCha(3,INe3,ICH3)+FD211HpChiCha(4,ICH3,INe3)*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD111ChiHCha(6,INe3,INH3)+FD111ChiHCha(8,INe3,INH3)+
     &  FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(8,INe3,ICH3)-
     &  FD211HpChiCha(5,ICH3,INe3)*Mah(INH3)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*Mah(INH3)**2+
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-FD111ChiHCha(3,INe3,INH3)+
     &  FD111ChiHpCha(3,INe3,ICH3)+FD211HpChiCha(4,ICH3,INe3)*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2))*MNeu(INe3))))/(2.*(Mah(INH3)**
     &  2-MassHpm(ICH3)**2)**2)+(CS1S3V3(INH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(CF11F12S3L(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*(3*Mah2(INH3)**2+4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2-MassHpm(ICH3)**4+Mah2(INH3)*(4*
     &  a0tcha+3*MCha2+4*A0TNeu(INe3)+4*A0TNH(INH3)+3*MNeu2(INe3))-
     &  Mah2(INH3)*(4*a0tcha+3*MCha2+8*A0THpN(ICH3)+4*A0TNeu(INe3)+2*
     &  MassHpm(ICH3)**2+3*MNeu2(INe3)))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (-3*Mah2(INH3)**3+2*Mah2(INH3)**2*(MCha2-2*A0TNH(INH3)+
     &  MNeu2(INe3))+Mah2(INH3)*(4*a0tcha*MCha2+3*MCha2**2-MNeu(INe3)**
     &  4+4*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+4*MNeu2(INe3)*
     &  *2+8*A0TNH(INH3)*(MCha2+MNeu2(INe3)))-2*MassHpm(ICH3)**2*
     &  (MassHpm(ICH3)**4+MNeu(INe3)**4-MNeu2(INe3)**2+3*MassHpm(ICH3)*
     &  *2*(MCha2+MNeu2(INe3))-4*A0THpN(ICH3)*(MCha2-MassHpm(ICH3)**2+
     &  MNeu2(INe3)))-Mah2(INH3)*(4*a0tcha*MCha2+3*MCha2**2-5*
     &  MassHpm(ICH3)**4-3*MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+6*MNeu2(INe3)**2-4*MassHpm(ICH3)**2*
     &  (MCha2+MNeu2(INe3))+4*A0THpN(ICH3)*(-3*MassHpm(ICH3)**2+4*
     &  (MCha2+MNeu2(INe3))))))+CF11F12S3R(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*(3*Mah2(INH3)**2+4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2-MassHpm(ICH3)**4+Mah2(INH3)*(4*
     &  a0tcha+3*MCha2+4*A0TNeu(INe3)+4*A0TNH(INH3)+3*MNeu2(INe3))-
     &  Mah2(INH3)*(4*a0tcha+3*MCha2+8*A0THpN(ICH3)+4*A0TNeu(INe3)+2*
     &  MassHpm(ICH3)**2+3*MNeu2(INe3)))+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-3*Mah2(INH3)**3+2*Mah2(INH3)**2*(MCha2-2*A0TNH(INH3)+
     &  MNeu2(INe3))+Mah2(INH3)*(4*a0tcha*MCha2+3*MCha2**2-MNeu(INe3)**
     &  4+4*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+4*MNeu2(INe3)*
     &  *2+8*A0TNH(INH3)*(MCha2+MNeu2(INe3)))-2*MassHpm(ICH3)**2*
     &  (MassHpm(ICH3)**4+MNeu(INe3)**4-MNeu2(INe3)**2+3*MassHpm(ICH3)*
     &  *2*(MCha2+MNeu2(INe3))-4*A0THpN(ICH3)*(MCha2-MassHpm(ICH3)**2+
     &  MNeu2(INe3)))-Mah2(INH3)*(4*a0tcha*MCha2+3*MCha2**2-5*
     &  MassHpm(ICH3)**4-3*MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+6*MNeu2(INe3)**2-4*MassHpm(ICH3)**2*
     &  (MCha2+MNeu2(INe3))+4*A0THpN(ICH3)*(-3*MassHpm(ICH3)**2+4*
     &  (MCha2+MNeu2(INe3))))))))/(32.*(Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(Mah(INH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH4)-
     &  FD111ChiHpCha(8,INe3,ICH3)+FD111ChiHpCha(8,INe3,ICH4)+
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH4)-
     &  FD111ChiHpCha(8,INe3,ICH3)+FD111ChiHpCha(8,INe3,ICH4)+
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))))/(2.*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+(CS1S3V3(INH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0THpN(ICH3)*
     &  (CF11F12S3L(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH4)
     &  *(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(MassHpm(ICH3)**2-2*
     &  MassHpm(ICH4)**2)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-2*
     &  MassHpm(ICH3)**4-4*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+
     &  MassHpm(ICH3)**2*(3*MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3))))))+
     &  CF11F12S3L(INe3,ICH4)*(-2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (MassHpm(ICH3)**4-4*A0THpN(ICH4)*MassHpm(ICH4)**2+2*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2-3*MassHpm(ICH4)**4)*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-2*MassHpm(ICH3)**6+
     &  MassHpm(ICH3)**4*(5*MassHpm(ICH4)**2-6*(MCha2+MNeu2(INe3)))+2*
     &  MassHpm(ICH3)**2*(-MNeu(INe3)**4+MNeu2(INe3)**2+2*MassHpm(ICH4)
     &  **2*(MCha2+MNeu2(INe3)))+MassHpm(ICH4)**2*(-3*MassHpm(ICH4)**4+
     &  2*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+2*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2)+A0THpN(ICH4)*(-4*MassHpm(ICH4)**2+8*(MCha2+
     &  MNeu2(INe3))))))+CF11F12S3R(INe3,ICH4)*(-2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(MassHpm(ICH3)**4-4*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2+2*MassHpm(ICH3)**2*MassHpm(ICH4)**2-3*
     &  MassHpm(ICH4)**4)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-2*
     &  MassHpm(ICH3)**6+MassHpm(ICH3)**4*(5*MassHpm(ICH4)**2-6*(MCha2+
     &  MNeu2(INe3)))+2*MassHpm(ICH3)**2*(-MNeu(INe3)**4+MNeu2(INe3)**
     &  2+2*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3)))+MassHpm(ICH4)**2*(-3*
     &  MassHpm(ICH4)**4+2*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+2*
     &  (MNeu(INe3)**4-MNeu2(INe3)**2)+A0THpN(ICH4)*(-4*MassHpm(ICH4)**
     &  2+8*(MCha2+MNeu2(INe3))))))))/(32.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD111ChiHpCha(6,INe3,ICH3)+FD111ChiHpCha(6,INe3,ICH4)+
     &  FD111ChiHpCha(8,INe3,ICH3)-FD111ChiHpCha(8,INe3,ICH4)-
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH4)**2-
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChiHpCha(3,INe3,ICH3)+
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH4,INe3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD111ChiHpCha(6,INe3,ICH3)+FD111ChiHpCha(6,INe3,ICH4)+
     &  FD111ChiHpCha(8,INe3,ICH3)-FD111ChiHpCha(8,INe3,ICH4)-
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH4)**2-
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-FD111ChiHpCha(3,INe3,ICH3)+
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH4,INe3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2))*MNeu(INe3))))/(2.*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+(CS1S3V3(INH3,ICH4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  (CF11F12S3L(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-MassHpm(ICH3)**2+2*
     &  (MCha2+MNeu2(INe3))))+CF11F12S3R(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3)))))-4*A0THpN(ICH4)*(CF11F12S3L(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(2*MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*(2*MassHpm(ICH4)*
     &  *2*(-MCha2+MassHpm(ICH4)**2-MNeu2(INe3))+MassHpm(ICH3)**2*(-3*
     &  MassHpm(ICH4)**2+4*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH4)
     &  *(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(2*MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*(2*
     &  MassHpm(ICH4)**2*(-MCha2+MassHpm(ICH4)**2-MNeu2(INe3))+
     &  MassHpm(ICH3)**2*(-3*MassHpm(ICH4)**2+4*(MCha2+MNeu2(INe3))))))
     &  +(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*(CF11F12S3L(INe3,ICH4)*(2*
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(3*MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-3*
     &  MassHpm(ICH3)**4+MassHpm(ICH3)**2*(-3*MassHpm(ICH4)**2+2*
     &  (MCha2+MNeu2(INe3)))+2*(MassHpm(ICH4)**4+MNeu(INe3)**4-
     &  MNeu2(INe3)**2+3*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3)))))+
     &  CF11F12S3R(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(3*
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-3*MassHpm(ICH3)**4+
     &  MassHpm(ICH3)**2*(-3*MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))+2*
     &  (MassHpm(ICH4)**4+MNeu(INe3)**4-MNeu2(INe3)**2+3*MassHpm(ICH4)*
     &  *2*(MCha2+MNeu2(INe3))))))))/(32.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD311HpChiCha(4,ICH3,INe3)-FD311HpChiCha(6,ICH3,INe3))-MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311HpChiCha(3,ICH3,INe3)*
     &  MNeu(INe3))+CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(FD311HpChiCha(4,ICH3,INe3)-FD311HpChiCha(6,ICH3,INe3))-MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311HpChiCha(3,ICH3,INe3)*
     &  MNeu(INe3))))/2.+(CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))
     &  *(MassHpm(ICH3)**2*(CF11F12S3L(INe3,ICH4)*(-6*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(MassHpm(ICH3)**2-10*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH4)*(-6*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(MassHpm(ICH3)**2-10*(MCha2+
     &  MNeu2(INe3)))))+4*A0THpN(ICH3)*(CF11F12S3L(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-3*MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-3*MassHpm(ICH3)**2+2*(MCha2+MNeu2(INe3)))))))/(32.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[7][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo7-NoGBC
c

       ! diagram  1  
        ICH3=1
        INH3=6
            do INH4=1,5
       selfW=selfW+((CS1S3V3(INH4,1)*DCONJG(CS1S3V3(6,1))*
     &  ((CFF12S1R(INH4)*(MCha2*CFF12S1R(6)*FD211HpChaCha(4,1)+
     &  CFF12S1L(6)*(-FD211HpChaCha(5,1)+FD211HpChaCha(6,1)))+
     &  CFF12S1L(INH4)*(MCha2*CFF12S1L(6)*FD211HpChaCha(4,1)+
     &  CFF12S1R(6)*(-FD211HpChaCha(5,1)+FD211HpChaCha(6,1)))+3*
     &  hy(INH4)*(M12*FD211HpTT(4,1)*hy(6)+(-FD211HpTT(5,1)+
     &  FD211HpTT(6,1))*hyc(6))+3*((-FD211HpTT(5,1)+FD211HpTT(6,1))*
     &  hy(6)+M12*FD211HpTT(4,1)*hyc(6))*hyc(INH4))*Mah(INH4)**4+
     &  (CFF12S1R(INH4)*(MCha2*CFF12S1R(6)*(-FD111ChaHCha(3,INH4)+
     &  FD111ChaHpCha(3,1))+CFF12S1L(6)*(-FD111ChaHCha(6,INH4)+
     &  FD111ChaHCha(8,INH4)+FD111ChaHpCha(6,1)-FD111ChaHpCha(8,1)))+
     &  CFF12S1L(INH4)*(MCha2*CFF12S1L(6)*(-FD111ChaHCha(3,INH4)+
     &  FD111ChaHpCha(3,1))+CFF12S1R(6)*(-FD111ChaHCha(6,INH4)+
     &  FD111ChaHCha(8,INH4)+FD111ChaHpCha(6,1)-FD111ChaHpCha(8,1)))+3*
     &  hy(INH4)*(M12*(FD111THpT(3,1)-FD111THT(3,INH4))*hy(6)+
     &  (FD111THpT(6,1)-FD111THpT(8,1)-FD111THT(6,INH4)+
     &  FD111THT(8,INH4))*hyc(6))+3*((FD111THpT(6,1)-FD111THpT(8,1)-
     &  FD111THT(6,INH4)+FD111THT(8,INH4))*hy(6)+M12*(FD111THpT(3,1)-
     &  FD111THT(3,INH4))*hyc(6))*hyc(INH4))*Mah2(INH4)))/(2.*Mah(INH4)
     &  **4*Mah2(INH4))+(CS1S3V3(INH4,1)*DCONJG(CS1S3V3(6,1))*(-16*
     &  a0tcha*MCha2*CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)-12*MCha2**2*
     &  CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)+4*MCha2*(4*a0tcha+3*
     &  MCha2)*CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)+8*MCha2*
     &  A0TNH(INH4)*CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)+24*M12*
     &  A0TNH(INH4)*hy(6)*hy(INH4)*Mah2(INH4)+48*M12*A0TNH(INH4)*
     &  hy(INH4)*hyc(6)*Mah2(INH4)+48*M12*A0TNH(INH4)*hy(6)*hyc(INH4)*
     &  Mah2(INH4)+24*M12*A0TNH(INH4)*hyc(6)*hyc(INH4)*Mah2(INH4)+6*
     &  MCha2*CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)**2+18*M12*hy(6)*
     &  hy(INH4)*Mah2(INH4)**2+12*M12*hy(INH4)*hyc(6)*Mah2(INH4)**2-12*
     &  A0TNH(INH4)*hy(INH4)*hyc(6)*Mah2(INH4)**2+12*M12*hy(6)*
     &  hyc(INH4)*Mah2(INH4)**2-12*A0TNH(INH4)*hy(6)*hyc(INH4)*
     &  Mah2(INH4)**2+18*M12*hyc(6)*hyc(INH4)*Mah2(INH4)**2-9*hy(INH4)*
     &  hyc(6)*Mah2(INH4)**3-9*hy(6)*hyc(INH4)*Mah2(INH4)**3+
     &  CFF12S1L(6)*CFF12S1R(INH4)*(-(Mah2(INH4)**2*(2*MCha2+4*
     &  A0TNH(INH4)+3*Mah2(INH4)))+2*MCha2*(-((4*a0tcha+5*MCha2)*
     &  Mah2(INH4))+(4*a0tcha+5*MCha2+8*A0TNH(INH4))*Mah2(INH4)+3*
     &  Mah2(INH4)**2))+CFF12S1L(INH4)*(2*MCha2*CFF12S1L(6)*(-2*(4*
     &  a0tcha+3*MCha2)*Mah2(INH4)+(8*a0tcha+6*MCha2+4*A0TNH(INH4))*
     &  Mah2(INH4)+3*Mah2(INH4)**2)+CFF12S1R(6)*(-(Mah2(INH4)**2*(2*
     &  MCha2+4*A0TNH(INH4)+3*Mah2(INH4)))+2*MCha2*(-((4*a0tcha+5*
     &  MCha2)*Mah2(INH4))+(4*a0tcha+5*MCha2+8*A0TNH(INH4))*Mah2(INH4)+
     &  3*Mah2(INH4)**2)))))/(32.*Mah(INH4)**4))
              enddo
        ICH3=1
        INH4=6
            do INH3=1,5
       selfW=selfW+((CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*
     &  ((CFF12S1R(INH3)*(MCha2*CFF12S1R(6)*FD211HpChaCha(4,1)+
     &  CFF12S1L(6)*(-FD211HpChaCha(5,1)+FD211HpChaCha(6,1)))+
     &  CFF12S1L(INH3)*(MCha2*CFF12S1L(6)*FD211HpChaCha(4,1)+
     &  CFF12S1R(6)*(-FD211HpChaCha(5,1)+FD211HpChaCha(6,1)))+3*
     &  hy(INH3)*(M12*FD211HpTT(4,1)*hy(6)+(-FD211HpTT(5,1)+
     &  FD211HpTT(6,1))*hyc(6))+3*((-FD211HpTT(5,1)+FD211HpTT(6,1))*
     &  hy(6)+M12*FD211HpTT(4,1)*hyc(6))*hyc(INH3))*Mah(INH3)**4+
     &  (CFF12S1R(INH3)*(MCha2*CFF12S1R(6)*(-FD111ChaHCha(3,INH3)+
     &  FD111ChaHpCha(3,1))+CFF12S1L(6)*(-FD111ChaHCha(6,INH3)+
     &  FD111ChaHCha(8,INH3)+FD111ChaHpCha(6,1)-FD111ChaHpCha(8,1)))+
     &  CFF12S1L(INH3)*(MCha2*CFF12S1L(6)*(-FD111ChaHCha(3,INH3)+
     &  FD111ChaHpCha(3,1))+CFF12S1R(6)*(-FD111ChaHCha(6,INH3)+
     &  FD111ChaHCha(8,INH3)+FD111ChaHpCha(6,1)-FD111ChaHpCha(8,1)))+3*
     &  hy(INH3)*(M12*(FD111THpT(3,1)-FD111THT(3,INH3))*hy(6)+
     &  (FD111THpT(6,1)-FD111THpT(8,1)-FD111THT(6,INH3)+
     &  FD111THT(8,INH3))*hyc(6))+3*((FD111THpT(6,1)-FD111THpT(8,1)-
     &  FD111THT(6,INH3)+FD111THT(8,INH3))*hy(6)+M12*(FD111THpT(3,1)-
     &  FD111THT(3,INH3))*hyc(6))*hyc(INH3))*Mah2(INH3)))/(2.*Mah(INH3)
     &  **4*Mah2(INH3))+(CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*(-16*
     &  a0tcha*MCha2*CFF12S1R(6)*CFF12S1R(INH3)*Mah2(INH3)-12*MCha2**2*
     &  CFF12S1R(6)*CFF12S1R(INH3)*Mah2(INH3)+4*MCha2*(4*a0tcha+3*
     &  MCha2)*CFF12S1R(6)*CFF12S1R(INH3)*Mah2(INH3)+8*MCha2*
     &  A0TNH(INH3)*CFF12S1R(6)*CFF12S1R(INH3)*Mah2(INH3)+24*M12*
     &  A0TNH(INH3)*hy(6)*hy(INH3)*Mah2(INH3)+48*M12*A0TNH(INH3)*
     &  hy(INH3)*hyc(6)*Mah2(INH3)+48*M12*A0TNH(INH3)*hy(6)*hyc(INH3)*
     &  Mah2(INH3)+24*M12*A0TNH(INH3)*hyc(6)*hyc(INH3)*Mah2(INH3)+6*
     &  MCha2*CFF12S1R(6)*CFF12S1R(INH3)*Mah2(INH3)**2+18*M12*hy(6)*
     &  hy(INH3)*Mah2(INH3)**2+12*M12*hy(INH3)*hyc(6)*Mah2(INH3)**2-12*
     &  A0TNH(INH3)*hy(INH3)*hyc(6)*Mah2(INH3)**2+12*M12*hy(6)*
     &  hyc(INH3)*Mah2(INH3)**2-12*A0TNH(INH3)*hy(6)*hyc(INH3)*
     &  Mah2(INH3)**2+18*M12*hyc(6)*hyc(INH3)*Mah2(INH3)**2-9*hy(INH3)*
     &  hyc(6)*Mah2(INH3)**3-9*hy(6)*hyc(INH3)*Mah2(INH3)**3+
     &  CFF12S1L(INH3)*CFF12S1R(6)*(-(Mah2(INH3)**2*(2*MCha2+4*
     &  A0TNH(INH3)+3*Mah2(INH3)))+2*MCha2*(-((4*a0tcha+5*MCha2)*
     &  Mah2(INH3))+(4*a0tcha+5*MCha2+8*A0TNH(INH3))*Mah2(INH3)+3*
     &  Mah2(INH3)**2))+CFF12S1L(6)*(2*MCha2*CFF12S1L(INH3)*(-2*(4*
     &  a0tcha+3*MCha2)*Mah2(INH3)+(8*a0tcha+6*MCha2+4*A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2)+CFF12S1R(INH3)*(-(Mah2(INH3)**2*(2*
     &  MCha2+4*A0TNH(INH3)+3*Mah2(INH3)))+2*MCha2*(-((4*a0tcha+5*
     &  MCha2)*Mah2(INH3))+(4*a0tcha+5*MCha2+8*A0TNH(INH3))*Mah2(INH3)+
     &  3*Mah2(INH3)**2)))))/(32.*Mah(INH3)**4))
              enddo
        INH4=6
        INH3=6
            ICH3=2
       selfW=selfW+((CS1S3V3(6,ICH3)*DCONJG(CS1S3V3(6,ICH3))*(MCha2*
     &  (CFF12S1L(6)**2+CFF12S1R(6)**2)*FD111ChaHCha(3,6)+2*CFF12S1L(6)
     &  *CFF12S1R(6)*(FD111ChaHCha(6,6)-FD111ChaHCha(8,6))-MCha2*
     &  (CFF12S1L(6)**2+CFF12S1R(6)**2)*FD111ChaHpCha(3,ICH3)+2*
     &  CFF12S1L(6)*CFF12S1R(6)*(-FD111ChaHpCha(6,ICH3)+
     &  FD111ChaHpCha(8,ICH3))+3*M12*(-FD111THpT(3,ICH3)+FD111THT(3,6))
     &  *hy(6)**2+6*(-FD111THpT(6,ICH3)+FD111THpT(8,ICH3)+FD111THT(6,6)
     &  -FD111THT(8,6))*hy(6)*hyc(6)+3*M12*(-FD111THpT(3,ICH3)+
     &  FD111THT(3,6))*hyc(6)**2+(MCha2*(CFF12S1L(6)**2+CFF12S1R(6)**2)
     &  *FD211HChaCha(4,6)+2*CFF12S1L(6)*CFF12S1R(6)*(-
     &  FD211HChaCha(5,6)+FD211HChaCha(6,6))+6*(-FD211HTT(5,6)+
     &  FD211HTT(6,6))*hy(6)*hyc(6)+3*M12*FD211HTT(4,6)*(hy(6)**2+
     &  hyc(6)**2))*MassHpm(ICH3)**2))/(2.*MassHpm(ICH3)**4)+
     &  (CS1S3V3(6,ICH3)*DCONJG(CS1S3V3(6,ICH3))*(8*A0THpN(ICH3)*(2*
     &  MCha2*CFF12S1L(6)*CFF12S1R(6)+MCha2*CFF12S1R(6)**2+3*M12*hy(6)*
     &  *2+12*M12*hy(6)*hyc(6)+3*M12*hyc(6)**2)*MassHpm(ICH3)**2+2*(2*
     &  (MCha2-A0THpN(ICH3))*CFF12S1L(6)*CFF12S1R(6)+3*MCha2*
     &  CFF12S1R(6)**2+6*(M12-A0THpN(ICH3))*hy(6)*hyc(6)+9*M12*hyc(6)**
     &  2+hy(6)*(9*M12*hy(6)+6*(M12-A0THpN(ICH3))*hyc(6)))*
     &  MassHpm(ICH3)**4-3*(CFF12S1L(6)*CFF12S1R(6)+6*hy(6)*hyc(6))*
     &  MassHpm(ICH3)**6+CFF12S1L(6)*(2*MCha2*CFF12S1L(6)*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)+CFF12S1R(6)*
     &  (16*MCha2*A0THpN(ICH3)*MassHpm(ICH3)**2+4*(MCha2-A0THpN(ICH3))*
     &  MassHpm(ICH3)**4-3*MassHpm(ICH3)**6))))/(32.*MassHpm(ICH3)**4))
     &  
        ICH3=1
       selfW=selfW+((CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1))*(2*(1-4*logx)*
     &  MCha2*CFF12S1L(6)*CFF12S1R(6)+3*MCha2*CFF12S1R(6)**2-4*logx*
     &  MCha2*CFF12S1R(6)**2+CFF12S1L(6)*((3-4*logx)*MCha2*CFF12S1L(6)+
     &  2*(1-4*logx)*MCha2*CFF12S1R(6))+9*M12*hy(6)**2-12*logx*M12*
     &  hy(6)**2+6*M12*hy(6)*hyc(6)-24*logx*M12*hy(6)*hyc(6)+3*hyc(6)*
     &  (2*(1-4*logx)*M12*hy(6)+(3-4*logx)*M12*hyc(6))))/16.-
     &  (CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1))*(MCha2*(CFF12S1L(6)**2+
     &  CFF12S1R(6)**2)*FD311HpChaCha(3,1)+2*CFF12S1L(6)*CFF12S1R(6)*(-
     &  FD311HpChaCha(4,1)+FD311HpChaCha(6,1))+6*(-FD311HpTT(4,1)+
     &  FD311HpTT(6,1))*hy(6)*hyc(6)+3*M12*FD311HpTT(3,1)*(hy(6)**2+
     &  hyc(6)**2)))/2.)

       ! diagram  2  
       do INe3=1,3
       do INe4=1,3
        ICH3=1
        INH3=6
            do INH4=1,5
       selfW=selfW+((CS1S3V3(INH4,1)*DCONJG(CS1S3V3(6,1))*(-
     &  ((CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH4))*
     &  ((FD211HpChiChi(5,1,INe3,INe4)-FD211HpChiChi(6,1,INe3,INe4))*
     &  Mah(INH4)**4+(FD111ChiHChi(6,INe3,INH4,INe4)-
     &  FD111ChiHChi(8,INe3,INH4,INe4)-FD111ChiHpChi(6,INe3,1,INe4)+
     &  FD111ChiHpChi(8,INe3,1,INe4))*Mah2(INH4)))+
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH4))*
     &  (FD211HpChiChi(4,1,INe3,INe4)*Mah(INH4)**4+(-
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD111ChiHpChi(3,INe3,1,INe4))*
     &  Mah2(INH4))*MNeu(INe3)*MNeu(INe4)))/(4.*Mah(INH4)**4*Mah2(INH4)
     &  )+(CS1S3V3(INH4,1)*DCONJG(CS1S3V3(6,1))*(-4*
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*
     &  MNeu(INe4)*(2*A0TNeu(INe4)*MNeu2(INe3)+(2*A0TNeu(INe3)+
     &  MNeu2(INe3))*MNeu2(INe4))+(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH4))*Mah2(INH4)*(MNeu2(INe3)*(4*
     &  A0TNeu(INe3)+8*A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))+(-4*
     &  A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))*MNeu2(INe4)-2*
     &  MNeu2(INe4)**2)+2*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,INH4)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe4)
     &  *(Mah2(INH4)+MNeu2(INe3))+Mah2(INH4)*(4*A0TNH(INH4)+3*
     &  (Mah2(INH4)+MNeu2(INe3)))+(3*Mah2(INH4)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH4)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH4))*Mah2(INH4)*
     &  MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*
     &  (MNeu2(INe3)+MNeu2(INe4)))-2*(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH4))*Mah2(INH4)*MNeu2(INe3)*(4*
     &  A0TNeu(INe3)+4*A0TNeu(INe4)+3*(MNeu2(INe3)+MNeu2(INe4)))+
     &  (CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH4))*(-(Mah2(INH4)*
     &  (4*A0TNH(INH4)*Mah2(INH4)+3*(Mah2(INH4)+MNeu2(INe3))**2))+2*
     &  Mah2(INH4)**2*(MNeu2(INe3)-MNeu2(INe4))-2*MNeu2(INe3)*
     &  (Mah2(INH4)+2*MNeu2(INe3))*MNeu2(INe4)+3*Mah2(INH4)*MNeu2(INe4)
     &  **2-4*A0TNeu(INe4)*(2*Mah2(INH4)**2+2*Mah2(INH4)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2-Mah2(INH4)*MNeu2(INe4))+4*A0TNeu(INe3)*
     &  (Mah2(INH4)**2-Mah2(INH4)*(Mah2(INH4)+MNeu2(INe3))-2*
     &  MNeu2(INe3)*MNeu2(INe4)))+2*(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH4))*(4*A0TNeu(INe3)*Mah2(INH4)*
     &  MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH4)**2+MNeu(INe3)**4+
     &  Mah2(INH4)*MNeu2(INe3))+2*(Mah2(INH4)**2+MNeu(INe3)**4)*
     &  MNeu2(INe4)+4*A0TNH(INH4)*Mah2(INH4)*(MNeu2(INe3)+MNeu2(INe4))+
     &  MNeu2(INe3)*(4*A0TNeu(INe3)*MNeu2(INe4)+3*Mah2(INH4)*(Mah2(INH4)+MNeu2(INe3)+MNeu2(INe4))))))/(64.*Mah(INH4)**4))
              enddo
        ICH3=1
        INH4=6
            do INH3=1,5
       selfW=selfW+((CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*(-
     &  ((CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,6))*
     &  ((FD211HpChiChi(5,1,INe3,INe4)-FD211HpChiChi(6,1,INe3,INe4))*
     &  Mah(INH3)**4+(FD111ChiHChi(6,INe3,INH3,INe4)-
     &  FD111ChiHChi(8,INe3,INH3,INe4)-FD111ChiHpChi(6,INe3,1,INe4)+
     &  FD111ChiHpChi(8,INe3,1,INe4))*Mah2(INH3)))+
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,6))*
     &  (FD211HpChiChi(4,1,INe3,INe4)*Mah(INH3)**4+(-
     &  FD111ChiHChi(3,INe3,INH3,INe4)+FD111ChiHpChi(3,INe3,1,INe4))*
     &  Mah2(INH3))*MNeu(INe3)*MNeu(INe4)))/(4.*Mah(INH3)**4*Mah2(INH3)
     &  )+(CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*(-4*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,6))*MNeu(INe3)*
     &  MNeu(INe4)*(2*A0TNeu(INe4)*MNeu2(INe3)+(2*A0TNeu(INe3)+
     &  MNeu2(INe3))*MNeu2(INe4))+(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,6))*Mah2(INH3)*(MNeu2(INe3)*(4*A0TNeu(INe3)+
     &  8*A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))+(-4*A0TNeu(INe4)+3*
     &  MNeu2(INe3)-MNeu2(INe4))*MNeu2(INe4)-2*MNeu2(INe4)**2)+2*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,6))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+Mah2(INH3)*
     &  (4*A0TNH(INH3)+3*(Mah2(INH3)+MNeu2(INe3)))+(3*Mah2(INH3)+2*
     &  MNeu2(INe3))*MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH3)+MNeu2(INe4)
     &  ))-2*(CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,6))*Mah2(INH3)*
     &  MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*
     &  (MNeu2(INe3)+MNeu2(INe4)))-2*(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,6))*Mah2(INH3)*MNeu2(INe3)*(4*A0TNeu(INe3)+
     &  4*A0TNeu(INe4)+3*(MNeu2(INe3)+MNeu2(INe4)))+
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,6))*(-(Mah2(INH3)*
     &  (4*A0TNH(INH3)*Mah2(INH3)+3*(Mah2(INH3)+MNeu2(INe3))**2))+2*
     &  Mah2(INH3)**2*(MNeu2(INe3)-MNeu2(INe4))-2*MNeu2(INe3)*
     &  (Mah2(INH3)+2*MNeu2(INe3))*MNeu2(INe4)+3*Mah2(INH3)*MNeu2(INe4)
     &  **2-4*A0TNeu(INe4)*(2*Mah2(INH3)**2+2*Mah2(INH3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2-Mah2(INH3)*MNeu2(INe4))+4*A0TNeu(INe3)*
     &  (Mah2(INH3)**2-Mah2(INH3)*(Mah2(INH3)+MNeu2(INe3))-2*
     &  MNeu2(INe3)*MNeu2(INe4)))+2*(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,6))*(4*A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+
     &  4*A0TNeu(INe4)*(Mah2(INH3)**2+MNeu(INe3)**4+Mah2(INH3)*
     &  MNeu2(INe3))+2*(Mah2(INH3)**2+MNeu(INe3)**4)*MNeu2(INe4)+4*
     &  A0TNH(INH3)*Mah2(INH3)*(MNeu2(INe3)+MNeu2(INe4))+MNeu2(INe3)*
     &  (4*A0TNeu(INe3)*MNeu2(INe4)+3*Mah2(INH3)*(Mah2(INH3)+
     &  MNeu2(INe3)+MNeu2(INe4))))))/(64.*Mah(INH3)**4))
              enddo
        INH4=6
        INH3=6
            ICH3=2
       selfW=selfW+((CS1S3V3(6,ICH3)*DCONJG(CS1S3V3(6,ICH3))*
     &  ((CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*
     &  (FD111ChiHChi(6,INe3,6,INe4)-FD111ChiHChi(8,INe3,6,INe4)-
     &  FD111ChiHpChi(6,INe3,ICH3,INe4)+FD111ChiHpChi(8,INe3,ICH3,INe4)
     &  +(-FD211HNeuNeu(5,6,INe3,INe4)+FD211HNeuNeu(6,6,INe3,INe4))*
     &  MassHpm(ICH3)**2)+(CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*
     &  (FD111ChiHChi(3,INe3,6,INe4)-FD111ChiHpChi(3,INe3,ICH3,INe4)+
     &  FD211HNeuNeu(4,6,INe3,INe4)*MassHpm(ICH3)**2)*MNeu(INe3)*
     &  MNeu(INe4)))/(4.*MassHpm(ICH3)**4)+(CS1S3V3(6,ICH3)*
     &  DCONJG(CS1S3V3(6,ICH3))*(-4*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*MNeu(INe3)*MNeu(INe4)*(2*A0TNeu(INe4)*
     &  MNeu2(INe3)+(2*A0TNeu(INe3)+MNeu2(INe3))*MNeu2(INe4))+2*
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*(4*A0TNeu(INe4)*
     &  (MassHpm(ICH3)**4+MNeu(INe3)**4+MassHpm(ICH3)**2*MNeu2(INe3))+
     &  MassHpm(ICH3)**2*MNeu2(INe3)*(4*A0THpN(ICH3)+4*A0TNeu(INe3)+3*
     &  (MassHpm(ICH3)**2+MNeu2(INe3)))+(4*A0THpN(ICH3)*MassHpm(ICH3)**
     &  2+2*(MassHpm(ICH3)**4+MNeu(INe3)**4)+(4*A0TNeu(INe3)+3*
     &  MassHpm(ICH3)**2)*MNeu2(INe3))*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*MassHpm(ICH3)**2*
     &  (MNeu2(INe3)*(4*A0TNeu(INe3)+8*A0TNeu(INe4)+3*MNeu2(INe3)-
     &  MNeu2(INe4))+(-4*A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))*
     &  MNeu2(INe4)-2*MNeu2(INe4)**2)-(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*(4*A0THpN(ICH3)*MassHpm(ICH3)**4+8*
     &  A0TNeu(INe4)*(MassHpm(ICH3)**4+MassHpm(ICH3)**2*MNeu2(INe3)+
     &  MNeu2(INe3)**2)+MassHpm(ICH3)**2*(3*MassHpm(ICH3)**4+4*
     &  (A0TNeu(INe3)+MassHpm(ICH3)**2)*MNeu2(INe3)+3*MNeu2(INe3)**2)-
     &  4*A0TNeu(INe4)*MassHpm(ICH3)**2*MNeu2(INe4)+2*(MassHpm(ICH3)**
     &  4+(4*A0TNeu(INe3)+MassHpm(ICH3)**2)*MNeu2(INe3)+2*MNeu2(INe3)**
     &  2)*MNeu2(INe4)-3*MassHpm(ICH3)**2*MNeu2(INe4)**2)+2*
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+(4*A0TNeu(INe4)+3*
     &  MassHpm(ICH3)**2)*(MassHpm(ICH3)**2+MNeu2(INe3))+(3*
     &  MassHpm(ICH3)**2+2*MNeu2(INe3))*MNeu2(INe4)+4*A0TNeu(INe3)*
     &  (MassHpm(ICH3)**2+MNeu2(INe4)))-2*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*
     &  (4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*(MNeu2(INe3)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*MassHpm(ICH3)**2*
     &  MNeu2(INe3)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*(MNeu2(INe3)+
     &  MNeu2(INe4)))))/(64.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+((CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1))*
     &  ((CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*
     &  (FD311HpChiChi(4,1,INe3,INe4)-FD311HpChiChi(6,1,INe3,INe4))-
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*
     &  FD311HpChiChi(3,1,INe3,INe4)*MNeu(INe3)*MNeu(INe4)))/4.-
     &  (CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1))*(CFF11S1R(INe3,INe4,6)*((-3+
     &  4*logx)*CFF11S1R(INe4,INe3,6)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe4,INe3,6)*(-2*MNeu2(INe3)+(1-2*logx)*MNeu2(INe3)-
     &  MNeu2(INe4)+2*logx*(3*MNeu2(INe3)+2*MNeu2(INe4))))+
     &  CFF11S1L(INe3,INe4,6)*((-3+4*logx)*CFF11S1L(INe4,INe3,6)*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1R(INe4,INe3,6)*(-2*MNeu2(INe3)+(1-
     &  2*logx)*MNeu2(INe3)-MNeu2(INe4)+2*logx*(3*MNeu2(INe3)+2*
     &  MNeu2(INe4))))))/32.)
       enddo 
       enddo 

       ! diagram  3  
        ICH3=1
        ICH4=1
            do INH3=1,5
       selfW=selfW+((3*CS1S3V3(INH3,1)*CTBS3(1)*CTBS3C(1)*
     &  DCONJG(CS1S3V3(INH3,1))*((-FD211HpTB(5,1)+FD211HpTB(6,1))*
     &  Mah(INH3)**4+(-FD111THB(6,INH3)+FD111THB(8,INH3)+FD111THpB(6,1)
     &  -FD111THpB(8,1))*Mah2(INH3)))/(2.*Mah(INH3)**4*Mah2(INH3))+(3*
     &  CS1S3V3(INH3,1)*CTBS3(1)*CTBS3C(1)*DCONJG(CS1S3V3(INH3,1))*(-
     &  (Mah2(INH3)**2*(M12+4*A0TNH(INH3)+3*Mah2(INH3)))+M12*(-((4*
     &  a0t1+3*M12)*Mah2(INH3))+(4*a0t1+3*M12+8*A0TNH(INH3))*Mah2(INH3)
     &  +3*Mah2(INH3)**2)))/(32.*Mah(INH3)**4))
              enddo
        ICH3=1
        INH3=6
            ICH4=2
       selfW=selfW+((3*CS1S3V3(6,ICH4)*CTBS3(1)*CTBS3C(ICH4)*
     &  DCONJG(CS1S3V3(6,1))*(FD111THpB(6,1)-FD111THpB(6,ICH4)-
     &  FD111THpB(8,1)+FD111THpB(8,ICH4)+(-FD211HpTB(5,1)+
     &  FD211HpTB(6,1))*MassHpm(ICH4)**2))/(2.*MassHpm(ICH4)**4)+(3*
     &  CS1S3V3(6,ICH4)*CTBS3(1)*CTBS3C(ICH4)*DCONJG(CS1S3V3(6,1))*(8*
     &  M12*A0THpN(ICH4)*MassHpm(ICH4)**2+2*(M12-2*A0THpN(ICH4))*
     &  MassHpm(ICH4)**4-3*MassHpm(ICH4)**6))/(32.*MassHpm(ICH4)**4))
        INH3=6
        ICH4=1
            ICH3=2
       selfW=selfW+((3*CS1S3V3(6,1)*CTBS3(ICH3)*CTBS3C(1)*
     &  DCONJG(CS1S3V3(6,ICH3))*(FD111THpB(6,1)-FD111THpB(6,ICH3)-
     &  FD111THpB(8,1)+FD111THpB(8,ICH3)+(-FD211HpTB(5,1)+
     &  FD211HpTB(6,1))*MassHpm(ICH3)**2))/(2.*MassHpm(ICH3)**4)+(3*
     &  CS1S3V3(6,1)*CTBS3(ICH3)*CTBS3C(1)*DCONJG(CS1S3V3(6,ICH3))*(8*
     &  M12*A0THpN(ICH3)*MassHpm(ICH3)**2+2*(M12-2*A0THpN(ICH3))*
     &  MassHpm(ICH3)**4-3*MassHpm(ICH3)**6))/(32.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+((3*(1-4*logx)*M12*CS1S3V3(6,1)*CTBS3(1)*CTBS3C(1)*
     &  DCONJG(CS1S3V3(6,1)))/16.+(3*CS1S3V3(6,1)*CTBS3(1)*CTBS3C(1)*
     &  DCONJG(CS1S3V3(6,1))*(FD311HpTB(4,1)-FD311HpTB(6,1)))/2.)
       ! diagram  4  
       do INe3=1,3
        ICH3=1
        ICH4=1
            do INH3=1,5
       selfW=selfW+((CS1S3V3(INH3,1)*DCONJG(CS1S3V3(INH3,1))*(-
     &  ((CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  ((FD211HpChiCha(5,1,INe3)-FD211HpChiCha(6,1,INe3))*Mah(INH3)**
     &  4+(FD111ChiHCha(6,INe3,INH3)-FD111ChiHCha(8,INe3,INH3)-
     &  FD111ChiHpCha(6,INe3,1)+FD111ChiHpCha(8,INe3,1))*Mah2(INH3)))+
     &  MCha*(CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD211HpChiCha(4,1,INe3)*Mah(INH3)**4+(-
     &  FD111ChiHCha(3,INe3,INH3)+FD111ChiHpCha(3,INe3,1))*Mah2(INH3))*
     &  MNeu(INe3)))/(2.*Mah(INH3)**4*Mah2(INH3))+(CS1S3V3(INH3,1)*
     &  DCONJG(CS1S3V3(INH3,1))*(-2*MCha*(CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*Mah2(INH3)*MNeu(INe3)*(4*a0tcha+3*
     &  MCha2+4*A0TNeu(INe3)+3*MNeu2(INe3))-2*(CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*Mah2(INH3)*MNeu2(INe3)*(4*a0tcha+3*
     &  MCha2+4*A0TNeu(INe3)+3*MNeu2(INe3))-4*MCha*(CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*MNeu(INe3)*(2*MCha2*A0TNeu(INe3)+
     &  (2*a0tcha+MCha2)*MNeu2(INe3))+2*MCha*(CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*MNeu(INe3)*(4*A0TNeu(INe3)*(MCha2+
     &  Mah2(INH3))+Mah2(INH3)*(4*a0tcha+3*MCha2+4*A0TNH(INH3)+3*
     &  Mah2(INH3))+(4*a0tcha+2*MCha2+3*Mah2(INH3))*MNeu2(INe3))-
     &  (CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*(Mah2(INH3)*(-
     &  (MCha2*(4*a0tcha+3*MCha2))+4*(a0tcha+A0TNeu(INe3)+A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2)+2*Mah2(INH3)**2*(2*a0tcha+MCha2-2*
     &  A0TNeu(INe3)-MNeu2(INe3))+2*(2*A0TNeu(INe3)*(2*MCha2+Mah2(INH3)
     &  )+Mah2(INH3)*(4*a0tcha+MCha2+3*Mah2(INH3)))*MNeu2(INe3)+(8*
     &  a0tcha+4*MCha2+3*Mah2(INH3))*MNeu2(INe3)**2)+4*
     &  (CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*((2*a0tcha+
     &  MCha2)*Mah2(INH3)**2+(2*a0tcha+MCha2)*MNeu(INe3)**4+((4*a0tcha*
     &  Mah2(INH3)+(MCha2+Mah2(INH3))*(4*A0TNeu(INe3)+3*Mah2(INH3)))*
     &  MNeu2(INe3))/2.+(3*Mah2(INH3)*MNeu2(INe3)**2)/2.+2*A0TNH(INH3)*
     &  Mah2(INH3)*(MCha2+MNeu2(INe3)))-(CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*Mah2(INH3)*(MCha2*(4*a0tcha+3*
     &  MCha2)+(-8*a0tcha+MCha2)*MNeu2(INe3)-MNeu2(INe3)*(MCha2+
     &  MNeu2(INe3))-2*MNeu2(INe3)*(MCha2+2*A0TNeu(INe3)+MNeu2(INe3)))))/(32.*Mah(INH3)**4))
              enddo
        ICH3=1
        INH3=6
            ICH4=2
       selfW=selfW+((CS1S3V3(6,ICH4)*DCONJG(CS1S3V3(6,1))*
     &  ((CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD111ChiHpCha(6,INe3,1)-FD111ChiHpCha(6,INe3,ICH4)-
     &  FD111ChiHpCha(8,INe3,1)+FD111ChiHpCha(8,INe3,ICH4)+(-
     &  FD211HpChiCha(5,1,INe3)+FD211HpChiCha(6,1,INe3))*MassHpm(ICH4)*
     &  *2)+MCha*(CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD111ChiHpCha(3,INe3,1)-FD111ChiHpCha(3,INe3,ICH4)+
     &  FD211HpChiCha(4,1,INe3)*MassHpm(ICH4)**2)*MNeu(INe3)))/(2.*
     &  MassHpm(ICH4)**4)+(CS1S3V3(6,ICH4)*DCONJG(CS1S3V3(6,1))*
     &  (CF11F12S3L(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3R(INe3,1))*(4*
     &  A0THpN(ICH4)*MassHpm(ICH4)**2+3*MassHpm(ICH4)**4)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,1))*(-3*MassHpm(ICH4)**6+8*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+2*MassHpm(ICH4)**4*(MCha2-
     &  2*A0THpN(ICH4)+MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2)))+CF11F12S3R(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,1))*(4*A0THpN(ICH4)*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH4)**4)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,1))*(-3*
     &  MassHpm(ICH4)**6+8*A0THpN(ICH4)*MassHpm(ICH4)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH4)**4*(MCha2-2*A0THpN(ICH4)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )))/(32.*MassHpm(ICH4)**4))
        INH3=6
        ICH4=1
            ICH3=2
       selfW=selfW+((CS1S3V3(6,1)*DCONJG(CS1S3V3(6,ICH3))*
     &  ((CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (FD111ChiHpCha(6,INe3,1)-FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(8,INe3,1)+FD111ChiHpCha(8,INe3,ICH3)+(-
     &  FD211HpChiCha(5,1,INe3)+FD211HpChiCha(6,1,INe3))*MassHpm(ICH3)*
     &  *2)+MCha*(CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (FD111ChiHpCha(3,INe3,1)-FD111ChiHpCha(3,INe3,ICH3)+
     &  FD211HpChiCha(4,1,INe3)*MassHpm(ICH3)**2)*MNeu(INe3)))/(2.*
     &  MassHpm(ICH3)**4)+(CS1S3V3(6,1)*DCONJG(CS1S3V3(6,ICH3))*
     &  (CF11F12S3L(INe3,1)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-3*MassHpm(ICH3)**6+8*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+2*
     &  MassHpm(ICH3)**4*(MCha2-2*A0THpN(ICH3)+MNeu2(INe3))+4*(2*
     &  a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2)))+
     &  CF11F12S3R(INe3,1)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-3*MassHpm(ICH3)**6+8*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+2*
     &  MassHpm(ICH3)**4*(MCha2-2*A0THpN(ICH3)+MNeu2(INe3))+4*(2*
     &  a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2)))))/(32.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+((CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1))*
     &  ((CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD311HpChiCha(4,1,INe3)-FD311HpChiCha(6,1,INe3))-MCha*
     &  (CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  FD311HpChiCha(3,1,INe3)*MNeu(INe3)))/2.-(CS1S3V3(6,1)*
     &  DCONJG(CS1S3V3(6,1))*(CF11F12S3L(INe3,1)*((-3+4*logx)*MCha*
     &  DCONJG(CF11F12S3R(INe3,1))*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,1)
     &  )*(2*logx*MCha2+(-1+2*logx)*MCha2+(1-2*logx)*MNeu2(INe3)+(-2+6*
     &  logx)*MNeu2(INe3)))+CF11F12S3R(INe3,1)*((-3+4*logx)*MCha*
     &  DCONJG(CF11F12S3L(INe3,1))*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,1)
     &  )*(2*logx*MCha2+(-1+2*logx)*MCha2+(1-2*logx)*MNeu2(INe3)+(-2+6*
     &  logx)*MNeu2(INe3)))))/16.)
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[7][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo7-GBC
c

       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
          if( Abs(-Mah(INH3) + Mah(INH6))*Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH6) - MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHpH(3,INH4,ICH3,INH5)*(Mah(INH3)**2-Mah(INH6)**2)+
     &  FD111HHH(4,INH3,INH4,INH5)*(Mah(INH6)**2-MassHpm(ICH3)**2)+
     &  FD111HHH(4,INH6,INH4,INH5)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))
     &  /(8.*(Mah(INH3)-Mah(INH6))*(Mah(INH3)+Mah(INH6))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH6)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(Mah(INH6)+MassHpm(ICH3)))+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-((4*A0TNH(INH3)
     &  *Mah2(INH3)+4*A0TNH(INH5)*Mah2(INH3)+3*Mah2(INH3)**2+4*
     &  A0TNH(INH5)*Mah2(INH4)+3*Mah2(INH3)*Mah2(INH4)+3*Mah2(INH3)*
     &  Mah2(INH5)+2*Mah2(INH4)*Mah2(INH5)+4*A0TNH(INH4)*(Mah2(INH3)+
     &  Mah2(INH5)))/((Mah(INH3)-Mah(INH6))*(Mah(INH3)+Mah(INH6))*
     &  (Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))))+(2*
     &  Mah2(INH4)*Mah2(INH5)+4*A0TNH(INH6)*Mah2(INH6)+3*Mah2(INH4)*
     &  Mah2(INH6)+3*Mah2(INH5)*Mah2(INH6)+3*Mah2(INH6)**2+4*
     &  A0TNH(INH5)*(Mah2(INH4)+Mah2(INH6))+4*A0TNH(INH4)*(Mah2(INH5)+
     &  Mah2(INH6)))/((Mah(INH3)-Mah(INH6))*(Mah(INH3)+Mah(INH6))*
     &  (Mah(INH6)-MassHpm(ICH3))*(Mah(INH6)+MassHpm(ICH3)))+(2*
     &  Mah2(INH4)*Mah2(INH5)+4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*
     &  Mah2(INH4)*MassHpm(ICH3)**2+3*Mah2(INH5)*MassHpm(ICH3)**2+3*
     &  MassHpm(ICH3)**4+4*A0TNH(INH5)*(Mah2(INH4)+MassHpm(ICH3)**2)+4*
     &  A0TNH(INH4)*(Mah2(INH5)+MassHpm(ICH3)**2))/((Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-Mah(INH6)+
     &  MassHpm(ICH3))*(Mah(INH6)+MassHpm(ICH3)))))/64.)
              else
             if( Abs(-Mah(INH3) + Mah(INH6))*Abs(Mah(INH6) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(8*A0THpN(ICH3)*
     &  Mah2(INH6)-4*A0TNH(INH6)*Mah2(INH6)-3*Mah2(INH6)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+2*Mah2(INH6)*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4))/(64.*(Mah2(INH6)-MassHpm(ICH3)**2)**2)+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHH(4,INH6,INH4,INH5)-FD111HHpH(3,INH4,ICH3,INH5)+
     &  FD211HpHH(4,ICH3,INH4,INH5)*(-Mah(INH6)**2+MassHpm(ICH3)**2)))
     &  /(8.*(Mah(INH6)**2-MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(-Mah(INH3) + Mah(INH6))*Abs(Mah(INH3) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(8*A0THpN(ICH3)*
     &  Mah2(INH3)-4*A0TNH(INH3)*Mah2(INH3)-3*Mah2(INH3)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+2*Mah2(INH3)*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4))/(64.*(Mah2(INH3)-MassHpm(ICH3)**2)**2)+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHH(4,INH3,INH4,INH5)-FD111HHpH(3,INH4,ICH3,INH5)+
     &  FD211HpHH(4,ICH3,INH4,INH5)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))
     &  /(8.*(Mah(INH3)**2-MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH6) - MassHpm(ICH3))*Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  FD111HHH(4,INH3,INH4,INH5)+FD111HHpH(3,INH4,ICH3,INH5)+
     &  FD211HHH(4,INH3,INH4,INH5)*(Mah(INH3)**2-MassHpm(ICH3)**2)))
     &  /(8.*(Mah(INH3)**2-MassHpm(ICH3)**2)**2)+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(Mah2(INH3)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+2*Mah2(INH3)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+4*A0TNH(INH3)*(-Mah2(INH3)+2*MassHpm(ICH3)**2)
     &  ))/(64.*(Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH6) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(-Mah(INH3) + MassHpm(ICH3)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD311HpHH(3,ICH3,INH4,INH5))/8.+(CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH4,INH5,INH6)*CS1S3V3(INH6,ICH3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-4*A0THpN(ICH3)+3*MassHpm(ICH3)**2)
     &  )/(64.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
       do INH4=1,6
          if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH5))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHpHp(3,INH4,ICH5,ICH4)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111HHHp(4,INH3,INH4,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)
     &  +FD111HHpHp(3,INH4,ICH3,ICH4)*(-Mah(INH3)**2+MassHpm(ICH5)**2))
     &  )/(4.*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*
     &  (Mah(INH3)-MassHpm(ICH5))*(MassHpm(ICH3)-MassHpm(ICH5))*
     &  (Mah(INH3)+MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5)))+
     &  (CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*(4*A0THpN(ICH3)*
     &  Mah2(INH3)*MassHpm(ICH3)**2-3*Mah2(INH3)**2*MassHpm(ICH3)**2+3*
     &  Mah2(INH3)*MassHpm(ICH3)**4-4*A0THpN(ICH5)*Mah2(INH3)*
     &  MassHpm(ICH5)**2+3*Mah2(INH3)**2*MassHpm(ICH5)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2*MassHpm(ICH5)**2+4*A0THpN(ICH5)*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2-3*MassHpm(ICH3)**4*
     &  MassHpm(ICH5)**2-3*Mah2(INH3)*MassHpm(ICH5)**4+3*MassHpm(ICH3)*
     &  *2*MassHpm(ICH5)**4+4*A0TNH(INH3)*Mah2(INH3)*(-MassHpm(ICH3)**
     &  2+MassHpm(ICH5)**2)))/(32.*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)
     &  +MassHpm(ICH3))*(Mah(INH3)-MassHpm(ICH5))*(MassHpm(ICH3)-
     &  MassHpm(ICH5))*(Mah(INH3)+MassHpm(ICH5))*(MassHpm(ICH3)+
     &  MassHpm(ICH5))))
              else
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*(8*A0THpN(ICH3)*
     &  Mah2(INH3)-4*A0TNH(INH3)*Mah2(INH3)-3*Mah2(INH3)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+2*Mah2(INH3)*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4))/(32.*(Mah2(INH3)-MassHpm(ICH3)**2)**2)+
     &  (CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHHp(4,INH3,INH4,ICH4)-FD111HHpHp(3,INH4,ICH3,ICH4)+
     &  FD211HpHHp(4,ICH3,INH4,ICH4)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))
     &  /(4.*(Mah(INH3)**2-MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(Mah(INH3) - MassHpm(ICH5))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*(MassHpm(ICH3)**
     &  4-4*A0THpN(ICH5)*MassHpm(ICH5)**2+2*MassHpm(ICH3)**2*
     &  MassHpm(ICH5)**2-3*MassHpm(ICH5)**4-4*A0THpN(ICH3)*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH5)**2)))/(32.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH5)**2)**2)+(CS1S3S3(INH4,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH5)*CS1S3V3(INH3,ICH5)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-FD111HHpHp(3,INH4,ICH3,ICH4)+
     &  FD111HHpHp(3,INH4,ICH5,ICH4)+FD211HpHHp(4,ICH3,INH4,ICH4)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH5)**2)))/(4.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH5)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*(-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2-3*MassHpm(ICH3)**4+2*MassHpm(ICH3)**2*
     &  MassHpm(ICH5)**2+MassHpm(ICH5)**4+A0THpN(ICH5)*(8*MassHpm(ICH3)
     &  **2-4*MassHpm(ICH5)**2)))/(32.*(MassHpm(ICH3)**2-MassHpm(ICH5)*
     &  *2)**2)+(CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HHpHp(3,INH4,ICH3,ICH4)-FD111HHpHp(3,INH4,ICH5,ICH4)+
     &  FD211HpHHp(4,ICH5,INH4,ICH4)*(-MassHpm(ICH3)**2+MassHpm(ICH5)**
     &  2)))/(4.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH5)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH3,ICH5)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD311HpHHp(3,ICH3,INH4,ICH4))/4.+(CS1S3S3(INH4,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH5)*CS1S3V3(INH3,ICH5)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-4*A0THpN(ICH3)+3*MassHpm(ICH3)**2)
     &  )/(32.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
       do INH4=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 

       selfW=selfW+((CS1S3S3(INH3,ICH5,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HpHpHp(4,ICH3,ICH4,ICH5)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HHpHp(4,INH3,ICH4,ICH5)*(Mah(INH4)**2-MassHpm(ICH3)**2)+
     &  FD111HHpHp(4,INH4,ICH4,ICH5)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))
     &  /(4.*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+
     &  (CS1S3S3(INH3,ICH5,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-((4*A0TNH(INH3)
     &  *Mah2(INH3)+3*Mah2(INH3)**2+3*Mah2(INH3)*MassHpm(ICH4)**2+4*
     &  A0THpN(ICH5)*(Mah2(INH3)+MassHpm(ICH4)**2)+3*Mah2(INH3)*
     &  MassHpm(ICH5)**2+2*MassHpm(ICH4)**2*MassHpm(ICH5)**2+4*
     &  A0THpN(ICH4)*(Mah2(INH3)+MassHpm(ICH5)**2))/((Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-MassHpm(ICH3))*
     &  (Mah(INH3)+MassHpm(ICH3))))+(4*A0TNH(INH4)*Mah2(INH4)+3*
     &  Mah2(INH4)**2+3*Mah2(INH4)*MassHpm(ICH4)**2+4*A0THpN(ICH5)*
     &  (Mah2(INH4)+MassHpm(ICH4)**2)+3*Mah2(INH4)*MassHpm(ICH5)**2+2*
     &  MassHpm(ICH4)**2*MassHpm(ICH5)**2+4*A0THpN(ICH4)*(Mah2(INH4)+
     &  MassHpm(ICH5)**2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))
     &  *(Mah(INH4)-MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+4*A0THpN(ICH5)*MassHpm(ICH3)**2+
     &  3*MassHpm(ICH3)**4+4*A0THpN(ICH5)*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2+3*MassHpm(ICH3)**2*
     &  MassHpm(ICH5)**2+2*MassHpm(ICH4)**2*MassHpm(ICH5)**2+4*
     &  A0THpN(ICH4)*(MassHpm(ICH3)**2+MassHpm(ICH5)**2))/((Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-Mah(INH4)+
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))))/32.)

              else

             if( Abs(Mah(INH4) - MassHpm(ICH3))*Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+((CS1S3S3(INH3,ICH5,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-4*A0TNH(INH3)*
     &  Mah2(INH3)+Mah2(INH3)**2-4*A0THpN(ICH3)*MassHpm(ICH3)**2+8*
     &  A0TNH(INH3)*MassHpm(ICH3)**2+2*Mah2(INH3)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4))/(32.*(Mah2(INH3)-MassHpm(ICH3)**2)**2)+
     &  (CS1S3S3(INH3,ICH5,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  FD111HHpHp(4,INH3,ICH4,ICH5)+FD111HpHpHp(4,ICH3,ICH4,ICH5)+
     &  FD211HHpHp(4,INH3,ICH4,ICH5)*(Mah(INH3)**2-MassHpm(ICH3)**2)))
     &  /(4.*(Mah(INH3)**2-MassHpm(ICH3)**2)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*
     &  CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HpSTST(4,ICH3,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HSTST(4,INH3,ISt3,ISt4)*(Mah(INH4)**2-MassHpm(ICH3)**2)+
     &  FD111HSTST(4,INH4,ISt3,ISt4)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))
     &  /(4.*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  MassHpm(ICH3))*(Mah(INH4)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(3*CS1S3V3(INH4,ICH3)
     &  *CSSS(INH3,ISt4,ISt3)*CSSS(INH4,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-((4*A0TNH(INH3)*Mah2(INH3)+4*
     &  aA0TN(ISt4)*Mah2(INH3)+3*Mah2(INH3)**2+4*aA0TN(ISt4)*
     &  MassSu2(ISt3)+3*Mah2(INH3)*MassSu2(ISt3)+3*Mah2(INH3)*
     &  MassSu2(ISt4)+2*MassSu2(ISt3)*MassSu2(ISt4)+4*aA0TN(ISt3)*
     &  (Mah2(INH3)+MassSu2(ISt4)))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3)))
     &  )+(4*A0TNH(INH4)*Mah2(INH4)+4*aA0TN(ISt4)*Mah2(INH4)+3*
     &  Mah2(INH4)**2+4*aA0TN(ISt4)*MassSu2(ISt3)+3*Mah2(INH4)*
     &  MassSu2(ISt3)+3*Mah2(INH4)*MassSu2(ISt4)+2*MassSu2(ISt3)*
     &  MassSu2(ISt4)+4*aA0TN(ISt3)*(Mah2(INH4)+MassSu2(ISt4)))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))+(4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2+4*aA0TN(ISt4)*MassHpm(ICH3)**2+3*MassHpm(ICH3)
     &  **4+4*aA0TN(ISt4)*MassSu2(ISt3)+3*MassHpm(ICH3)**2*
     &  MassSu2(ISt3)+3*MassHpm(ICH3)**2*MassSu2(ISt4)+2*MassSu2(ISt3)*
     &  MassSu2(ISt4)+4*aA0TN(ISt3)*(MassHpm(ICH3)**2+MassSu2(ISt4)))
     &  /((Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*(-
     &  Mah(INH4)+MassHpm(ICH3))*(Mah(INH4)+MassHpm(ICH3)))))/32.)
              else
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH4) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*
     &  CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(INH3,ICH3))*(8*A0THpN(ICH3)
     &  *Mah2(INH4)-4*A0TNH(INH4)*Mah2(INH4)-3*Mah2(INH4)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+2*Mah2(INH4)*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4))/(32.*(Mah2(INH4)-MassHpm(ICH3)**2)**2)-(3*
     &  CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*CSSS(INH4,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(FD111HpSTST(4,ICH3,ISt3,ISt4)-
     &  FD111HSTST(4,INH4,ISt3,ISt4)+FD211HpSTST(4,ICH3,ISt3,ISt4)*
     &  (Mah(INH4)**2-MassHpm(ICH3)**2)))/(4.*(Mah(INH4)**2-
     &  MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(Mah(INH3) - MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*
     &  CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(INH3,ICH3))*(8*A0THpN(ICH3)
     &  *Mah2(INH3)-4*A0TNH(INH3)*Mah2(INH3)-3*Mah2(INH3)**2-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+2*Mah2(INH3)*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4))/(32.*(Mah2(INH3)-MassHpm(ICH3)**2)**2)-(3*
     &  CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*CSSS(INH4,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(FD111HpSTST(4,ICH3,ISt3,ISt4)-
     &  FD111HSTST(4,INH3,ISt3,ISt4)+FD211HpSTST(4,ICH3,ISt3,ISt4)*
     &  (Mah(INH3)**2-MassHpm(ICH3)**2)))/(4.*(Mah(INH3)**2-
     &  MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH4) - MassHpm(ICH3))*Abs(-Mah(INH3) + MassHpm(ICH3)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*
     &  CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HpSTST(4,ICH3,ISt3,ISt4)-FD111HSTST(4,INH3,ISt3,ISt4)+
     &  FD211HSTST(4,INH3,ISt3,ISt4)*(Mah(INH3)**2-MassHpm(ICH3)**2)))
     &  /(4.*(Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(3*CS1S3V3(INH4,ICH3)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH4,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(Mah2(INH3)**2-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2+2*Mah2(INH3)*MassHpm(ICH3)**2-3*MassHpm(ICH3)*
     &  *4+4*A0TNH(INH3)*(-Mah2(INH3)+2*MassHpm(ICH3)**2)))/(32.*
     &  (Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
             endif
             if( Abs(Mah(INH4) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(-Mah(INH3) + MassHpm(ICH3)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH4,ICH3)*CSSS(INH3,ISt4,ISt3)*
     &  CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD311HpSTST(3,ICH3,ISt3,ISt4))/4.+(3*CS1S3V3(INH4,ICH3)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH4,ISt3,ISt4)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-4*A0THpN(ICH3)+3*MassHpm(ICH3)**2)
     &  )/(32.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do ISt3=1,2
          if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HpSTSB(4,ICH4,ISt3)*(Mah(INH3)**2-MassHpm(ICH3)**2)+
     &  FD111HSTSB(4,INH3,ISt3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)+
     &  FD111HpSTSB(4,ICH3,ISt3)*(-Mah(INH3)**2+MassHpm(ICH4)**2)))
     &  /(4.*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+MassHpm(ICH3))*
     &  (Mah(INH3)-MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (Mah(INH3)+MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))+(3*
     &  CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-3*Mah2(INH3)**2*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)+MassHpm(ICH3)**2*MassHpm(ICH4)**2*(-4*
     &  A0THpN(ICH3)+4*A0THpN(ICH4)-3*MassHpm(ICH3)**2+3*MassHpm(ICH4)*
     &  *2)-Mah2(INH3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*(4*a0t5+3*
     &  MSQ2+4*A0TNH(INH3)+4*aA0TN(ISt3)+3*MassSu2(ISt3))+Mah2(INH3)*
     &  (3*MassHpm(ICH3)**4+MassHpm(ICH3)**2*(4*a0t5+3*MSQ2+4*
     &  A0THpN(ICH3)+4*aA0TN(ISt3)+3*MassSu2(ISt3))-MassHpm(ICH4)**2*
     &  (4*a0t5+3*MSQ2+4*A0THpN(ICH4)+4*aA0TN(ISt3)+3*MassHpm(ICH4)**2+
     &  3*MassSu2(ISt3)))))/(32.*(Mah(INH3)-MassHpm(ICH3))*(Mah(INH3)+
     &  MassHpm(ICH3))*(Mah(INH3)-MassHpm(ICH4))*(MassHpm(ICH3)-
     &  MassHpm(ICH4))*(Mah(INH3)+MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4))))
              else
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(Mah(INH3) - MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  FD111HpSTSB(4,ICH3,ISt3)+FD111HSTSB(4,INH3,ISt3)+
     &  FD211HpSTSB(4,ICH3,ISt3)*(-Mah(INH3)**2+MassHpm(ICH3)**2)))
     &  /(4.*(Mah(INH3)**2-MassHpm(ICH3)**2)**2)+(3*CS1S3V3(INH3,ICH4)*
     &  CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-3*Mah2(INH3)**2-4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2+MassHpm(ICH3)**4-Mah2(INH3)*(4*a0t5+3*MSQ2+4*
     &  A0TNH(INH3)+4*aA0TN(ISt3)+3*MassSu2(ISt3))+Mah2(INH3)*(4*a0t5+
     &  3*MSQ2+8*A0THpN(ICH3)+4*aA0TN(ISt3)+2*MassHpm(ICH3)**2+3*
     &  MassSu2(ISt3))))/(32.*(Mah2(INH3)-MassHpm(ICH3)**2)**2))
             endif
              endif
             if( Abs(Mah(INH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*(MassHpm(ICH3)**
     &  4-4*A0THpN(ICH4)*MassHpm(ICH4)**2+2*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2-3*MassHpm(ICH4)**4-4*A0THpN(ICH3)*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH4)**2)))/(32.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)**2)+(3*CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  FD111HpSTSB(4,ICH3,ISt3)+FD111HpSTSB(4,ICH4,ISt3)+
     &  FD211HpSTSB(4,ICH3,ISt3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)))
     &  /(4.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3))*Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  (FD111HpSTSB(4,ICH3,ISt3)-FD111HpSTSB(4,ICH4,ISt3)+
     &  FD211HpSTSB(4,ICH4,ISt3)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)))
     &  /(4.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)-(3*
     &  CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*
     &  MassHpm(ICH3)**4-2*MassHpm(ICH3)**2*MassHpm(ICH4)**2-
     &  MassHpm(ICH4)**4+A0THpN(ICH4)*(-8*MassHpm(ICH3)**2+4*
     &  MassHpm(ICH4)**2)))/(32.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2))
             endif
             endif
             if( Abs(Mah(INH3) - MassHpm(ICH3)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+((3*CS1S3V3(INH3,ICH4)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(INH3,ICH3))*
     &  FD311HpSTSB(3,ICH3,ISt3))/4.+(3*CS1S3V3(INH3,ICH4)*
     &  CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  DCONJG(CS1S3V3(INH3,ICH3))*(-4*A0THpN(ICH3)+3*MassHpm(ICH3)**2)
     &  )/(32.*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[8][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo8-NoGBC
c

       ! diagram  1  
       do INH4=1,6
       do INH5=1,6
        ICH3=1
        INH3=6
            do INH6=1,5
       selfW=selfW+(-(CS1S1S1(6,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,1)*DCONJG(CS1S3V3(6,1))*(FD211HpHH(4,1,INH4,INH5)*
     &  Mah(INH6)**4+(-FD111HHH(4,INH6,INH4,INH5)+
     &  FD111HHpH(3,INH4,1,INH5))*Mah2(INH6)))/(8.*Mah(INH6)**4*
     &  Mah2(INH6))-(CS1S1S1(6,INH4,INH5)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S3V3(INH6,1)*DCONJG(CS1S3V3(6,1))*(4*A0TNH(INH6)*Mah2(INH6)+
     &  3*Mah2(INH6)**2))/(64.*Mah(INH6)**4))
              enddo
        ICH3=1
        INH6=6
            do INH3=1,5
       selfW=selfW+(-(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,6)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*(FD211HpHH(4,1,INH4,INH5)*
     &  Mah(INH3)**4+(-FD111HHH(4,INH3,INH4,INH5)+
     &  FD111HHpH(3,INH4,1,INH5))*Mah2(INH3)))/(8.*Mah(INH3)**4*
     &  Mah2(INH3))-(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH4,INH5,6)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*(4*A0TNH(INH3)*Mah2(INH3)+
     &  3*Mah2(INH3)**2))/(64.*Mah(INH3)**4))
              enddo
        INH6=6
        INH3=6
            ICH3=2
       selfW=selfW+(-(CS1S1S1(6,INH4,INH5)*CS1S1S1(INH4,INH5,6)*
     &  CS1S3V3(6,ICH3)*DCONJG(CS1S3V3(6,ICH3))*
     &  (FD111HHH(4,6,INH4,INH5)-FD111HHpH(3,INH4,ICH3,INH5)+
     &  FD211HHH(4,6,INH4,INH5)*MassHpm(ICH3)**2))/(8.*MassHpm(ICH3)**
     &  4)-(CS1S1S1(6,INH4,INH5)*CS1S1S1(INH4,INH5,6)*CS1S3V3(6,ICH3)*
     &  DCONJG(CS1S3V3(6,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*
     &  MassHpm(ICH3)**4))/(64.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+(((-3+4*logx)*CS1S1S1(6,INH4,INH5)*
     &  CS1S1S1(INH4,INH5,6)*CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1)))/64.+
     &  (CS1S1S1(6,INH4,INH5)*CS1S1S1(INH4,INH5,6)*CS1S3V3(6,1)*
     &  DCONJG(CS1S3V3(6,1))*FD311HpHH(3,1,INH4,INH5))/8.)
       enddo 
       enddo 
       ! diagram  2  
       do ICH4=1,2
       do INH4=1,6
        ICH3=1
        ICH5=1
            do INH3=1,5
       selfW=selfW+(-(CS1S3S3(INH4,1,ICH4)*CS1S3S3(INH4,ICH4,1)*
     &  CS1S3V3(INH3,1)*DCONJG(CS1S3V3(INH3,1))*
     &  (FD211HpHHp(4,1,INH4,ICH4)*Mah(INH3)**4+(-
     &  FD111HHHp(4,INH3,INH4,ICH4)+FD111HHpHp(3,INH4,1,ICH4))*
     &  Mah2(INH3)))/(4.*Mah(INH3)**4*Mah2(INH3))-(CS1S3S3(INH4,1,ICH4)
     &  *CS1S3S3(INH4,ICH4,1)*CS1S3V3(INH3,1)*DCONJG(CS1S3V3(INH3,1))*
     &  (4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2))/(32.*Mah(INH3)**4))
              enddo
        ICH3=1
        INH3=6
            ICH5=2
       selfW=selfW+(-(CS1S3S3(INH4,1,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(6,ICH5)*DCONJG(CS1S3V3(6,1))*(FD111HHpHp(3,INH4,1,ICH4)
     &  -FD111HHpHp(3,INH4,ICH5,ICH4)+FD211HpHHp(4,1,INH4,ICH4)*
     &  MassHpm(ICH5)**2))/(4.*MassHpm(ICH5)**4)-(CS1S3S3(INH4,1,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH5)*CS1S3V3(6,ICH5)*DCONJG(CS1S3V3(6,1))*
     &  (4*A0THpN(ICH5)*MassHpm(ICH5)**2+3*MassHpm(ICH5)**4))/(32.*
     &  MassHpm(ICH5)**4))
        INH3=6
        ICH5=1
            ICH3=2
       selfW=selfW+(-(CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,1)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(6,ICH3))*(FD111HHpHp(3,INH4,1,ICH4)
     &  -FD111HHpHp(3,INH4,ICH3,ICH4)+FD211HpHHp(4,1,INH4,ICH4)*
     &  MassHpm(ICH3)**2))/(4.*MassHpm(ICH3)**4)-
     &  (CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,1)*CS1S3V3(6,1)*
     &  DCONJG(CS1S3V3(6,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*
     &  MassHpm(ICH3)**4))/(32.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+(((-3+4*logx)*CS1S3S3(INH4,1,ICH4)*
     &  CS1S3S3(INH4,ICH4,1)*CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1)))/32.+
     &  (CS1S3S3(INH4,1,ICH4)*CS1S3S3(INH4,ICH4,1)*CS1S3V3(6,1)*
     &  DCONJG(CS1S3V3(6,1))*FD311HpHHp(3,1,INH4,ICH4))/4.)
       enddo 
       enddo 
       ! diagram  3  
       do ICH4=1,2
       do ICH5=1,2
        ICH3=1
        INH3=6
            do INH4=1,5
       selfW=selfW+(-(CS1S3S3(6,ICH5,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  CS1S3V3(INH4,1)*DCONJG(CS1S3V3(6,1))*
     &  (FD211HpHpHp(4,1,ICH4,ICH5)*Mah(INH4)**4+(-
     &  FD111HHpHp(4,INH4,ICH4,ICH5)+FD111HpHpHp(4,1,ICH4,ICH5))*
     &  Mah2(INH4)))/(4.*Mah(INH4)**4*Mah2(INH4))-(CS1S3S3(6,ICH5,ICH4)
     &  *CS1S3S3(INH4,ICH4,ICH5)*CS1S3V3(INH4,1)*DCONJG(CS1S3V3(6,1))*
     &  (4*A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2))/(32.*Mah(INH4)**4))
              enddo
        ICH3=1
        INH4=6
            do INH3=1,5
       selfW=selfW+(-(CS1S3S3(6,ICH4,ICH5)*CS1S3S3(INH3,ICH5,ICH4)*
     &  CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*
     &  (FD211HpHpHp(4,1,ICH4,ICH5)*Mah(INH3)**4+(-
     &  FD111HHpHp(4,INH3,ICH4,ICH5)+FD111HpHpHp(4,1,ICH4,ICH5))*
     &  Mah2(INH3)))/(4.*Mah(INH3)**4*Mah2(INH3))-(CS1S3S3(6,ICH4,ICH5)
     &  *CS1S3S3(INH3,ICH5,ICH4)*CS1S3V3(6,1)*DCONJG(CS1S3V3(INH3,1))*
     &  (4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2))/(32.*Mah(INH3)**4))
              enddo
        INH4=6
        INH3=6
            ICH3=2
       selfW=selfW+(-(CS1S3S3(6,ICH4,ICH5)*CS1S3S3(6,ICH5,ICH4)*
     &  CS1S3V3(6,ICH3)*DCONJG(CS1S3V3(6,ICH3))*
     &  (FD111HHpHp(4,6,ICH4,ICH5)-FD111HpHpHp(4,ICH3,ICH4,ICH5)+
     &  FD211HHpHp(4,6,ICH4,ICH5)*MassHpm(ICH3)**2))/(4.*MassHpm(ICH3)*
     &  *4)-(CS1S3S3(6,ICH4,ICH5)*CS1S3S3(6,ICH5,ICH4)*CS1S3V3(6,ICH3)*
     &  DCONJG(CS1S3V3(6,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*
     &  MassHpm(ICH3)**4))/(32.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+(((-3+4*logx)*CS1S3S3(6,ICH4,ICH5)*
     &  CS1S3S3(6,ICH5,ICH4)*CS1S3V3(6,1)*DCONJG(CS1S3V3(6,1)))/32.+
     &  (CS1S3S3(6,ICH4,ICH5)*CS1S3S3(6,ICH5,ICH4)*CS1S3V3(6,1)*
     &  DCONJG(CS1S3V3(6,1))*FD311HpHpHp(3,1,ICH4,ICH5))/4.)
       enddo 
       enddo 
       ! diagram  4  
       do ISt3=1,2
       do ISt4=1,2
        ICH3=1
        INH3=6
            do INH4=1,5
       selfW=selfW+((-3*CS1S3V3(INH4,1)*CSSS(6,ISt4,ISt3)*
     &  CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(6,1))*
     &  (FD211HpSTST(4,1,ISt3,ISt4)*Mah(INH4)**4+
     &  (FD111HpSTST(4,1,ISt3,ISt4)-FD111HSTST(4,INH4,ISt3,ISt4))*
     &  Mah2(INH4)))/(4.*Mah(INH4)**4*Mah2(INH4))-(3*CS1S3V3(INH4,1)*
     &  CSSS(6,ISt4,ISt3)*CSSS(INH4,ISt3,ISt4)*DCONJG(CS1S3V3(6,1))*(4*
     &  A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2))/(32.*Mah(INH4)**4))
              enddo
        ICH3=1
        INH4=6
            do INH3=1,5
       selfW=selfW+((-3*CS1S3V3(6,1)*CSSS(6,ISt3,ISt4)*
     &  CSSS(INH3,ISt4,ISt3)*DCONJG(CS1S3V3(INH3,1))*
     &  (FD211HpSTST(4,1,ISt3,ISt4)*Mah(INH3)**4+
     &  (FD111HpSTST(4,1,ISt3,ISt4)-FD111HSTST(4,INH3,ISt3,ISt4))*
     &  Mah2(INH3)))/(4.*Mah(INH3)**4*Mah2(INH3))-(3*CS1S3V3(6,1)*
     &  CSSS(6,ISt3,ISt4)*CSSS(INH3,ISt4,ISt3)*DCONJG(CS1S3V3(INH3,1))*
     &  (4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2))/(32.*Mah(INH3)**4))
              enddo
        INH4=6
        INH3=6
            ICH3=2
       selfW=selfW+((-3*CS1S3V3(6,ICH3)*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt3)*DCONJG(CS1S3V3(6,ICH3))*(-
     &  FD111HpSTST(4,ICH3,ISt3,ISt4)+FD111HSTST(4,6,ISt3,ISt4)+
     &  FD211HSTST(4,6,ISt3,ISt4)*MassHpm(ICH3)**2))/(4.*MassHpm(ICH3)*
     &  *4)-(3*CS1S3V3(6,ICH3)*CSSS(6,ISt3,ISt4)*CSSS(6,ISt4,ISt3)*
     &  DCONJG(CS1S3V3(6,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*
     &  MassHpm(ICH3)**4))/(32.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+((3*(-3+4*logx)*CS1S3V3(6,1)*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt3)*DCONJG(CS1S3V3(6,1)))/32.+(3*CS1S3V3(6,1)*
     &  CSSS(6,ISt3,ISt4)*CSSS(6,ISt4,ISt3)*DCONJG(CS1S3V3(6,1))*
     &  FD311HpSTST(3,1,ISt3,ISt4))/4.)
       enddo 
       enddo 
       ! diagram  5  
       do ISt3=1,2
        ICH3=1
        ICH4=1
            do INH3=1,5
       selfW=selfW+((-3*CS1S3V3(INH3,1)*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt3)*DCONJG(CS1S3V3(INH3,1))*(FD211HpSTSB(4,1,ISt3)
     &  *Mah(INH3)**4+(FD111HpSTSB(4,1,ISt3)-FD111HSTSB(4,INH3,ISt3))*
     &  Mah2(INH3)))/(4.*Mah(INH3)**4*Mah2(INH3))-(3*CS1S3V3(INH3,1)*
     &  CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*DCONJG(CS1S3V3(INH3,1))*(3*
     &  Mah2(INH3)**2-Mah2(INH3)*(4*a0t5+3*MSQ2+4*aA0TN(ISt3)+3*
     &  MassSu2(ISt3))+Mah2(INH3)*(4*a0t5+3*MSQ2+4*A0TNH(INH3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3))))/(32.*Mah(INH3)**4))
              enddo
        ICH3=1
        INH3=6
            ICH4=2
       selfW=selfW+((-3*CS1S3V3(6,ICH4)*CS3S13S(1,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(6,1))*(FD111HpSTSB(4,1,ISt3)
     &  -FD111HpSTSB(4,ICH4,ISt3)+FD211HpSTSB(4,1,ISt3)*MassHpm(ICH4)**
     &  2))/(4.*MassHpm(ICH4)**4)-(3*CS1S3V3(6,ICH4)*CS3S13S(1,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*DCONJG(CS1S3V3(6,1))*(4*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2+3*MassHpm(ICH4)**4))/(32.*MassHpm(ICH4)**4))
        INH3=6
        ICH4=1
            ICH3=2
       selfW=selfW+((-3*CS1S3V3(6,1)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(1,ISt3)*DCONJG(CS1S3V3(6,ICH3))*(FD111HpSTSB(4,1,ISt3)
     &  -FD111HpSTSB(4,ICH3,ISt3)+FD211HpSTSB(4,1,ISt3)*MassHpm(ICH3)**
     &  2))/(4.*MassHpm(ICH3)**4)-(3*CS1S3V3(6,1)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(1,ISt3)*DCONJG(CS1S3V3(6,ICH3))*(4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2+3*MassHpm(ICH3)**4))/(32.*MassHpm(ICH3)**4))
        ICH3=1
       selfW=selfW+((3*(-3+4*logx)*CS1S3V3(6,1)*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt3)*DCONJG(CS1S3V3(6,1)))/32.+(3*CS1S3V3(6,1)*
     &  CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*DCONJG(CS1S3V3(6,1))*
     &  FD311HpSTSB(3,1,ISt3))/4.)
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[8][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo8-GBC
c


       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then       
       selfW=selfW-(CS1S1S1S1(INH3,INH4,INH5,INH5)*
     &  CS1S1V3V3(INH3,INH4)*(A0TNH(INH5)*aB0TNH(INH3,INH4)+AETNH(INH5)
     &  +aBEpTNH(INH3,INH4)*Mah2(INH5)))/16.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then     
       selfW=selfW-(CS1S1S3S3(INH3,INH4,ICH3,ICH3)*
     &  CS1S1V3V3(INH3,INH4)*(A0THpN(ICH3)*aB0TNH(INH3,INH4)+
     &  AETHpN(ICH3)+aBEpTNH(INH3,INH4)*MassHpm(ICH3)**2))/8.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then        
       selfW=selfW-(CS1S1S3S3(INH3,INH3,ICH4,ICH3)*
     &  CS3S3V3V3(ICH3,ICH4)*(A0TNH(INH3)*aB0TCH(ICH3,ICH4)+AETNH(INH3)
     &  +aBEpTCH(ICH3,ICH4)*Mah2(INH3)))/8.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfW=selfW-(CS3S3S3S3(ICH4,ICH5,ICH3,ICH5)*
     &  CS3S3V3V3(ICH3,ICH4)*(A0THpN(ICH5)*aB0TCH(ICH3,ICH4)+
     &  AETHpN(ICH5)+aBEpTCH(ICH3,ICH4)*MassHpm(ICH5)**2))/4.
              endif
       enddo 
       enddo 
       enddo 
       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then         
       selfW=selfW+(-3*CS1S1V3V3(INH3,INH4)*CSSSS(INH3,INH4,ISt3,ISt3)*
     &  (aAETN(ISt3)+aA0TN(ISt3)*aB0TNH(INH3,INH4)+aBEpTNH(INH3,INH4)*
     &  MassSu2(ISt3)))/8.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then         
       selfW=selfW+(-3*CS3S3S13S13(ICH4,ICH3,ISt3,ISt3)*
     &  CS3S3V3V3(ICH3,ICH4)*(aAETN(ISt3)+aA0TN(ISt3)*aB0TCH(ICH3,ICH4)
     &  +aBEpTCH(ICH3,ICH4)*MassSu2(ISt3)))/4.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then    
       selfW=selfW+(-3*(aet5+a0t5*aB0TCH(ICH3,ICH4)+MSQ2*
     &  aBEpTCH(ICH3,ICH4))*CS3S3S14S14(ICH4,ICH3)*CS3S3V3V3(ICH3,ICH4)
     &  )/4.
              endif
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[9][Nhung1]=",DBLE(selfW)
       selfW=0
#endif              
c
c topo9-NoGBC
c  
        Do INH3=1,6
        Do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .lt. 1D-15) then 
        do INH5=1,6
       selfW=selfW-(CS1S1S1S1(INH3,INH4,INH5,INH5)*
     &  CS1S1V3V3(INH3,INH4)*(A0TNH(INH5)*aB0TNH(INH3,INH4)+AETNH(INH5)
     &  +aBEpTNH(INH3,INH4)*Mah2(INH5)))/16.
         enddo 
              endif
        Enddo 
        Enddo 
        
        Do INH3=1,6
        Do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .lt. 1D-15) then 
        do ICH3=1,2
       selfW=selfW-(CS1S1S3S3(INH3,INH4,ICH3,ICH3)*
     &  CS1S1V3V3(INH3,INH4)*(A0THpN(ICH3)*aB0TNH(INH3,INH4)+
     &  AETHpN(ICH3)+aBEpTNH(INH3,INH4)*MassHpm(ICH3)**2))/8.
         enddo 
              endif
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
        do INH3=1,6
       selfW=selfW-(CS1S1S3S3(INH3,INH3,ICH4,ICH3)*
     &  CS3S3V3V3(ICH3,ICH4)*(A0TNH(INH3)*aB0TCH(ICH3,ICH4)+AETNH(INH3)
     &  +aBEpTCH(ICH3,ICH4)*Mah2(INH3)))/8.
         enddo 
              endif
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
        do ICH5=1,2
       selfW=selfW-(CS3S3S3S3(ICH4,ICH5,ICH3,ICH5)*
     &  CS3S3V3V3(ICH3,ICH4)*(A0THpN(ICH5)*aB0TCH(ICH3,ICH4)+
     &  AETHpN(ICH5)+aBEpTCH(ICH3,ICH4)*MassHpm(ICH5)**2))/4.
         enddo 
              endif
        Enddo 
        Enddo 
        
        Do INH3=1,6
        Do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .lt. 1D-15) then 
        do ISt3=1,2
       selfW=selfW+(-3*CS1S1V3V3(INH3,INH4)*CSSSS(INH3,INH4,ISt3,ISt3)*
     &  (aAETN(ISt3)+aA0TN(ISt3)*aB0TNH(INH3,INH4)+aBEpTNH(INH3,INH4)*
     &  MassSu2(ISt3)))/8.
         enddo 
              endif
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
        do ISt3=1,2
       selfW=selfW+(-3*CS3S3S13S13(ICH4,ICH3,ISt3,ISt3)*
     &  CS3S3V3V3(ICH3,ICH4)*(aAETN(ISt3)+aA0TN(ISt3)*aB0TCH(ICH3,ICH4)
     &  +aBEpTCH(ICH3,ICH4)*MassSu2(ISt3)))/4.
         enddo 
              endif
        Enddo 
        Enddo 

        
        Do ICH3=1,2
        Do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
       selfW=selfW+(-3*(aet5+a0t5*aB0TCH(ICH3,ICH4)+MSQ2*
     &  aBEpTCH(ICH3,ICH4))*CS3S3S14S14(ICH4,ICH3)*CS3S3V3V3(ICH3,ICH4)
     &  )/4.
              endif
        Enddo 
        Enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[9][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       

c
c topo9-GBC
c

c
c topo10-NoGBC
c
        
c
c topo10-GBC
c
       do INH3=1,6
       do INH4=1,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*(CFF12S1L(INH4)*
     &  (CFF12S1R(INH3)*(-FD111ChaChaH(2,INH3)+FD111ChaChaH(2,INH4))+
     &  MCha2*CFF12S1L(INH3)*(-FD111ChaHCha(1,INH3)+
     &  FD111ChaHCha(1,INH4)))+CFF12S1R(INH4)*(CFF12S1L(INH3)*(-
     &  FD111ChaChaH(2,INH3)+FD111ChaChaH(2,INH4))+MCha2*CFF12S1R(INH3)
     &  *(-FD111ChaHCha(1,INH3)+FD111ChaHCha(1,INH4)))+3*
     &  (FD111THT(2,INH3)-FD111THT(2,INH4)-FD111THT(4,INH3)+
     &  FD111THT(4,INH4))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))-3*
     &  M12*FD111THT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))+3*
     &  M12*FD111THT(1,INH4)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /(4.*(Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW-(CS1S1V3V3(INH3,INH4)*(CFF12S1R(INH3)*(MCha2*
     &  CFF12S1R(INH4)*FD211HChaCha(1,INH3)+CFF12S1L(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))+CFF12S1L(INH3)*
     &  (MCha2*CFF12S1L(INH4)*FD211HChaCha(1,INH3)+CFF12S1R(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))-3*(FD211HTT(2,INH3)
     &  -FD211HTT(3,INH3))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))+3*
     &  M12*FD211HTT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /4.
               endif
              endif
       enddo 
       enddo 
        
       do INe3=1,3
       do INe4=1,3
       do INH3=1,6
       do INH4=1,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*(-((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD111ChiChiH(2,INe3,INe4,INH3)-
     &  FD111ChiChiH(2,INe3,INe4,INH4)))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD111ChiChiH(1,INe3,INe4,INH3)-
     &  FD111ChiChiH(1,INe3,INe4,INH4))*MNeu(INe3)*MNeu(INe4)))/(8.*
     &  (Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD211HNeuNeu(2,INH3,INe4,INe3)-
     &  FD211HNeuNeu(3,INH3,INe4,INe3))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*FD211HNeuNeu(1,INH3,INe4,INe3)*
     &  MNeu(INe3)*MNeu(INe4)))/8.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+(3*CS3S3V3V3(ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD111THpB(2,ICH3)-FD111THpB(2,ICH4)-FD111THpB(4,ICH3)+
     &  FD111THpB(4,ICH4)))/(2.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+(3*CS3S3V3V3(ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD211HpTB(2,ICH3)-FD211HpTB(3,ICH3)))/2.
               endif
              endif
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INe3=1,3
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+(CS3S3V3V3(ICH3,ICH4)*(-((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD111ChaChiHp(2,INe3,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH4)))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD111ChaChiHp(1,INe3,ICH3)-
     &  FD111ChaChiHp(1,INe3,ICH4))*MNeu(INe3)))/(2.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+(CS3S3V3V3(ICH3,ICH4)*((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(3,ICH3,INe3))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*FD211HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3)))/2.
               endif
              endif
       enddo 
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[11][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo11-NoGBC
c
        INH3=6
        INH4=6
        
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*(CFF12S1L(INH3)*CFF12S1R(INH4)
     &  *(12*aetcha-12*a0tcha*logx+6*logx**2*MCha2+MCha2*Pi**2+6*
     &  FD111ChaHCha(1,INH3)-12*MCha2*FD211HChaCha(1,INH3))+
     &  CFF12S1L(INH4)*(CFF12S1R(INH3)*(12*aetcha-12*a0tcha*logx+6*
     &  logx**2*MCha2+MCha2*Pi**2+6*FD111ChaHCha(1,INH3))-12*MCha2*
     &  (CFF12S1L(INH3)+CFF12S1R(INH3))*FD211HChaCha(1,INH3))+3*(-4*
     &  MCha2*CFF12S1R(INH3)*CFF12S1R(INH4)*FD211HChaCha(1,INH3)-12*
     &  M12*FD211HTT(1,INH3)*(hy(INH3)+hyc(INH3))*(hy(INH4)+hyc(INH4))+
     &  (12*aet1-12*a0t1*logx+6*logx**2*M12+M12*Pi**2+6*
     &  FD111THT(1,INH3))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4)))))
     &  /48.
        INH3=6
        INH4=6
       do INe3=1,3
       do INe4=1,3
      
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*(-((CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*FD211HNeuNeu(1,INH3,INe4,INe3)*
     &  MNeu(INe3)*MNeu(INe4))+((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(-12*logx*A0TNeu(INe3)-12*logx*
     &  A0TNeu(INe4)+12*(AETNeu(INe3)+AETNeu(INe4)+
     &  FD111ChiChiH(1,INe3,INe4,INH3))+(6*logx**2+Pi**2-12*
     &  FD211HNeuNeu(1,INH3,INe4,INe3))*(MNeu2(INe3)+MNeu2(INe4))))/24.))/8.
       enddo 
       enddo 
        ICH3=1
        ICH4=1        
       selfW=selfW+((3*(2*(aet1+aK0TT)-4*a0t1*(-1+logx)+(-3-(-4+
     &  LogM12)*LogM12+logx**2+logx2)*M12)*
     &  CS3S3V3V3(ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4))/8.)
        ICH3=1
        ICH4=1
       do INe3=1,3        
       selfW=selfW+(CS3S3V3V3(ICH3,ICH4)*(-(MCha*(CF11F12S3R(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*FD211HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3))+((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(12*aetcha-12*a0tcha*logx+6*
     &  logx**2*MCha2+MCha2*Pi**2-12*logx*A0TNeu(INe3)+12*AETNeu(INe3)+
     &  12*FD111ChaChiHp(1,INe3,ICH3)+(6*logx**2+Pi**2)*MNeu2(INe3)-12*
     &  FD211HpChiCha(1,ICH3,INe3)*(MCha2+MNeu2(INe3))))/24.))/2.
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[11][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo11-GBC
c
        
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
              if( Abs(Mah(INH5) - Mah(INH6)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1V3V3(INH5,INH6)*(FD111HHH(1,INH3,INH4,INH5)-
     &  FD111HHH(1,INH3,INH4,INH6)))/(16.*(Mah(INH5)**2-Mah(INH6)**2))
              else
               if( Abs(Mah(INH5)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1V3V3(INH5,INH6)*FD211HHH(1,INH5,INH4,INH3))/16.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(FD111HpHpH(1,ICH3,ICH4,INH3)-
     &  FD111HpHpH(1,ICH3,ICH4,INH4)))/(8.*(Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+(CS1S1V3V3(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*FD211HHpHp(1,INH3,ICH4,ICH3))/8.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
              if( Abs(MassHpm(ICH4) - MassHpm(ICH5)) .gt. 1D-15) then 
       selfW=selfW+(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH5,ICH3)*
     &  CS3S3V3V3(ICH4,ICH5)*(FD111HHpHp(1,INH3,ICH3,ICH4)-
     &  FD111HHpHp(1,INH3,ICH3,ICH5)))/(4.*(MassHpm(ICH4)**2-
     &  MassHpm(ICH5)**2))
              else
               if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH5,ICH3)*
     &  CS3S3V3V3(ICH4,ICH5)*FD211HpHpH(1,ICH4,ICH3,INH3))/4.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
       do ISt4=1,2
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfW=selfW+(3*CS1S1V3V3(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH4,ISt3,ISt4)))/(8.*(Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfW=selfW+(3*CS1S1V3V3(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt4,ISt3))/8.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 

        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfW=selfW+(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  CS3S3V3V3(ICH4,ICH3)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH4,ISt3)))/(4.*(MassHpm(ICH3)**2-MassHpm(ICH4)*
     &  *2))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfW=selfW+(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  CS3S3V3V3(ICH4,ICH3)*FD211HpSTSB(1,ICH3,ISt3))/4.
               endif
              endif
       enddo 
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfNoGBC[12][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo12-NoGBC
c
        INH5=6
        INH6=6
       do INH3=1,6
       do INH4=1,6       
       selfW=selfW+(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1V3V3(INH5,INH6)*FD211HHH(1,INH5,INH4,INH3))/16.
       enddo 
       enddo 

        ICH4=1
        ICH5=1
       do ICH3=1,2
       do INH3=1,6
       selfW=selfW+(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH5,ICH3)*
     &  CS3S3V3V3(ICH4,ICH5)*FD211HpHpH(1,ICH4,ICH3,INH3))/4.
       enddo 
       enddo 
        INH3=6
        INH4=6
       do ISt3=1,2
       do ISt4=1,2    
       selfW=selfW+(3*CS1S1V3V3(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt4,ISt3))/8.
       enddo 
       enddo 
        ICH3=1
        ICH4=1
       do ISt3=1,2
       selfW=selfW+(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  CS3S3V3V3(ICH4,ICH3)*FD211HpSTSB(1,ICH3,ISt3))/4.
       enddo 

#ifdef MATHEMATICA
       selfW=selfW*afac
      Write(16,110) "TwoLoopWSelfGBC[12][Nhung1]=",DBLE(selfW)
       selfW=0
#endif       
c
c topo12-GBC
c
        
       selfWCT=selfWCT-6*CF4F3V3*M1*DCONJG(CF4F3V3)*((1+2*aB0TN1-4*
     &  aBEpTN1)*dmt4(1)+(2-4*aB0TN1)*dmt4(2)-4*dmt4(3))
        
       do INe3=1,3
       do INe4=1,3
              if( MNeu(INe3) + MNeu(INe4) .gt. 1D-15) then 
       selfWCT=selfWCT+(-8*MCha*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*DCONJG(dMNeu1L(INe4,INe3,3))-8*MCha*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3R(INe3))*dMNeu1L(INe3,INe4,3)-
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3)-2*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*DCONJG(dMNeu1L(INe4,INe3,2))*
     &  MNeu(INe3)+4*CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*
     &  DCONJG(dMNeu1L(INe4,INe3,3))*MNeu(INe3)-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*dMNeu1L(INe3,INe4,1)*MNeu(INe3)-2*
     &  CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*dMNeu1L(INe3,INe4,2)*
     &  MNeu(INe3)+4*CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*
     &  dMNeu1L(INe3,INe4,3)*MNeu(INe3)-CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*DCONJG(dMNeu1L(INe4,INe3,1))*
     &  MNeu(INe4)-2*CF11F12V3L(INe4)*DCONJG(CF11F12V3L(INe3))*
     &  DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe4)+4*CF11F12V3L(INe4)*
     &  DCONJG(CF11F12V3L(INe3))*DCONJG(dMNeu1L(INe4,INe3,3))*
     &  MNeu(INe4)-CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*
     &  dMNeu1L(INe3,INe4,1)*MNeu(INe4)-2*CF11F12V3R(INe4)*
     &  DCONJG(CF11F12V3R(INe3))*dMNeu1L(INe3,INe4,2)*MNeu(INe4)+4*
     &  CF11F12V3R(INe4)*DCONJG(CF11F12V3R(INe3))*dMNeu1L(INe3,INe4,3)*
     &  MNeu(INe4)+4*MCha*aCEpTChaChi2(INe3,INe4)*(CF11F12V3R(INe4)*
     &  (MCha*DCONJG(dMNeu1L(INe4,INe3,1))*(-2*MCha*
     &  DCONJG(CF11F12V3L(INe3))+DCONJG(CF11F12V3R(INe3))*MNeu(INe3))+
     &  dMNeu1L(INe3,INe4,1)*(MCha*DCONJG(CF11F12V3R(INe3))-2*
     &  DCONJG(CF11F12V3L(INe3))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12V3L(INe4)*(MCha*dMNeu1L(INe3,INe4,1)*(-2*MCha*
     &  DCONJG(CF11F12V3R(INe3))+DCONJG(CF11F12V3L(INe3))*MNeu(INe3))+
     &  DCONJG(dMNeu1L(INe4,INe3,1))*(MCha*DCONJG(CF11F12V3L(INe3))-2*
     &  DCONJG(CF11F12V3R(INe3))*MNeu(INe3))*MNeu(INe4)))+4*
     &  aBEpTNeu(INe3,INe4)*(CF11F12V3L(INe4)*(-2*MCha*
     &  DCONJG(CF11F12V3R(INe3))*dMNeu1L(INe3,INe4,1)+
     &  DCONJG(CF11F12V3L(INe3))*(dMNeu1L(INe3,INe4,1)*MNeu(INe3)+
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe4)))+CF11F12V3R(INe4)*(-2*
     &  MCha*DCONJG(CF11F12V3L(INe3))*DCONJG(dMNeu1L(INe4,INe3,1))+
     &  DCONJG(CF11F12V3R(INe3))*(DCONJG(dMNeu1L(INe4,INe3,1))*
     &  MNeu(INe3)+dMNeu1L(INe3,INe4,1)*MNeu(INe4))))-2*
     &  aB0TNeu(INe3,INe4)*(CF11F12V3L(INe4)*(4*MCha*
     &  DCONJG(CF11F12V3R(INe3))*dMNeu1L(INe3,INe4,2)+
     &  DCONJG(CF11F12V3L(INe3))*((dMNeu1L(INe3,INe4,1)-2*
     &  dMNeu1L(INe3,INe4,2))*MNeu(INe3)+(DCONJG(dMNeu1L(INe4,INe3,1))-
     &  2*DCONJG(dMNeu1L(INe4,INe3,2)))*MNeu(INe4)))+CF11F12V3R(INe4)*
     &  (4*MCha*DCONJG(CF11F12V3L(INe3))*DCONJG(dMNeu1L(INe4,INe3,2))+
     &  DCONJG(CF11F12V3R(INe3))*((DCONJG(dMNeu1L(INe4,INe3,1))-2*
     &  DCONJG(dMNeu1L(INe4,INe3,2)))*MNeu(INe3)+(dMNeu1L(INe3,INe4,1)-
     &  2*dMNeu1L(INe3,INe4,2))*MNeu(INe4))))-2*MCha*
     &  aC0TChaChi2(INe3,INe4)*(CF11F12V3L(INe4)*(MCha*
     &  DCONJG(CF11F12V3L(INe3))*((dMNeu1L(INe3,INe4,1)-2*
     &  dMNeu1L(INe3,INe4,2))*MNeu(INe3)+(DCONJG(dMNeu1L(INe4,INe3,1))-
     &  2*DCONJG(dMNeu1L(INe4,INe3,2)))*MNeu(INe4))+4*
     &  DCONJG(CF11F12V3R(INe3))*(MCha2*dMNeu1L(INe3,INe4,2)+
     &  DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe3)*MNeu(INe4)))+
     &  CF11F12V3R(INe4)*(MCha*DCONJG(CF11F12V3R(INe3))*
     &  ((DCONJG(dMNeu1L(INe4,INe3,1))-2*DCONJG(dMNeu1L(INe4,INe3,2)))*
     &  MNeu(INe3)+(dMNeu1L(INe3,INe4,1)-2*dMNeu1L(INe3,INe4,2))*
     &  MNeu(INe4))+4*DCONJG(CF11F12V3L(INe3))*(MCha2*
     &  DCONJG(dMNeu1L(INe4,INe3,2))+dMNeu1L(INe3,INe4,2)*MNeu(INe3)*MNeu(INe4)))))
              endif
       enddo 
       enddo 
        
       do INe3=1,3
       selfWCT=selfWCT+(-2*MCha*(Abs(CF11F12V3L(INe3))**2+
     &  Abs(CF11F12V3R(INe3))**2)*(dMCha1L(1)+2*(aB0TChaChi(INe3)-2*
     &  aBEpTChaChi(INe3)+MCha2*(aC0TCha2Chi(INe3)-2*aCEpTCha2Chi(INe3)
     &  ))*dMCha1L(1)+2*dMCha1L(2)-4*(aB0TChaChi(INe3)+MCha2*
     &  aC0TCha2Chi(INe3))*dMCha1L(2)-4*dMCha1L(3))-8*(CF11F12V3R(INe3)
     &  *DCONJG(CF11F12V3L(INe3))+CF11F12V3L(INe3)*
     &  DCONJG(CF11F12V3R(INe3)))*(aBEpTChaChi(INe3)*dMCha1L(1)+
     &  aB0TChaChi(INe3)*dMCha1L(2)+2*MCha2*(aCEpTCha2Chi(INe3)*
     &  dMCha1L(1)+aC0TCha2Chi(INe3)*dMCha1L(2))+dMCha1L(3))*MNeu(INe3)
     &  )
       enddo 

#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2
      Write(16,110) "TwoLoopWSelfCTNoGBC[1][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
#endif       
!!  Counterterm part     
c
c CTtopo1-NoGBC
c

c
c CTtopo1-GBC
c
        
       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .gt. 1D-15) then 
       selfWCT=selfWCT+CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  2*A0THpN(ICH3)*dZHiggs1(INH3,INH4,1)-4*AETHpN(ICH3)*
     &  dZHiggs1(INH3,INH4,1)-4*A0THpN(ICH3)*dZHiggs1(INH3,INH4,2)+((2+
     &  4*aB0TNCH(INH4,ICH3)+8*aBEpTNCH(INH4,ICH3))*
     &  dMH1MT4(INH3,INH4,1)+(4+8*aB0TNCH(INH4,ICH3))*
     &  dMH1MT4(INH3,INH4,2)+8*dMH1MT4(INH3,INH4,3)+(-2+signf)*((1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3))*dZHiggs1(INH3,INH4,1)
     &  +(2+4*aB0TNCH(INH4,ICH3))*dZHiggs1(INH3,INH4,2)+4*
     &  dZHiggs1(INH3,INH4,3))*(Mah2(INH3)+Mah2(INH4)))/2.+Mah2(INH3)*
     &  ((aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*(2*
     &  dMH1MT4(INH3,INH4,1)+dZHiggs1(INH3,INH4,1)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4)))+2*aC0THHCH(INH3,INH4,ICH3)*(2*
     &  dMH1MT4(INH3,INH4,2)+dZHiggs1(INH3,INH4,2)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))))-dZHiggs1(INH3,INH4,1)*
     &  MassHpm(ICH3)**2-2*dZHiggs1(INH3,INH4,2)*MassHpm(ICH3)**2-4*
     &  dZHiggs1(INH3,INH4,3)*MassHpm(ICH3)**2)
              endif
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .gt. 1D-15) then 
       selfWCT=selfWCT+CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  2*A0THpN(ICH4)*dZCHiggs1(ICH4,ICH3,1)-4*AETHpN(ICH4)*
     &  dZCHiggs1(ICH4,ICH3,1)-4*A0THpN(ICH4)*dZCHiggs1(ICH4,ICH3,2)-
     &  dZCHiggs1(ICH4,ICH3,1)*MassHpm(ICH4)**2-2*
     &  dZCHiggs1(ICH4,ICH3,2)*MassHpm(ICH4)**2-4*
     &  dZCHiggs1(ICH4,ICH3,3)*MassHpm(ICH4)**2+((2+4*aB0TCH(ICH3,ICH4)
     &  +8*aBEpTCH(ICH3,ICH4))*dMCH1L(ICH4,ICH3,1)+(4+8*
     &  aB0TCH(ICH3,ICH4))*dMCH1L(ICH4,ICH3,2)+8*dMCH1L(ICH4,ICH3,3)-
     &  ((1+2*aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4))*
     &  dZCHiggs1(ICH4,ICH3,1)+(2+4*aB0TCH(ICH3,ICH4))*
     &  dZCHiggs1(ICH4,ICH3,2)+4*dZCHiggs1(ICH4,ICH3,3))*(2*Mah2(INH3)-
     &  (-2+signf)*MassHpm(ICH3)**2-signf*MassHpm(ICH4)**2))/2.+
     &  Mah2(INH3)*((aC0THCHCH(INH3,ICH3,ICH4)+2*
     &  aCepTHCHCH(INH3,ICH3,ICH4))*(2*dMCH1L(ICH4,ICH3,1)+
     &  dZCHiggs1(ICH4,ICH3,1)*(-2*Mah2(INH3)+signf*(MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)))+2*aC0THCHCH(INH3,ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)*(-2*Mah2(INH3)+
     &  signf*(MassHpm(ICH3)**2+MassHpm(ICH4)**2)))))
              endif
       enddo 
       enddo 
       enddo 
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfWCT=selfWCT+3*CS14S13V3(ISt4)*DCONJG(CS14S13V3(ISt3))*((1+2*
     &  aB0T1(ISt3,ISt4)+4*aBEpT1(ISt3,ISt4)+2*MSQ2*(aC0TH1(ISt3,ISt4)+
     &  2*aCEpTH1(ISt3,ISt4)))*dMSf4(ISt3,ISt4,1)+(2+4*aB0T1(ISt3,ISt4)
     &  +4*MSQ2*aC0TH1(ISt3,ISt4))*dMSf4(ISt3,ISt4,2)+4*
     &  dMSf4(ISt3,ISt4,3))
              endif
       enddo 
       enddo 
        
       do ISt3=1,2
       selfWCT=selfWCT+3*Abs(CS14S13V3(ISt3))**2*(dMSQ4(1)+2*
     &  (aB0TH1(ISt3)+2*aBEpTH1(ISt3)+MSQ2*(aC0TH2(ISt3)+2*
     &  aCEpTH2(ISt3)))*dMSQ4(1)+2*dMSQ4(2)+4*(aB0TH1(ISt3)+MSQ2*
     &  aC0TH2(ISt3))*dMSQ4(2)+4*dMSQ4(3))
       enddo 

#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2
      Write(16,110) "TwoLoopWSelfCTNoGBC[2][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
#endif       
c
c CTtopo2-NoGBC
c
      
       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*MassHpm(ICH3) + Mah(INH4)*MassHpm(ICH3) .lt. 1D-15) then 
       selfWCT=selfWCT+CS1S3V3(INH4,ICH3)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  2*A0THpN(ICH3)*dZHiggs1(INH3,INH4,1)-4*AETHpN(ICH3)*
     &  dZHiggs1(INH3,INH4,1)-4*A0THpN(ICH3)*dZHiggs1(INH3,INH4,2)+((2+
     &  4*aB0TNCH(INH4,ICH3)+8*aBEpTNCH(INH4,ICH3))*
     &  dMH1MT4(INH3,INH4,1)+(4+8*aB0TNCH(INH4,ICH3))*
     &  dMH1MT4(INH3,INH4,2)+8*dMH1MT4(INH3,INH4,3)+(-2+signf)*((1+2*
     &  aB0TNCH(INH4,ICH3)+4*aBEpTNCH(INH4,ICH3))*dZHiggs1(INH3,INH4,1)
     &  +(2+4*aB0TNCH(INH4,ICH3))*dZHiggs1(INH3,INH4,2)+4*
     &  dZHiggs1(INH3,INH4,3))*(Mah2(INH3)+Mah2(INH4)))/2.+Mah2(INH3)*
     &  ((aC0THHCH(INH3,INH4,ICH3)+2*aCepTHHCH(INH3,INH4,ICH3))*(2*
     &  dMH1MT4(INH3,INH4,1)+dZHiggs1(INH3,INH4,1)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4)))+2*aC0THHCH(INH3,INH4,ICH3)*(2*
     &  dMH1MT4(INH3,INH4,2)+dZHiggs1(INH3,INH4,2)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))))-dZHiggs1(INH3,INH4,1)*
     &  MassHpm(ICH3)**2-2*dZHiggs1(INH3,INH4,2)*MassHpm(ICH3)**2-4*
     &  dZHiggs1(INH3,INH4,3)*MassHpm(ICH3)**2)
              endif
       enddo 
       enddo 
       enddo 

        
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
              if( Mah(INH3)*MassHpm(ICH3) + Mah(INH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH4) .lt. 1D-15) then 
       selfWCT=selfWCT+CS1S3V3(INH3,ICH4)*DCONJG(CS1S3V3(INH3,ICH3))*(-
     &  2*A0THpN(ICH4)*dZCHiggs1(ICH4,ICH3,1)-4*AETHpN(ICH4)*
     &  dZCHiggs1(ICH4,ICH3,1)-4*A0THpN(ICH4)*dZCHiggs1(ICH4,ICH3,2)-
     &  dZCHiggs1(ICH4,ICH3,1)*MassHpm(ICH4)**2-2*
     &  dZCHiggs1(ICH4,ICH3,2)*MassHpm(ICH4)**2-4*
     &  dZCHiggs1(ICH4,ICH3,3)*MassHpm(ICH4)**2+((2+4*aB0TCH(ICH3,ICH4)
     &  +8*aBEpTCH(ICH3,ICH4))*dMCH1L(ICH4,ICH3,1)+(4+8*
     &  aB0TCH(ICH3,ICH4))*dMCH1L(ICH4,ICH3,2)+8*dMCH1L(ICH4,ICH3,3)-
     &  ((1+2*aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4))*
     &  dZCHiggs1(ICH4,ICH3,1)+(2+4*aB0TCH(ICH3,ICH4))*
     &  dZCHiggs1(ICH4,ICH3,2)+4*dZCHiggs1(ICH4,ICH3,3))*(2*Mah2(INH3)-
     &  (-2+signf)*MassHpm(ICH3)**2-signf*MassHpm(ICH4)**2))/2.+
     &  Mah2(INH3)*((aC0THCHCH(INH3,ICH3,ICH4)+2*
     &  aCepTHCHCH(INH3,ICH3,ICH4))*(2*dMCH1L(ICH4,ICH3,1)+
     &  dZCHiggs1(ICH4,ICH3,1)*(-2*Mah2(INH3)+signf*(MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)))+2*aC0THCHCH(INH3,ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)*(-2*Mah2(INH3)+
     &  signf*(MassHpm(ICH3)**2+MassHpm(ICH4)**2)))))
              endif
       enddo 
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2
      Write(16,110) "TwoLoopWSelfCTGBC[2][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
#endif      
c
c CTtopo2-GBC
c
        
       do INH3=1,6
       selfWCT=selfWCT+2*(AETNH(INH3)*dCS1S1V3V3(INH3,INH3,1)+
     &  A0TNH(INH3)*dCS1S1V3V3(INH3,INH3,2)+dCS1S1V3V3(INH3,INH3,3)*
     &  Mah2(INH3))
       enddo 
        
       do ICH3=1,2
       selfWCT=selfWCT+4*(AETHpN(ICH3)*dCS3S3V3V3(ICH3,ICH3,1)+
     &  A0THpN(ICH3)*dCS3S3V3V3(ICH3,ICH3,2)+dCS3S3V3V3(ICH3,ICH3,3)*
     &  MassHpm(ICH3)**2)
       enddo 

       do ISt3=1,2
       selfWCT=selfWCT+12*(aAETN(ISt3)*dCS13S13V3V3(ISt3,ISt3,1)+
     &  aA0TN(ISt3)*dCS13S13V3V3(ISt3,ISt3,2)+dCS13S13V3V3(ISt3,ISt3,3)
     &  *MassSu2(ISt3))
       enddo 
        
       selfWCT=selfWCT+12*(aet5*dCS14S14V3V3(1)+a0t5*dCS14S14V3V3(2)+
     &  MSQ2*dCS14S14V3V3(3))
 
#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2
      Write(16,110) "TwoLoopWSelfCTNoGBC[3][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
#endif     
c
c CTtopo3-NoGBC
c
c
c CTtopo3-GBC
c
        
       selfWCT=selfWCT-3*(CF4F3V3*(2*a0t1-4*aet1+M12)*
     &  DCONJG(dF4F3V3(1))+2*CF4F3V3*(-2*a0t1+M12)*DCONJG(dF4F3V3(2))-
     &  4*CF4F3V3*M12*DCONJG(dF4F3V3(3))+DCONJG(CF4F3V3)*(-4*aet1*
     &  dF4F3V3(1)+2*a0t1*(dF4F3V3(1)-2*dF4F3V3(2))+M12*(dF4F3V3(1)+2*
     &  dF4F3V3(2)-4*dF4F3V3(3))))

        
       do INe3=1,3
       selfWCT=selfWCT+(-(DCONJG(CF11F12V3L(INe3))*(-4*MCha2*
     &  dCF11F12V3L(INe3,3)+8*MCha*aBEpTChaChi(INe3)*
     &  dCF11F12V3R(INe3,1)*MNeu(INe3)+8*MCha*aB0TChaChi(INe3)*
     &  dCF11F12V3R(INe3,2)*MNeu(INe3)+8*MCha*dCF11F12V3R(INe3,3)*
     &  MNeu(INe3)-4*dCF11F12V3L(INe3,3)*MNeu2(INe3)+2*
     &  dCF11F12V3L(INe3,2)*(MCha2-2*A0TNeu(INe3)-2*MCha2*
     &  aB0TChaChi(INe3)+MNeu2(INe3))+dCF11F12V3L(INe3,1)*(MCha2+2*
     &  A0TNeu(INe3)+2*MCha2*(aB0TChaChi(INe3)-2*aBEpTChaChi(INe3))-4*
     &  AETNeu(INe3)+MNeu2(INe3))))-DCONJG(CF11F12V3R(INe3))*(-4*MCha2*
     &  dCF11F12V3R(INe3,3)+8*MCha*aBEpTChaChi(INe3)*
     &  dCF11F12V3L(INe3,1)*MNeu(INe3)+8*MCha*aB0TChaChi(INe3)*
     &  dCF11F12V3L(INe3,2)*MNeu(INe3)+8*MCha*dCF11F12V3L(INe3,3)*
     &  MNeu(INe3)-4*dCF11F12V3R(INe3,3)*MNeu2(INe3)+2*
     &  dCF11F12V3R(INe3,2)*(MCha2-2*A0TNeu(INe3)-2*MCha2*
     &  aB0TChaChi(INe3)+MNeu2(INe3))+dCF11F12V3R(INe3,1)*(MCha2+2*
     &  A0TNeu(INe3)+2*MCha2*(aB0TChaChi(INe3)-2*aBEpTChaChi(INe3))-4*
     &  AETNeu(INe3)+MNeu2(INe3)))-CF11F12V3L(INe3)*(8*MCha*
     &  (aBEpTChaChi(INe3)*DCONJG(dCF11F12V3R(INe3,1))+aB0TChaChi(INe3)
     &  *DCONJG(dCF11F12V3R(INe3,2))+DCONJG(dCF11F12V3R(INe3,3)))*
     &  MNeu(INe3)-4*DCONJG(dCF11F12V3L(INe3,3))*(MCha2+MNeu2(INe3))+2*
     &  DCONJG(dCF11F12V3L(INe3,2))*(MCha2-2*A0TNeu(INe3)-2*MCha2*
     &  aB0TChaChi(INe3)+MNeu2(INe3))+DCONJG(dCF11F12V3L(INe3,1))*
     &  (MCha2+2*A0TNeu(INe3)+2*MCha2*(aB0TChaChi(INe3)-2*
     &  aBEpTChaChi(INe3))-4*AETNeu(INe3)+MNeu2(INe3)))-
     &  CF11F12V3R(INe3)*(8*MCha*(aBEpTChaChi(INe3)*
     &  DCONJG(dCF11F12V3L(INe3,1))+aB0TChaChi(INe3)*
     &  DCONJG(dCF11F12V3L(INe3,2))+DCONJG(dCF11F12V3L(INe3,3)))*
     &  MNeu(INe3)-4*DCONJG(dCF11F12V3R(INe3,3))*(MCha2+MNeu2(INe3))+2*
     &  DCONJG(dCF11F12V3R(INe3,2))*(MCha2-2*A0TNeu(INe3)-2*MCha2*
     &  aB0TChaChi(INe3)+MNeu2(INe3))+DCONJG(dCF11F12V3R(INe3,1))*
     &  (MCha2+2*A0TNeu(INe3)+2*MCha2*(aB0TChaChi(INe3)-2*
     &  aBEpTChaChi(INe3))-4*AETNeu(INe3)+MNeu2(INe3))))
       enddo 

#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2/2D0
      Write(16,110) "TwoLoopWSelfCTNoGBC[4][Nhung1]=",DBLE(selfWCT)

      Write(16,110) "TwoLoopWSelfCTNoGBC[7][Nhung1]=",DBLE(selfWCT)      
       selfWCT=0
#endif     
c
c CTtopo4+7-NoGBC
c
c
c CTtopo4+7-GBC
c
        
       do ICH3=1,2
       do INH3=1,6
              if( Mah(INH3) + MassHpm(ICH3) .gt. 1D-15) then 
       selfWCT=selfWCT+(DCONJG(CS1S3V3(INH3,ICH3))*((1+2*
     &  aB0TNCH(INH3,ICH3)+4*aBEpTNCH(INH3,ICH3))*dCS1S3V3(INH3,ICH3,1)
     &  +(2+4*aB0TNCH(INH3,ICH3))*dCS1S3V3(INH3,ICH3,2)+4*
     &  dCS1S3V3(INH3,ICH3,3))*Mah2(INH3)+CS1S3V3(INH3,ICH3)*((1+2*
     &  aB0TNCH(INH3,ICH3)+4*aBEpTNCH(INH3,ICH3))*
     &  dCS1S3V3C(INH3,ICH3,1)+(2+4*aB0TNCH(INH3,ICH3))*
     &  dCS1S3V3C(INH3,ICH3,2)+4*dCS1S3V3C(INH3,ICH3,3))*Mah2(INH3)+
     &  DCONJG(CS1S3V3(INH3,ICH3))*(2*(A0THpN(ICH3)+2*AETHpN(ICH3))*
     &  dCS1S3V3(INH3,ICH3,1)+4*A0THpN(ICH3)*dCS1S3V3(INH3,ICH3,2)+
     &  (dCS1S3V3(INH3,ICH3,1)+2*dCS1S3V3(INH3,ICH3,2)+4*
     &  dCS1S3V3(INH3,ICH3,3))*MassHpm(ICH3)**2)+CS1S3V3(INH3,ICH3)*(2*
     &  (A0THpN(ICH3)+2*AETHpN(ICH3))*dCS1S3V3C(INH3,ICH3,1)+4*
     &  A0THpN(ICH3)*dCS1S3V3C(INH3,ICH3,2)+(dCS1S3V3C(INH3,ICH3,1)+2*
     &  dCS1S3V3C(INH3,ICH3,2)+4*dCS1S3V3C(INH3,ICH3,3))*MassHpm(ICH3)*
     &  *2))
              endif
       enddo 
       enddo 

        
       do ISt3=1,2
       selfWCT=selfWCT+3*(4*CS14S13V3(ISt3)*DCONJG(dCS14S13V3(ISt3,3))*
     &  (MSQ2+MassSu2(ISt3))+2*CS14S13V3(ISt3)*
     &  DCONJG(dCS14S13V3(ISt3,2))*(MSQ2+2*aA0TN(ISt3)+2*MSQ2*
     &  aB0TH1(ISt3)+MassSu2(ISt3))+CS14S13V3(ISt3)*
     &  DCONJG(dCS14S13V3(ISt3,1))*(2*aA0TN(ISt3)+4*aAETN(ISt3)+MSQ2*
     &  (1+2*aB0TH1(ISt3)+4*aBEpTH1(ISt3))+MassSu2(ISt3))+
     &  DCONJG(CS14S13V3(ISt3))*(dCS14S13V3(ISt3,1)*(2*aA0TN(ISt3)+4*
     &  aAETN(ISt3)+MSQ2*(1+2*aB0TH1(ISt3)+4*aBEpTH1(ISt3))+
     &  MassSu2(ISt3))+2*(2*dCS14S13V3(ISt3,3)*(MSQ2+MassSu2(ISt3))+
     &  dCS14S13V3(ISt3,2)*(MSQ2+2*aA0TN(ISt3)+2*MSQ2*aB0TH1(ISt3)+
     &  MassSu2(ISt3)))))
       enddo 

#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2/2D0
      Write(16,110) "TwoLoopWSelfCTNoGBC[5][Nhung1]=",DBLE(selfWCT)
      
      Write(16,110) "TwoLoopWSelfCTNoGBC[8][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
#endif      
c
c CTtopo5+8-NoGBC
c
        
       do ICH3=1,2
       do INH3=1,6
              if( Mah(INH3) + MassHpm(ICH3) .lt. 1D-15) then 
       selfWCT=selfWCT+(DCONJG(CS1S3V3(INH3,ICH3))*((1+2*
     &  aB0TNCH(INH3,ICH3)+4*aBEpTNCH(INH3,ICH3))*dCS1S3V3(INH3,ICH3,1)
     &  +(2+4*aB0TNCH(INH3,ICH3))*dCS1S3V3(INH3,ICH3,2)+4*
     &  dCS1S3V3(INH3,ICH3,3))*Mah2(INH3)+CS1S3V3(INH3,ICH3)*((1+2*
     &  aB0TNCH(INH3,ICH3)+4*aBEpTNCH(INH3,ICH3))*
     &  dCS1S3V3C(INH3,ICH3,1)+(2+4*aB0TNCH(INH3,ICH3))*
     &  dCS1S3V3C(INH3,ICH3,2)+4*dCS1S3V3C(INH3,ICH3,3))*Mah2(INH3)+
     &  DCONJG(CS1S3V3(INH3,ICH3))*(2*(A0THpN(ICH3)+2*AETHpN(ICH3))*
     &  dCS1S3V3(INH3,ICH3,1)+4*A0THpN(ICH3)*dCS1S3V3(INH3,ICH3,2)+
     &  (dCS1S3V3(INH3,ICH3,1)+2*dCS1S3V3(INH3,ICH3,2)+4*
     &  dCS1S3V3(INH3,ICH3,3))*MassHpm(ICH3)**2)+CS1S3V3(INH3,ICH3)*(2*
     &  (A0THpN(ICH3)+2*AETHpN(ICH3))*dCS1S3V3C(INH3,ICH3,1)+4*
     &  A0THpN(ICH3)*dCS1S3V3C(INH3,ICH3,2)+(dCS1S3V3C(INH3,ICH3,1)+2*
     &  dCS1S3V3C(INH3,ICH3,2)+4*dCS1S3V3C(INH3,ICH3,3))*MassHpm(ICH3)*
     &  *2))
              endif
       enddo 
       enddo 
 
#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2/2D0
      Write(16,110) "TwoLoopWSelfCTGBC[5][Nhung1]=",DBLE(selfWCT)

      Write(16,110) "TwoLoopWSelfCTGBC[8][Nhung1]=",DBLE(selfWCT)      
       selfWCT=0
#endif    
c
c CTtopo5+8-GBC
c
        
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       selfWCT=selfWCT+CS1S1V3V3(INH3,INH4)*((aB0TNH(INH3,INH4)*
     &  dZHiggs1(INH3,INH4,2)+dZHiggs1(INH3,INH4,3))*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))-2*(-(aB0TNH(INH3,INH4)*
     &  dMH1MT4(INH3,INH4,2))-dMH1MT4(INH3,INH4,3)+AETNH(INH4)*
     &  dZHiggs1(INH3,INH4,1)+A0TNH(INH4)*dZHiggs1(INH3,INH4,2)+
     &  dZHiggs1(INH3,INH4,3)*Mah2(INH4))+aBEpTNH(INH3,INH4)*(2*
     &  dMH1MT4(INH3,INH4,1)+dZHiggs1(INH3,INH4,1)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))))
              endif
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfWCT=selfWCT+2*CS3S3V3V3(ICH4,ICH3)*(2*dMCH1L(ICH4,ICH3,3)-2*
     &  AETHpN(ICH4)*dZCHiggs1(ICH4,ICH3,1)-2*A0THpN(ICH4)*
     &  dZCHiggs1(ICH4,ICH3,2)+(-2+signf)*dZCHiggs1(ICH4,ICH3,3)*
     &  (MassHpm(ICH3)**2+MassHpm(ICH4)**2)+aBEpTCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,1)+dZCHiggs1(ICH4,ICH3,1)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2))+aB0TCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2)))
              endif
       enddo 
       enddo 
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfWCT=selfWCT+12*CS13S13V3V3(ISt4,ISt3)*(aBEpT1(ISt3,ISt4)*
     &  dMSf4(ISt4,ISt3,1)+aB0T1(ISt3,ISt4)*dMSf4(ISt4,ISt3,2)+
     &  dMSf4(ISt4,ISt3,3))
              endif
       enddo 
       enddo 
        
       selfWCT=selfWCT+12*CS14S14V3V3*(aBEpT5*dMSQ4(1)+aB0T5*dMSQ4(2)+dMSQ4(3))
 
#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2
      Write(16,110) "TwoLoopWSelfCTNoGBC[6][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
#endif   
c
c CTtopo6-NoGBC
c

       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .lt. 1D-15) then 
       selfWCT=selfWCT+CS1S1V3V3(INH3,INH4)*((aB0TNH(INH3,INH4)*
     &  dZHiggs1(INH3,INH4,2)+dZHiggs1(INH3,INH4,3))*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))-2*(-(aB0TNH(INH3,INH4)*
     &  dMH1MT4(INH3,INH4,2))-dMH1MT4(INH3,INH4,3)+AETNH(INH4)*
     &  dZHiggs1(INH3,INH4,1)+A0TNH(INH4)*dZHiggs1(INH3,INH4,2)+
     &  dZHiggs1(INH3,INH4,3)*Mah2(INH4))+aBEpTNH(INH3,INH4)*(2*
     &  dMH1MT4(INH3,INH4,1)+dZHiggs1(INH3,INH4,1)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))))
              endif
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
       selfWCT=selfWCT+2*CS3S3V3V3(ICH4,ICH3)*(2*dMCH1L(ICH4,ICH3,3)-2*
     &  AETHpN(ICH4)*dZCHiggs1(ICH4,ICH3,1)-2*A0THpN(ICH4)*
     &  dZCHiggs1(ICH4,ICH3,2)+(-2+signf)*dZCHiggs1(ICH4,ICH3,3)*
     &  (MassHpm(ICH3)**2+MassHpm(ICH4)**2)+aBEpTCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,1)+dZCHiggs1(ICH4,ICH3,1)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2))+aB0TCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2)))
              endif
       enddo 
       enddo 

#ifdef MATHEMATICA
       selfWCT=selfWCT*afac2
      Write(16,110) "TwoLoopWSelfCTGBC[6][Nhung1]=",DBLE(selfWCT)
       selfWCT=0
110   format(A,F24.14)       
#endif     
c
c CTtopo6-GBC
c
       selfW=-selfWCT*afac2-selfW*afac
       selfWO=DBLE(selfW)


#ifdef printMT4
      Write(16,110) "TwoLoopWSelfMSSM[Sum][Nhung1]=",selfWO
110   format(A,F24.14)
#endif
      end subroutine SelfTWW2L_lambda

